/* @(#)arg.c	1.11 12/26/95*/
/*-------------------------------------------------------------------------*/
/* arg.c 7-6-96 genebank archive utility, by T Uffner, D Pirone, & T Ray   */
/* Tierra Simulator V4.3: Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996 */
/* Tom Ray & Virtual Life */
/*-------------------------------------------------------------------------*/

#ifndef lint
static char sccsid[] = "@(#)arg.c    1.5     7/21/92";
#endif

#include "license.h"
#include "tierra.h"
#define  EXTERN
#define PROBE
#include "globals.h"
#include <errno.h>

#ifdef __TRS6000__
void *malloc();
#else
#ifdef unix
char *malloc();
#endif
#endif

InstDef *id;

int main(argc, argv)
    int   argc;
    char  *argv[];
{
    I8s  com, *mod, *u = "usage:  arg c|r[v12] afile size file [file...]\
        \n\targ x[v12] afile [genotype [genotype...]]\n\targ t[v] afile\n";
    I8s  *file = 0, m[20];
#ifndef AMIGA
    I8s  data[85];
#endif
    I32s i, v = 0, f = GFormat, size = 0;
    FILE *afp = 0;
#if PLOIDY == 1
    I32s j, splits;
    I8s  rep[64] ;      /* added by kurt for e (entropy) option */
    I32s hist[64] ;     /* added by kurt for e (entropy) option */
    I16u di ;           /* added by kurt for e (entropy) option */
    I16u t ;            /* added by kurt for e (entropy) option */
    double h, p ;       /* added by kurt for e (entropy) option */
#endif
#ifdef __TURBOC__
    float  z = sin(0); /* fix silly Turbo bug */
#endif /* __TURBOC__ */

    GList *g = 0;
    head_t head;
    indx_t *indx, *tindx;
#ifndef AMIGA
    indx_t gindx;
#endif

#ifdef __MWERKS__               /* get command line and parse it if on Mac */
    /* Choose to use my command line or the MWERKS dialog box */
    I8s *p1 = "\nPlease input arguments for arg separated by spaces:\n\narg ";
    fprintf(stdout, u);
    fprintf(stdout, p1);
    argc = cmdline( "arg ", &argv);
#endif /* __MWERKS */

    hangup = 0;
    GeneBnker = 1; /* turn genebanker on and off */
    NumCells = 1; /* # of creatures and gaps used to inoculate new soup */
    if (argc < 3)
    {   fprintf(stderr, u);
        exit(1);
    }
    GetAMap("opcode.map");
    switch (com = *argv[1])
    {   case 'c':
        case 'r':
        if (argc < 5)
        {   fprintf(stderr, u);
            exit(2);
        }
        if (!sscanf(argv[3], "%ld", &size))
        {   fprintf(stderr, u);
            exit(3);
        }
        case 'k':
        case 't':
        case 'x':
        case 'e':
            break;
        default:
            fprintf(stderr, u);
        exit(4);
    }
    for (mod = ++argv[1]; *mod; mod++)
        switch (*mod)
        {   case 'v':
                ++v;
                break;
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
            case '8':
            case '9':
                f = *mod - '0';
                break;
            default:
                fprintf(stderr, u);
            exit(5);
        }
    file = argv[2];
    switch (com)
    {
#if PLOIDY == 1
        case 'k':
        for (j = 2 ; j < argc ; j++)
        {   file = argv[j];
            if (!(afp = fopen(file, "rb")))
            {   perror(argv[0]);
                exit(7);
            }
            head = read_head(afp);
            indx = read_indx(afp, &head);
            sprintf(m, "%4s",head.magic);
            m[4]='\0';  /* insanity for not having null in the struct */
            for (i = 0; i < head.n; i++)
            {   tindx = &indx[i];
                g = get_gen(afp, &head, tindx, i);
                if (tindx->d1.BreedTrue) 
                {   sprintf(m,"%3s",tindx->gen);
                    fprintf(stdout, "%04ld %.3s %6d ",
                        head.size, m, tindx->mppT.m);
                    if (tindx->d1.mov_daught == head.size)
                        fprintf(stdout, " %6d %6d %6.2f .",
                            tindx->d1.mov_daught, tindx->d1.inst,
                            (float) tindx->d1.inst / (float) head.size);
                    else if (tindx->d1.mov_daught != 0)
                        fprintf(stdout, " %6d %6d %6.2f *",
                            tindx->d1.mov_daught, tindx->d1.inst,
                            (float) tindx->d1.inst / (float) head.size);
                    else 
                        fprintf(stdout, " %6d %6d %6.2f *",
                            tindx->d1.mov_daught, tindx->d1.inst,0.0);
                    /* only works if PLOIDY == 1 */
                    splits = 0 ;
                    for (t = 0; t < g->gen.size; t++)
                    {   di = g->genome[t];
                        if (strcmp(id[di].mn,"split") == 0)
                            splits++ ;
                    }
                    fprintf(stdout," %d %ld\n",splits,g->max_cpus);
                }
            }
            fclose(afp) ;
        }
        break ;
#endif
        case 'c':
            fprintf(stdout, "creating archive \"%s\"\n", file);
            g = (GList *) calloc(1, sizeof(GList));
            GetAscGen(g,argv[4]);
            f = GFormat;
        case 'r':
            if (!(afp = open_ar(file, size, f , com == 'c' ? 1 : 0)))
            {   perror(argv[0]);
                exit(6);
            }
            head = read_head(afp);
            indx = read_indx(afp, &head);
            if (g)
            {   free((void *) g);
                g = NULL;
            }
            g = (GList *) calloc(1, sizeof(GList));
            for (i=4; i < argc; i++)
            {   int j;
                GetAscGen(g, argv[i]);
                if (head.size != g->gen.size)
                {   fprintf(stderr, "%s is wrong size\n", g->gen.label);
                    continue;
                }
                j = add_gen(afp, &head, &indx, g);
                if (v)
                {   fprintf(stdout, "%c - %04ld%3s %.3f %.3f", j?'r':'a',
                        size, g->gen.label, g->MaxPropPop, g->MaxPropInst);
                    if (IsBit(g->bits,0))
                    {   WritEcoB(g->bits, Buff);
                        fprintf(stdout," 1 %s\n",Buff);
                    }
                    else fprintf(stdout," 0\n");
                }
                else fprintf(stdout, "%c - %3s\n", j?'r':'a', g->gen.label);
            }
            if (g)
            {   free((void *) g);
                g = NULL;
            }
            fclose(afp);
            break;
        case 't':
            if (!(afp = fopen(file, "rb")))
            {   perror(argv[0]);
                exit(7);
            }
            head = read_head(afp);
            if (strncmp(head.magic, "tie", 3) 
                || (f > -1 && head.magic[3] - '0' != f))
            {   fprintf(stderr, "%s: bad magic number", *argv);
                exit(8);
            }
            indx = read_indx(afp, &head);
            sprintf(m, "%4s",head.magic);
            m[4]='\0';  /* insanity for not having null in the struct */
            fprintf(stdout, "Format: %s, Size: %ld, # of entries: %ld\n\n",
                m, head.size, head.n);
            for (i = 0; i < head.n; i++)
            {
                tindx = &indx[i];
                if (v)
                {   g = get_gen(afp, &head, tindx, i);
                    sprintf(m,"%3s",tindx->gen);
                    fprintf(stdout, "%04ld%.3s %.3f %.3f", head.size,
                        m, tindx->mpp / 10000., tindx->mpi / 10000.);
                    if (IsBit(tindx->bits, 0))
                    {   WritEcoB(tindx->bits, Buff);
                        fprintf(stdout," 1 %s\n",Buff);
                    }
                    else fprintf(stdout," 0\n");
                }
                else fprintf(stdout, "%.3s\n", tindx->gen);
            }
            break;
        case 'x':
            if (!(afp = fopen(file, "rb")))
            {   perror(argv[0]);
                exit(9);
            }
            head = read_head(afp);
            if (strncmp(head.magic, "tie", 3) 
                || (f > -1 && head.magic[3] - '0' != f))
            {   fprintf(stderr, "%s: bad magic number", *argv);
                exit(10);
            }
            indx = read_indx(afp, &head);
            if (argc > 3)
                for (i=3; i<argc; i++)
                {   int j;
                    if ((j = find_gen(indx, argv[i], head.n)) == head.n)
                    {   fprintf(stderr, "%s not in archive\n", argv[i]);
                        continue;
                    }
                    tindx = &indx[j];
                    g = get_gen(afp, &head, tindx, j);
                    file = (I8s *) malloc(8);
                    sprintf(file, "%04ld%3s", head.size, g->gen.label);
                    WritAscFile(g, file);
                    if (v)
                    {   fprintf(stdout, "x - %04ld%3s %.3f %.3f", g->gen.size,
                            g->gen.label, g->MaxPropPop, g->MaxPropInst);
                        if (IsBit(g->bits,0))
                        {   WritEcoB(g->bits, Buff);
                            fprintf(stdout," 1 %s\n",Buff);
                        }
                        else fprintf(stdout," 0\n");
                    }
                    else fprintf(stdout, "x - %3s\n", g->gen.label);
                    if (file)
                    {   free((void *) file);
                        file = NULL;
                    }
                    if (g)
                    {   if (g->genome)
                        {   free((void *) g->genome);
                            g->genome = NULL;
                        }
                        if (g->gbits)
                        {   free((void *) g->gbits);
                            g->gbits = NULL;
                        }
                        free((void *) g);
                        g = NULL;
                    }
                }
            else
                for (i=0; i<head.n; i++)
                {
                    tindx = &indx[i];
                    g = get_gen(afp, &head, tindx, i);
                    file = (I8s *) malloc(12);
                    sprintf(file, "%04ld%3s", head.size, g->gen.label);
                    WritAscFile(g, file);
                    if (v)
                    {   fprintf(stdout, "x - %04ld%3s %.3f %.3f", g->gen.size,
                            g->gen.label, g->MaxPropPop, g->MaxPropInst);
                        if (IsBit(g->bits,0))
                        {   WritEcoB(g->bits, Buff);
                            fprintf(stdout," 1 %s\n",Buff);
                        }
                        else fprintf(stdout," 0\n");
                    }
                    else fprintf(stdout, "x - %3s\n", g->gen.label);
                    if (file)
                    {   free((void *) file);
                        file = NULL;
                    }
                    if (g)
                    {   if (g->genome)
                        {   free((void *) g->genome);
                            g->genome = NULL;
                        }
                        if (g->gbits)
                        {   free((void *) g->gbits);
                            g->gbits = NULL;
                        }
                        free((void *) g);
                        g = NULL;
                    }
                }
            break;
#if PLOIDY == 1
        case 'e':
      rep[0] = 0 ;
      for (i = 1 ; i < InstNum ; i++)
        for (j = 0 ; j < i ; j++)
          {
        if (strncmp(id[i].mn,id[j].mn,9) == 0)
          {
            rep[i] = j ;
            break ;
          }
        else
          rep[i] = i ;
          }

/*      for (i = 0 ; i < InstNum ; i++)
        printf("inst %2d with mn %9s and op %3d has rep = %d\n",i,id[i].mn,id[i].op,rep[i]) ; */

      for (j = 2 ; j < argc ; j++)
        {
          file = argv[j];
          if (!(afp = fopen(file, "rb")))
        {   perror(argv[0]);
            exit(7);
          }
          head = read_head(afp);
          indx = read_indx(afp, &head);
          sprintf(m, "%4s",head.magic);
          m[4]='\0';  
          for (i = 0; i < head.n; i++)
        {
          tindx = &indx[i];
          g = get_gen(afp, &head, tindx, i);
          if (tindx->d1.BreedTrue)
            {
              sprintf(m,"%3s",tindx->gen);
              fprintf(stdout, "%04ld %.3s %6d ",head.size,m,tindx->mppT.m) ;
              if (tindx->d1.mov_daught == head.size)
            fprintf(stdout, " %6d %6d %6.2f .",
                tindx->d1.mov_daught, 
                tindx->d1.inst,(float) tindx->d1.inst / (float) head.size) ;
              else
            if (tindx->d1.mov_daught != 0)
              fprintf(stdout, " %6d %6d %6.2f *",
                  tindx->d1.mov_daught, tindx->d1.inst,
                  (float) tindx->d1.inst / (float) head.size) ;
            else 
              fprintf(stdout, " %6d %6d %6.2f *",
                  tindx->d1.mov_daught, tindx->d1.inst,0.0) ;
              /* only works if PLOIDY == 1 */
              for (t = 0 ; t < InstNum ; t++)
            hist[t] = 0 ;
              for (t = 0; t < g->gen.size; t++)
            {
              di = g->genome[t];
              hist[rep[id[di].op]]++ ;
            }
              /* only works if PLOIDY == 1 */
              for (t = 0 ; t < InstNum ; t++)
            hist[t] = 0 ;
              for (t = 0; t < g->gen.size; t++)
            {
              di = g->genome[t];
              hist[rep[id[di].op]]++ ;
            }
              h = 0.0 ;
              for (t = 0 ; t < InstNum ; t++)
            if (hist[t])
              {
                p = ((double) hist[t]) / g->gen.size ;
                h += p * log(p) ;
              }
              h /= - log(2.0) ;
              fprintf(stdout, "  %7.3f\n",h) ;
            }
        }
          fclose(afp) ;
        }
            break;
#endif
    }
    return 0;
}
