/* @(#)configur.h       1.1 11/15/94*/
/* configur.h  7-3-96  configurable parameters at compile time */
/* Tierra Simulator V4.3: Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996 */
/* Tom Ray & Virtual Life */
/*
#ifndef lint
static char     sccsid[] = "@(#)configur.h	1.5     7/21/92";
#endif
*/

#include "license.h"

#ifndef CONFIGUR_H
#define CONFIGUR_H
#define VER 4.3

#ifndef TSEEK
#define TSEEK fseek
#endif /* TSEEK */

#ifndef PLOIDY
#define PLOIDY 1
#endif /* PLOIDY */

#define MICRO        /* define for micro step debugging */
#define IO           /* define for buffered input-output */
/* #define NET       */ /* define for network version of tierra */
#define SHADOW
#define READPROT     /* define to implement read protection of soup */ 
#define WRITEPROT    /* define to implement write protection of soup */
#define EXECPROT     /* define to implement execute protection of soup */
/* #define ERROR     */ /* use to include error checking code */
/* #define ALCOMM    */ /* define for socket communications */
/* #define MEM_PROF  */ /* profile dynamic memory usage */
#define HSEX         /* define for haploid, crossover sex */
/* #define KURT      */ /* define for counting executions of only first cpu */

#ifdef NET
#define DYNIPADR     /* define for dynamically assigned ip address */
#endif
#ifdef NET
#ifndef AMIGA
#define SIGBLOCK
#endif /* AMIGA */
/* #define VRML */
#endif /* NET */

#define STACK_SIZE 10
#ifdef SHADOW
#define ALOC_REG 8
#define NUMREG 4         /* NUMREG = ALOC_REG / 2 */
#else /* SHADOW */
#define ALOC_REG 4
#define NUMREG 4         /* NUMREG = ALOC_REG */
#endif /* SHADOW */

/* FRONTEND types: */

#define STDIO     0
#define BASIC     1

#ifndef FRONTEND
#define FRONTEND      BASIC
#endif /* FRONTEND */

/* OPSYS types: */

#define UNIX      0
#define BCDOS     1 /* Dos with Borland C */
#define WATDOS    2 /* Dos with Watcom C */
#define DJGPPDOS  3 /* Dos with DJGPP */
#define MAC       4
#define AMIGADOS  5
#define DECVMS    6

#ifdef __MWERKS__
#ifdef FRONTEND
#undef FRONTEND
#endif
#define FRONTEND  BASIC
#define NET
#define OPSYS     MAC
#define SHELL "noshell"
#endif /* __MWERKS__ */

#ifdef __TURBOC__  /* applies to GUI Windows */
#define OPSYS     BCDOS
#define SHELL "command"
#endif /* __TURBOC__ */

#ifdef __WATCOMC__
#define OPSYS     WATDOS
#define SHELL "command"
#endif /* __WATCOMC__ */

#ifdef DJGPP
#define OPSYS     DJGPPDOS
#define SHELL "command"
#endif /* DJGPP */

#ifdef unix
#define OPSYS     UNIX
#define SHELL "csh"       /* DAN #define SHELL "xterm" */
#endif /* unix */

#ifdef AMIGA
#undef TSEEK
#define TSEEK xseek
#define OPSYS     AMIGADOS
#define SHELL "newshell"
#endif /* AMIGA */

#ifdef DECVAX
#define OPSYS     DECVMS
#define SHELL "spawn"
#endif /* DECVAX */

#ifdef __GUI__  /* Windows 3.1 with WIN32s installed */
#undef FRONTEND
#define FRONTEND BASIC
#endif /* __GUI__ */

/* INTERFACE types: */

#define STDIOU  0  /* stdio frontend with unix */
#define STDIOB  1  /* stdio frontend with Borland C */
#define STDIOW  2  /* stdio frontend with Watcom C */
#define STDIOD  3  /* stdio frontend with DJGPP */
#define STDIOM  4  /* stdio frontend with MetroWerks for the Mac */
#define STDIOA  5  /* stdio frontend with Amiga */
#define STDIOV  6  /* stdio frontend with VAX */

#define BASICC  7  /* basic frontend with Curses */
#define BASICB  8  /* basic frontend with Borland C - applies to GUI Windows */
#define BASICW  9  /* basic frontend with Watcom C */
#define BASICD 10  /* basic frontend with DJGPP */
#define BASICM 11  /* basic frontend with MetroWerks for the Mac */
#define BASICA 12  /* basic frontend with Amiga */
#define BASICV 13  /* basic frontend with VAX */

#ifndef INTERFACE
#define INTERFACE ((FRONTEND * 7) + OPSYS)
#endif /* INTERFACE */

#ifdef ARG
#undef MEM_PROF
#endif /* ARG */

#ifdef ALCOMM
#ifndef AMIGA
#define SIGBLOCK
#endif /* AMIGA */
#endif /* ALCOMM */

/* the following definitions should be provided by the compilers,
	except for IBM3090 which must be manually defined */

/* __MWERKS__   = Metrowerks CodeWarrior for Macintosh and Power Mac */
/* __WATCOMC__  = Watcom C for any platform */
/* __TURBOC__   = Turbo C for DOS */
/* OS2_MC       = Microsoft C for OS/2 */
/* IBM3090      = IBM 3090 the compiler will not define this, do it manually */
/* unix         = for unix systems */
/* __GNUC__     = gcc unix compiler */
/* ANSI         = for ANSI environment */
/* __WIN32__    = 32-bit WIN32s installed in Windows 3.1 */

#endif /* CONFIGUR_H */
