/* @(#)diskbank.c	1.16 2/13/95*/
/* diskbank.c   6-3-96  disk genebank manager for the Tierra Simulator */
/* Tierra Simulator V4.3: Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996 */
/* Tom Ray & Virtual Life */
/* MemProf labels: #04XX, in use: 0400 */
/* FEError labels: #04XX, in use: 0400-403 */

#ifndef lint
static char sccsid[] = "@(#)diskbank.c    1.0        7/21/92";

#endif

#include "license.h"
#include "tierra.h"
#include "globals.h"
#ifdef MON
#include "obs.h"
#include "tmon_global.h"
#endif /* MON */

int Inject(g, size, sad, tol, disk, rrpi)
FpInst  g;     /* pointer to genome */
I32s    size;  /* size of genome */
I32s    sad;   /* suggested address for placement of genome */
I32s    tol;   /* tolerance placement of genome */
I32s    disk;  /* 1 = this genome comes from the disk */
float   *rrpi; /* reap rand prop for injection */
{   float   tReapRndProp = ReapRndProp;
    I32s    j, flag, allocmemptr;
    int errflag;
#if PLOIDY > 1
    I32s    k;
#endif
    Pcells  cp; /* pointer to cell struct where injected creature will go */
    FpInst  si;

    errflag=0;
    if((allocmemptr=MemAlloc(size, sad, tol))>=0){
        cp = GetFreeCell();   /* get a cell structure */
        cp->ld = 1;
        cp->d.gen.size = cp->mm.s = size;
        ReapRndProp = *rrpi;   /* allocate the needed memory */
        cp->mm.p=allocmemptr;
/*
    while ((cp->mm.p = MemAlloc(size, sad, tol)) < 0)
        reaper(1,sad);
 */
    ReapRndProp = tReapRndProp;
    si = cp->d.genome = soup + cp->mm.p;
    for (j = 0; j < cp->c.n; j++)
        cp->c.ar[j].ip = cp->mm.p;
    if (cp == &cells[0][2])
    {   cp->q.p_reap = TopDummy->q.this;
        cp->q.n_reap = BottomDummy->q.this;
        TopDummy->q.n_reap = cp->q.this;
        BottomDummy->q.p_reap = cp->q.this;
    }
    else
    {   EntBotSlicer(cp);
        EntBotReaper(cp);
    }
    cp->d.is = 1;
    for (j = 0; j < size; j++, si++) /* put genome in soup */
#if PLOIDY == 1
        si[0] = mo(g[j], InstNum);
#else  /* PLOIDY == 1 */
        for (k = 0; k < PLOIDY; k++)
            si[0][k] = mo(g[j][k], InstNum);
#endif /* PLOIDY == 1 */

    if (GeneBnker) /* determine genotype, record in genebanker */
    {   cp->d.hash = Hash(cp->d.gen.size,cp->d.genome);
        if (DiskBank) /* new hash due to mutation */
        {   flag = 21;
            if(CumGeneBnk)
                SetBit((I32u *) &flag, 3, ONE);
        }
        else
            flag = 0;
        CheckGenotype(&(cp->d), flag, &siz_sl, &sl); /* check .gen files */
        cp->d.parent = sl[size]->g[cp->d.gi]->parent;
        strcpy(cp->d.gen.label, Int2Lbl(cp->d.gi));

#ifdef NET
        sprintf(Fbuf, "%s: Genome %04ld%3s was injected from %s",
            LocalHostName, cp->d.gen.size, cp->d.gen.label,
            inet_ntoa(client.sin_addr));
        FEPrintf(MSG_X, MSG_Y, 0, 2, Fbuf);
#ifdef MON
        sprintf(MReplyBuf,"Genome %04ld%3s was injected",
						cp->d.gen.size, cp->d.gen.label);
        tmon_make_femessages(Fbuf,strlen(Fbuf));
#endif /* MON */
#endif /* NET */

        DivGenBook(cp, InstExe, reaped, 0, 0, disk);
    }
#ifdef NET
    else
    {   sprintf(Fbuf, "%s: Genome %04ld was injected from %s",
        LocalHostName,cp->d.gen.size,inet_ntoa(client.sin_addr));
        FEPrintf(MSG_X, MSG_Y, 0, 2, Fbuf);
#ifdef MON
        sprintf(MReplyBuf,"Genome %04ld was injected",
						cp->d.gen.size);
        tmon_make_femessages(Fbuf,strlen(Fbuf));
#endif /* MON */
    }
#endif /* NET */

    OutDisk((I32s) 'b', cp);
    LastDiv = InstExe;
#if FRONTEND != STDIO
    FEStats();
#endif /* FRONTEND != STDIO */
    }
    else{
      errflag=1;
    }
    return errflag;
}

I32s InjectFromBank(crit, sad, tol, injectnum)
    I8s     *crit;
    I32s    sad;       /* suggested address for placement of genome */
    I32s    tol;       /* tolerance placement of genome */
    I32s    injectnum; /* number of creatures to be injected */
{
    float  rrpi;
    I32s   size, i, actnuminject;
    GList  *g;
    int loopflag;

    actnuminject=0;
    g = GetAGen(crit);
    if (g == NULL)
        return actnuminject;
    sscanf(crit, "%4ld", &size);
    loopflag=1;
    for(i=0;(i<injectnum)&&(loopflag);i++){
        rrpi=1;
        if(!Inject(g->genome, size, sad, tol, 1, &rrpi)){
            actnuminject++;
            sad+=size;
        }
        else{
            loopflag=0;
        }
    }
    FreeGen(g,0);
    return actnuminject;
}

GList * GetAGen(crit)
    I8s     *crit;
{
    GList  *g;

   if(!(g=GetAGenExt(crit, ".gen"))){
      if(!(g=GetAGenExt(crit, ".tmp"))){
         sprintf(Fbuf, "genome not found");
         FEError(-400, NOEXIT, NOWRITE, Fbuf);
#ifdef MON
         strcpy(MReplyBuf,"genome not found");
#endif /* MON */
      }
   }
   return g;
}

GList * GetAGenExt(crit, ext)
    I8s     *crit, *ext;
{
    I32s    size;
    I16s    n;
    GList   *g = NULL;
    char    cpath[128], gen[4];
    FILE    *fp = NULL;
    head_t  head;
    indx_t  *indx = NULL, *tindx;
#ifndef AMIGA
    indx_t  gindx;
#endif

    sscanf(crit, "%4ld%3s", &size, gen);
    sprintf(cpath, "%s%04ld%s", GenebankPath, size, ext);
    if(fp = open_ar(cpath, size, GFormat, 0))
    {   head = read_head(fp);
        if(indx = read_indx(fp, &head))
        {   if((n = find_gen(indx, gen, head.n)) != head.n)
            {   tindx = &indx[n];
                g = get_gen(fp, &head, tindx, n);
            }
            else
            {   sprintf(Fbuf, "find_gen: genome %s not found", cpath);
                FEError(-403, NOEXIT, NOWRITE, Fbuf);
#ifdef MON
                strcpy(MReplyBuf,Fbuf);
#endif /* MON */
                return NULL;
            }
            thfree((void *) indx, head.n_alloc * sizeof(indx_t), 600);
        }
        fclose(fp);
    }
    else
    {   sprintf(Fbuf, "open_ar: genome %s not found", cpath);
        FEError(-402, NOEXIT, NOWRITE, Fbuf);
#ifdef MON
        strcpy(MReplyBuf,Fbuf);
#endif /* MON */
    }
    return g;
}

void extract(cx, virtual)
Pcells cx;
I32s   virtual;
{   Pgl g;
    FILE *fp;
    head_t head;
    indx_t *indx;
#ifndef AMIGA
    indx_t gindx;
#endif

    if (!DiskBank)
        virtual = 1;
    isolate = 0;
    g = sl[cx->d.gen.size]->g[cx->d.gi];
    if (g->pop)
    {   if (virtual)
            sprintf(ExtrG, "%04ld%s @ %ld v",
                g->gen.size, g->gen.label, (GeneBnker) ? g->pop : 0L);
        else
            sprintf(ExtrG, "%04ld%s @ %ld",
                g->gen.size, g->gen.label, (GeneBnker) ? g->pop : 0L);
#if FRONTEND == STDIO
        sprintf(Fbuf, "extract: %s", ExtrG);
        FEPrintf(MSG_X, MSG_Y, 0, 2, Fbuf);
#endif /* FRONTEND == STDIO */
        if (Log)
            fprintf(tfp_log, "ex = %s\n", ExtrG);
    }
    if (virtual)
        return;

/* open an archive, if it does not exist, create it */

#ifdef IBM3090
    sprintf(Buff, "%04ld.gen.d", cx->d.gen.size);
#else
    sprintf(Buff, "%s%04ld.gen", GenebankPath, cx->d.gen.size);
#endif
    if (!(fp = open_ar(Buff, cx->d.gen.size, GFormat, -1)))
    {   sprintf(Fbuf,
            "Tierra extract() Unable to open extract file %s", Buff);
        FEError(-401, EXIT, NOWRITE, Fbuf);
    }
    head = read_head(fp);
    indx = read_indx(fp, &head);
    add_gen(fp, &head, &indx, g);
    if (indx)
    {   thfree((void *) indx, head.n_alloc * sizeof(indx_t), 600);
        indx = NULL;
    }
    fclose(fp);
    NumGenDG++;
#ifdef MONKIM
    sprintf(MDFEStatsBuf.ExtrG_gen, "%04ld%s", g->gen.size, g->gen.label);
    MDFEStatsBuf.ExtrG_pop = g->pop;
#endif /* MONKIM */
}
