/* @(#)globals.h 1.27 1/30/95*/
/* globals.h   7-3-96  Artificial Life simulator */
/* Tierra Simulator V4.3: Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996 */
/*  Tom Ray & Virtual Life */

/*
 * sccsid: @(#)globals.h 1.38    12/8/91
 */

#include "license.h"

#ifdef ALCOMM
#include <mlayer.h>
#endif /* ALCOMM */

#ifndef EXTERN
#define EXTERN extern
#endif

EXTERN I32s histostrtidx;
EXTERN I32s histoentcnt;
EXTERN I32s histodsplnct;
EXTERN int LINES1;
EXTERN int  COLS1;

#ifdef __GUI__
#ifdef WEXTERN_H
#undef WEXTERN_H
#include <windows.h>
EXTERN HANDLE   hInst ;
EXTERN HWND     hwnd ;
EXTERN UINT     message ;
EXTERN UINT     wParam ;
EXTERN LONG     lParam ;
EXTERN HDC      hdcnew ;
EXTERN PAINTSTRUCT  ps ;
EXTERN FARPROC  lpfnGetStrDlgProc ;
EXTERN short    cxChar, cyChar, nVscrollPos, 
			nHscrollPos, nPaintBeg, nPaintEnd;
EXTERN wScreen  *FEw;
#endif /* WEXTERN_H */
#endif /* __GUI__ */

#ifndef LEXTERN_H
#define LEXTERN_H

#ifdef MEM_PROF
EXTERN MemProfStat  MemStat; /* structure for memory profile statistics */
#endif /* MEM_PROF */

#ifdef NET
EXTERN I8s OpSys;                /* nature of the OS */
EXTERN I8s ConnectedFlg;     /* flag for connection to the net */
#endif /* NET */

EXTERN VarQuer  vqu;    /* structure for variable query */
EXTERN TmpList  tmpl;  /* list of .tmp files */
EXTERN indx_t  GIndx;     /* global index structure */
EXTERN IDRegs IDregs; /* definitions of special registers */
EXTERN I8s  TierraWait;
EXTERN FILE *oufr;
EXTERN HpInst soup;
EXTERN I32s TierraClock; /* clock time at last plan() */
EXTERN I32s Speed; /* difference in TierraClock time between plans() */
EXTERN I32s BitBucket; /* place to dump return values */
EXTERN I32s alive;     /* run simulator alive * 1,000,000 instructions */
EXTERN I32s AverageSize;        /* average size of cells in soup */
EXTERN Pcells BottomDummy; /* dummy cell at bottom of reaper queue */
EXTERN Pcells BottomReap;/* index of cell bottom reaper queue, last to die */
EXTERN I32s BrkupCou;  /* count of output files break.n */
EXTERN I32s BrkupCum;  /* cumulative count of bytes output to break.n */
EXTERN I32s BrkupSiz;  /* size of output files break.n in K */
EXTERN I8s  Fbuf[90]; /* global text buff for FEPrintf & FEError messages */
EXTERN I8s  FGSbuf[90]; /* buff for FEGetStr() */
EXTERN I8s  Buff[120]; /* nice global text buff for all sorts of messages */
EXTERN I8s  Buf85[85]; /* nice global text buff for all sorts of messages */
EXTERN I8s  Buf85a[85]; /* nice global text buff for all sorts of messages */
EXTERN I8s  Buf85b[85]; /* nice global text buff for all sorts of messages */
EXTERN I32s pos; /* file pointer for position in break.X files */
EXTERN I32s CelArSiz; /* size of each cells array */
EXTERN I32s CellsSize; /* number of allocated elements in cells array */
EXTERN I32s CountFlaw; /* counter for flaw random number */
EXTERN I32s CountJmpSou; /* counter for source track jumping */
EXTERN I32s CountMovMut;
EXTERN I32s CountMutRate;
EXTERN I32s CumGeneBnk;    /* Use cumulative gene files, or overwrite */
EXTERN I32s debug;     /* output info to screen for debugging */
EXTERN I32s debug_switch;
EXTERN I32s DiskOut;   /* 0 = no output to disk, 1 = output to disk */
EXTERN Event Disturb;   /* time of disturbance */
EXTERN float DistFreq; /* freq. of disturbance, in multiples of recovery t */
EXTERN Event DistNext;  /* time of next disturbance */
EXTERN float DistProp; /* proportion of cells killed in each disturbance */
EXTERN I32s DivSameSiz;/* 0 = off, 1 = daughter cell must be same size */
EXTERN I32s DivSameGen;/* 0 = off, 1 = daught cell must be same genotype */
EXTERN I32s DropDead;  /* millions instruction since last divide till dead */
EXTERN I32s EjectRate; /* which cells are randomly ejected from soup */
EXTERN CellInd extr;      /* which cell to isolate */
EXTERN I8s ExtrG[20];   /* last geno extracted */
EXTERN I32s ExtractCount;
EXTERN I32s FirstOutDisk;
EXTERN I32s fe_lines;  /* approx hight in chars of screen, default 20 */
EXTERN I32s fe_width;  /* approx width in chars of screen, default 60 */
EXTERN I32s FreeBlocks;/* number of free blocks of memory */
EXTERN I32s DiskBank;    /* turn disk-genebanker on and off */
EXTERN I32s GeneBnker; /* 0 = don't keep track genotyes, 1 = keep track */
EXTERN I32s TGeneBnker; /* 0 = don't keep track genotyes, 1 = keep track */
EXTERN double AvgPop; /* average population over the last million */
EXTERN double Generations; /* elapsed generations (AvgPop/TimeBirth-Death) */
EXTERN I8s **GenInList;/* pointers to soup_in genome names */
EXTERN I8s *GenInBuf;  /* buffer containing soup_in genome names */
EXTERN float GenPerBkgMut;      /* generations per background mutation */
EXTERN float GenPerFlaw;        /* generations per flaw */
EXTERN float GenPerMovMut;      /* generations per move mutation */
EXTERN I32s GFormat; /* select genebank format -1 = first file = format */
EXTERN I8s  GoDown; /* flag to bring system down to defragment memory */
EXTERN I32s hangup; /* 0 = exit on error, 1 = hangup on error, for debugging*/
EXTERN HistType *Hist;       /* pointer to struct for histograms */
EXTERN I32s HistSize; /* Num of elements alloced in Hist */
EXTERN I32s HistAlocSiz; /* allocated size of Hist array, in bytes */
EXTERN float HistNStars; /* ratio of counts to stars */
EXTERN I32s HistPrint; /* boolean to tell us weather to print hists, to log */
EXTERN I8s IMapFile[80];  /* inst map filename, default.map is assumed */
EXTERN I8s IMode;      /* info display (plan,histo_size,histo_geno etc) */
EXTERN InstDef *id;

#ifndef PROBE
EXTERN InstDef idt[];
#endif /* PROBE */

EXTERN Event InstExe;   /* counter of instructions executed */
#ifdef NET
EXTERN Event InstExeConnect; /* counter of instruc executed while connected */
#endif /* NET */
EXTERN PInst is; /* struct for passing info between parse & execute */
EXTERN I32s isolate;   /* isolate the genome of the cell extr */
EXTERN float JmpSouTra; /* source track switches per average size */
EXTERN float JumpTrackProb; /* prob of switching track during a jump of IP */
EXTERN Event LastDiv;   /* instructions executed at last divide */
EXTERN I32s Log;         /* boolean for FE loging */
EXTERN I32s MateSearchL;  /* used with HSEX, see soup_in.h */
EXTERN float MateProb;  /* used with HSEX, see soup_in.h */
EXTERN float MateXoverProp;  /* used with HSEX, see soup_in.h */
EXTERN I32s MateSizeEp;  /* used with HSEX, see soup_in.h */
EXTERN I32s Max_hits;  /* cardinality of most populous size class */
EXTERN I32s MaxCpuPerCell; /* maximum number of CPUs allowed per cell */
EXTERN I32s MaxFreeBlocks; /* number allocated elements in FreeMemry array */
EXTERN I32s MaxIOBufSiz; /* maximum size of IOS buffer */
EXTERN float MaxMalMult;        /* multiple of cell size allowed for mal() */
EXTERN I32s MaxPutBufSiz;  /* maximum size for put IO buffer */
EXTERN I32s MaxGetBufSiz;  /* maximum size for get IO buffer */
EXTERN I32s MaxPop;    /* maximum population of any genotype in soup/GB */
EXTERN unsigned int  MaxSizeT;   /* portable max value for size_t */
EXTERN I32s MaxMemry;  /* maximum memory usage of any genotype in soup/GB */
EXTERN Genotype MaxGenPop; /* genotype with maximum population in soup/GB */
EXTERN Genotype MaxGenMem; /* genotype with maximum memory usage in soup/GB */
EXTERN I32s MemModeFree;  /* unix chmod for when mem is dealloced,  */
EXTERN I32s MemModeMine;  /* unix chmod for when mem is owned by a creature */
EXTERN I32s MemModeProt;  /* chmod when mem is owned by another creature */
EXTERN I32s MalMode; /* 0= first fit, 1= better fit, 2= random preference,
  3= near mother's address, 4= near dx address, 5= near top of stack address*/
EXTERN I32s MalReapTol; /* 1 = reap oldest creature within MalTol */
EXTERN I32s MalSamSiz; /* force memory alloc to be same size as parent */
EXTERN I32s MalTol; /* multiple of avgsize to search for free block */
EXTERN I32s MalLimit;  /* search limit for memory allocation */
EXTERN I32s MinCellSize;        /* minimum cell size */
EXTERN I32s MinTemplSize;       /* minimum template size */
EXTERN float MovPropThrDiv; /* min proportion of daught cell filled by mov */
EXTERN I32s new_soup;  /* 0 = processed soup core, 1 = new soup core */
EXTERN I32s  Nop0;  /* instruct num corresponding to nop0 */
EXTERN I32s  Nop1;  /* instruct num corresponding to nop1 */
EXTERN I32s  NopS;  /* sum of nops */
EXTERN I32s NumCelAr; /* number of cells arrays */
EXTERN I32s NumCells;  /* present number of cells in soup */
EXTERN I32s NumGenDG; /* present # of permanent genotypes saved to disk */
EXTERN I32s NumGenotypes; /* # of genotypes of adult cells extant in soup */
EXTERN I32s NumSizes; /* # of sizes of adult cells extant in soup */
EXTERN I32s PhotonSize;/* number of instructions in photon */
EXTERN I32s PhotonWidth; /* amount by which photons slide to determine fit */
EXTERN I32s RandIx1, RandIx2, RandIx3;  /* for tsrand() */
EXTERN I32s RateFlaw;  /* frequency of flaws */
EXTERN I32s RateJmpSou;
EXTERN I32s RateMovMut;/* 1 / frequency of mutations per mov event */
EXTERN I32s RateMut;   /* number of instructions per mutations */
EXTERN I32s reaped;    /* 0 = reaper has not killed, 1 = reaper has killed */
EXTERN float ReapRndProp; /* rnd prop of top of reaper Q to reap from */
EXTERN I32s SaveFreq;  /* frequency of saving core_out, soup_out and list */
EXTERN I32s SavRenewMem; /* free & renew dynamic memory after save to disk */
EXTERN I32s SigBlockSet;/* mask to block sig int in unix, for certain calls */
EXTERN I32s seed;      /* seed for random number generator */
EXTERN I32s SizDepSlice;  /* 0 = slice constant, 1 = slice size dependent */
EXTERN I32s siz_sl;    /* allocated size of *sl array */
EXTERN I32s SliceSize; /* number of instructions executed in each slice */
EXTERN I32s SliceStyle;/* select style of allocating slice size */
EXTERN I8s soup_fn[85];/* place for soup_in filename */
EXTERN I32s SoupBot;   /* index FreeMemry struct for bottom of soup memory */
EXTERN I32s SoupTop;   /* index of FreeMemry struct for top of soup memory */
EXTERN FILE *tfp_log; /* file pointer for log */
EXTERN I8s  TC_Menu;       /* flag unix sigint, to do a menu */
EXTERN Pcells ce; /* cell that is currently active, formerly ThisSlice */
EXTERN Event TimeStats;/* time of last calculation of stats */
EXTERN I32s TimeBirth; /* count of births in each million instruction */
EXTERN I32s TimeDeath; /* count of deaths in each million instruction */
EXTERN I32s TimeGenIndiv;/* cpu cycles per replication, on average */
EXTERN double TimePop; /* sum of ttime * NumCells for each million */
EXTERN Pcells TopDummy; /* dummy cell at top of reaper queue */
EXTERN Pcells TopReap;   /* cell at top reaper queue, next to die */
EXTERN I32s TotFlaw;   /* total number of flaws in this run */
EXTERN I32s TotMovMut; /* total number of move mutations in this run */
EXTERN I32s TotMut;    /* total number of background mutations in this run */
EXTERN I32s WatchExe;  /* mark executed instructions in genome in genebank */
EXTERN I32s WatchMov;  /* set mov bits in genome in genebank */
EXTERN I32s WatchTem;  /* set template bits in genome in genebank */
EXTERN I8s GenebankPath[80];    /* path for genebank */
EXTERN I8s OutPath[80];   /* path for disk output */
EXTERN I8s PhotonWord[80];      /* alphabetic representation of photon */
EXTERN Instruction PhotonInst[80];/* instructional representation of photon */
EXTERN I32s FreeMemCurrent;     /* current amount of free memory in soup */
EXTERN float SearchLimit; /* limit on search, as multiple of average size */
EXTERN I32s Search_limit; /* limit how far address instructions will search */
EXTERN float PutLimit; /* distance for intercellular communication */
EXTERN I32s Put_limit; /* limit on intercellular communications distance */
EXTERN I32s SoupSize;  /* size of soup memory, measured in instructions */
EXTERN Pcells Fp cells;  /* cells array */
EXTERN SList **sl; /* list of size classes for genebanker */
EXTERN Pmf FreeMemry;    /* free memory array */
EXTERN double PhotonPow;        /* power for photon match slice size */
EXTERN double SlicePow;/* power for size dependent slice */
EXTERN double TrandArray[98];   /* for trand() */
EXTERN I32s  SavMinNum; /* minimum number of individuals to save genotype */
EXTERN float SavThrMem; /* thresh memory prop. to save genotype */
EXTERN float SavThrPop; /* thresh population prop. to save genotype */
EXTERN float SlicFixFrac;       /* fixed fraction of slice size */
EXTERN float SlicRanFrac;       /* random fraction of slice size */
EXTERN LastOut lo;      /* last data output to disk */
EXTERN void (*slicer) ();
EXTERN I16s InstNum;    /* number of instructions in set */
EXTERN I16s InstBitNum; /* number of bits in instructions */
EXTERN I16s FE_DV_Mode;

#ifdef ALCOMM
EXTERN I16s           AL_run_flag;
EXTERN I16s           VPORT;
#endif /* ALCOMM */
EXTERN I32s MAX_species_SIZ;/* Maximum number of query_species for Size histogram */
EXTERN I32s MAX_species_GEN;/* Maximum number of query_species for Gene histogram */
EXTERN I32s MAX_species_MEM;/* Maximum number of query_species for Memory histogram */
EXTERN I32s M_tvWait_sec; /* time out for select in OV mode (sec.) */
EXTERN I32s M_OV_threshold; /* Threshold for time out in OV mode */

EXTERN I8u MSG_X ;
EXTERN I8u MSG_Y ;
EXTERN I8u ERR_X ;
EXTERN I8u ERR_Y ;
EXTERN I8u PLN_X ;
EXTERN I8u PLN_Y ;
EXTERN I8u HLP_X ;
EXTERN I8u HLP_Y ;

#ifdef MICRO
EXTERN I32s MC_step;
EXTERN I32s soupviewstrt;
EXTERN I8s dbgdisptype;
#endif

EXTERN BrkTrapCond BrkTrapCondBuf;

#if OPSYS == MAC
EXTERN MenuHandle appleMenu;
#if INTERFACE == BASICM
EXTERN int      LINES;
EXTERN int      COLS;
EXTERN WindowPeek       wp;
EXTERN FontInfo         fontInfo;
EXTERN short            rowHeight;
#endif /* INTERFACE == BASICM */
#endif /* OPSYS == MAC */

#ifdef NET
EXTERN I8s * inet_ntoa();
EXTERN I8s * getenv();
EXTERN struct hostent * gethostbyaddr();
EXTERN I16s MessageLen; /* Message length */
EXTERN I8s map_fn[40];  /* mapfile for Internet */
EXTERN MapNode *IPMap;  /* list of remote Tierra nodes on the Internet */
EXTERN I16u NumNodes;
EXTERN I32s TierraNice;/* Nice value for cpu */
EXTERN I32s clilen;
EXTERN struct sockaddr_in client;
EXTERN struct hostent *LocalHost;
EXTERN struct in_addr LocalHostAddr;
EXTERN NetAddr LocalNetAddr;
EXTERN I8s LocalHostName[NAMBUFSIZ];
EXTERN I16u LocalPort;
EXTERN I16s CellSockUDP; /* UDP Socket for internet comm between Cells */
EXTERN I16s CellSockTCP; /* TCP Socket for internet comm between Cells */
EXTERN I16s MonSockUDP; /* UDP Socket for Network Monitor */
EXTERN I16s MonSockTCP; /* TCP Socket for Network Monitor */
#ifndef MON
EXTERN MonSock MonSockTCP_ID[64];/* Multiple TCP Socket for Network Monitor */
EXTERN I16s SuMonFlg;    /* Flag for if SU Monitor is exit(=1) or not(=0) */
EXTERN I16s MonTCPNid;   /* Number of used MonSockTCP_ID */
#endif /* MON */
EXTERN I32s Nfds;        /* Number of descriptors */
EXTERN fd_set Afds, Rfds, Wfds, Efds;
EXTERN struct timeval tvWait; /* time out for select */
EXTERN I16u MonPort;  /* Port Number of Network Monitor */
EXTERN I8s  RecvBuf[2048];
EXTERN I16s RecvLength;
EXTERN struct sockaddr_in remot;
EXTERN I16u RemotPort;
EXTERN I32s remotlen;
EXTERN I16s SendLength;
EXTERN I8s *SendBuf;
EXTERN I8s *RemotHostName;
EXTERN I8s *RemotHostAddr;
EXTERN I16s NetWriteSoupFlg;
#ifdef __MWERKS__
EXTERN I8s MacHost[80];
EXTERN I8s MacSite[80];
#endif /* __MWERKS__ */
#endif /* NET */


#ifdef SIGBLOCK

EXTERN I32s SigSet;

#endif /* SIGBLOCK */

#endif /* LEXTERN_H */
