/* @(#)instruct.c       1.34 2/13/95*/
/* instruct.c  7-3-96  instruction set for the Tierra Simulator */
/* Tierra Simulator V4.3: Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996 */
/* Tom Ray & Virtual Life */
/* MemProf labels: #07XX, in use: 0700-0705 */
/* FEError labels: #07XX, in use: 0706-0720 */

#ifndef lint
static char sccsid[] = "@(#)instruct.c    1.22     9/19/91";
#endif

#include "license.h"
#include "tierra.h"
#include "globals.h"

#ifdef MON
#include "obs.h"
#include "tmon_global.h"
#endif /* MON */

#ifdef ALCOMM
#include "tmonitor.h"
#include "trequest.h"
#endif /* ALCOMM */

void DoRPNd()
{   I16s  i;

    if (ce->c.d->idf.P)
        for (i = 1; i < NUMREG - 1; i++)
            ce->c.c->re[i] = ce->c.c->re[i + 1] + flaw();
}

void DoRPNu()
{   I16s  i;

    if (ce->c.d->idf.P)
        for (i = NUMREG - 1; i > 0; i--)
            ce->c.c->re[i] = ce->c.c->re[i - 1] + flaw();
}

void DoFlags()
{   ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
    if (*(is.dreg) == 0)
        ce->c.c->fl.Z = 1;
    if (*(is.dreg) < 0)
        ce->c.c->fl.S = 1;
}

void DoMods()
{   if (is.dmod)
    {   *(is.dreg) = mo(*(is.dreg), is.dmod);
        is.dmod = 0;
    }
    else if (is.dran && (*(is.dreg) > is.dran || *(is.dreg) < -is.dran))
    {   *(is.dreg) = 0;
        is.dran = 0;
    }
}

void DoMods2()
{   if (is.dmod2)
    {   *(is.dreg2) = mo(*(is.dreg2), is.dmod2);
        is.dmod2 = 0;
    }
    else if (is.dran2 && (*(is.dreg2) > is.dran2 || *(is.dreg2) < -is.dran2))
    {   *(is.dreg2) = 0;
        is.dran2 = 0;
    }
}

void DoMods3()
{   if (is.dmod3)
    {   *(is.dreg3) = mo(*(is.dreg3), is.dmod3);
        is.dmod3 = 0;
    }
    else if (is.dran3 && (*(is.dreg3) > is.dran3 || *(is.dreg3) < -is.dran3))
    {   *(is.dreg3) = 0;
        is.dran3 = 0;
    }
}

/* takes no arguments, returns no values (except clears flag) */
void nop() /* no operation */
{   ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0; }

#ifdef SHADOW

/* void regorder() adjust register order
 * is.sval  = the number of the register that will go to the top
 */
void regorder() /* adjust register order */
{   pushst();
    ce->c.c->re[NUMREG] = is.sval;
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

void pushst() /* called by regorder() */
{   I16s  i;

    for (i = (2 * NUMREG) - 1; i > NUMREG; i--)
        ce->c.c->re[i] = ce->c.c->re[i - 1];
}

#endif /* SHADOW */

/* takes no arguments, returns no values (except clears flag) */
void rollu()
{   I32s  tvar;
    I16s  i;

    tvar = ce->c.c->re[i = NUMREG - 1] + flaw();
    for (; i > 0; i--)
        ce->c.c->re[i] = ce->c.c->re[i - 1] + flaw();
    ce->c.c->re[0] = tvar;
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

/* takes no arguments, returns no values (except clears flag) */
void rolld()
{   I32s  tvar;
    I16s  i;

    tvar = ce->c.c->re[0] + flaw();
    for (i = 0; i < NUMREG - 1; i++)
        ce->c.c->re[i] = ce->c.c->re[i + 1] + flaw();
    ce->c.c->re[NUMREG - 1] = tvar;
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

/* takes no arguments, returns no values (except clears flag) */
void enter()
{
#ifndef AMIGA
    I32s  tvar;
#endif /* AMIGA */
    I16s  i;

    for (i = NUMREG - 1; i > 0; i--)
        ce->c.c->re[i] = ce->c.c->re[i - 1] + flaw();
    ce->c.c->re[0] += flaw();
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

/* takes no arguments, returns no values (except clears flag) */
void exch()
{   *(is.dreg) = is.sval2;
    DoMods();
    *(is.dreg2) = is.sval;
    DoMods2();
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

/* void not() *(is.dreg) = ~(is.sval) + flaw();
 * is.dreg = destination register
 * is.sval = value whose bits will be flipped and put in dest reg
 * is.dmod = value by which to modulus destination register
 * is.dran = range within which to contain destination register
 */
void not() /* flip all bits of destination register */
{   *(is.dreg) = ~(is.sval) + flaw();
    DoMods();
    DoFlags();
}

#ifdef FUTURE

/* BEGIN GLOBAL INTER-PROCESSOR COMMUNICATIONS */

void bcs() /* broadcast send */
{
}

void bcr() /* broadcast receive */
{
}

void bsu() /* broadcast sum */
{
}

void togpar() /* toggle participation */
{
}

void gloor() /* global or */
{
}

void pscan() /* plus scan of cpus */
{
}

/* END GLOBAL INTER-PROCESSOR COMMUNICATIONS */

/* BEGIN POINT TO POINT INTER-PROCESSOR COMMUNICATIONS */

void ppsend() /* send IOS data to specific other processor */
{
}

void ppreceive() /* receive IOS data to specific other processor */
{
}

void setag() /* set tag, otherwise, tag is -1 */
{
}

void setsrc() /* set processor to receive from, -1 means any proc */
{
}

void setdst() /* set processor to send to */
{
}

void ifsfl() /* if send flag is set, do next inst, otherwise skip */
{
}

/* END POINT TO POINT INTER-PROCESSOR COMMUNICATIONS */

#endif /* FUTURE */

#ifdef NET

/* BEGIN NETWORK COMMUNICATIONS */

IOS * GetFreeIOS(cp) /* find an IOS to write incoming message to */
Pcells  cp;
{   I16s  i, nio;

    if (!cp->c.io.siz) /* if no buffer, make buffer */
    {   cp->c.io.siz = 2;
        cp->c.io.nio = 1;
        cp->c.io.io = (IOS *) tcalloc((I32u) 2, (I32u) sizeof(IOS), 700);
    }
    if (cp->c.io.siz < 2) /* there is an output struct, but no input buffer */
    {   cp->c.io.io = (IOS *) trecalloc((void *) cp->c.io.io,
            2 * sizeof(IOS), cp->c.io.siz * sizeof(IOS), 700);
        cp->c.io.siz = 2;
    }
    for (i = 0, nio = cp->c.io.nio; i < (cp->c.io.siz - 1); i++)
    {   if (!cp->c.io.io[nio].t) /* if tag = 0 struct is free for use */
        {   memset((char *) &(cp->c.io.io[nio]), 0, sizeof(IOS));
            return &(cp->c.io.io[nio]);
        }
        nio++;
        if (nio >= cp->c.io.siz)
            nio = 1; /* note: 0 struct is used for output, not input */
    } /* note: MaxIOBufSiz counts both input and output structs */
    if (cp->c.io.siz < MaxIOBufSiz)
    {   cp->c.io.io = (IOS *) trecalloc((void *) cp->c.io.io,
            (cp->c.io.siz + 1) * sizeof(IOS), cp->c.io.siz * sizeof(IOS), 700);
    /* this loop moves the input buffers above nio to the end of the array */
    /* so that we put the fresh struct where nio points ? */
        for (i = cp->c.io.siz; i > cp->c.io.nio; i--)
            cp->c.io.io[i] = cp->c.io.io[i - 1];
        ++(cp->c.io.siz);
    }
    memset((char *) &(cp->c.io.io[cp->c.io.nio]), 0, sizeof(IOS));
    return &(cp->c.io.io[cp->c.io.nio]);
}

IOS * GetIOSOut(cp) /* get address of IOS output structure */
Pcells  cp;
{   if (!cp->c.io.siz) /* if no buffer, make buffer */
    {   cp->c.io.siz = 1;
        cp->c.io.io = (IOS *) tcalloc((I32u) 1, (I32u) sizeof(IOS), 700);
    }
    return cp->c.io.io;
}

IOS * GetTagIOS(cp, tag) /* find next IOS with specified tag, to read */
Pcells  cp;
I32s    tag;
{   I16s  i, nio;

    if (cp->c.io.siz < 2)
    return NULL;
    for (i = 0, nio = cp->c.io.nio; i < (cp->c.io.siz - 1); i++)
    {   if (cp->c.io.io[nio].t == tag)
            return &(cp->c.io.io[nio]);
        nio++;
        if (nio >= cp->c.io.siz)
            nio = 1; /* note: 0 struct is used for output, not input */
    }
    return NULL;
}

void IncrIOSnio(cp) /* increment cp->c.io.nio with funky modulus */
Pcells  cp;
{   (cp->c.io.nio)++;
    if (cp->c.io.nio >= cp->c.io.siz)
        cp->c.io.nio = 1; /* note: 0 struct is used for output, not input */
}

I8s ReadIOS(cp, tag, dest) /* copy data from IOS buffer to soup */
Pcells  cp;                /* returns 1 on success, 0 on failure */
I32s    tag;  /* tag for type of message to be read */
I32s    dest; /* address in soup where data will be written */
{   IOS *  ios;
    I8u *  buf;
    I8s    ok = 1;
    I32s   i;

    ios = GetTagIOS(cp, tag);
    if (ios == NULL)
        return 0;
    /* create char buffer, copy tag, source address and data to buffer */
    /* tag = 4, source address = 20, data = 4 + len bytes */
    buf = (I8u *) tcalloc(28 + ios->d.len, sizeof(I8u), 701);
    *((I32s *) (buf +  0)) = ios->t;
    *((I32u *) (buf +  4)) = ios->s.address.node;
    *((I32s *) (buf +  8)) = ios->s.address.portnb;
    *((I32s *) (buf + 12)) = ios->s.soup;
    *((I32s *) (buf + 16)) = ios->s.cellID;
    *((I32s *) (buf + 20)) = ios->s.ranID;
    *((I32s *) (buf + 24)) = ios->d.len;
    memcpy(buf + 28, ios->d.d, ios->d.len);
    for (i = 0; i < (28 + ios->d.len); i++)
    {   if (PrivWrite(cp, dest + i))
            *((I8u *) (soup + dest + i)) = *((I8u *) (ios->d.d + i));
        else
        {   ok = 0;
            break;
        }
    }
    tfree(buf, (28 + ios->d.len) * sizeof(I8u), 701);
    InitIOS(ios);
    return ok;
}

I8s WriteIOS(cp, sou) /* copy data from soup to IOS buffer */
Pcells  cp;
I32s    sou; /* address in soup where data will be copied from */
{   IOS *  ios;
    I8u *  buf = (I8u *) soup + sou;
#ifndef AMIGA
    I32s   i;
#endif

    ios = GetIOSOut(cp);
    InitIOS(ios);
    /* tag = 4, source address = 20, data = 4 + len bytes */
    if (!PrivReadRange(cp, sou +  0, sou +  3))
        goto failure;
    ios->t =        *((I32s *) (buf +  0));
    if (!PrivReadRange(cp, sou +  4, sou +  7))
        goto failure;
    ios->s.address.node =   *((I32u *) (buf +  4));
    if (!PrivReadRange(cp, sou +  8, sou + 11))
        goto failure;
    ios->s.address.portnb = *((I32s *) (buf +  8));
    if (!PrivReadRange(cp, sou + 12, sou + 15))
        goto failure;
    ios->s.soup =   *((I32s *) (buf + 12));
    if (!PrivReadRange(cp, sou + 16, sou + 19))
        goto failure;
    ios->s.cellID = *((I32s *) (buf + 16));
    if (!PrivReadRange(cp, sou + 20, sou + 23))
        goto failure;
    ios->s.ranID =  *((I32s *) (buf + 20));
    if (!PrivReadRange(cp, sou + 24, sou + 27))
        goto failure;
    ios->d.len =    *((I32s *) (buf + 24));
    if (!PrivReadRange(cp, sou + 28, sou + 28 + ios->d.len))
        goto failure;
    ios->d.d = (I8s *) tcalloc(ios->d.len, sizeof(I8s), 702);
    memcpy(ios->d.d, buf + 28, ios->d.len);
    return 1;
    failure:
    InitIOS(ios);
    return 0;
}

void InitIOS(ios) /* initialize IOS structure */
IOS *  ios;
{
    ios->t = 0;
    ios->e.address.node = ios->s.address.node = 0;
    ios->e.address.portnb = ios->e.soup = ios->e.cellID = ios->e.ranID = 0;
    ios->s.address.portnb = ios->s.soup = ios->s.cellID = ios->s.ranID = 0;
    if (ios->d.d)
        tfree(ios->d.d, ios->d.len * sizeof(I8s), 702);
    ios->d.d = NULL;
    ios->d.len = 0;
}

/* END NETWORK COMMUNICATIONS */

#endif /* NET */

#ifdef IO

/* Preg GetFreeGetBuf(cp) find get buf reg to write incoming message to
 * cp->c.pg.pb[cp->c.pg.gsiz]     == index of next output value to be read
 * cp->c.pg.pb[cp->c.pg.gsiz + 1] == index of next output value to be written
 */
Preg GetFreeGetBuf(cp) /* find get buf reg to write incoming message to */
Pcells  cp;
{   I16s  i, npg, siz = cp->c.pg.gsiz;

    if (!siz) /* if no buffer, make buffer */
    {   cp->c.pg.gsiz = 1;
        cp->c.pg.gb = (Preg) tcalloc(3, sizeof(Reg), 703);
        return cp->c.pg.gb;
    }
    npg = cp->c.pg.gb[siz + 1]; /* index of next put location */
    if (npg < siz) /* next location is within allocated buffer */
        return &(cp->c.pg.gb[npg]);
    if (npg >= MaxGetBufSiz)
        FEError(-706,EXIT,NOWRITE,
            "Tierra GetFreeGetBuf() error in npg value");
    cp->c.pg.gb = (Preg) trecalloc((void *) cp->c.pg.gb,
        (siz + 3) * sizeof(Reg), (siz + 2) * sizeof(Reg), 703);
    for (i = siz + 2; i > siz; i--)
        cp->c.pg.gb[i] = cp->c.pg.gb[i - 1];
    siz = ++(cp->c.pg.gsiz);
    if (npg >= siz)
        FEError(-707,EXIT,NOWRITE,
            "Tierra GetFreeGetBuf() error 2 in npg value");
    return &(cp->c.pg.gb[npg]);
}

/* Preg GetFreePutBuf(cp)  find put buf reg to write incoming message to
 * cp->c.pg.pb[cp->c.pg.psiz]     == index of next output value to be read
 * cp->c.pg.pb[cp->c.pg.psiz + 1] == index of next output value to be written
 */
Preg GetFreePutBuf(cp) /* find put buf reg to write incoming message to */
Pcells  cp;
{   I16s  i, npg, siz = cp->c.pg.psiz;

    if (!siz) /* if no buffer, make buffer */
    {   cp->c.pg.psiz = 1;
        cp->c.pg.pb = (Preg) tcalloc(3, sizeof(Reg), 704);
        return cp->c.pg.pb;
    }
    npg = cp->c.pg.pb[siz + 1]; /* index of next put location */
    if (npg < siz) /* next location is within allocated buffer */
        return &(cp->c.pg.pb[npg]);
    if (npg >= MaxPutBufSiz)
        FEError(-708,EXIT,NOWRITE,
            "Tierra GetFreePutBuf() error in npg value");
    cp->c.pg.pb = (Preg) trecalloc((void *) cp->c.pg.pb,
        (siz + 3) * sizeof(Reg), (siz + 2) * sizeof(Reg), 704);
    for (i = siz + 2; i > siz; i--)
        cp->c.pg.pb[i] = cp->c.pg.pb[i - 1];
    siz = ++(cp->c.pg.psiz);
    if (npg >= siz)
        FEError(-709,EXIT,NOWRITE,
            "Tierra GetFreePutBuf() error 2 in npg value");
    return &(cp->c.pg.pb[npg]);
}

/* void put() write a value to the output buffer (prayer)
 * ce->c.pg.pb[ce->c.pg.psiz]     == index of next output value to be read
 * ce->c.pg.pb[ce->c.pg.psiz + 1] == index of next output value to be written
 *
 * is.dreg = destination "register" in the put buffer
 * is.sval = value to be placed in the dest reg
 * is.dmod = value by which to modulus destination register
 * is.dran = range within which to contain destination register
 */
void put() /* write a value to the output buffer (prayer) */
{   I16s  ri = ce->c.pg.psiz;     /*  read index */
    I16s  wi = ce->c.pg.psiz + 1; /* write index */

    if (is.dreg == &BitBucket)
    {   ce->c.c->fl.E = 1;
        return;
    }
    movdd();
    if ((ce->c.pg.psiz > 1) && (ce->c.pg.pb[wi] == ce->c.pg.pb[ri]))
        ce->c.pg.pb[ri] = ++(ce->c.pg.pb[ri]) % MaxGetBufSiz;
    ce->c.pg.pb[wi] = ++(ce->c.pg.pb[wi]) % MaxPutBufSiz;
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

/* void put() write a value to the output buffer
 * ce->c.pg.pb[ce->c.pg.psiz]     == index of next output value to be read
 * ce->c.pg.pb[ce->c.pg.psiz + 1] == index of next output value to be written
 *
 * is.dcel  = destination cell, in whose buffer the value will be put
 * is.dreg  = destination "register" in the put buffer
 * is.dval3 = destination for address returned by adr()
 * is.mode3 = 0 = broadcast to other cells' get buffer
 *            1 = write to other cell's get buffer
 *
 * void adr() find address of a template
 * is.mode  = search mode: 1 = forward, 2 = backward, 0 = outward
 * is.mode2 =  preference: 1 = forward, 2 = backward, and return for
 *        direction found: 1 = forward, 2 = backward, 3 = both, 0 = none
 * is.dval  = starting address for forward search
 * is.dval2 = starting address for backward search
 * is.dreg  = destination register where target address will be stored
 * is.dreg2 = destination register where template size will be stored
 * is.dreg3 = destination register where offset of target will be stored
 * is.sval  = return address if template size = 0
 * is.sval2 = template size, 0 = no template
 * is.sval3 = search limit, and return for distance actually searched
 * is.dmod  = modulus value for is.dreg
 * is.dmod2 = modulus value for is.dreg2
 * is.dmod3 = modulus value for is.dreg3
 */
void puticc() /* write a value to the output buffer */
{   Pcells  dc = is.dcel;
    I32s    ta, lpl = Put_limit;
    I8s     tmode2 = is.mode2;

    if (is.dreg == &BitBucket)
    {   ce->c.c->fl.E = 1;
        return;
    }
    if (is.mode3) /* write to other cell's get buffer */
        Write2Get(dc, is.sval);
    else
    {   adr();
        if (!ce->c.c->fl.E) do /* broadcast to other cells' get buffer */
        {   if (is.mode2 == 1 || is.mode2 == 3)
            {   ta = is.dval - 1;
                if (is.dcel = FindPutCell(ce, ad(ta)))
                {   Write2Get(is.dcel, is.sval);
                }
            }
            if (is.mode2 == 2 || is.mode2 == 3)
            {   ta = is.dval2 - 1;
                if (is.dcel = FindPutCell(ce, ad(ta)))
                {   Write2Get(is.dcel, is.sval);
                }
            }
            is.mode2 = tmode2;
            lpl -= is.sval3;
            is.sval3 = lpl;
            is.dval++; is.dval2--;
            adr();
        } while (!ce->c.c->fl.E);
    }
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

Pcells FindPutCell(cp, adre)
Pcells  cp;
I32s    adre;
{   Pcells  lcp;
    I8s     md;

#if PLOIDY == 1
    if(strcmp(id[soup[adre]].mn, "get")
#else /* PLOIDY > 1 */
    if(strcmp(id[soup[adre][cp->c.c->ex]].mn, "get")
#endif /* PLOIDY > 1 */
        || adre < 0 || adre >= SoupSize || IsFree(adre))
        lcp = NULL;
    else
        WhichCell(adre, &lcp, &md);
    return lcp;
}

/* I8s ReadFPut(cp, value)  for god to read the data in the output buffer
 * cp->c.pg.pb[cp->c.pg.psiz]     == index of next output value to be read
 * cp->c.pg.pb[cp->c.pg.psiz + 1] == index of next output value to be written
 */
I8s ReadFPut(cp, value) /* for god to read the data in the output buffer */
Pcells  cp;
I32s    *value;
{   I16s  ri, wi;

    ri = cp->c.pg.psiz;
    wi = ri + 1;
    if (cp->c.pg.pb[ri] == cp->c.pg.pb[wi])
        return 0;
    *value = cp->c.pg.pb[cp->c.pg.pb[ri]];
    cp->c.pg.pb[ri] = ++(cp->c.pg.pb[ri]) % ri;
    return 1;
}

/* void get() read a value from the input buffer
 * ce->c.pg.gb[ce->c.pg.gsiz]     == index to next input value to be read
 * ce->c.pg.gb[ce->c.pg.gsiz + 1] == index to next input value to be written
 *
 * also specify the values used by movdd():
 * is.dreg = destination register, where moved value will be placed
 * is.sval = value to be placed in the dest reg
 * is.dmod = value by which to modulus destination register
 *
 * Note: As long as anything has ever been written to the get buffer,
 * we are allowed to read.  This may cause the re-reading of old data.
 *
 */
void get() /* read a value from the input buffer */
{   I16s  ri = ce->c.pg.gsiz;     /*  read index */

    if (!ri) /* there is no buffer */
    {   ce->c.c->fl.E = 1;
        return;
    }
    movdd();
    ce->c.pg.gb[ri] = ++(ce->c.pg.gb[ri]) % MaxGetBufSiz;
    DoFlags();
}

/* void Write2Get(cp, value)  place value in input buffer of cell cp
 * cp->c.pg.pb[cp->c.pg.gsiz]     == index of next output value to be read
 * cp->c.pg.pb[cp->c.pg.gsiz + 1] == index of next output value to be written
 */
void Write2Get(cp, value) /* place value in input buffer of cell cp */
Pcells  cp;
I32s    value;
{   Preg  greg;
    I16s  ri, wi;

    greg = GetFreeGetBuf(cp);
    *greg = value;
    ri = cp->c.pg.gsiz;     /*  read index */
    wi = cp->c.pg.gsiz + 1; /* write index */
    if ((cp->c.pg.gsiz > 1) && (cp->c.pg.gb[wi] == cp->c.pg.gb[ri]))
    cp->c.pg.gb[ri] = ++(cp->c.pg.gb[ri]) % MaxGetBufSiz;
    cp->c.pg.gb[wi] = ++(cp->c.pg.gb[wi]) % MaxGetBufSiz;
}


void Broad2Get(value) /* broadcast value to input buffer of all cells */
I32s  value;
{   Pcells  tce = ce;

    do
    {   Write2Get(tce, value);
        tce = &cells[tce->q.n_time.a][tce->q.n_time.i];
    } while (tce != tce);
}

#endif /* IO */

void clrf() /* clear all Cpu.Flags */
{   ce->c.c->fl.E = ce->c.c->fl.S  = ce->c.c->fl.Z =
    ce->c.c->fl.B = ce->c.c->fl.D = 0;
}

void clrfi() /* clear Cpu.Flags associated with CPU cycles */
{   ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

void clrrf() /* clear all Cpu.CRflags */
{   ce->c.c->cf.Se.t = 0;
    ce->c.c->cf.Se.i = IDregs.Se.r[0];
    ce->c.c->cf.De.t = 0;
    ce->c.c->cf.De.i = IDregs.De.r[0];
    ce->c.c->cf.So.t = 0;
    ce->c.c->cf.So.i = IDregs.So.r[0];
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

void tbf() /* toggle bits flag */
{   ce->c.c->fl.B = (ce->c.c->fl.B)++ % 3;
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

void tdf() /* toggle direction flag */
{   (ce->c.c->fl.D)++;
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

void ter() /* toggle segment registers */
{   ++(ce->c.c->cf.Se.t);
    ce->c.c->cf.Se.t %= IDregs.Se.n;
    ce->c.c->cf.Se.i = IDregs.Se.r[ce->c.c->cf.Se.t];
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

void tdr() /* toggle destination registers */
{   ++(ce->c.c->cf.De.t);
    ce->c.c->cf.De.t %= IDregs.De.n;
    ce->c.c->cf.De.i = IDregs.De.r[ce->c.c->cf.De.t];
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

void tsr() /* toggle source registers */
{   ++(ce->c.c->cf.So.t);
    ce->c.c->cf.So.t %= IDregs.So.n;
    ce->c.c->cf.So.i = IDregs.So.r[ce->c.c->cf.So.t];
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

/* void not0() *(is.dreg) ^= (1 + flaw());
 * is.dreg = destination register, whose bit will be flipped
 * is.dmod = value by which to modulus destination register
 * is.dran = range within which to contain destination register
 */
void not0() /* flip low order bit of destination register */
{   *(is.dreg) ^= (1 + flaw());
    DoMods();
    DoFlags();
}

/* void shl() *(is.dreg) <<= (Reg) (1 + flaw());
 * is.dreg = destination register, whose bits will be shifted left
 * is.dmod = value by which to modulus destination register
 * is.dran = range within which to contain destination register
 */
void shl() /* shift left all bits in register */
{   *(is.dreg) <<= (Reg) (1 + flaw());
    DoMods();
    DoFlags();
}

/* void shr() *(is.dreg) >>= (Reg) (1 + flaw());
 * is.dreg = destination register, whose bits will be shifted right
 * is.dmod = value by which to modulus destination register
 * is.dran = range within which to contain destination register
 */
void shr() /* shift right all bits in register */
{   *(is.dreg) >>= (Reg) (1 + flaw());
    DoMods();
    DoFlags();
}

/* void skip() if (is.sval) is.iip = 1 else is.iip = is.sval2 = 2;
 * is.sval  = value to test
 * is.sval2 = amount to increment IP (2) if is.sval == 0
 * is.iip   = amount to increment IP (1) if is.sval == 1
 */
void skip() /* execute or skip next instruction, if is.sval == 0 */
{   if (!(is.sval))       
        is.iip = is.sval2; /* is.sval2 = 2 to skip next instruction */
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

/* void split() create a new processor
 * is.sval = source value for processor number
 * is.dreg = destination register for old processor number
 * is.dval = destination register # for new processor number
 */
void split() /* create a new processor */
{   Cpu   *ncpu;

    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
    if (ce->c.n >= MaxCpuPerCell)
    {   ce->c.c->fl.E = 1;
        return;
    }
    ce->c.ar = (Cpu *) trecalloc((void *) (ce->c.ar),
        (I32u) sizeof(Cpu) * (I32u) (ce->c.n + 1),
        (I32u) sizeof(Cpu) * (I32u) ce->c.n, 1902);
    ++(ce->c.n);
#ifndef OLD
    if ((!ce->d.flaw && !ce->d.mut) && (ce->d.max_cpus < ce->c.n))
        ce->d.max_cpus = ce->c.n ;
#endif /* OLD */
    ncpu = &(ce->c.ar[ce->c.n - 1]);
    ce->c.c = &(ce->c.ar[ce->c.ac]);
    *(ncpu) = *(ce->c.c);
    (ncpu->ip)++;
    ncpu->ip = ad(ncpu->ip);
    *(is.dreg) = is.sval * 2;
#ifdef SHADOW
    ncpu->re[ncpu->re[NUMREG + is.dval]] = (is.sval * 2) + 1;
#else /* SHADOW */
    ncpu->re[is.dval] = (is.sval * 2) + 1;
#endif /* SHADOW */
#ifdef MICRO
    if (BrkTrapCondBuf.curbrkdat.MicroCpu)
        BrkTrapCondBuf.curbrkdat.MicroCpu =
      &(ce->c.ar[BrkTrapCondBuf.curbrkdat.MicroCpuI]);
#endif /* MICRO */
}

void csync() /* synchronize cpus within a cell */
{   I16s  i;

    if (!(ce->c.c->sync) && !(ce->c.sync))
    {   ce->c.c->sync = 1;
        ce->c.sync = ce->c.n - 1;
    }
    else if (!(ce->c.c->sync) && ce->c.sync)
    {   (ce->c.sync)--;
        if (ce->c.sync)
            ce->c.c->sync = 1;
        else for (i = 0; i < ce->c.n; i++)
            ce->c.ar[i].sync = 0;
    }
    else if (ce->c.c->sync && !(ce->c.sync))
        ce->c.c->sync = 0;
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

void join() /* destroy a cpu */
{   I16s  i, j;
    Cpu   *cpu;

    if (!(ce->c.ac))        /* you are cpu 0 */
    {   ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
        if (ce->c.n == 1) /* there is only one cpu, so you are finished */
        {   TierraWait = 0;
            return;
        }
        if (ce->c.n > 1) /* must wait */
        {   TierraWait = 1;
            return;
        }
#ifdef ERROR
    FEError(-710,EXIT,WRITE, "Tierra join() error: ce->c.n < 1");
#endif /* ERROR */
    }
#ifdef MICRO
    if (ce->c.c == BrkTrapCondBuf.curbrkdat.MicroCpu)
        BrkTrapCondBuf.curbrkdat.MicroCpu = NULL;
#endif /* MICRO */
    cpu = ce->c.ar;
#ifdef ERROR
    if (ce->c.n <= 1)
        FEError(-711,EXIT,WRITE, "Tierra join() error: ce->c.n <= 1");
#endif /* ERROR */
    ce->c.ar = (Cpu *) tcalloc((I32u) (ce->c.n - 1), (I32u) sizeof(Cpu),1902);
    for (i = 0, j = 0; i < ce->c.n - 1; i++, j++)
    {   if (i == ce->c.ac)
        j++;
        ce->c.ar[i] = cpu[j];
#ifdef MICRO
        if ((cpu + j) == BrkTrapCondBuf.curbrkdat.MicroCpu)
        {   BrkTrapCondBuf.curbrkdat.MicroCpu = &(ce->c.ar[i]);
            BrkTrapCondBuf.curbrkdat.MicroCpuI = i;
        }
#endif /* MICRO */
    }
    tfree((void *) cpu, ce->c.n * sizeof(Cpu), 1902);
    --(ce->c.n);
    TierraWait = 1;
}

/* void add() *(is.dreg) = is.sval + is.sval2;
 * is.dreg  = destination register, where calculation will be stored
 * is.sval  = a value that will be added to is.sval2 and placed in dest reg
 * is.sval2 = a value that will be added to is.sval  and placed in dest reg
 * is.dmod  = value by which to modulus destination register
 * is.dran  = range within which to contain destination register
 */
void add() /* add (subtract) two numbers and store them in a register */
{   *(is.dreg) = is.sval + is.sval2;
    DoMods();
    DoFlags();
    DoRPNd();
}

/* void mul() *(is.dreg) = is.sval * is.sval2;
 * is.dreg  = destination register, where calculation will be stored
 * is.sval  = value that will be multiplied by is.sval2 and placed in dest reg
 * is.sval2 = value that will be multiplied by is.sval  and placed in dest reg
 * is.dmod  = value by which to modulus destination register
 * is.dran  = range within which to contain destination register
 */
void mul() /* multiply two numbers and store them in a register */
{   *(is.dreg) = is.sval * is.sval2;
    DoMods();
    DoFlags();
    DoRPNd();
}

/* void idiv() *(is.dreg) = is.sval / is.sval2;
 * is.dreg  = destination register, where calculation will be stored
 * is.sval  = value that will be divided by is.sval2 and placed in dest reg
 * is.sval2 = value that will be divided into is.sval and placed in dest reg
 * is.dmod  = value by which to modulus destination register
 * is.dran  = range within which to contain destination register
 */
void idiv() /* divide two numbers and store them in a register */
{   if (!is.sval2)
    {   ce->c.c->fl.E = 1;
        return;
    }
    *(is.dreg) = is.sval / is.sval2;
    DoMods();
    DoFlags();
    DoRPNd();
}

/* void and() *(is.dreg) = is.sval & is.sval2;
 * is.dreg  = destination register, where calculation will be stored
 * is.sval  = value that will be anded by is.sval2 and placed in dest reg
 * is.sval2 = value that will be anded into is.sval and placed in dest reg
 * is.dmod  = value by which to modulus destination register
 * is.dran  = range within which to contain destination register
 */
void and() /* bitwise and two numbers and store them in a register */
{   if (!is.sval2)
    {   ce->c.c->fl.E = 1;
        return;
    }
    *(is.dreg) = is.sval & is.sval2;
    DoMods();
    DoFlags();
    DoRPNd();
}

/* void ior() *(is.dreg) = is.sval | is.sval2;
 * is.dreg  = destination register, where calculation will be stored
 * is.sval  = value that will be ored by is.sval2 and placed in dest reg
 * is.sval2 = value that will be ored into is.sval and placed in dest reg
 * is.dmod  = value by which to modulus destination register
 * is.dran  = range within which to contain destination register
 */
void ior() /* bitwise inclusive or two numbers and store them in register */
{   if (!is.sval2)
    {   ce->c.c->fl.E = 1;
        return;
    }
    *(is.dreg) = is.sval | is.sval2;
    DoMods();
    DoFlags();
    DoRPNd();
}

/* void xor() *(is.dreg) = is.sval ^ is.sval2;
 * is.dreg  = destination register, where calculation will be stored
 * is.sval  = value that will be ored by is.sval2 and placed in dest reg
 * is.sval2 = value that will be ored into is.sval and placed in dest reg
 * is.dmod  = value by which to modulus destination register
 * is.dran  = range within which to contain destination register
 */
void xor() /* bitwise exclusive or two numbers and store them in register */
{   if (!is.sval2)
    {   ce->c.c->fl.E = 1;
        return;
    }
    *(is.dreg) = is.sval ^ is.sval2;
    DoMods();
    DoFlags();
    DoRPNd();
}

/* void offset() *(is.dreg) = is.sval + (is.sval2 * is.sval3) + flaw();
 * is.dreg  = destination register, where calculation will be stored
 * is.sval  = will be added to (is.sval2 * is.sval3) and placed in dest reg
 * is.sval2 = will be multiplied by is.sval3, and added to is.sval
 * is.sval3 = will be multiplied by is.sval2, and added to is.sval
 * is.dmod  = value by which to modulus destination register
 * is.dran  = range within which to contain destination register
 *
 * multiply two numbers, add them to another,
 * and store them in a register
 */
void offset()
{   *(is.dreg) = is.sval + (is.sval2 * is.sval3) + flaw();
    DoMods();
    DoFlags();
}

/* void push() ce->c.c->sp = ++ce->c.c->sp % STACK_SIZE;
 *               ce->c.c->st[ce->c.c->sp] = is.sval + flaw();
 * is.sval = value to be pushed onto the stack
 */
void push() /* push a value onto the stack */
{   ce->c.c->sp = ++ce->c.c->sp % STACK_SIZE;
    ce->c.c->st[ce->c.c->sp] = is.sval + flaw();
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

/* void pop() *(is.dreg) = ce->c.c->st[ce->c.c->sp] + flaw();
 *        if (!ce->c.c->sp) ce->c.c->sp = STACK_SIZE - 1; else --ce->c.c->sp;
 * is.dreg = destination register, where value popped off stack will go
 * is.dmod = value by which to modulus destination register
 * is.dran = range within which to contain destination register
 */
void pop() /* pop a value from the stack into a register */
{   DoRPNu();
    *(is.dreg) = ce->c.c->st[ce->c.c->sp] + flaw();
    if (!ce->c.c->sp)
        ce->c.c->sp = STACK_SIZE - 1; /* decr stack pointer */
    else
        --ce->c.c->sp;
    DoMods();
    DoFlags();
#if PLOIDY > 1
    JumpTrack();
#endif /* PLOIDY > 1 */
}

/* void adr() find address of a template
 * is.mode  = search mode: 1 = forward, 2 = backward, 0 = outward
 * is.mode2 =  preference: 1 = forward, 2 = backward, and return for
 *        direction found: 1 = forward, 2 = backward, 3 = both, 0 = none
 * is.dval  = starting address for forward search
 * is.dval2 = starting address for backward search
 * is.dreg  = destination register where target address will be stored
 * is.dreg2 = destination register where template size will be stored
 * is.dreg3 = destination register where offset of target will be stored
 * is.sval  = return address if template size = 0
 * is.sval2 = template size, 0 = no template
 * is.sval3 = search limit, and return for distance actually searched
 * is.dmod  = modulus value for is.dreg
 * is.dmod2 = modulus value for is.dreg2
 * is.dmod3 = modulus value for is.dreg3
 * is.dran  = range to maintain for is.dreg
 * is.dran2 = range to maintain for is.dreg2
 * is.dran3 = range to maintain for is.dreg3
 */
/* void push()
 * is.sval = value to be pushed onto the stack
 */
void tcall() /* call template */
{   adr();
    push();
}

/* specify the values used by movdd():
 * is.dreg = destination register, where moved value will be placed
 * is.sval = value to be placed in the dest reg
 * is.dmod = value by which to modulus destination register
 * is.dran = range within which to contain destination register
 */
/* void push()
 * is.sval = value to be pushed onto the stack
 */
void call() /* call address */
{   movdd();
    push();
}

/* void mov() move some data
 * is.mode = form of mov to use
 * see specific movs below for other passed values
 */
void mov() /* move some data */
{   switch (is.mode)
    {   case 0: movdd(); break; /*   direct destination,   direct source */
        case 1: movdi(); break; /*   direct destination, indirect source */
        case 2: movid(); break; /* indirect destination,   direct source */
        case 3: movii(); break; /* indirect destination, indirect source */
    }
}

/* void movdd() *(is.dreg) = is.sval + flaw();
 * is.dreg = destination register, where moved value will be placed
 * is.sval = value to be placed in the dest reg
 * is.dmod = value by which to modulus destination register
 * is.dran = range within which to contain destination register
 */
void movdd() /* inter-register mov */
{   DoRPNu();
    *(is.dreg) = is.sval + flaw();
    DoMods();
    DoFlags();
}

/* void movid() *(is.dins) = is.sval + flaw();
 * is.dval  = address of destination instruction
 * is.dins  = pointer to destination instruction
 * is.sval  = value to be moved to destination instruction
 * is.sval2 = original value of destination instruction
 * is.dtra  = track of destination instruction
 */
void movid() /* move from register to soup, e.g.: soup [R0] = R1 */
{   I8s   *i8;
    I16s  *i16;
    I32s  *i32;

    if ((0 <= is.dval && is.dval < SoupSize)
#ifdef WRITEPROT
        && PrivWrite(ce, is.dval)
#endif /* WRITEPROT */
        )
    {   switch (ce->c.d->mn[5])
        {   case 0: /* movid() */
            {   if (ce->c.d->idf.B)
                {   switch (ce->c.c->fl.B)
                    {   case 0: goto bits32;
                        case 1: goto bits16;
                        case 2: goto bits8;
                    }
                }
                *(is.dins) = is.sval + flaw();
                break;
            }
            case '8': /* movid8() */
            {   bits8:
                i8 = (I8s *) is.dins;
                *(i8) = is.sval + flaw();
                break;
            }
            case '1': /* movid16() */
            {   bits16:
                i16 = (I16s *) is.dins;
                *(i16) = is.sval + flaw();
                break;
            }
            case '3': /* movid32() */
            {   bits32:
                i32 = (I32s *) is.dins;
                *(i32) = is.sval + flaw();
                break;
            }
        }
        ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
        if (is.dval >= ce->md.p && is.dval < ce->md.p + ce->md.s)
            ce->d.mov_daught++;
        else if (GeneBnker && *(is.dins) != is.sval2)
            MutBookeep(is.dval);
    }
    else ce->c.c->fl.E = 1;
}

/* void movdi() *(is.dreg) = *(is.sins) + flaw();
 * is.sins = pointer to source instruction
 * is.sval = address of source instruction
 * is.dreg = destination register, where moved value will be placed
 * is.dmod = value by which to modulus destination register
 * is.dran = range within which to contain destination register
 * is.stra  = track of source instruction
 */
void movdi() /* move from soup to register, e.g.: R0 = soup [R1] */
{   I8s   *i8;
    I16s  *i16;
    I32s  *i32;

#ifdef READPROT
    if (PrivRead(ce, is.dval))
#endif /* READPROT */
    {   switch (ce->c.d->mn[5])
        {   case 0: /* movdi() */
            {   if (ce->c.d->idf.B)
                {   switch (ce->c.c->fl.B)
                    {   case 0: goto bits32;
                        case 1: goto bits16;
                        case 2: goto bits8;
                    }
                }
                *(is.dreg) = *(is.sins) + flaw();
                break;
            }
            case '8': /* movdi8() */
            {   bits8:
                i8 = (I8s *) is.sins;
                *(is.dreg) = *(i8) + flaw();
                break;
            }
            case '1': /* movdi16() */
            {   bits16:
                i16 = (I16s *) is.sins;
                *(is.dreg) = *(i16) + flaw();
                break;
            }
            case '3': /* movdi32() */
            {   bits32:
                i32 = (I32s *) is.sins;
                *(is.dreg) = *(i32) + flaw();
                break;
            }
        }
        DoFlags();
        DoMods();
    }
#ifdef READPROT
    else
    {   ce->c.c->fl.E = 1;
        return;
    }
#endif /* READPROT */
}

/* void movii() *(is.dins) = *(is.sins);
 * is.dval  = address of destination instruction
 * is.dins  = pointer to destination instruction
 * is.sval  = address of source instruction
 * is.sins  = pointer to source instruction
 * is.dtra  = track of destination instruction
 * is.stra  = track of source instruction
 * is.sval2 = original value of destination instruction
 */
void movii() /* move data from soup to soup, e.g.: soup [R0] = soup [R1] */
{
#ifndef AMIGA
    I8s  ttr;
#endif /* AMIGA */

    if ((is.dval != is.sval)
#ifdef WRITEPROT
        && PrivWrite(ce, is.dval)
#endif /* WRITEPROT */
#ifdef READPROT
        && PrivRead(ce, is.dval)
#endif /* READPROT */
        && (0 <= is.dval && is.dval < SoupSize)
        && (0 <= is.sval && is.sval < SoupSize))
    {   
        *(is.dins) = *(is.sins);
        if (RateMovMut && ++CountMovMut >= RateMovMut)
        {   mut_site(soup + ad(is.dval), is.dtra);
            CountMovMut = tlrand() % RateMovMut;
            TotMovMut++;
        }
#if PLOIDY > 1
        if (RateJmpSou && ++CountJmpSou >= RateJmpSou)
        {
#if PLOIDY == 2
            ce->c.c->so = !(ce->c.c->so);
#else /* PLOIDY == 2 */
            {   ttr = ce->c.c->so;
                do
                {   ce->c.c->so = (I8s) tcrand() % PLOIDY;
                }   while (ce->c.c->so == ttr);
            }
#endif /* PLOIDY == 2 */
            CountJmpSou = tlrand() % RateJmpSou;
        }
#endif /* PLOIDY > 1 */
        if (GeneBnker && WatchMov)
            GenExMov(is.dval, is.sval);
        if (is.dval >= ce->md.p && is.dval < ce->md.p + ce->md.s)
            ce->d.mov_daught++;
        else if (GeneBnker && *(is.dins) != is.sval2)
            MutBookeep(is.dval);
        ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
#ifdef ALCOMM
        if ( MIsDFEnabled( TrtMVEvent ) )
            TMoveD( ce->mm.p,is.sval,is.dval);
#endif /* ALCOMM */
    }
    else ce->c.c->fl.E = 1;
}

/* void adr() find address of a template
 * is.mode  = search mode: 1 = forward, 2 = backward, 0 = outward
 * is.mode2 =  preference: 1 = forward, 2 = backward, and return for
 *        direction found: 1 = forward, 2 = backward, 3 = both, 0 = none
 * is.dval  = starting address for forward search
 *                and return for finish address
 * is.dval2 = starting address for backward search
 *                and return for finish address
 * is.dreg  = destination register where target address will be stored
 * is.dreg2 = destination register where template size will be stored
 * is.dreg3 = destination register where offset of target will be stored
 * is.sval  = return address if template size = 0
 * is.sval2 = template size, 0 = no template
 * is.sval3 = search limit, and return for distance actually searched
 * is.dmod  = modulus value for is.dreg
 * is.dmod2 = modulus value for is.dreg2
 * is.dmod3 = modulus value for is.dreg3
 * is.dran  = range to maintain for is.dreg
 * is.dran2 = range to maintain for is.dreg2
 * is.dran3 = range to maintain for is.dreg3
 */
void adr() /* find address of a template */
{   I32s adrt, tval;

    if (!is.sval2)
    {   *(is.dreg) = is.sval;   /* source template missing */
        return;
    }
    if (ce->c.d->idf.P)
    {   tval = 3 + flaw();
        ce->c.c->re[mo(tval, NUMREG)] = ce->c.c->re[0] + flaw();
    }
    if (!is.mode)                 /* outward search */
        adrt = ctemplate(&is.dval, &is.dval2, &is.sval3, &is.mode2, is.sval2,
            'o');
    else if (is.mode == 1)        /* forward search */
        adrt = ctemplate(&is.dval, &is.dval2, &is.sval3, &is.mode2, is.sval2,
            'f');
    else if (is.mode == 2)        /* backward search */
        adrt = ctemplate(&is.dval, &is.dval2, &is.sval3, &is.mode2, is.sval2,
            'b');
    if (adrt < 0)                 /* target template not found */
    {   is.iip = is.sval2 + 1;    /* skip IP over source template */
        ce->c.c->fl.E = 1;
        return;
    }
    *(is.dreg3) = is.sval3;
    DoMods3();
    *(is.dreg2) = is.sval2;
    DoMods2();
    *(is.dreg) = adrt;
    DoMods();
#if PLOIDY > 1
    JumpTrack();
#endif /* PLOIDY > 1 */

    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
    return;
}

/* void malchm() allocate space and protect it
 * is.dreg  = destination register where allocated address is stored
 * is.sval  = requested size of block for mal()
 * is.sval2 = flawed size of block
 * is.sval3 = suggested address, and allocated address
 * is.mode  = memory protection mode (rwx), probably MemModeProt
 * is.mode2 = memory allocation mode for mal()
 */
void malchm() /* allocate space and protect it */
{   /* is.sval = requested size of block, is.sval2 = flawed size of block */
    /* is.sval3 = suggested address, & returned address */
    /* is.dreg = location of block, is.mode2 = allocation style */

    DoRPNu();
    if (is.sval < MinCellSize)
    {   ce->c.c->fl.E = 1;
        return ;
    }
    if (!(is.sval2 = mal(&(is.sval3),is.sval,is.mode2)))
    {   ce->c.c->fl.E = 1;
        return ;
    }
    *(is.dreg) = is.sval3;

    /* is.sval3 = location of chmoded block */
    /* is.sval2 = size of chmoded block */
    /* is.mode  = chmod mode, unix notation, e.g. 7 = full protection */

    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
#ifdef HSEX
    if (DoMate())
       SetXover(ce);
    else
       ce->d.x_over_addr = ce->d.mate_addr = 0;
#endif /* ifdef HSEX */
}

/* void divide() cell division
 * is.sval  = offset of IP into daughter's genome
 * is.sval2 = eject genome from soup = 0, 1 = leave in soup
 * is.mode  = divide mode (3 steps)
 */
void divide() /* cell division */
{   Pcells nc;           /* pointer to the new cell */
    I32s  i;
#ifndef AMIGA
    I32s  j;
#endif /* AMIGA */
    I16s  cpu;

    if (ce->md.s < MinCellSize ||
        ce->d.mov_daught < (I32s) (ce->md.s * MovPropThrDiv * PLOIDY))
    {   ce->c.c->fl.E = 1;
        return;
    }
    if (DivSameSiz)
    {   if (ce->mm.s != ce->md.s)
        {   ce->c.c->fl.E = 1;
            return;
        }
        if (DivSameGen &&
            !IsSameGen(ce->mm.s, soup + ce->md.p, soup + ce->mm.p))
        {   ce->c.c->fl.E = 1;
            return;
        }
    }

    if (EjectRate && !(tlrand() % EjectRate))
    {
#ifdef NET
        if ( NumNodes != 0 )
        {   NEject(ce->md.p, ce->md.s, RandIP()); 
#else /* NET */
        {   NEject(ce->md.p, ce->md.s, 0); 
#endif /* NET */
            MemDealloc(ce->md.p, ce->md.s);
            ce->d.mov_daught = 0;
            ce->d.fecundity++;
            ce->md.s = ce->md.p = 0;
        }
    }
    else switch (is.mode)
    {   case 0:           /* create cpu */
        {   if ((ce->d.ne.a == ce->q.this.a) && (ce->d.ne.i == ce->q.this.i))
            /* if there is no cpu (first call to div 0) */
            {   nc = GetFreeCell();
                nc->ld = 1;
                nc->mm = ce->md;
                nc->d.dm = 1;
                nc->d.genome = soup + nc->mm.p;
                ce->d.ne = nc->q.this;
                for (cpu = 0; cpu < nc->c.n; cpu++)
                {   nc->c.c = &(nc->c.ar[cpu]);
                    nc->c.c->ip = nc->mm.p;
                    if (!(ce->c.d->idf.C))
                    {   nc->c.c->ip += mo(is.sval, nc->mm.s);
                        nc->c.c->ip = ad(nc->c.c->ip);
                        for (i = 0; i < NUMREG; i++)
                            nc->c.c->re[i] = ce->c.c->re[i];
                    }
                }
            }
            else      /* if there is a cpu (second call to div 0) */
            {   nc = &cells[ce->d.ne.a][ce->d.ne.i];
                if (nc->d.is)   /* call to div 0 after call to div 1 */
                {   RmvFrmSlicer(nc);
                    nc->d.is = 0;
                }
                else     /* two sequential calls to div 0, error */
                {   ce->c.c->fl.E = 1;
                    return;
                }
            }
            break;
        }
        case 1:           /* start cpu */
        {   if ((ce->d.ne.a == ce->q.this.a) && (ce->d.ne.i == ce->q.this.i))
            /* if there is no cpu, div 1 before div 0 */
            {   nc = GetFreeCell();
                nc->ld = 1;
                nc->mm = ce->md;
                nc->d.dm = 1;
                nc->d.genome = soup + nc->mm.p;
                ce->d.ne = nc->q.this;
                for (cpu = 0; cpu < nc->c.n; cpu++)
                {   nc->c.c = &(nc->c.ar[cpu]);
                    nc->c.c->ip = nc->mm.p;
                    if (!(ce->c.d->idf.C))
                    {   nc->c.c->ip += mo(is.sval, nc->mm.s);
                        nc->c.c->ip = ad(nc->c.c->ip);
                        for (i = 0; i < NUMREG; i++)
                            nc->c.c->re[i] = ce->c.c->re[i];
                    }
                }
            }
            else     /* if there is already a cpu, make pointers to it */
                nc = &cells[ce->d.ne.a][ce->d.ne.i];
            if (nc->d.is) /* 2nd call to div 1, cpu is already started */
            {   RmvFrmSlicer(nc);
                nc->d.is = 0;
            }
            else    /* not 2nd call to div 1, cpu is not already started */
            {   EntBotSlicer(nc);
                nc->d.is = 1;
            }
            break;
        }
        case 2: /* split cells */
        {   if ((ce->d.ne.a == ce->q.this.a) && (ce->d.ne.i == ce->q.this.i))
            /* if there is no cpu, div 2 before div 0 */
            {   nc = GetFreeCell();
                nc->ld = 1;
                nc->mm = ce->md;
                nc->d.genome = soup + nc->mm.p;
                for (cpu = 0; cpu < nc->c.n; cpu++)
                {   nc->c.c = &(nc->c.ar[cpu]);
                    nc->c.c->ip = nc->mm.p;
                    if (!(ce->c.d->idf.C))
                    {   nc->c.c->ip += mo(is.sval, nc->mm.s);
                        nc->c.c->ip = ad(nc->c.c->ip);
                        for (i = 0; i < NUMREG; i++)
                            nc->c.c->re[i] = ce->c.c->re[i];
                    }
                }
            }
            else
                nc = &cells[ce->d.ne.a][ce->d.ne.i];
            if (!nc->d.is)   /* no slicer, div 2 before div 1 */
            {   EntBotSlicer(nc);
                nc->d.is = 1;
            }
            ce->md.s = ce->md.p = 0;
            ce->d.ne = ce->q.this; /* clean up if div 0 or 1 before 2 */
            nc->d.dm = 0;
            EntBotReaper(nc);
            DownReperIf(ce);
            DivideBookeep(ce, nc);
        }
    } /* switch */
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

/* void migrate()
 * is.sval = IP address of the remote node to which creature is to be sent
 */
void migrate()
{   Pcells  nc;

#ifdef NET
    NEject(ce->mm.p, ce->mm.s, ChooseIP(is.sval));
#else  /* NET */
    NEject(ce->mm.p, ce->mm.s, 0);
#endif /* NET */

    if(ce->mm.s) /* cleanup mother memory */
    {
#ifdef ERROR
        if(ce->mm.p < 0 || ce->mm.p >= SoupSize)
        {   FEError(-714,EXIT,WRITE,
"Tierra reaper() error 2: attempt to deallocate mother memory not in soup");
        }
#endif
        MemDealloc(ce->mm.p,ce->mm.s);
    }
    if(ce->md.s && (ce->md.p > -1)) /* cleanup daughter, if there is one */
    {
#ifdef ERROR
        if(ce->md.p < 0 || ce->md.p >= SoupSize)
        {   FEError(-715,EXIT,WRITE,
"Tierra reaper() error 3: attempt to deallocate daughter memory not in soup");
        }
#endif
        if(ce->d.ne.a != ce->q.this.a || ce->d.ne.i != ce->q.this.i)
            /* cleanup daughter cpu */
        {   nc = &cells[ce->d.ne.a][ce->d.ne.i];
            if(nc->d.is) /* cleanup daughter instruction pointer */
                RmvFrmSlicer(nc);
            NumCells--;
            InitCell(nc->q.this.a, nc->q.this.i, nc);
        }
        MemDealloc(ce->md.p,ce->md.s);
    }
/* START: I don't understand this code! */
    if(ce->md.s && ce->md.p == -1)
    {   if (ce->d.genome)
            ce->d.genome = soup + ce->mm.p;
    }
/* END: I don't understand this code! */
    is.ts = 0;        /* get mom out of the queues */
    nc = ce;
    DecrSliceQueue();
    RmvFrmSlicer(nc);
    RmvFrmReaper(nc);
    ReapBookeep(nc);
}

#ifdef NET

/* void tpingsnd() 
 * is.sval = IP address of the remote node to which the ping is to be sent
 */
void tpingsnd() /* send a tping */
{   ComAddr cell_addr;

    SelfID(ce, &cell_addr);          /* fill in the source cell address */
    TPing_send(is.sval, &cell_addr);  /* send the tping */
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

/* void tpingrec()
 * is.dreg = points to location in soup where data will be written
 */
void tpingrec() /* receive a tping response */
{
    if (ReadIOS(ce, TPINGREPTAG, *(is.dreg)))
        ce->c.c->fl.E = 0;
    else
        ce->c.c->fl.E = 1;
    ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

/* void getip()
 * is.dreg = the register where the IP address will be placed
 */
void getip() /* get an IP address from the map file */
{
    *(is.dreg) = ReadIPMap(ce);
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

I32u ReadIPMap(ce)
Pcells  ce;
{   if (ce->c.io.ipi >= NumNodes)
        return (I32u) (ce->c.io.ipi = 0);
    return (I32u) (IPMap[(ce->c.io.ipi)++].address.node);
}

#endif /* NET */


void NEject(gen, siz, index)
I32s  gen;
I32s  siz;
I32s  index;
{   I32s  i;
#if PLOIDY > 1
    I32s  j;
#endif /* PLOIDY > 1 */
    FpInst  p = soup + gen;
#ifdef NET
#ifndef AMIGA
    FILE *fp;
    I32s SigSaveSet;
#endif /* AMIGA */
    I32s len,Sendlen;
    I8s *SendingBuf;
    XDR xdrs;
    TMessage mesg;
    I32s overhead;
#endif /* NET */

#ifdef ERROR
    if (!siz)
        FEError(-716,EXIT,WRITE, "Tierra NEject() error: size = 0");
    if (gen < 0 || gen + siz > SoupSize)
    {   sprintf(Fbuf,
            "Tierra NEject() error: genome gen: %ld siz: %ld not in soup",
            siz, gen);
        FEError(-717, EXIT, WRITE, Fbuf);
    }
#endif /* ERROR */

#ifdef NET                              /* WARNING: to be modified along */
    overhead = 4 +  sizeof(NetAddr) + sizeof(TPingData);     /* with XDR */
    MessageLen = 4*siz + overhead;                /*structures: overhead */
    SendingBuf = tcalloc(4*SoupSize+overhead,sizeof(I8s),705);

    mesg.info.tag = EMIGRATETAG;
    mesg.info.Data_u.Creature.source.node = LocalHostAddr.s_addr;
    mesg.info.Data_u.Creature.source.portnb = LocalPort;
    mesg.info.Data_u.Creature.genome.genome_len = siz;
    mesg.info.Data_u.Creature.genome.genome_val = (I8s *)p;
    mesg.PingData.TransitTime = 0;
    GetTPingData(&mesg.PingData);
#ifdef SIGBLOCK
    SigSaveSet=TSigBlock(SigSet);
#endif /* SIGBLOCK */
    xdrmem_create(&xdrs,SendingBuf,4*SoupSize+overhead,XDR_ENCODE);
    if (!xdr_TMessage(&xdrs,&mesg))
        FEPrintf(MSG_X, MSG_Y, 0, 2, "XDR encode error");
    len = xdr_getpos(&xdrs);
    memset((char *) &remot, 0, sizeof(remot));
    if (Remot_from_IPMap(index) == 0)      /* read address info from IPMap */
    {   if ((Sendlen = sendto(CellSockUDP, SendingBuf, len, 0,
            (struct sockaddr*)&remot, remotlen)) != len)
        FEPrintf(MSG_X, MSG_Y, 0, 2, "sendto error for NEject()");
        else
        {   if (GeneBnker)
            {   sprintf(Fbuf, "%s:Send Genome %04ld%3s to %s",
                LocalHostName, siz, "---", inet_ntoa(remot.sin_addr));
            }
            else
            {   sprintf(Fbuf, "%s:Send Genome %04ld to %s", LocalHostName,
                siz, inet_ntoa(remot.sin_addr));
            }
            FEPrintf(MSG_X, MSG_Y, 0, 2, Fbuf);
#ifdef MON
            tmon_make_femessages(Fbuf,strlen(Fbuf));
#endif /* MON */
        }
    }
    tfree(SendingBuf,MessageLen,705);
    xdr_destroy(&xdrs);
#ifdef SIGBLOCK
    (void)TSigRelease(SigSaveSet);
#endif /* SIGBLOCK */
#endif /* NET */

/* write genome ejection function here */

/* the following code erases the genome from the soup */

    for (i = 0; i < siz; i++)
#if PLOIDY == 1
        p[i] = tcrand() % InstNum;
#else /* PLOIDY == 1 */
        for (j = 0; j < PLOIDY; j++)
            p[i][j] = tcrand() % InstNum;
#endif /* PLOIDY == 1 */
}

Pcells GetFreeCell()
{   Pcells fc;
    I32s       i, j, found = 0;

    if (++NumCells > CellsSize - 2)
        CheckCells();
    for (i = 0; i < NumCelAr; i++)  /* find unoccupied cell struct */
    {   for (j = 0; j < CelArSiz; j++)
        {
#ifdef ERROR
            if (i * j >= CellsSize)
                FEError(-718,EXIT,WRITE, 
                    "Tierra GetFreeCell() error, exiting");
#endif
            if(!cells[i][j].ld)
            {   found = 1;
                fc = &cells[i][j];
                break;
            }
        }
        if (found)
            break;
    }
    InitCell(i, j, fc);
    return fc;
}

void CheckCells() /* check and adjust memory allocation if necessary */
{   I32s j;

#ifndef AMIGA
    Pcells Fp  tcells;
#endif

#ifdef ERROR
    sprintf(Fbuf, "in_div CheckCells: recalloc, NumCells = %ld", NumCells);
    sprintf(Buff, "    old CellsSize = %ld  ", CellsSize);
    FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);
#endif /* ERROR */

    NumCelAr++;
    cells = (Pcells Fp) trecalloc((void *) cells,
    (I32u) sizeof(Pcells) * (I32u) NumCelAr,
    (I32u) sizeof(Pcells) * (I32u) (NumCelAr - 1), 1900);
    CellsSize = NumCelAr * CelArSiz;
    cells[NumCelAr - 1] = (Pcells) tcalloc(CelArSiz, sizeof(TCell), 1901);

#ifdef ERROR
#ifdef __TURBOC__
    sprintf(Fbuf, "%s new CellsSize = %ld", Buff, CellsSize);
    FEPrintf(MSG_X, MSG_Y + 1, 0, 0, Fbuf);
#ifndef __GUI__
    sprintf(Fbuf, "coreleft = %lu  divide (cells)", coreleft());
    FEPrintf(MSG_X, MSG_Y + 2, 0, 2, Fbuf);
#endif /* __GUI__ */
#else /* __TURBOC__ */
    sprintf(Fbuf, "%s new CellsSize = %ld", Buff, CellsSize);
    FEPrintf(MSG_X, MSG_Y + 1, 0, 2, Fbuf);
#endif /* __TURBOC__ */
#endif /* ERROR */

    for (j = 0; j < CelArSiz; j++)
        InitCell(NumCelAr - 1, j, &cells[NumCelAr - 1][j]);
}

I32s flaw()
{   CountFlaw++;
    if (RateFlaw && CountFlaw >= RateFlaw)
    {   CountFlaw = tlrand() % RateFlaw;
        TotFlaw++;
        ce->d.flaw++;
        if (tcrand() % 2)
            return 1;
        return -1;
    }
    return 0;
}

/* search in specified direction for
 * nop template return address, returns address of instruction following
 * target template, i.e., target + tz
 * NOTE: ce->c.c->ip must point to the instruction (agent) being executed
 */
I32s ctemplate(f, b, slim, mode, tz, dir)
I32s *f;    /* starting address for forward search */
I32s *b;    /* starting address for backward search */
I32s *slim; /* search limit, and return for distance searched */
I8s  *mode; /* preference for forward (1) or backward (2) target */
I32s tz;    /* template size */
I32s dir;   /* direction of search, f = forward, b = backward, o = out */
{   I32s  o, l = 1, adrt;
    I32s  i = 0, fmatch = 0, bmatch = 0;
    I8s   df, db;
    Pgl   tgl;

    if ((tz < MinTemplSize) || (tz > SoupSize))
    {   adrt = -1;
        *mode = 0;
        goto finish;
    }
    if ((I8s) dir == 'o')      /* both directions */
        df = db = 1;
    else if ((I8s) dir == 'f') /* forward only */
    {   df = 1;
        db = 0;
    }
    else if ((I8s) dir == 'b') /* backwards only */
    {   df = 0;
        db = 1;
    }
    o = ad(ce->c.c->ip + 1);
    while (1)
    {
    while (1) /* this skips sections of codes that are not templates (NOPs) */
    {
#if PLOIDY == 1
        if ((df &&               /* forward */
            (soup[*f] == Nop0 || soup[*f] == Nop1)
#ifdef READPROT
            && PrivRead(ce, *f)
#endif /* READPROT */
            )
            || (db &&           /* backward */
            (soup[*b] == Nop0 || soup[*b] == Nop1)
#ifdef READPROT
            && PrivRead(ce, *b)
#endif /* READPROT */
            ))
#else /* PLOIDY > 1 */
        if ((df &&     /* forward */
            (soup[*f][is.dtra] == Nop0 || soup[*f][is.dtra] == Nop1)
#ifdef READPROT
            && PrivRead(ce, *f)
#endif /* READPROT */
            )
            || (db &&  /* backward */
            (soup[*b][is.dtra] == Nop0 || soup[*b][is.dtra] == Nop1)
#ifdef READPROT
            && PrivRead(ce, *b)
#endif /* READPROT */
            ))
#endif /* PLOIDY > 1 */
            break;
        if (df)
        {   (*f)++;
            *f = ad(*f);
        }
        if (db)
        {   (*b)--;
            *b = ad(*b);
        }
        l++;
        if (l > *slim)   /* if we exceed the search limit abort */
        {   adrt = -1;
            *mode = 0;
            goto finish;
        }
    } /* inner while(1) this skips sections of codes that are not templates */

    /* forward */
#if PLOIDY == 1
    if (df && (soup[*f] == Nop0    /* if NOPs */
       ||  soup[*f] == Nop1))
#else /* PLOIDY > 1 */
    if (df && (soup[*f][is.dtra] == Nop0    /* if NOPs */
       ||  soup[*f][is.dtra] == Nop1))
#endif /* PLOIDY > 1 */
    {   fmatch = 1;
        for (i = 0; i < tz; i++)   /* over the full template size */
        {   
#if PLOIDY == 1
            if (soup[ad(o + i)] +
                soup[ad(*f + i)] - NopS
#ifdef READPROT
                || !PrivRead(ce, ad(*f + i))
#endif /* READPROT */
#else /* PLOIDY > 1 */
            if (soup[ad(o + i)][is.stra] +
                soup[ad(*f + i)][is.dtra] - NopS
#ifdef READPROT
                || !PrivRead(ce, ad(*f + i))
#endif /* READPROT */
#endif /* PLOIDY > 1 */
                )
            {   fmatch = 0;
                break;
            }
        }
    }
    else fmatch = 0;

    /* backward */
#if PLOIDY == 1
    if (db && (soup[*b] == Nop0    /* if NOPs */
       ||  soup[*b] == Nop1))
#else /* PLOIDY > 1 */
    if (db && (soup[*b][is.dtra] == Nop0    /* if NOPs */
       ||  soup[*b][is.dtra] == Nop1))
#endif /* PLOIDY > 1 */
    {   bmatch = 1;
        for (i = 0; i < tz; i++)  /* over the full template size */
        {
#if PLOIDY == 1
            if (soup[ad(o + i)] +
                soup[ad(*b + i)] - NopS
#ifdef READPROT
                || !PrivRead(ce, ad(*b + i))
#endif /* READPROT */
#else /* PLOIDY > 1 */
            if (soup[ad(o + i)][is.stra] +
                soup[ad(*b + i)][is.dtra] - NopS
#ifdef READPROT
                || !PrivRead(ce, ad(*b + i))
#endif /* READPROT */
#endif /* PLOIDY > 1 */
                )
            {   bmatch = 0;
                break;
            }
        }
    }
    else bmatch = 0;

    if (fmatch && bmatch)
    {   if (*mode == 1)
        {   *f += flaw();
            adrt = ad(*f + tz);
            *mode = 3;
            goto finish;
        }
        else if (*mode == 2)
        {   *b += flaw();
            adrt = ad(*b + tz);
            *mode = 3;
            goto finish;
        }
    }
    else if (fmatch)
    {   *f += flaw();
        adrt = ad(*f + tz);
        *mode = 1;
        goto finish;
    }
    else if (bmatch)
    {   *b += flaw();
        adrt = ad(*b + tz);
        *mode = 2;
        goto finish;
    }

    if (db)      /* increment search pointers, backward and forward */
    {   (*b)--;
        *b = ad(*b);
    }
    if (df)
    {   (*f)++;
        *f = ad(*f);
    }
    l++;
    if (l > *slim)   /* if we exceed the search limit abort */
    {   adrt = -1;
        *mode = 0;
        goto finish;
    }
    }  /* outermost while(1) */
finish:
    *slim = l;
    if (GeneBnker && WatchTem)
    {   tgl = sl[ce->d.gen.size]->g[ce->d.gi];
        if (adrt >= 0 && !ce->d.flaw && !ce->d.mut && ce->mm.p <= ce->c.c->ip
            && ce->c.c->ip < (ce->mm.p + ce->mm.s) && IsBit(tgl->bits, 0))
            GenExTemp(ad(adrt - tz), tz);
    }
    return adrt;  /* address of instruction following target template */
}

/* ------------------------------------------------------------------- */
#ifdef HSEX
   /* put this at movii at point of  x over  & at mal */

I8s FindMate(cp)
Pcells cp;
{
/* search out FORWARD (sorry ) to find cell of roughly the close size
 * but diff genotype
 * insert addr into cp->d.mate_addr
 * if (cp->d.x_over_addr > 0)
 *    cp->d.mate_addr = me->mm.p;
 * else
 *    cp->d.mate_addr = me->mm.p + cp->d.x_over_addr;
 * if one can't be found, return 0
 *
 */

Pcells me;
I32s fi,fmasl,ll;
I8s tmd, fi_not_free=0;

#ifdef ERROR
    if ((!ce))
    {   FEError(-719,NOEXIT,NOWRITE,"FindMate - Bad cell passed !\n");
        return 0;
    }
#endif
    /* bi = ad(ce->mm.p -1);   byte before cell */
    fi = ad(ce->mm.p +ce->mm.s+1);  /* byte after cell */
    fmasl = ad( (I32s) ( MateSearchL * AverageSize));
    while(1)
    { /* forward */
        if (!(IsFree(fi)))
        {   fi_not_free =1;
            WhichCell(fi,&me,&tmd);
            if ((!MateSearchL) && (me == ce))
                return 0;
            if ((tmd == 'm') && (me->mm.s >= (ce->mm.s - MateSizeEp)) &&
                (me->mm.s <= (ce->mm.s + MateSizeEp)))
            {   if (!IsSameGen(ce->mm.s,&soup[ce->mm.p],&soup[me->mm.p]))
                {   if(ce->d.x_over_addr < 0)
                        ce->d.mate_addr = me->mm.p;
                    else
                        ce->d.mate_addr = ad(me->mm.p + ce->d.x_over_addr);
                    return 1;
                }
            }
        }
        /* not found so inc soup indexs */
        if(fi_not_free)
        {   fi_not_free=0;
            fi = ad(me->mm.s+me->mm.p +1);
        }
        else
            fi = ad(fi+MinCellSize -1);
        /* check to see if we are done */
        if( fi < ce->mm.p) /* we have rolled of the top */
            ll = SoupSize - ce->mm.p + fi;
        else
            ll = fi - ce->mm.p;
        if ((!MateSearchL) && (ll > fmasl))
            return 0;
    }
}       /* end of FindMate */

/* have func that chooses mate or not in mal */
I8s DoMate()
{   if ((NumCells) && (MateProb > 0.0 ) && ((tlrand() %101) < (100*MateProb))) 
        return 1;
    return 0;
}

/* then have func that chooses x_over */
I16s SetXover(cp)
Pcells cp;
{   return ((I16s)(((tlrand() %2) ? 1: -1) *
        (tlrand() % ((I32s) (MateXoverProp * cp->mm.s)+1))));
}

void UseMate(cp)
Pcells cp;
{   if ((( cp->d.x_over_addr > 0) && /* second half, ! > x_over */
        (cp->d.mov_daught < cp->d.x_over_addr)) ||
        (( cp->d.x_over_addr < 0) && /* first half, > x_over */
        (cp->d.mov_daught > (-1*cp->d.x_over_addr))))
    {   is.sval = ad((is.sval - cp->mm.p) + cp->d.mate_addr);
#if PLOIDY == 1
        is.dins = &soup[is.sval];
#else /* PLOIDY > 1 */
        is.dins = &soup[is.sval][cp->c.c->de];
#endif /* PLOIDY > 1 */
    }
}

#endif /* ifdef HSEX */

/* ------------------------------------------------------------------- */
/* ------------------------------------------------------------------- */

void getregs() /* get registers of other cpu */
{   I16s  i, s, d = ce->c.ac;

    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
    if (ce->c.n < 2)
    {
#ifdef ERROR
        FEError(-720,EXIT,WRITE, "Tierra getregs() error: ce->c.n < 2");
#endif /* ERROR */
        ce->c.c->fl.E = 1;
        return;
    }
    switch (is.sval)
    {   case 0:
        {   if (d)
                s = d - 1;
            else
                s = ce->c.n - 1;
            break;
        }
        case 1:
        {   if (d < ce->c.n - 1)
                s = d + 1;
            else
                s = 0;
            break;
        }
        case 2:
        {   do
            {   s = (I8s) tcrand() % ce->c.n;
            }   while (s == d);
            break;
        }
        default: break;
    }
    for (i = 0; i < ALOC_REG; i++)
        ce->c.c->re[i] = ce->c.ar[s].re[i];
}

#if PLOIDY > 1

void trex() /* switch track of execution */
{
#if PLOIDY > 2
   I8s  ttr;
#endif

    if (!flaw())
#if PLOIDY == 2
        ce->c.c->ex = !(ce->c.c->ex);
#else /* PLOIDY == 2 */
    {   ttr = ce->c.c->ex;
        do
        {   ce->c.c->ex = (I8s) tcrand() % PLOIDY;
        }   while (ce->c.c->ex == ttr);
    }
#endif /* PLOIDY == 2 */
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

void trso() /* switch track of source */
{
#if PLOIDY > 2
   I8s  ttr;
#endif

    if (!flaw())
#if PLOIDY == 2
        ce->c.c->so = !(ce->c.c->so);
#else /* PLOIDY == 2 */
    {   ttr = ce->c.c->so;
        do
        {   ce->c.c->so = (I8s) tcrand() % PLOIDY;
        }   while (ce->c.c->so == ttr);
    }
#endif /* PLOIDY == 2 */
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

void trde() /* switch track of destination */
{
#if PLOIDY > 2
   I8s  ttr;
#endif

    if (!flaw())
#if PLOIDY == 2
        ce->c.c->de = !(ce->c.c->de);
#else /* PLOIDY == 2 */
    {   ttr = ce->c.c->de;
        do
        {   ce->c.c->de = (I8s) tcrand() % PLOIDY;
        }   while (ce->c.c->de == ttr);
    }
#endif /* PLOIDY == 2 */
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

void JumpTrack()
{
#if PLOIDY > 2
    I8s  ttr;
#endif

    if(is.dreg == &(ce->c.c->ip) && tdrand() < JumpTrackProb)
    {
#if PLOIDY == 2
        ce->c.c->ex = !(ce->c.c->ex);
#else /* PLOIDY == 2 */
        {   ttr = ce->c.c->ex;
            do
            {   ce->c.c->ex = (I8s) tcrand() % PLOIDY;
            }   while (ce->c.c->ex == ttr);
        }
#endif /* PLOIDY == 2 */
    }
    ce->c.c->fl.E = ce->c.c->fl.S = ce->c.c->fl.Z = 0;
}

#endif /* PLOIDY > 1 */
