/*-------------------------------------------------------------------------*/
/* cmdline.c 16-02-95 command line utility by Matt Jones                   */
/* Tierra Simulator V4.2: Copyright (c) 1991, 1992, 1993, 1994, 1995       */
/* Tom Ray & Virtual Life                                                  */
/*-------------------------------------------------------------------------*/

#ifdef __MWERKS__

#include "tierra.h"

#define NARGS		50
static char *argv[NARGS+1];
static char cline[2048];
static char argbuf[2048];
static int parse(char *, char *);

/* cmdline - get and process "command line" */
int cmdline( app, locarg)
char *app;
char ***locarg;
{	short i, argc;
	char buf[2048];

	strcpy( argbuf, app );
	gets(cline);
	strcat( argbuf, cline );
	strcpy( buf, argbuf );
	argc = parse(buf, argbuf);
	*locarg = argv;
	errno = 0;
	return(argc);
}

/* parse - pull out separate command words */
static int parse(char *s1, char *s2)
{
	int quote = 0, thechar, argc = 0;
		
	while (thechar = *s1++) 	//Spaces are used as word separators,
	{							//characters in matching quotes
		if (thechar == ' ')		//are taken literally, as are characters
			continue;			//preceded by a backslash
		if (argc < NARGS)
			argv[argc++] = s2;
		do 
		{
			if (thechar == '\\' && *s1)
				thechar = *s1++;
			else if (thechar == '"' || thechar == '\'') 
			{
				if (!quote) 
				{
					quote = thechar;
					continue;
				}
				if (thechar == quote) {
					quote = 0;
					continue;
				}
			}
			*s2++ = thechar;
		} while (*s1 && ((thechar = *s1++) != ' ' || quote));
		*s2++ = 0;
	}
	return(argc);
}

#endif /* __MWERKS__ */