/* ======================================================================*/
/* tmac.c 8-23-94 support for Macintosh frontend by Matt Jones
*/

#include "tierra.h"
#include "extern.h"
#ifdef __MWERKS__
/* Private prototypes */
int  HandleEvent( EventRecord *event );
void HandleMouseDown( EventRecord *event );
void HandleMenuChoice( long choice );

#if INTERFACE == BASICM
#include <SIOUX.h>


/* ======================================================================*/
void FEInitToolbox(void)
{
	MenuHandle menu;
	int i;

		/*  initialize the Memory Manager  */
	MaxApplZone();
	for (i = 0; i < 10; i++)
		MoreMasters();
		/*  initialize Quickdraw  */
	InitGraf( &qd.thePort );	
		/*  initialize the Toolbox  */
	InitFonts();
	InitWindows();
	TEInit();
	InitDialogs(0);
	InitMenus();
		/*  create menus  */	
	InsertMenu(appleMenu = NewMenu(1, "\p\024"), 0);
	AppendMenu(appleMenu, "\pAbout Tierra...;(-");
	AddResMenu(appleMenu, 'DRVR');
	InsertMenu(menu = NewMenu(2, "\pFile"), 0);
	AppendMenu(menu, "\pQuit");
	InsertMenu(menu = NewMenu(3, "\pEdit"), 0);
	AppendMenu(menu, "\pUndo/Z;(-;Cut/X;Copy/C;Paste/V;(-;Clear");
	DisableItem( menu, 0 );
	DrawMenuBar();
		/*  ready to receive events  */
	FlushEvents(everyEvent, 0);
	InitCursor();
}
/* ======================================================================*/
WindowPeek FECreateNewWindow(void)
{
	GrafPtr savePort;
	static Rect wbox = { 100, 100, 200, 300 };
	Rect bounds;
	short fontNum;
	
	GetPort(&savePort);
	wp = (WindowPeek) NewCWindow(0, &wbox, "\pTierra for Macintosh!", 0, 
			noGrowDocProc, (WindowPtr) -1, 0, 0);
	MoveWindow((WindowPtr)wp, 5, 40, 0);
	SetPort((WindowPtr)(wp));
	GetFNum( "\pCourier", &fontNum );
	if (fontNum != 0)
		TextFont(fontNum);
	TextSize(12);
	GetFontInfo(&fontInfo);
	rowHeight = fontInfo.ascent + fontInfo.descent + fontInfo.leading;
	bounds.top = bounds.left = 0;
	bounds.bottom = windowHeight;
	bounds.right = windowWidth;
	SizeWindow((WindowPtr)wp, bounds.right, bounds.bottom, 0);
	fe_lines = windowHeight/rowHeight;
	fe_width = (bounds.right-displayOffset)/fontInfo.widMax;
	ERR_Y = fe_lines - 2;
	HLP_Y = fe_lines - 1;		
	ShowWindow((WindowPtr)wp);
	SetPort(savePort);
	return(wp);
}

#endif /* INTERFACE == BASICM */
/* ======================================================================*/
int FEProcessEvent(void)
{	EventRecord event;
	Boolean		SIOUXDidEvent;
	int			keyPressed=0;
	
		/*  check for an event  */
	if (WaitNextEvent( everyEvent, &event, 60, nil ))
	{	
		SIOUXDidEvent = SIOUXHandleOneEvent(&event);
		if (!SIOUXDidEvent)	{
			keyPressed = HandleEvent( &event );
		}
	}
	return( keyPressed );
}

int HandleEvent( EventRecord *event )
{	char		theChar;
	WindowPtr	window;
	int			keyPressed;	
	
	switch ( event->what )
	{
		case mouseDown:
			keyPressed = 0;
			HandleMouseDown( event );
			break;
		case keyDown:
		case autoKey:
			theChar = event->message & charCodeMask;
			if ( (event->modifiers & cmdKey) != 0 )	{
/*				HandleMenuChoice( MenuKey( theChar ) );	*/
				keyPressed = 0;
			}
			else {
				keyPressed = 1;
			}
			break;
		case updateEvt:
			keyPressed = 0;
			break;
	}
	return keyPressed;
}

void HandleMouseDown( EventRecord *event )
{	
	WindowPeek 	window;
	long		choice;
	GrafPtr		oldPort;
	Rect		desktopExtent;
	
	GetPort( &oldPort );
	SetPort( (WindowPtr)window );
	
	switch (FindWindow(event->where, (WindowPtr *)&window))
	{	case inMenuBar:
			InitCursor();
			choice = MenuSelect(event->where);
			HandleMenuChoice( choice );
			break;
		case inDrag:
			desktopExtent = (**GetGrayRgn()).rgnBBox;
			InsetRect(&desktopExtent, 4, 4);
			DragWindow((WindowPtr)window, event->where, &desktopExtent);
			break;
		case inSysWindow:
			SystemClick(event, (WindowPtr)window);
			break;
	}
	SetPort( oldPort );
}

void HandleMenuChoice( long choice )
{	
	Str255 		buf;

	switch (HiWord(choice))
	{	case 1:		/*  Apple  */
			switch (LoWord(choice))
			{	case 1:
					Alert(128, nil);
					break;
				case 2:
					GetItem(appleMenu, LoWord(choice), buf);
					OpenDeskAcc(buf);
					break;
			}
			break;
		case 2:		/*  File  */
			switch (LoWord(choice))
			{	case 1:
					ExitToShell();
					break;			
			}
			break;
		case 3:		/*  Edit  */
			SystemEdit(LoWord(choice) - 1);
			break;
	}
	HiliteMenu(0);
}

#endif /* __MWERKS__ */
