/* @(#)frontend.c    1.2 11/25/94*/
/* frontend.c   6-3-96  Tierra Simulator frontend routines */
/* Tierra Simulator V4.3: Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996 */
/* Tom Ray & Virtual Life */
/* FEError labels: #22XX, in use: 2200-2230 */
#include "license.h"
#include "tierra.h"
#ifdef __GUI__
#define WEXTERN_H
#endif /* __GUI__ */
#include "globals.h"
#include <signal.h>
#ifdef ALCOMM
#include "tmonitor.h"
#include "trequest.h"
#include <mlayer.h>
#endif /* ALCOMM */
#if INTERFACE == BASICD
#include <gppconio.h>
#endif /* INTERFACE == BASICD */

#ifdef __GUI__
#include "wntierra.h"
static char *ENDBLANK[80];
#endif /* __GUI__ */

#ifdef MON
#include "obs.h"
#include "tmon_global.h"
#endif /* MON */

/*************************************/
/* Clear step debugger break point   */
/*************************************/
void GoBrkClr(untrkflg)
int untrkflg;
{
   if(untrkflg){
      /* untrack cell */
      UnTrkCell();
   }

#ifdef MICRO

   /* clear break trap data */
   BrkTrapCondBuf.curbrkdat.TrapType=0;
   BrkTrapCondBuf.curbrkdat.BrkSet=0;
   BrkTrapCondBuf.curbrkdat.BrkFnd=0;
   BrkTrapCondBuf.curbrkdat.host_genome.gi=0;
   BrkTrapCondBuf.curbrkdat.host_genome.si=0;
   BrkTrapCondBuf.curbrkdat.prim_genome.gi=0;
   BrkTrapCondBuf.curbrkdat.prim_genome.si=0;
   BrkTrapCondBuf.curbrkdat.genoffset=0;
   BrkTrapCondBuf.curbrkdat.AbsTime.m=0;
   BrkTrapCondBuf.curbrkdat.AbsTime.i=0;
   BrkTrapCondBuf.curbrkdat.IntervalTime.m=0;
   BrkTrapCondBuf.curbrkdat.IntervalTime.i=0;
   BrkTrapCondBuf.curbrkdat.pctchg=0;
   BrkTrapCondBuf.curbrkdat.lowlim=0;
   BrkTrapCondBuf.curbrkdat.hilim=0;
   BrkTrapCondBuf.curbrkdat.permtemp=0;
   BrkTrapCondBuf.curbrkdat.avgpoprng=0;

#endif /* MICRO */
}

void SavBrkDat()
{
   BrkTrapCondBuf.savbrkdat.MicroSlice=
      BrkTrapCondBuf.curbrkdat.MicroSlice;
   BrkTrapCondBuf.savbrkdat.MicroCpu=
      BrkTrapCondBuf.curbrkdat.MicroCpu;
   BrkTrapCondBuf.savbrkdat.MicroCpuI=
      BrkTrapCondBuf.curbrkdat.MicroCpuI;

#ifdef MICRO
   BrkTrapCondBuf.savbrkdat.TrapType=
      BrkTrapCondBuf.curbrkdat.TrapType;
   BrkTrapCondBuf.savbrkdat.BrkSet=
      BrkTrapCondBuf.curbrkdat.BrkSet;
   BrkTrapCondBuf.savbrkdat.BrkFnd=
      BrkTrapCondBuf.curbrkdat.BrkFnd;
   BrkTrapCondBuf.savbrkdat.host_genome.gi=
      BrkTrapCondBuf.curbrkdat.host_genome.gi;
   BrkTrapCondBuf.savbrkdat.host_genome.si=
      BrkTrapCondBuf.curbrkdat.host_genome.si;
   BrkTrapCondBuf.savbrkdat.prim_genome.gi=
      BrkTrapCondBuf.curbrkdat.prim_genome.gi;
   BrkTrapCondBuf.savbrkdat.prim_genome.si=
      BrkTrapCondBuf.curbrkdat.prim_genome.si;
   BrkTrapCondBuf.savbrkdat.genoffset=
      BrkTrapCondBuf.curbrkdat.genoffset;
   BrkTrapCondBuf.savbrkdat.AbsTime.m=
      BrkTrapCondBuf.curbrkdat.AbsTime.m;
   BrkTrapCondBuf.savbrkdat.AbsTime.i=
      BrkTrapCondBuf.curbrkdat.AbsTime.i;
   BrkTrapCondBuf.savbrkdat.IntervalTime.i=
      BrkTrapCondBuf.curbrkdat.IntervalTime.i;
   BrkTrapCondBuf.savbrkdat.pctchg=
      BrkTrapCondBuf.curbrkdat.pctchg;
   BrkTrapCondBuf.savbrkdat.lowlim=
      BrkTrapCondBuf.curbrkdat.lowlim;
   BrkTrapCondBuf.savbrkdat.hilim=
      BrkTrapCondBuf.curbrkdat.hilim;
   BrkTrapCondBuf.savbrkdat.permtemp=
      BrkTrapCondBuf.curbrkdat.permtemp;
   BrkTrapCondBuf.savbrkdat.avgpoprng=
      BrkTrapCondBuf.curbrkdat.avgpoprng;
#endif /* MICRO */
}

void TrkCPU(cp)
Pcells cp;
{
   TrkCell(cp);
   BrkTrapCondBuf.curbrkdat.MicroCpu   = cp->c.c;
   BrkTrapCondBuf.curbrkdat.MicroCpuI  = cp->c.ac;
}

void UnTrkCPU()
{
   BrkTrapCondBuf.curbrkdat.MicroCpu   = 0;
   BrkTrapCondBuf.curbrkdat.MicroCpuI  = 0;
}

void TrkCell(cp)
Pcells cp;
{
   BrkTrapCondBuf.curbrkdat.MicroSlice = cp;
}

void UnTrkCell()
{
   BrkTrapCondBuf.curbrkdat.MicroSlice = 0;
   UnTrkCPU();
}

I32s EnterLongVal(promptline, prompttext, abortflag)
int promptline;
char *prompttext;
int *abortflag;
{
   int loopflag;
   I32s rtnlongint;

   rtnlongint=0;
   (*abortflag)=0;
   loopflag=1;
   while(loopflag){
#if FRONTEND == BASIC
      FEClrmsg(promptline, "");
      FEBanner();
      FEStats();
#endif /* FRONTEND == BASIC */
      sprintf(Fbuf, prompttext);
      FEPrintf(MSG_X, promptline, 0, 0, Fbuf);
      FEGetStr(MSG_X+strlen(prompttext), promptline);
      if(strlen(&(FGSbuf[0]))){
         if(sscanf(&(FGSbuf[0]), "%ld", &rtnlongint)==1){
            loopflag=0;
         }
         else{
            sprintf(Fbuf, "invalid entry");
            FEError(-2200, NOEXIT, NOWRITE, Fbuf);
         }
      }
      else{
         (*abortflag)=1;
         loopflag=0;
      }
   }
   return rtnlongint;
}

double EnterFloatVal(promptline, prompttext, abortflag)
int promptline;
char *prompttext;
int *abortflag;
{
   int loopflag;
   double rtnfloatval;

   rtnfloatval=0;
   (*abortflag)=0;
   loopflag=1;
   while(loopflag){
#if FRONTEND == BASIC
      FEClrmsg(promptline, "");
      FEBanner();
      FEStats();
#endif /* FRONTEND == BASIC */
      sprintf(Fbuf, prompttext);
      FEPrintf(MSG_X, promptline, 0, 0, Fbuf);
      FEGetStr(MSG_X+strlen(prompttext), promptline);
      if(strlen(&(FGSbuf[0]))){
         if(sscanf(&(FGSbuf[0]), "%lf", &rtnfloatval)==1){
            loopflag=0;
         }
         else{
            sprintf(Fbuf, "invalid entry");
            FEError(-2201, NOEXIT, NOWRITE, Fbuf);
         }
      }
      else{
         (*abortflag)=1;
         loopflag=0;
      }
   }
   return rtnfloatval;
}

GlIndex EnterGenome(promptline, prompttext, abortflag, genchk)
int promptline;
char *prompttext;
int *abortflag;
int genchk;
{
   char gen[4];
   I32s size;
   int loopflag;
   I16s gidx;
   GlIndex rtngenome;

   (*abortflag)=0;
   rtngenome.si=0;
   rtngenome.gi=0;
   /* enter parasite genome name */
   loopflag=1;
   while(loopflag){
#if FRONTEND == BASIC
      FEClrmsg(promptline, "");
      FEBanner();
      FEStats();
#endif /* FRONTEND == BASIC */
      sprintf(Fbuf, prompttext);
      FEPrintf(MSG_X, promptline, 0, 0, Fbuf);
      FEGetStr(MSG_X+strlen(prompttext), promptline);
      if(strlen(&(FGSbuf[0]))){
         if(sscanf(&(FGSbuf[0]), "%4ld%3s", &size, &(gen[0]))==2){
            gidx=Lbl2Int(&(gen[0]));
            if(genchk){
               if(!((size<1)||(size>(siz_sl-1))||(TNULL(sl[size])))){
                  if(gidx<sl[size]->a_num){
                     if(!((TNULL(sl[size]->g[gidx]))||
                        (!sl[size]->g[gidx]->pop))){
                        loopflag=0;
                     }
                     else{
                        sprintf(Fbuf, "genome not found");
                        FEError(-2202, NOEXIT, NOWRITE, Fbuf);
                     }
                  }
                  else{
                     sprintf(Fbuf, "genome not found");
                     FEError(-2203, NOEXIT, NOWRITE, Fbuf);
                  }
               }
               else{
                  sprintf(Fbuf, "genome not found");
                  FEError(-2204, NOEXIT, NOWRITE, Fbuf);
               }
            }
            else{
               loopflag=0;
            }
         }
         else{
            sprintf(Fbuf, "invalid entry");
            FEError(-2205, NOEXIT, NOWRITE, Fbuf);
         }
      }
      else{
         (*abortflag)=1;
         loopflag=0;
      }
   }
   if(!(*abortflag)){
      rtngenome.si=size;
      rtngenome.gi=gidx;
   }
   return(rtngenome);
}

#ifdef MICRO

void GoMicroToggle()
{   if (MC_step == -1L)
    {   MC_step = 0L;
#ifdef __GUI__
        sprintf(Fbuf,
"                     Click Mouse to Switch Mode                   ");
        FEPrintf(HLP_X, HLP_Y, 1, 0, Fbuf);
#endif
    }
    else if (MC_step == 0L)
        MC_step = 1L;
    else
    {   MC_step =-1L;
        if (tfp_log != NULL)
            Log = 1L;
        GoBrkClr(0);
    }
#if INTERFACE == BASICM
    FEClear();
#endif /* INTERFACE == BASICM */
}

/*************************************/
/* Break Menu                        */
/*************************************/
void GoBrkMenu()
{
   I8s  answer;

#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
   sprintf(Fbuf,"b-Set Brk  c-Clr Brk  r-Rpt Brk->");
   FEPrintf(HLP_X, HLP_Y, 1, 0, Fbuf);
#ifdef AMIGA
#if FRONTEND == BASIC
      nodelay(stdscr, FALSE);
#endif /* FRONTEND == BASIC */
#endif /* AMIGA */
   answer = FEGetch(HLP_X + strlen(&(Fbuf[0])), HLP_Y);
#ifdef AMIGA
#if FRONTEND == BASIC
      nodelay(stdscr, TRUE);
#endif /* FRONTEND == BASIC */
#endif /* AMIGA */
   switch(answer){
      case 'b':         /* Break Set */
          GoBrkSet();
          break;
      case 'c':         /* Break Clear */
          GoBrkClr(1);
          break;
      case 'r':         /* Repeat Break */
          GoRepeatBrk();
          break;
       default:
           break;
   }
}

/*************************************/
/* Break Set Menu                    */
/*************************************/
void GoBrkSet()
{
   int menuline, loopflag, menuopt, abortflag, menunum;
   int lstmenuline, lstcolline, menucol2;

   abortflag=0;
   loopflag=1;
   while(loopflag){

      menuline=0;
      menunum=1;

#if FRONTEND == BASIC
      FEClrmsg(MSG_Y, "");
      FEBanner();
      FEStats();
#endif /* FRONTEND == BASIC */

      MenuLine("Genome / offset",
         &menuline, MSG_X, &menunum, 1);
      MenuLine("Current cell / offset",
         &menuline, MSG_X, &menunum, 1);
      MenuLine("Abs Time (Instr)",
         &menuline, MSG_X, &menunum, 1);
      MenuLine("Rel Time (Instr)",
         &menuline, MSG_X, &menunum, 1);
      MenuLine("Given Parasite & Host",
         &menuline, MSG_X, &menunum, 1);
      MenuLine("Pct change in avg pop",
         &menuline, MSG_X, &menunum, 1);
      MenuLine("Perm parasite / perm host",
         &menuline, MSG_X, &menunum, 1);

#if FRONTEND == BASIC
      MenuLine("q - Quit", &menuline, MSG_X, &menunum, 0);
#endif /* FRONTEND == BASIC */

      lstmenuline=menuline-1;

      menuline=0;

#if FRONTEND == BASIC
   menucol2=MSG_X+33;
#else
   menucol2=MSG_X;
#endif /* FRONTEND == BASIC */

      MenuLine("any perm genome / given time",
         &menuline, menucol2, &menunum, 1);
      MenuLine("given parasite / any perm host",
         &menuline, menucol2, &menunum, 1);
      MenuLine("any perm parasite / given host",
         &menuline, menucol2, &menunum, 1);
      MenuLine("any genome in given size range",
         &menuline, menucol2, &menunum, 1);
      MenuLine("perm parasite, host size range",
         &menuline, menucol2, &menunum, 1);
      MenuLine("perm host, parasite size range",
         &menuline, menucol2, &menunum, 1);

      lstcolline=menuline-1;
      lstmenuline=(lstcolline>lstmenuline)?lstcolline:lstmenuline;

      menuline=lstmenuline+2;

#if FRONTEND == STDIO
      MenuLine("q - Quit", &menuline, MSG_X, &menunum, 0);
#endif /* FRONTEND == BASIC */

      MenuLine("Menu Option->",
         &menuline, MSG_X, &menunum, 0);
      FEGetStr(MSG_X+strlen(&(Fbuf[0])), MSG_Y+(menuline-1));

      if(strlen(&(FGSbuf[0]))){
         if(!strcmp(&(FGSbuf[0]),"q")){
            abortflag=1;
            loopflag=0;
         }
         else{
            if(sscanf(&(FGSbuf[0]), "%d", &menuopt)==1){
               switch(menuopt){

                  case 1:    /* Genome/offset */
                     Brk_Genome_Offset();
                     loopflag=0;
                     break;

                  case 2:    /* Current cell/offset */
                     Brk_CurCell_Offset();
                     loopflag=0;
                     break;

                  case 3:    /* Absolute Time (Instr Exec) */
                     Brk_AbsTimeInst();
                     loopflag=0;
                     break;

                  case 4:    /* Time Interval (Instr Exec) */
                     Brk_IntrvlTimeInst();
                     loopflag=0;
                     break;

                  case 5:    /* Parasite genome / Host genome */
                     Brk_ParaGen_HostGen();
                     loopflag=0;
                     break;

                  case 6:    /* Percent change in average population */
                     Brk_PctChgPop();
                     loopflag=0;
                     break;

                  case 7:    /* perm para - perm host */
                     Brk_PermParaPermHost();
                     loopflag=0;
                     break;

                  case 8:    /* perm genome - given time */
                     Brk_PermGenTime();
                     loopflag=0;
                     break;

                  case 9:    /* parasite - perm host */
                     Brk_ParaGenPermHost();
                     loopflag=0;
                     break;

                  case 10:   /* permanent parasite / given host */
                     Brk_PermParaHost();
                     loopflag=0;
                     break;

                  case 11:   /* any genome in given size range */
                     Brk_GenSizeRange();
                     loopflag=0;
                     break;

                  case 12:   /* permanent parasite, host size range */
                     Brk_PermPara_HostSizeRange();
                     loopflag=0;
                     break;

                  case 13:   /* permanent host, parasite size range */
                     Brk_PermHost_ParaSizeRange();
                     loopflag=0;
                     break;

                  default:
                     sprintf(Fbuf, "invalid menu option");
                     FEError(-2206, NOEXIT, NOWRITE, Fbuf);
                     break;
               }
            }
            else{
               sprintf(Fbuf, "invalid menu option");
               FEError(-2207, NOEXIT, NOWRITE, Fbuf);
            }
         }
      }
      else{
         abortflag=1;
         loopflag=0;
      }
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

void Micro_Spy(cp)
Pcells cp;
{   I32s tlog;
    I8s  cc;
    int MicroSpyLoop;
#ifdef __GUI__
     DWORD tick;
#endif

    tlog = Log;
    Log = 0;   /*note: file not closed, we just wont scream at it */

    if ((!(BrkTrapCondBuf.curbrkdat.BrkSet)) &&
       (BrkTrapCondBuf.curbrkdat.MicroSlice) &&
       (cp != BrkTrapCondBuf.curbrkdat.MicroSlice))
        return;
    if ((!(BrkTrapCondBuf.curbrkdat.BrkSet)) &&
       (BrkTrapCondBuf.curbrkdat.MicroCpu) &&
       (cp->c.c != BrkTrapCondBuf.curbrkdat.MicroCpu))
        return;

    if(ChkBrk(cp)){
      return;
    }

    if(IMode!=PLN_STATS){
      IMode = PLN_STATS;
      FEVidInit(0);
      FEPlan(0);
    }

    Log= tlog;
#ifndef MON
    MicroSpyLoop=1;
    while(MicroSpyLoop){
#endif /* MON */

      if(dbgdisptype==0){
        DebugDisplay(cp);
      }
      else{
        soupviewstrt=ce->c.c->ip;
        DisplaySoupPage();
      }

      if (MC_step > 0L)
      {   FEBanner();
          FEStats();
          sprintf(Fbuf,
#ifdef __GUI__
        "%s  %s  Click-Mode Switch  n-Next step",
#else
        "%s  %s  q-Main Menu  d-display a-disasmbl",
#endif /* __GUI__ */
        (BrkTrapCondBuf.curbrkdat.MicroSlice) ?
            "t-Untrack cell" : "T-Track cell",
        (BrkTrapCondBuf.curbrkdat.MicroCpu)   ?
            "u-Untrack Cpu"  : "U-Track Cpu");
        FEPrintf(HLP_X, HLP_Y, 1, 0, Fbuf);
#if FRONTEND == STDIO
        printf("\n");
#endif /* FRONTEND == STDIO */
      }
      if( MC_step  > 0L)
      {
#ifdef AMIGA
#if FRONTEND == BASIC
        if(MC_step == 1)
        {   nodelay(stdscr, FALSE);
        }
#endif /* FRONTEND == BASIC */
#endif /* AMIGA */
#ifdef __GUI__
        while ((
          cc = FEGetch(HLP_X + strlen(&(Fbuf[0])), HLP_Y)
        ) == ' ');
        if (cc == 'z')
        {    GoMicroToggle();  /* turn off microSpy on mouse click*/
             sprintf(Fbuf,
"                    Use Menu for Mode Selection                    ");
             FEPrintf(HLP_X, HLP_Y, 1, 0, Fbuf);
        }
#else
        cc = FEGetch(HLP_X + strlen(&(Fbuf[0])), HLP_Y);
        if(cc == 'q')
        {   FEMenu();
        }
#endif /* __GUI__ */
#ifdef AMIGA
#if FRONTEND == BASIC
        if(MC_step == 1)
        {   nodelay(stdscr, TRUE);
        }
#endif /* FRONTEND == BASIC */
#endif /* AMIGA */
           switch (cc) {
              case 'T':                  /* track cell */
                 TrkCell(cp);
                 break;
              case 't':                  /* untrack cell */
                 GoBrkClr(1);
                 break;
              case 'U':                  /* track cpu */
                 TrkCPU(cp);
                 break;
              case 'u':                  /* untrack cpu */
                 UnTrkCPU();
                 break;
#ifndef __GUI__
              case 'd':                  /* debugger display */
                 DbgDisplCtrl(cp);
                 break;
              case 'a':                  /* disassembly menu */
                 DisasmMenu(cp);
                 break;
#endif
              default:
                 MicroSpyLoop=0;
                 break;
           }
      }
      if( MC_step  == 0L)
      {
#ifndef __GUI__
        if (KEYHIT())
            FEMenu();
        else {
            sleep(1);
            MicroSpyLoop=0;
        }
#else /* __GUI__ */
            if ((
                   cc = FEGetch(HLP_X + strlen(&(Fbuf[0])), HLP_Y)
            ) != ' ')
            GoMicroToggle();   /* go to keypress mode */
        else
        {
            tick = GetTickCount();
            while (GetTickCount() - tick < 1000);
        }
#endif /* __GUI__ */

      }

#ifdef ALCOMM
     if ( MIsDFEnabled(TrtIPEvent))
         TMoveIP( cp->mm.p,cp->c.c->ip);
#endif /* ALCOMM */

#ifndef MON
    }
#endif /* MON */

#ifdef MON
    if (MC_step != -1) {
      FD_SET(MASK_MICRO, &MDMASK);
    }
    if (MC_step == -1) {
      FD_CLR(MASK_MICRO, &MDMASK);
    }
    TmpMC_step = MC_step;
#endif /* MON */

}

void DisplayHostCell(cp, hostbuf1, hostbuf2, hostbuf3, hostbuf4)
Pcells cp;
char *hostbuf1, *hostbuf2, *hostbuf3, *hostbuf4;
{
   int hostbuflen;
   char hostbuf2a[20], hostbuf3a[10], hostbuf4a[7];

   /* initialize title */
   sprintf(hostbuf1, "----------- host ------------");

   ViewSoupHost(cp->c.c->ip, &(hostbuf2a[0]),
      &(hostbuf3a[0]), &(hostbuf4a[0]));

   sprintf(&(hostbuf2[0]),"    id : ");
   hostbuflen=strlen(&(hostbuf2[0]));
   sprintf(&(hostbuf2[hostbuflen]),"%s", hostbuf2a);

   sprintf(&(hostbuf3[0]),"status : ");
   hostbuflen=strlen(&(hostbuf3[0]));
   sprintf(&(hostbuf3[hostbuflen]),"%s", hostbuf3a);

   sprintf(&(hostbuf4[0]),"offset : ");
   hostbuflen=strlen(&(hostbuf4[0]));
   sprintf(&(hostbuf4[hostbuflen]),"%s", hostbuf4a);
}

void ViewSoupHost(soupviewaddr, hostbuf1, hostbuf2, hostbuf3)
I32s soupviewaddr;
char *hostbuf1, *hostbuf2, *hostbuf3;
{
   Pcells scncp;
   int hosttype;
   I32s hostoffset;

   scncp=FindHost(soupviewaddr, &hosttype);

   switch(hosttype){

      case 1:   /* live host */

         /* display host identity */
         sprintf(hostbuf1, "%04ld%3s",
            scncp->mm.s, Int2Lbl(scncp->d.gi));

         /* display host status */
         sprintf(hostbuf2,"%s",
            (scncp->ld)?"alive":"dead");

         /* display host offset */
         hostoffset=soupviewaddr-(scncp->mm.p);
         sprintf(hostbuf3,"%6ld", hostoffset);

         break;

      case 2:   /* host is daughter */

         /* display host identity */
         sprintf(hostbuf1, "daughter of %04ld%3s",
            scncp->mm.s, Int2Lbl(scncp->d.gi));

         /* display host status */
         sprintf(hostbuf2,"%s","embryonic");

         /* display host offset */
         hostoffset=soupviewaddr-(scncp->md.p);
         sprintf(hostbuf3,"%6ld", hostoffset);

         break;

      default:   /* free memory */

         /* display host identity */
         sprintf(hostbuf1, "free memory");

         /* display host status */
         sprintf(hostbuf2," ");

         /* display host offset */
         sprintf(hostbuf3," ");

         break;
   }
}

/*************************************/
/* debugger display                  */
/*************************************/
void DebugDisplay(cp)
Pcells cp;
{
    I8s  off_char = ' ',d_data[80];
    char hostbuf1[30];
    char hostbuf2[30];
    char hostbuf3[30];
    char hostbuf4[30];
    I32s off_int;

    off_int = cp->c.c->ip - cp->mm.p  ;
    DisplayHostCell(cp, &(hostbuf1[0]),
       &(hostbuf2[0]), &(hostbuf3[0]), &(hostbuf4[0]));
    if (!(off_int < cp->mm.s))
        off_char = '+';
    if (cp->md.s >= MinCellSize)
        sprintf(d_data,"Daughter @ %-6ld + %-6ld",cp->md.p,cp->md.s);
    else
        sprintf(d_data,"NO Daughter");
    sprintf(Fbuf,
        "Cell %2d:%3d %04ld%3s @ %7ld Slice=%4d  Stack[%7ld]              ",
        cp->q.this.a, cp->q.this.i,
        cp->mm.s,Int2Lbl( cp->d.gi),cp->mm.p,
        cp->c.ib,cp->c.c->st[0]);
    if (cp->c.c->sp == 0) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);
    sprintf(Fbuf,
        "IP [%7ld](%c%-7ld) = 0x%02x %9.9s        [%7ld]         ",
        cp->c.c->ip, off_char, off_int,
#if PLOIDY == 1
        soup[ad(cp->c.c->ip)],
        id[soup[ad(cp->c.c->ip)]].mn, cp->c.c->st[1]);
#else /* PLOIDY == 1 */
        soup[ad(cp->c.c->ip)][cp->c.c->ex],
        id[soup[ad(cp->c.c->ip)][cp->c.c->ex]].mn, cp->c.c->st[1]);
#endif /* PLOIDY == 1 */
    if (cp->c.c->sp == 1) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 1, 0, 0, Fbuf);
    sprintf(Fbuf,
        "AX [%7ld]  %-29s    [%7ld]              ",
        cp->c.c->re[0],&(hostbuf1[0]), cp->c.c->st[2]);
    if (cp->c.c->sp == 2) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 2, 0, 0, Fbuf);
    sprintf(Fbuf,
        "BX [%7ld]  %-29s    [%7ld]              ",
        cp->c.c->re[1], &(hostbuf2[0]), cp->c.c->st[3]);
    if (cp->c.c->sp == 3) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 3, 0, 0, Fbuf);
    sprintf(Fbuf,
        "CX [%7ld]  %-29s    [%7ld]              ",
        cp->c.c->re[2], &(hostbuf3[0]), cp->c.c->st[4]);
    if (cp->c.c->sp == 4) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 4, 0, 0, Fbuf);
    sprintf(Fbuf,
        "DX [%7ld]  %-29s    [%7ld]              ",
        cp->c.c->re[3], &(hostbuf4[0]), cp->c.c->st[5]);
    if (cp->c.c->sp == 5) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 5, 0, 0, Fbuf);
    sprintf(Fbuf,
      "Flag = %2d                                      [%7ld]             ",
        (int) cp->c.c->fl.E,cp->c.c->st[6]);
    if (cp->c.c->sp == 6) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 6, 0, 0, Fbuf);
    sprintf(Fbuf,
        "%-30.30s                 [%7ld]             ",
        d_data, cp->c.c->st[7]);
    if (cp->c.c->sp == 7) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 7, 0, 0, Fbuf);
#if PLOIDY == 1
    sprintf(Fbuf,
        "                                               [%7ld]             ",
        cp->c.c->st[8]);
    if (cp->c.c->sp == 8) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 8, 0, 0, Fbuf);
    sprintf(Fbuf,
        "                                               [%7ld]             ",
        cp->c.c->st[9]);
    if (cp->c.c->sp == 9) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 9, 0, 0, Fbuf);
#else /* PLOIDY == 1 */
    sprintf(Fbuf,
        "Tracks: Ex So De                               [%7ld]             ",
        cp->c.c->st[8]);
    if (cp->c.c->sp == 8) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 8, 0, 0, Fbuf);
    sprintf(Fbuf,
   "        %ld  %ld  %ld                                [%7ld]            ",
        (I32s) cp->c.c->ex, (I32s) cp->c.c->so, (I32s) cp->c.c->de,
        cp->c.c->st[9]);
    if (cp->c.c->sp == 9) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 9, 0, 0, Fbuf);
#endif /* PLOIDY == 1 */
    sprintf(Fbuf, "        %ld of %ld Cpus ",
        (I32s) cp->c.ac, (I32s) cp->c.n);
    if (cp->c.c->sp == 10) Fbuf[57] = '<';
    FEPrintf(MSG_X, MSG_Y + 10, 0, 0, Fbuf);
}

/*************************************/
/* Check for break condition         */
/*************************************/
int ChkBrk(cp)
Pcells cp;
{
   int waitforbrk, hosttype;
   I32s off_int;
   Pcells hostcp;

   waitforbrk=0;
   off_int = (cp->c.c->ip)-(cp->mm.p);
   if(BrkTrapCondBuf.curbrkdat.BrkSet){
      switch(BrkTrapCondBuf.curbrkdat.TrapType){

         case BRKTYP_GENOME_OFFSET:
            if((cp->d.gi==BrkTrapCondBuf.curbrkdat.prim_genome.gi) &&
               (cp->mm.s==BrkTrapCondBuf.curbrkdat.prim_genome.si) &&
               (off_int==BrkTrapCondBuf.curbrkdat.genoffset)){
               BrkTrapCondBuf.curbrkdat.BrkFnd=1;
            }
            break;

         case BRKTYP_CURCELL_OFFSET:
            if((cp==BrkTrapCondBuf.curbrkdat.MicroSlice) &&
               (off_int==BrkTrapCondBuf.curbrkdat.genoffset)){
               BrkTrapCondBuf.curbrkdat.BrkFnd=1;
            }
            break;

         case BRKTYP_ABSTIMEINST:
         case BRKTYP_INTRVLTIMEINST:
            if(CmpEvents(InstExe, BrkTrapCondBuf.
               curbrkdat.AbsTime)>(-1)){
               BrkTrapCondBuf.curbrkdat.BrkFnd=1;
            }
            break;

         case BRKTYP_PARAGEN_HOSTGEN:
            if((cp->d.gi==BrkTrapCondBuf.
                  curbrkdat.prim_genome.gi) &&
               (cp->mm.s==BrkTrapCondBuf.
                  curbrkdat.prim_genome.si)){
               if((off_int<0)||(off_int>((cp->mm.s)-1))){
                  hostcp=FindHost(cp->c.c->ip, &hosttype);
                  if(hosttype==1){
                     if((hostcp->d.gi==BrkTrapCondBuf.
                           curbrkdat.host_genome.gi) &&
                        (hostcp->mm.s==BrkTrapCondBuf.
                           curbrkdat.host_genome.si)){
                        BrkTrapCondBuf.curbrkdat.BrkFnd=1;
                     }
                  }
               }
            }
            break;

         case BRKTYP_PERMPARAPERMHOST:
            if(IsBit(sl[cp->d.gen.size]->g[cp->d.gi]->bits, 0)){
               if(CmpEvents(sl[cp->d.gen.size]->g[cp->d.gi]->
                  originI, BrkTrapCondBuf.curbrkdat.AbsTime)>(-1)){
                  if((off_int<0)||(off_int>((cp->mm.s)-1))){
                     hostcp=FindHost(cp->c.c->ip, &hosttype);
                     if(hosttype==1){
                        if(IsBit(sl[hostcp->d.gen.size]->
                           g[hostcp->d.gi]->bits, 0)){
                           if(CmpEvents(sl[hostcp->d.gen.size]->
                              g[hostcp->d.gi]->originI,
                              BrkTrapCondBuf.curbrkdat.AbsTime)>(-1)){
                              BrkTrapCondBuf.curbrkdat.BrkFnd=1;
                           }
                        }
                     }
                  }
               }
            }
            break;

         case BRKTYP_PERMGENTIME:
            if(IsBit(sl[cp->d.gen.size]->g[cp->d.gi]->bits, 0)){
               if(CmpEvents(sl[cp->d.gen.size]->g[cp->d.gi]->
                  originI, BrkTrapCondBuf.curbrkdat.AbsTime)>(-1)){
                  BrkTrapCondBuf.curbrkdat.BrkFnd=1;
               }
            }
            break;

         case BRKTYP_PARAGENPERMHOST:
            if((cp->d.gi==BrkTrapCondBuf.
                  curbrkdat.prim_genome.gi) &&
               (cp->mm.s==BrkTrapCondBuf.
                  curbrkdat.prim_genome.si)){
               if((off_int<0)||(off_int>((cp->mm.s)-1))){
                  hostcp=FindHost(cp->c.c->ip, &hosttype);
                  if(hosttype==1){
                     if(IsBit(sl[hostcp->d.gen.size]->
                        g[hostcp->d.gi]->bits, 0)){
                        BrkTrapCondBuf.curbrkdat.BrkFnd=1;
                     }
                  }
               }
            }
            break;

         case BRKTYP_PERMPARAHOST:
            if(IsBit(sl[cp->d.gen.size]->g[cp->d.gi]->bits, 0)){
               if((off_int<0)||(off_int>((cp->mm.s)-1))){
                  hostcp=FindHost(cp->c.c->ip, &hosttype);
                  if(hosttype==1){
                     if((hostcp->d.gi==BrkTrapCondBuf.
                           curbrkdat.host_genome.gi) &&
                        (hostcp->mm.s==BrkTrapCondBuf.
                           curbrkdat.host_genome.si)){
                        BrkTrapCondBuf.curbrkdat.BrkFnd=1;
                     }
                  }
               }
            }
            break;

         case BRKTYP_GENSIZERANGE:
            if((cp->d.gen.size >= BrkTrapCondBuf.curbrkdat.lowlim) &&
               (cp->d.gen.size <= BrkTrapCondBuf.curbrkdat.hilim)){
               if(BrkTrapCondBuf.curbrkdat.permtemp=='b'){
                  BrkTrapCondBuf.curbrkdat.BrkFnd=1;
               }
               else{
                  if(BrkTrapCondBuf.curbrkdat.permtemp=='p'){
                     if(IsBit(sl[cp->d.gen.size]->
                        g[cp->d.gi]->bits, 0)){
                        BrkTrapCondBuf.curbrkdat.BrkFnd=1;
                     }
                  }
                  else{
                     if(!IsBit(sl[cp->d.gen.size]->
                        g[cp->d.gi]->bits, 0)){
                        BrkTrapCondBuf.curbrkdat.BrkFnd=1;
                     }
                  }
               }
            }
            break;

         case BRKTYP_PERMHOST_PARASIZERANGE:
            if(IsBit(sl[cp->d.gen.size]->g[cp->d.gi]->bits, 0)){
               if((off_int<0)||(off_int>((cp->mm.s)-1))){
                  if((cp->d.gen.size >= 
                     BrkTrapCondBuf.curbrkdat.lowlim) &&
                     (cp->d.gen.size <= 
                     BrkTrapCondBuf.curbrkdat.hilim)){
                     hostcp=FindHost(cp->c.c->ip, &hosttype);
                     if(hosttype==1){
                        if(IsBit(sl[hostcp->d.gen.size]->
                           g[hostcp->d.gi]->bits, 0)){
                           BrkTrapCondBuf.curbrkdat.BrkFnd=1;
                        }
                     }
                  }
               }
            }
            break;

         case BRKTYP_PERMPARA_HOSTSIZERANGE:
            if(IsBit(sl[cp->d.gen.size]->g[cp->d.gi]->bits, 0)){
               if((off_int<0)||(off_int>((cp->mm.s)-1))){
                  hostcp=FindHost(cp->c.c->ip, &hosttype);
                  if(hosttype==1){
                     if((hostcp->d.gen.size >=
                        BrkTrapCondBuf.curbrkdat.lowlim) &&
                        (hostcp->d.gen.size <=
                        BrkTrapCondBuf.curbrkdat.hilim)){
                        BrkTrapCondBuf.curbrkdat.BrkFnd=1;
                     }
                  }
               }
            }
            break;

         default:
            break;
      }
   }
   if(BrkTrapCondBuf.curbrkdat.BrkSet){
      if(!BrkTrapCondBuf.curbrkdat.BrkFnd){
         waitforbrk=1;
      }
      else{
         SavBrkDat();
         GoBrkClr(1);
         TrkCPU(cp);
      }
   }
   return waitforbrk;
}

/*************************************/
/* Chk for brk at cell birth/death   */
/*************************************/
void ChkBrkBd()
{
   double curavg, dlta_avg, dlta_pct;

   if(BrkTrapCondBuf.curbrkdat.BrkSet){
      switch(BrkTrapCondBuf.curbrkdat.TrapType){
         case BRKTYP_PCTCHGPOP:
            curavg=CalcAvgPopSizRng();
            dlta_avg=curavg-BrkTrapCondBuf.curbrkdat.avgpoprng;
            dlta_avg=(dlta_avg < 0)?(-1 * dlta_avg):dlta_avg;
            if(BrkTrapCondBuf.curbrkdat.avgpoprng){
               dlta_pct=((dlta_avg / BrkTrapCondBuf.
                  curbrkdat.avgpoprng) * ((double)100));
               if(dlta_pct > BrkTrapCondBuf.curbrkdat.pctchg){
                  BrkTrapCondBuf.curbrkdat.BrkFnd=1;
               }
            }
            else{
               if(dlta_avg){
                  BrkTrapCondBuf.curbrkdat.BrkFnd=1;
               }
            }
            break;
         default:
            break;
      }
   }
}

/*************************************/
/* convert string to Event value     */
/*************************************/
Event Str2Event(eventbuf)
char *eventbuf;
{
   Event event;
   int numlen, mlen;
   char mbuf[10];

   event.m=0;
   event.i=0;
   numlen=strlen(eventbuf);
   if(numlen){
      mlen=(numlen>6)?(numlen-6):0;
      if(mlen){
         strncpy(&(mbuf[0]), eventbuf, mlen);
         mbuf[mlen]='\0';
         sscanf(&(mbuf[0]), "%d", &(event.m));
      }
      sscanf(&(eventbuf[mlen]), "%d", &(event.i));
   }
   return event;
}

void RclBrkDat()
{
   BrkTrapCondBuf.curbrkdat.TrapType=
      BrkTrapCondBuf.savbrkdat.TrapType;
   BrkTrapCondBuf.curbrkdat.BrkSet=
      BrkTrapCondBuf.savbrkdat.BrkSet;
   BrkTrapCondBuf.curbrkdat.BrkFnd=0;

   switch(BrkTrapCondBuf.savbrkdat.TrapType){

      case BRKTYP_GENOME_OFFSET:   /* Genome/offset */
         BrkTrapCondBuf.curbrkdat.prim_genome.gi=
            BrkTrapCondBuf.savbrkdat.prim_genome.gi;
         BrkTrapCondBuf.curbrkdat.prim_genome.si=
            BrkTrapCondBuf.savbrkdat.prim_genome.si;
         BrkTrapCondBuf.curbrkdat.genoffset=
            BrkTrapCondBuf.savbrkdat.genoffset;
         break;

      case BRKTYP_CURCELL_OFFSET:   /* Current cell/offset */
         BrkTrapCondBuf.curbrkdat.MicroSlice=ce;
         BrkTrapCondBuf.curbrkdat.MicroCpu=ce->c.c;
         BrkTrapCondBuf.curbrkdat.MicroCpuI=ce->c.ac;
         BrkTrapCondBuf.curbrkdat.genoffset=
            BrkTrapCondBuf.savbrkdat.genoffset;
         break;

      case BRKTYP_ABSTIMEINST:   /* Absolute Time (Instr Exec) */
         BrkTrapCondBuf.curbrkdat.AbsTime.m=
            BrkTrapCondBuf.savbrkdat.AbsTime.m;
         BrkTrapCondBuf.curbrkdat.AbsTime.i=
            BrkTrapCondBuf.savbrkdat.AbsTime.i;
         break;

      case BRKTYP_INTRVLTIMEINST:   /* Absolute Time (Instr Exec) */
         BrkTrapCondBuf.curbrkdat.IntervalTime.m=
            BrkTrapCondBuf.savbrkdat.IntervalTime.m;
         BrkTrapCondBuf.curbrkdat.IntervalTime.i=
            BrkTrapCondBuf.savbrkdat.IntervalTime.i;

         BrkTrapCondBuf.curbrkdat.AbsTime.m=0;
         BrkTrapCondBuf.curbrkdat.AbsTime.i =
            InstExe.i + BrkTrapCondBuf.curbrkdat.IntervalTime.i;
         if( BrkTrapCondBuf.curbrkdat.AbsTime.i > 999999){
            BrkTrapCondBuf.curbrkdat.AbsTime.i =
               BrkTrapCondBuf.curbrkdat.AbsTime.i - 1000000;
            BrkTrapCondBuf.curbrkdat.AbsTime.m=1;
         }
         BrkTrapCondBuf.curbrkdat.AbsTime.m +=
            InstExe.m + BrkTrapCondBuf.curbrkdat.IntervalTime.m;
         break;

      case BRKTYP_PARAGEN_HOSTGEN:   /* Parasite genome / Host genome */
         BrkTrapCondBuf.curbrkdat.host_genome.gi=
            BrkTrapCondBuf.savbrkdat.host_genome.gi;
         BrkTrapCondBuf.curbrkdat.host_genome.si=
            BrkTrapCondBuf.savbrkdat.host_genome.si;
         BrkTrapCondBuf.curbrkdat.prim_genome.gi=
            BrkTrapCondBuf.savbrkdat.prim_genome.gi;
         BrkTrapCondBuf.curbrkdat.prim_genome.si=
            BrkTrapCondBuf.savbrkdat.prim_genome.si;
         break;

      case BRKTYP_PCTCHGPOP:
         BrkTrapCondBuf.curbrkdat.pctchg=
            BrkTrapCondBuf.savbrkdat.pctchg;
         BrkTrapCondBuf.curbrkdat.lowlim=
            BrkTrapCondBuf.savbrkdat.lowlim;
         BrkTrapCondBuf.curbrkdat.hilim=
            BrkTrapCondBuf.savbrkdat.hilim;
         BrkTrapCondBuf.curbrkdat.permtemp=
            BrkTrapCondBuf.savbrkdat.permtemp;
         BrkTrapCondBuf.curbrkdat.avgpoprng=CalcAvgPopSizRng();
         break;

      case BRKTYP_PERMPARAPERMHOST:
         BrkTrapCondBuf.curbrkdat.AbsTime.m=
            BrkTrapCondBuf.savbrkdat.AbsTime.m;
         BrkTrapCondBuf.curbrkdat.AbsTime.i=
            BrkTrapCondBuf.savbrkdat.AbsTime.i;
         break;

      case BRKTYP_PERMGENTIME:
         BrkTrapCondBuf.curbrkdat.AbsTime.m=
            BrkTrapCondBuf.savbrkdat.AbsTime.m;
         BrkTrapCondBuf.curbrkdat.AbsTime.i=
            BrkTrapCondBuf.savbrkdat.AbsTime.i;
         break;

      case BRKTYP_PARAGENPERMHOST:   /* parasite - perm host */
         BrkTrapCondBuf.curbrkdat.prim_genome.gi=
            BrkTrapCondBuf.savbrkdat.prim_genome.gi;
         BrkTrapCondBuf.curbrkdat.prim_genome.si=
            BrkTrapCondBuf.savbrkdat.prim_genome.si;
         break;

      case BRKTYP_PERMPARAHOST:   /* perm parasite - given host */
         BrkTrapCondBuf.curbrkdat.host_genome.gi=
            BrkTrapCondBuf.savbrkdat.host_genome.gi;
         BrkTrapCondBuf.curbrkdat.host_genome.si=
            BrkTrapCondBuf.savbrkdat.host_genome.si;
         break;

      case BRKTYP_GENSIZERANGE:
         BrkTrapCondBuf.curbrkdat.lowlim=
            BrkTrapCondBuf.savbrkdat.lowlim;
         BrkTrapCondBuf.curbrkdat.hilim=
            BrkTrapCondBuf.savbrkdat.hilim;
         BrkTrapCondBuf.curbrkdat.permtemp=
            BrkTrapCondBuf.savbrkdat.permtemp;
         break;

      case BRKTYP_PERMPARA_HOSTSIZERANGE:
      case BRKTYP_PERMHOST_PARASIZERANGE:
         BrkTrapCondBuf.curbrkdat.lowlim=
            BrkTrapCondBuf.savbrkdat.lowlim;
         BrkTrapCondBuf.curbrkdat.hilim=
            BrkTrapCondBuf.savbrkdat.hilim;
         break;

      default:
         break;
   }
}

Pcells FindHost(soupaddr, hosttype)
I32s soupaddr;
int *hosttype;
{
   Pcells scncp;
   int loopflag;
   I32s hostend, daughtend;

   (*hosttype)=0;

   /* select currently active cell */
   scncp=ce;

   loopflag=1;
   while(loopflag){

      /* host end = host start + host size */
      hostend=(scncp->mm.p)+(scncp->mm.s)-1;

      /* if addr is inside a host creature */
      if(!((soupaddr<(scncp->mm.p))||
         (soupaddr>hostend))){
         (*hosttype)=1;
         loopflag=0;
      }
      else{

         /* daughter end = daughter start + daughter size */
         daughtend=(scncp->md.p)+(scncp->md.s)-1;

         /* if addr is in daughter of creature ? */
         if(!((soupaddr<(scncp->md.p))||
            (soupaddr>daughtend))){
            (*hosttype)=2;
            loopflag=0;
         }
         else{

            /* select next cell in slicer queue */
            scncp = &cells[scncp->q.n_time.a][scncp->q.n_time.i];

            /* if selected cell is currently active cell */
            if(scncp==ce){

               /* current location is not in live cell */
               loopflag=0;
            }
         }
      }
   }
   return scncp;
}

/*************************************/
/* Repeat previous break settings    */
/*************************************/
void GoRepeatBrk()
{
   GoBrkClr(1);
   if(BrkTrapCondBuf.savbrkdat.BrkSet){
      MC_step=1;
      RclBrkDat();
   }
   else{
      sprintf(Fbuf, "no previous break settings available");
      FEError(-2208, NOEXIT, NOWRITE, Fbuf);
   }
}

/*************************************/
/* Enter soup view start address     */
/*************************************/
void ViewSoupStartAddr()
{
   I32s tsoupviewstrt;
   int abortflag, loopflag;

   abortflag=0;
   soupviewstrt=0;

   loopflag=1;
   while(loopflag){

#if FRONTEND == BASIC
      FEClrmsg(MSG_Y, "");
      FEBanner();
      FEStats();
#endif /* FRONTEND == BASIC */

   /* display soup limits */
      sprintf(Fbuf,"soup address limits = 0 - %ld", SoupSize-1);
      FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);

      /* enter view start address */
      tsoupviewstrt=EnterLongVal(MSG_Y+1,
         "Enter view start address (enter to abort)->",
         &abortflag);

      if(!abortflag){
         if((tsoupviewstrt>=0)&&(tsoupviewstrt<SoupSize)){
            soupviewstrt=tsoupviewstrt;
            loopflag=0;
         }
         else{
            sprintf(Fbuf, "invalid soup address");
            FEError(-2209, NOEXIT, NOWRITE, Fbuf);
         }
      }
      else{
         loopflag=0;
      }
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* display soup memory page          */
/*************************************/
void DisplaySoupPage()
{

   I32s soupviewaddr, maxviewstrt;
   int loopflag, souppglnct;
   char hostbuf1[20], hostbuf2[10], hostbuf3[7];

   maxviewstrt=(VIEWSOUPLINES>SoupSize)?0:SoupSize-VIEWSOUPLINES;
   soupviewstrt=(soupviewstrt<0)?
      0:((soupviewstrt>maxviewstrt)?
      maxviewstrt:soupviewstrt);

   soupviewaddr=soupviewstrt;

#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */

   sprintf(Fbuf, "        soup      soup                    current          host      host");
   FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);
   sprintf(Fbuf, "       address    byte    opcode         resident         status    offset");
   FEPrintf(MSG_X, MSG_Y+1, 0, 0, Fbuf);
   sprintf(Fbuf, "      ---------  ------  ---------  -------------------  ---------  ------");
   FEPrintf(MSG_X, MSG_Y+2, 0, 0, Fbuf);

   souppglnct=0;
   loopflag=1;
   while(loopflag){
      if(souppglnct<VIEWSOUPLINES){
         if(soupviewaddr<SoupSize){
            ViewSoupHost(soupviewaddr, &(hostbuf1[0]),
               &(hostbuf2[0]), &(hostbuf3[0]));

            sprintf(Fbuf, "      [%7ld]  [0x%02x]  %-9s  %-19s  %-9s  %-6s",
               soupviewaddr,
#if PLOIDY == 1
               soup[ad(soupviewaddr)],
               id[soup[ad(soupviewaddr)]].mn,
#else /* PLOIDY == 1 */
               soup[ad(soupviewaddr)][ce->c.c->ex],
               id[soup[ad(soupviewaddr)][ce->c.c->ex]].mn,
#endif /* PLOIDY == 1 */
               &(hostbuf1[0]), &(hostbuf2[0]), &(hostbuf3[0]));
            FEPrintf(MSG_X, MSG_Y+3+souppglnct, 0, 0, Fbuf);
            souppglnct++;
            soupviewaddr++;
         }
         else{
            loopflag=0;
         }
      }
      else{
         loopflag=0;
      }
   }
}

/*************************************/
/* calc average pop over size range  */
/*************************************/
double CalcAvgPopSizRng()
{
   int i, loopflag, j;
   I32s totsizpoprng, totsizcntrng;
   double avgpoprng;

   totsizpoprng=0;
   totsizcntrng=0;

   loopflag=1;
   i=BrkTrapCondBuf.curbrkdat.lowlim;
   while(loopflag){
      if(i < siz_sl){
         if(i > BrkTrapCondBuf.curbrkdat.hilim){
            loopflag=0;
         }
         else{
            if(sl[i]){
               if(BrkTrapCondBuf.curbrkdat.permtemp=='b'){
                  totsizpoprng+=sl[i]->num_c;
               }
               else{
                  for(j=0; j < sl[i]->num_g; j++){
                     if( ((I32u)(sl[i]->g[j])) > 4){
                        if(BrkTrapCondBuf.curbrkdat.permtemp=='p'){
                           if(IsBit(sl[i]->g[j]->bits, 0)){
                              totsizpoprng+=sl[i]->g[j]->pop;
                           }
                        }
                        else{
                           if(!IsBit(sl[i]->g[j]->bits, 0)){
                              totsizpoprng+=sl[i]->g[j]->pop;
                           }
                        }
                     }
                  }
               }
               totsizcntrng++;
            }
            i++;
         }
      }
      else{
         loopflag=0;
      }
   }
   if(totsizcntrng){
      avgpoprng = ((double)totsizpoprng) / (double)(totsizcntrng);
   }
   else{
      avgpoprng=0;
   }
   return avgpoprng;
}

#ifndef __GUI__
/*************************************/
/* debugger display control          */
/*************************************/
void DbgDisplCtrl(cp)
Pcells cp;
{
   int loopflag;
   char cc;

   loopflag=1;
   while(loopflag){
      FEBanner();
      FEStats();
      if(dbgdisptype==0){
         sprintf(Fbuf,"t-toggle display  q-quit->");
      }
      else{
         sprintf(Fbuf,"a-addr  U/D-page  u/d-scroll  i-IP  t-toggle display  q-quit->");
      }
      FEPrintf(HLP_X, HLP_Y, 1, 0, Fbuf);
#ifdef AMIGA
#if FRONTEND == BASIC
      nodelay(stdscr, FALSE);
#endif /* FRONTEND == BASIC */
#endif /* AMIGA */
      cc=FEGetch(HLP_X+strlen(&(Fbuf[0])), HLP_Y);
#ifdef AMIGA
#if FRONTEND == BASIC
      nodelay(stdscr, TRUE);
#endif /* FRONTEND == BASIC */
#endif /* AMIGA */
      switch(cc){
         case 'a':
            if(dbgdisptype==1){
               ViewSoupStartAddr();
               FEClrmsg(MSG_Y, "");
               FEBanner();
               FEStats();
               DisplaySoupPage();
            }
            break;
         case 'U':
            if(dbgdisptype==1){
               soupviewstrt+=VIEWSOUPLINES;
               FEClrmsg(MSG_Y, "");
               FEBanner();
               FEStats();
               DisplaySoupPage();
            }
            break;
         case 'D':
            if(dbgdisptype==1){
               soupviewstrt-=VIEWSOUPLINES;
               FEClrmsg(MSG_Y, "");
               FEBanner();
               FEStats();
               DisplaySoupPage();
            }
            break;
         case 'u':
            if(dbgdisptype==1){
               soupviewstrt++;
               FEClrmsg(MSG_Y, "");
               FEBanner();
               FEStats();
               DisplaySoupPage();
            }
            break;
         case 'd':
            if(dbgdisptype==1){
               soupviewstrt--;
               FEClrmsg(MSG_Y, "");
               FEBanner();
               FEStats();
               DisplaySoupPage();
            }
            break;
         case 'i':
            if(dbgdisptype==1){
               soupviewstrt=ce->c.c->ip;
               FEClrmsg(MSG_Y, "");
               FEBanner();
               FEStats();
               DisplaySoupPage();
            }
            break;
         case 't':
            if(dbgdisptype==0){
               FEClrmsg(MSG_Y, "");
               FEBanner();
               FEStats();
               dbgdisptype=1;
               soupviewstrt=ce->c.c->ip;
               DisplaySoupPage();
            }
            else{
               FEClrmsg(MSG_Y, "");
               FEBanner();
               FEStats();
               DebugDisplay(cp);
               dbgdisptype=0;
            }
            break;
         case 'q':
            loopflag=0;
            break;
         default:
            break;
      }
   }
}
#endif /* __GUI__ */

/*************************************/
/* compare events                    */
/*************************************/
int CmpEvents(event1, event2)
Event  event1, event2;
{
   int eventcmpcd;

   if((event1.m)<(event2.m)){
      eventcmpcd=-1;
   }
   else{
      if((event1.m)==(event2.m)){
         if((event1.i)<(event2.i)){
            eventcmpcd=-1;
         }
         else{
            if((event1.i)==(event2.i)){
               eventcmpcd=0;
            }
            else{
               eventcmpcd=1;
            }
         }
      }
      else{
         eventcmpcd=1;
      }
   }
   return eventcmpcd;
}

/*************************************/
/* disassembly menu                  */
/*************************************/
void DisasmMenu(cp)
Pcells cp;
{
   int menuline, loopflag, menuopt, abortflag, menunum;

   abortflag=0;
   loopflag=1;
   while(loopflag){
      menuline=0;
      menunum=1;

#if FRONTEND == BASIC
      FEClrmsg(MSG_Y, "");
      FEBanner();
      FEStats();
#endif /* FRONTEND == BASIC */

      MenuLine("Genome disassembly", 
         &menuline, MSG_X, &menunum, 0);
      MenuLine("current creature", 
         &menuline, MSG_X, &menunum, 1);
      MenuLine("specific genome", 
         &menuline, MSG_X, &menunum, 1);
      MenuLine("resident of specific address", 
         &menuline, MSG_X, &menunum, 1);
      MenuLine("q - Quit", 
         &menuline, MSG_X, &menunum, 0);
      MenuLine(" ",
         &menuline, MSG_X, &menunum, 0);
      MenuLine("Menu Option->",
         &menuline, MSG_X, &menunum, 0);

      FEGetStr(MSG_X + strlen(&(Fbuf[0])), MSG_Y + (menuline-1));
      if(strlen(&(FGSbuf[0]))){
         if(!strcmp(&(FGSbuf[0]),"q")){
            abortflag=1;
            loopflag=0;
         }
         else{
            if(sscanf(&(FGSbuf[0]), "%d", &menuopt)==1){
               switch(menuopt){
                  case 1:   /* current creature */
                     Disasm_Creature(cp);
                     loopflag=0;
                     break;
                  case 2:   /* specific genome */
                     Disasm_SpecGenome();
                     loopflag=0;
                     break;
                  case 3:   /* resident of specific address */
                     Disasm_Resident();
                     loopflag=0;
                     break;
                  default:
                     sprintf(Fbuf, "invalid menu option");
                     FEError(-2210, NOEXIT, NOWRITE, Fbuf);
                     break;
               }
            }
            else{
               sprintf(Fbuf, "invalid menu option");
               FEError(-2211, NOEXIT, NOWRITE, Fbuf);
            }
         }
      }
      else{
         abortflag=1;
         loopflag=0;
      }
   }

#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* disassemble creature              */
/*************************************/
void Disasm_Creature(cp)
Pcells cp;
{
   char file[80];
   FILE *srcfilptr;

   sprintf(&(file[0]), "%s%04ld%3s",
      &(GenebankPath[0]), cp->d.gen.size,
      sl[cp->d.gen.size]->g[cp->d.gi]->gen.label);
   if(!(srcfilptr=fopen(&(file[0]), "rb"))){
      WritAscFile(sl[cp->d.gen.size]->g[cp->d.gi], &(file[0]));
   }
   else{
      fclose(srcfilptr);
      sprintf(Fbuf, "disassembly file already exists");
      FEError(-2212, NOEXIT, NOWRITE, Fbuf);
   }
}

/*************************************/
/* disassemble specific genome       */
/*************************************/
void Disasm_SpecGenome()
{
   GlIndex tmpgen;
   int abortflag, loopflag;
   char file[80];
   FILE *srcfilptr;

   abortflag=0;

   loopflag=1;
   while(loopflag){

      /* enter genome name */
      tmpgen=EnterGenome(MSG_Y,
         "Enter genome to disassemble (eg 0080aaa) (enter to abort)->",
         &abortflag, 1);
      if(!abortflag){
         sprintf(&(file[0]), "%s%04ld%3s",
            &(GenebankPath[0]), tmpgen.si, Int2Lbl(tmpgen.gi));
         if(!(srcfilptr=fopen(&(file[0]), "rb"))){
            WritAscFile(sl[tmpgen.si]->g[tmpgen.gi], &(file[0]));
            loopflag=0;
         }
         else{
            fclose(srcfilptr);
            sprintf(Fbuf, "disassembly file already exists");
            FEError(-2213, NOEXIT, NOWRITE, Fbuf);
         }
      }
      else{
         loopflag=0;
      }
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* disassemble soup resident         */
/*************************************/
void Disasm_Resident()
{
   I32s disasmaddr;
   int abortflag, loopflag, hosttype;
   Pcells rescp;
   char file[80];
   FILE *srcfilptr;

   abortflag=0;

   loopflag=1;
   while(loopflag){

#if FRONTEND == BASIC
      FEClrmsg(MSG_Y, "");
      FEBanner();
      FEStats();
#endif /* FRONTEND == BASIC */

   /* display soup limits */
      sprintf(Fbuf,"soup address limits = 0 - %ld", SoupSize-1);
      FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);

      /* enter view start address */
      disasmaddr=EnterLongVal(MSG_Y+1,
         "address of resident to disassemble (enter to abort)->",
         &abortflag);

      if(!abortflag){
         if((disasmaddr>=0)&&(disasmaddr<SoupSize)){
            rescp=FindHost(disasmaddr, &hosttype);

            switch(hosttype){

               case 1:   /* live host */

                  /* display host identity */
                  if(rescp->ld){
                     sprintf(&(file[0]), "%s%04ld%3s",
                        &(GenebankPath[0]), rescp->d.gen.size,
                        Int2Lbl(rescp->d.gi));
                     if(!(srcfilptr=fopen(&(file[0]), "rb"))){
                        WritAscFile(sl[rescp->d.gen.size]->
                           g[rescp->d.gi], &(file[0]));
                        loopflag=0;
                     }
                     else{
                        fclose(srcfilptr);
                        sprintf(Fbuf, "disassembly file already exists");
                        FEError(-2214, NOEXIT, NOWRITE, Fbuf);
                     }
                  }
                  else{
                     sprintf(Fbuf, "resident is dead");
                     FEError(-2215, NOEXIT, NOWRITE, Fbuf);
                  }
                  break;

               case 2:   /* embryonic resident */
                  sprintf(Fbuf, "resident is embryonic");
                  FEError(-2216, NOEXIT, NOWRITE, Fbuf);
                  break;

               default:   /* free memory */
                  sprintf(Fbuf, "location is in free memory");
                  FEError(-2217, NOEXIT, NOWRITE, Fbuf);
                  break;
            }
         }
         else{
            sprintf(Fbuf, "invalid soup address");
            FEError(-2218, NOEXIT, NOWRITE, Fbuf);
         }
      }
      else{
         loopflag=0;
      }
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/******* Break Trap Settings *********/

/*************************************/
/* Genome/offset                     */
/*************************************/
void Brk_Genome_Offset()
{
   GlIndex brkgen;
   I32s offset;
   int abortflag;

   abortflag=0;
   GoBrkClr(1);

   /* enter genome name */
   brkgen=EnterGenome(MSG_Y,
      "Enter genome (eg 0080aaa) (enter to abort)->", &abortflag, 1);

   if(!abortflag){

      /* enter creature offset */
      offset=EnterLongVal(MSG_Y+1,
         "Enter creature offset (enter to abort)->", &abortflag);
   }
   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_GENOME_OFFSET;
      BrkTrapCondBuf.curbrkdat.prim_genome.gi=brkgen.gi;
      BrkTrapCondBuf.curbrkdat.prim_genome.si=brkgen.si;
      BrkTrapCondBuf.curbrkdat.genoffset=offset;
   }
   else{
      GoBrkClr(1);
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* Current cell/offset               */
/*************************************/
void Brk_CurCell_Offset()
{
   I32s offset;
   int abortflag;

   abortflag=0;
   GoBrkClr(1);

#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
   sprintf(Fbuf,"current cell is %04ld%3s",
      ce->d.gen.size,Int2Lbl(ce->d.gi));
   FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);

   /* enter creature offset */
   offset=EnterLongVal(MSG_Y+1,
      "Enter creature offset (enter to abort)->", &abortflag);

   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_CURCELL_OFFSET;
      TrkCell(ce);
      BrkTrapCondBuf.curbrkdat.genoffset=offset;
   }
   else{
      GoBrkClr(1);
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* Absolute Time (Instr Exec)        */
/*************************************/
void Brk_AbsTimeInst()
{
   Event stoptime;
   int loopflag, abortflag;

   abortflag=0;
   GoBrkClr(1);

   /* enter absolute time in instructions */
   loopflag=1;
   while(loopflag){
#if FRONTEND == BASIC
      FEClrmsg(MSG_Y, "");
      FEBanner();
      FEStats();
#endif /* FRONTEND == BASIC */
      if(InstExe.m){
         sprintf(Fbuf,"current time (instructions executed) = %d%06d",
            InstExe.m, InstExe.i);
      }
      else{
         sprintf(Fbuf,"current time (instructions executed) = %6d",
            InstExe.i);
      }
      FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);
      sprintf(Fbuf,"Enter break time (enter to abort)->");
      FEPrintf(MSG_X, MSG_Y+1, 0, 0, Fbuf);
      FEGetStr(HLP_X+strlen(&(Fbuf[0])), MSG_Y+1);
      if(strlen(&(FGSbuf[0]))){
         stoptime=Str2Event(&(FGSbuf[0]));
         if(CmpEvents(stoptime, InstExe)==1){
            loopflag=0;
         }
         else{
            sprintf(Fbuf, "invalid start time");
            FEError(-2219, NOEXIT, NOWRITE, Fbuf);
         }
      }
      else{
         abortflag=1;
         loopflag=0;
      }
   }
   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_ABSTIMEINST;
      BrkTrapCondBuf.curbrkdat.AbsTime.m=stoptime.m;
      BrkTrapCondBuf.curbrkdat.AbsTime.i=stoptime.i;
   }
   else{
      GoBrkClr(1);
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* Time Interval (Instr Exec)        */
/*************************************/
void Brk_IntrvlTimeInst()
{
   Event stoptime, intervaltime;
   int abortflag;

   abortflag=0;
   GoBrkClr(1);

   /* enter interval time in instructions */
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
   if(InstExe.m){
      sprintf(Fbuf,"current time (instructions executed) = %d%06d",
         InstExe.m, InstExe.i);
   }
   else{
      sprintf(Fbuf,"current time (instructions executed) = %6d",
         InstExe.i);
   }
   FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);
   sprintf(Fbuf,"Enter interval time (enter to abort)->");
   FEPrintf(MSG_X, MSG_Y+1, 0, 0, Fbuf);
   FEGetStr(HLP_X+strlen(&(Fbuf[0])), MSG_Y+1);
   if(strlen(&(FGSbuf[0]))){
      intervaltime=Str2Event(&(FGSbuf[0]));
      stoptime.m=0;
      stoptime.i = InstExe.i + intervaltime.i;
      if( stoptime.i > 999999){
         stoptime.i = stoptime.i - 1000000;
         stoptime.m=1;
      }
      stoptime.m += InstExe.m + intervaltime.m;
   }
   else{
      abortflag=1;
   }

   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_INTRVLTIMEINST;
      BrkTrapCondBuf.curbrkdat.AbsTime.m=stoptime.m;
      BrkTrapCondBuf.curbrkdat.AbsTime.i=stoptime.i;
      BrkTrapCondBuf.curbrkdat.IntervalTime.m=intervaltime.m;
      BrkTrapCondBuf.curbrkdat.IntervalTime.i=intervaltime.i;
   }
   else{
      GoBrkClr(1);
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* Parasite genome / Host genome     */
/*************************************/
void Brk_ParaGen_HostGen()
{
   GlIndex para_gen, host_gen;
   int abortflag;

   abortflag=0;
   GoBrkClr(1);

   /* enter parasite genome name */
   para_gen=EnterGenome(MSG_Y,
      "Enter parasite genome (eg 0080aaa) (enter to abort)->",
      &abortflag, 1);

   if(!abortflag){
      host_gen=EnterGenome(MSG_Y+1,
         "Enter host genome (eg 0080aaa) (enter to abort)->",
         &abortflag, 1);
   }
   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_PARAGEN_HOSTGEN;
      BrkTrapCondBuf.curbrkdat.prim_genome.gi=para_gen.gi;
      BrkTrapCondBuf.curbrkdat.prim_genome.si=para_gen.si;
      BrkTrapCondBuf.curbrkdat.host_genome.gi=host_gen.gi;
      BrkTrapCondBuf.curbrkdat.host_genome.si=host_gen.si;
   }
   else{
      GoBrkClr(1);
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* Pct Chg in Population             */
/*************************************/
void Brk_PctChgPop()
{
   int abortflag, loopflag;
   I32s lowlim, hilim;
   double pctchg;
   char permtemp;

   abortflag=0;
   GoBrkClr(1);

   if(!GeneBnker){
      TGeneBnker=GeneBnker;
      GeneBnker=1;
      ChangeGeneBnker(GeneBnker);
   }
   loopflag=1;
   while(loopflag){

      /* Enter percent change in population */
      pctchg=EnterFloatVal(MSG_Y,
         "Enter pct change in population (pct > 0)->", &abortflag);
      if(!abortflag){
         if(pctchg > 0){
            loopflag=0;
         }
         else{
            sprintf(Fbuf, "invalid entry");
            FEError(-2220, NOEXIT, NOWRITE, Fbuf);
         }
      }
      else{
         loopflag=0;
      }
   }
   if(!abortflag){

      loopflag=1;
      while(loopflag){

         /* Enter lower limit of size range */
         lowlim=EnterLongVal(MSG_Y+1,
            "Enter lower limit of size range ->", &abortflag);
         if(!abortflag){
            if(lowlim > 0){
               loopflag=0;
            }
            else{
               sprintf(Fbuf, "invalid entry");
               FEError(-2221, NOEXIT, NOWRITE, Fbuf);
            }
         }
         else{
            loopflag=0;
         }
      }
      if(!abortflag){

         loopflag=1;
         while(loopflag){

            /* Enter upper limit of size range */
            hilim=EnterLongVal(MSG_Y+2,
               "Enter upper limit of size range ->", &abortflag);
            if(!abortflag){
               if(hilim < lowlim){
                  sprintf(Fbuf, "invalid entry");
                  FEError(-2222, NOEXIT, NOWRITE, Fbuf);
               }
               else{
                  loopflag=0;
               }
            }
            else{
               loopflag=0;
            }
         }
         if(!abortflag){

            loopflag=1;
            while(loopflag){

               /* Genomes - p-permanent, t-temporary, b-both */
               sprintf(Fbuf,
                  "Genomes - p-permanent, t-temporary, b-both->");
               FEPrintf(MSG_X, MSG_Y+3, 0, 0, Fbuf);
               FEGetStr(HLP_X+strlen(&(Fbuf[0])), MSG_Y+3);
               if(strlen(&(FGSbuf[0]))){
                  switch(FGSbuf[0]){
                     case 'p':
                     case 't':
                     case 'b':
                        loopflag=0;
                        permtemp=FGSbuf[0];
                        break;
                     default :
                        sprintf(Fbuf, "invalid entry");
                        FEError(-2223, NOEXIT, NOWRITE, Fbuf);
                  }
               }
               else{
                  loopflag=0;
                  abortflag=1;
               }
            }
         }
      }
   }

   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_PCTCHGPOP;
      BrkTrapCondBuf.curbrkdat.pctchg=pctchg;
      BrkTrapCondBuf.curbrkdat.lowlim=lowlim;
      BrkTrapCondBuf.curbrkdat.hilim=hilim;
      BrkTrapCondBuf.curbrkdat.permtemp=permtemp;
      BrkTrapCondBuf.curbrkdat.avgpoprng=CalcAvgPopSizRng();
   }
   else{
      GoBrkClr(1);
   }

#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* permanent parasite on perm host   */
/*************************************/
void Brk_PermParaPermHost()
{
   Event begtime;
   int abortflag;

   abortflag=0;
   GoBrkClr(1);

   /* enter beginning time in instructions */
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */

   if(!GeneBnker){
      TGeneBnker=GeneBnker;
      GeneBnker=1;
      ChangeGeneBnker(GeneBnker);
   }
   if(InstExe.m){
      sprintf(Fbuf,"current time (instructions executed) = %d%06d",
         InstExe.m, InstExe.i);
   }
   else{
      sprintf(Fbuf,"current time (instructions executed) = %6d",
         InstExe.i);
   }
   FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);
   sprintf(Fbuf,
      "Enter earliest origin time to look for (enter to abort)->");
   FEPrintf(MSG_X, MSG_Y+1, 0, 0, Fbuf);
   FEGetStr(HLP_X+strlen(&(Fbuf[0])), MSG_Y+1);
   if(strlen(&(FGSbuf[0]))){
      begtime=Str2Event(&(FGSbuf[0]));
   }
   else{
      abortflag=1;
   }

   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_PERMPARAPERMHOST;
      BrkTrapCondBuf.curbrkdat.AbsTime.m=begtime.m;
      BrkTrapCondBuf.curbrkdat.AbsTime.i=begtime.i;
   }
}

/*************************************/
/* any permanent genome / given time */
/*************************************/
void Brk_PermGenTime()
{
   Event begtime;
   int loopflag, abortflag;

   abortflag=0;
   GoBrkClr(1);

   if(!GeneBnker){
      TGeneBnker=GeneBnker;
      GeneBnker=1;
      ChangeGeneBnker(GeneBnker);
   }
   /* enter absolute time in instructions */
   loopflag=1;
   while(loopflag){
#if FRONTEND == BASIC
      FEClrmsg(MSG_Y, "");
      FEBanner();
      FEStats();
#endif /* FRONTEND == BASIC */
      if(InstExe.m){
         sprintf(Fbuf,"current time (instructions executed) = %d%06d",
            InstExe.m, InstExe.i);
      }
      else{
         sprintf(Fbuf,"current time (instructions executed) = %6d",
            InstExe.i);
      }
      FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);
      sprintf(Fbuf,
         "Enter earliest origin time to look for (enter to abort)->");
      FEPrintf(MSG_X, MSG_Y+1, 0, 0, Fbuf);
      FEGetStr(HLP_X+strlen(&(Fbuf[0])), MSG_Y+1);
      if(strlen(&(FGSbuf[0]))){
         begtime=Str2Event(&(FGSbuf[0]));
         loopflag=0;
      }
      else{
         abortflag=1;
         loopflag=0;
      }
   }
   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_PERMGENTIME;
      BrkTrapCondBuf.curbrkdat.AbsTime.m=begtime.m;
      BrkTrapCondBuf.curbrkdat.AbsTime.i=begtime.i;
   }
   else{
      GoBrkClr(1);
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* given parasite / permanent host   */
/*************************************/
void Brk_ParaGenPermHost()
{
   GlIndex para_gen;
   int abortflag;

   abortflag=0;
   GoBrkClr(1);

   if(!GeneBnker){
      TGeneBnker=GeneBnker;
      GeneBnker=1;
      ChangeGeneBnker(GeneBnker);
   }
   /* enter parasite genome name */
   para_gen=EnterGenome(MSG_Y,
      "Enter parasite genome (eg 0080aaa) (enter to abort)->",
      &abortflag, 1);

   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_PARAGENPERMHOST;
      BrkTrapCondBuf.curbrkdat.prim_genome.gi=para_gen.gi;
      BrkTrapCondBuf.curbrkdat.prim_genome.si=para_gen.si;
   }
   else{
      GoBrkClr(1);
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* perm parasite / given host        */
/*************************************/
void Brk_PermParaHost()
{
   GlIndex host_gen;
   int abortflag;

   abortflag=0;
   GoBrkClr(1);

   if(!GeneBnker){
      TGeneBnker=GeneBnker;
      GeneBnker=1;
      ChangeGeneBnker(GeneBnker);
   }
   /* enter parasite genome name */
   host_gen=EnterGenome(MSG_Y,
      "Enter host genome (eg 0080aaa) (enter to abort)->",
      &abortflag, 1);

   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_PERMPARAHOST;
      BrkTrapCondBuf.curbrkdat.host_genome.gi=host_gen.gi;
      BrkTrapCondBuf.curbrkdat.host_genome.si=host_gen.si;
   }
   else{
      GoBrkClr(1);
   }
#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* any genome in given size range    */
/*************************************/
void Brk_GenSizeRange()
{
   int abortflag, loopflag;
   I32s lowlim, hilim;
   char permtemp;

   abortflag=0;
   GoBrkClr(1);

   loopflag=1;
   while(loopflag){

      /* Enter lower limit of size range */
      lowlim=EnterLongVal(MSG_Y,
         "Enter lower limit of size range ->", &abortflag);
      if(!abortflag){
         if(lowlim > 0){
            loopflag=0;
         }
         else{
            sprintf(Fbuf, "invalid entry");
            FEError(-2224, NOEXIT, NOWRITE, Fbuf);
         }
      }
      else{
         loopflag=0;
      }
   }
   if(!abortflag){

      loopflag=1;
      while(loopflag){

         /* Enter upper limit of size range */
         hilim=EnterLongVal(MSG_Y+1,
            "Enter upper limit of size range ->", &abortflag);
         if(!abortflag){
            if(hilim < lowlim){
               sprintf(Fbuf, "invalid entry");
               FEError(-2225, NOEXIT, NOWRITE, Fbuf);
            }
            else{
               loopflag=0;
            }
         }
         else{
            loopflag=0;
         }
      }
      if(!abortflag){
         if(GeneBnker){
            loopflag=1;
            while(loopflag){

               /* Genomes - p-permanent, t-temporary, b-both */
               sprintf(Fbuf,
                  "Genomes - p-permanent, t-temporary, b-both->");
               FEPrintf(MSG_X, MSG_Y+2, 0, 0, Fbuf);
               FEGetStr(HLP_X+strlen(&(Fbuf[0])), MSG_Y+2);
               if(strlen(&(FGSbuf[0]))){
                  switch(FGSbuf[0]){
                     case 'p':
                     case 't':
                     case 'b':
                        loopflag=0;
                        permtemp=FGSbuf[0];
                        break;
                     default :
                        sprintf(Fbuf, "invalid entry");
                        FEError(-2226, NOEXIT, NOWRITE, Fbuf);
                  }
               }
               else{
                  loopflag=0;
                  abortflag=1;
               }
            }
         }
         else{
            permtemp='b';
         }
      }
   }

   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_GENSIZERANGE;
      BrkTrapCondBuf.curbrkdat.lowlim=lowlim;
      BrkTrapCondBuf.curbrkdat.hilim=hilim;
      BrkTrapCondBuf.curbrkdat.permtemp=permtemp;
   }
   else{
      GoBrkClr(1);
   }

#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* perm parasite, host size range    */
/*************************************/
void Brk_PermPara_HostSizeRange()
{
   int abortflag, loopflag;
   I32s lowlim, hilim;

   abortflag=0;
   GoBrkClr(1);

   if(!GeneBnker){
      TGeneBnker=GeneBnker;
      GeneBnker=1;
      ChangeGeneBnker(GeneBnker);
   }
   loopflag=1;
   while(loopflag){

      /* Enter lower limit of size range */
      lowlim=EnterLongVal(MSG_Y,
         "Enter lower limit of size range ->", &abortflag);
      if(!abortflag){
         if(lowlim > 0){
            loopflag=0;
         }
         else{
            sprintf(Fbuf, "invalid entry");
            FEError(-2227, NOEXIT, NOWRITE, Fbuf);
         }
      }
      else{
         loopflag=0;
      }
   }
   if(!abortflag){

      loopflag=1;
      while(loopflag){

         /* Enter upper limit of size range */
         hilim=EnterLongVal(MSG_Y+1,
            "Enter upper limit of size range ->", &abortflag);
         if(!abortflag){
            if(hilim < lowlim){
               sprintf(Fbuf, "invalid entry");
               FEError(-2228, NOEXIT, NOWRITE, Fbuf);
            }
            else{
               loopflag=0;
            }
         }
         else{
            loopflag=0;
         }
      }
   }

   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_PERMPARA_HOSTSIZERANGE;
      BrkTrapCondBuf.curbrkdat.lowlim=lowlim;
      BrkTrapCondBuf.curbrkdat.hilim=hilim;
   }
   else{
      GoBrkClr(1);
   }

#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}

/*************************************/
/* perm host, parasite size range    */
/*************************************/
void Brk_PermHost_ParaSizeRange()
{
   int abortflag, loopflag;
   I32s lowlim, hilim;

   abortflag=0;
   GoBrkClr(1);

   if(!GeneBnker){
      TGeneBnker=GeneBnker;
      GeneBnker=1;
      ChangeGeneBnker(GeneBnker);
   }
   loopflag=1;
   while(loopflag){

      /* Enter lower limit of size range */
      lowlim=EnterLongVal(MSG_Y,
         "Enter lower limit of size range ->", &abortflag);
      if(!abortflag){
         if(lowlim > 0){
            loopflag=0;
         }
         else{
            sprintf(Fbuf, "invalid entry");
            FEError(-2229, NOEXIT, NOWRITE, Fbuf);
         }
      }
      else{
         loopflag=0;
      }
   }
   if(!abortflag){

      loopflag=1;
      while(loopflag){

         /* Enter upper limit of size range */
         hilim=EnterLongVal(MSG_Y+1,
            "Enter upper limit of size range ->", &abortflag);
         if(!abortflag){
            if(hilim < lowlim){
               sprintf(Fbuf, "invalid entry");
               FEError(-2230, NOEXIT, NOWRITE, Fbuf);
            }
            else{
               loopflag=0;
            }
         }
         else{
            loopflag=0;
         }
      }
   }

   if(!abortflag){

      /* set trap parameters. */
      MC_step=1;
      BrkTrapCondBuf.curbrkdat.BrkSet=1;
      BrkTrapCondBuf.curbrkdat.TrapType=BRKTYP_PERMHOST_PARASIZERANGE;
      BrkTrapCondBuf.curbrkdat.lowlim=lowlim;
      BrkTrapCondBuf.curbrkdat.hilim=hilim;
   }
   else{
      GoBrkClr(1);
   }

#if FRONTEND == BASIC
   FEClrmsg(MSG_Y, "");
   FEBanner();
   FEStats();
#endif /* FRONTEND == BASIC */
}
#endif /* MICRO */
