/* @(#)queues.c	1.7 2/13/95*/
/* queues.c   7-3-96  Tierra Simulator */
/* Tierra Simulator V4.3: Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996 */
/* Tom Ray & Virtual Life */
/* MemProf labels: #13XX, in use: none */
/* FEError labels: #13XX, in use: 1300-1306 */

#ifndef lint
static char     sccsid[] = "@(#)queues.c	1.5     7/21/92";
#endif

#include "license.h"
#include "tierra.h"
#include "globals.h"

void IncrSliceQueue() /* increment slicer queue */
{   ce = &cells[ce->q.n_time.a][ce->q.n_time.i];
    while(!ce->ld) /* get dead cells out of queue */
        RmvFrmSlicer(ce);
}

void DecrSliceQueue() /* decrement slicer queue */
{   ce = &cells[ce->q.p_time.a][ce->q.p_time.i];
    while(!ce->ld) /* get dead cells out of queue */
        RmvFrmSlicer(ce);
}

void EntBotSlicer(nc)
Pcells  nc; /* new cell being added to bottom of slicer queue */
{   Pcells  tc; /* ThisSlice cell (ce) */
    Pcells  pc; /* previous slice cell */

    tc = ce; pc = &cells[tc->q.p_time.a][tc->q.p_time.i];
#ifdef ERROR
    if((nc->q.n_time.a != nc->q.p_time.a || nc->q.n_time.i != nc->q.p_time.i)
        && NumCells > 1)
    {   FEError(-1300,EXIT,WRITE,
            "Tierra EntBotSlicer() error: cell already in slicer queue");
    }
#endif
    pc->q.n_time = nc->q.this; /* previous slice points to nc */
    nc->q.p_time = tc->q.p_time; /* nc points back at previous slice */
    nc->q.n_time = ce->q.this; /* nc points to this slice */
    tc->q.p_time = nc->q.this; /* this slice points back at nc */
}

void UpReaper(cp) /* move cell up the reaper queue */
Pcells  cp; /* cp is cell to be moved up in reaper */
{   Pcells  pe2, pe, ne;

    if(cp == TopReap) return;
#ifdef ERROR
    if(cp->q.n_reap.a == cp->q.p_reap.a && cp->q.n_reap.i == cp->q.p_reap.i
        && NumCells > 1)
    {   FEError(-1301,EXIT,WRITE,
        "Tierra UpReaper() error: cell not in reaper queue");
    }
#endif
    ne = &cells[cp->q.n_reap.a][cp->q.n_reap.i];/*ne is next cell in reaper */
    pe = &cells[cp->q.p_reap.a][cp->q.p_reap.i];
        /* pe is previous cell in reaper */
    pe2 = &cells[pe->q.p_reap.a][pe->q.p_reap.i];
        /* pe2 is 2nd previous cell in reaper */
    ne->q.p_reap = pe->q.this;  /* ne points back to pe */
    cp->q.p_reap = pe2->q.this; /* cp points back to pe2 */
    cp->q.n_reap = pe->q.this;  /* cp points ahead to pe */
    pe->q.p_reap = cp->q.this;  /* pe points back to cp */
    pe->q.n_reap = ne->q.this;  /* pe points ahead to ne */
    pe2->q.n_reap = cp->q.this; /* pe2 points ahead to cp */
    if(cp == BottomReap)
        BottomReap = pe;
    if(pe == TopReap)
        TopReap = cp;
}

void DownReaper(cp)
Pcells  cp; /* cp is cell to be moved down in reaper */
{   Pcells  pe, ne, ne2;

    if(cp == BottomReap) return;
#ifdef ERROR
    if(cp->q.n_reap.a == cp->q.p_reap.a && cp->q.n_reap.i == cp->q.p_reap.i
        && NumCells > 1)
    {   FEError(-1302,EXIT,WRITE,
        "Tierra DownReaper() error: cell not in reaper queue");
    }
#endif
    ne = &cells[cp->q.n_reap.a][cp->q.n_reap.i];/*ne is next cell in reaper */
    ne2 = &cells[ne->q.n_reap.a][ne->q.n_reap.i];
        /* ne2 is 2nd next cell in reaper */
    pe = &cells[cp->q.p_reap.a][cp->q.p_reap.i];
        /* pe is previous cell in reaper */
    pe->q.n_reap = ne->q.this;  /* pe points ahead to ne */
    cp->q.n_reap = ne2->q.this; /* cp points ahead to ne2 */
    cp->q.p_reap = ne->q.this;  /* cp points back to ne */
    ne->q.n_reap = cp->q.this;  /* ne points ahead to cp */
    ne->q.p_reap = pe->q.this;  /* ne points back to pe */
    ne2->q.p_reap = cp->q.this; /* ne2 points back to cp */
    if(cp == TopReap)
        TopReap = ne;
    if(ne == BottomReap)
        BottomReap = cp;
}

void UpRprIf(cp)
Pcells  cp;
{   if(cp->d.flags >= cells[cp->q.p_reap.a][cp->q.p_reap.i].d.flags)
        UpReaper(cp);
}

void DownReperIf(cp)
Pcells  cp;
{   if(cp->d.flags <= cells[cp->q.n_reap.a][cp->q.n_reap.i].d.flags)
        DownReaper(cp);
}

void EntBotReaper(cp)
Pcells  cp; /* cell to be added to the bottom of reaper queue */
{   Pcells  be = BottomReap; /* cell presently at bottom of reaper queue */

#ifdef ERROR
    if((cp->q.n_reap.a != cp->q.p_reap.a || cp->q.n_reap.i != cp->q.p_reap.i)
        && NumCells > 1)
    {   FEError(-1303,EXIT,WRITE,
            "Tierra EntBotReaper() error: cell already in reaper queue");
    }
#endif
    cp->q.p_reap = BottomReap->q.this;
        /* new cell points back to old BottomReap */
    cp->q.n_reap = BottomDummy->q.this;
        /* new cell points ahead to dummy bottom */
    be->q.n_reap = cp->q.this;/* old BottomReap cell now points ahead to cp */
    BottomDummy->q.p_reap = cp->q.this;
    BottomReap = cp; /* BottomReap is now cp */
}

void RmvFrmReaper(cp)
Pcells  cp; /* cell to be removed from reaper queue */
{   Pcells  nc; /* next cell in reaper queue */
    Pcells  pc; /* previous cell in reaper queue */

    nc = &cells[cp->q.n_reap.a][cp->q.n_reap.i];
    pc = &cells[cp->q.p_reap.a][cp->q.p_reap.i];
#ifdef ERROR
    if(cp->q.n_reap.a == cp->q.p_reap.a && cp->q.n_reap.i == cp->q.p_reap.i
        && NumCells > 1)
    {   FEError(-1304,EXIT,WRITE,
            "Tierra RmvFrmReaper() error: cell not in reaper queue");
    }
#endif
    if(cp == TopReap) /* TopReap changed to next cell in queue */
        TopReap = &cells[cp->q.n_reap.a][cp->q.n_reap.i];
    if(cp == BottomReap) /* BottomReap changed to previous cell in queue */
        BottomReap = &cells[cp->q.p_reap.a][cp->q.p_reap.i];
        /* previous cell points ahead to next cell: */
    pc->q.n_reap = cp->q.n_reap;
        /* next cell points back to previous cell: */
    nc->q.p_reap = cp->q.p_reap;
    cp->q.p_reap = cp->q.n_reap = cp->q.this;
        /* initialize reap queue this cell */
#ifdef ERROR
    if((cp->q.n_time.a != cp->q.p_time.a || cp->q.n_time.i != cp->q.p_time.i)
        && NumCells > 1)
    {   FEError(-1305,EXIT,WRITE,
            "Tierra RmvFrmReaper() error: cell still in slicer queue");
    }
#endif
}

void RmvFrmSlicer(rc)
Pcells  rc; /* cell to be removed from slicer queue */
{   Pcells  nc; /* next cell in slicer queue */
    Pcells  pc; /* previous cell in slicer queue */
    nc = &cells[rc->q.n_time.a][rc->q.n_time.i];
    pc = &cells[rc->q.p_time.a][rc->q.p_time.i];
#ifdef ERROR
    if(rc->q.n_time.a == rc->q.p_time.a && rc->q.n_time.i == rc->q.p_time.i
        && NumCells > 1)
    {   FEError(-1306,EXIT,WRITE,
            "Tierra RmvFrmSlicer() error: cell not in slicer queue");
    }
#endif
        /* previous cell points ahead to next cell: */
    pc->q.n_time = rc->q.n_time;
        /* next cell points back to previous cell: */
    nc->q.p_time = rc->q.p_time;
    if(rc == ce)
        ce = &cells[rc->q.n_time.a][rc->q.n_time.i];
    rc->q.n_time = rc->q.p_time = rc->q.this;
         /* initialize slice queue this cell */
}
