/* @(#)soup_in.h	1.15 1/19/95*/
/* soup_in.h   7-3-96  Artificial Life simulator setup routines */
/* Tierra Simulator V4.3: Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996 */
/* Tom Ray & Virtual Life */

/*
 * sccsid: @(#)soup_in.h	1.5	7/21/92
 */

#include "license.h"

#ifndef SOUP_IN_H
#define SOUP_IN_H

/* observational parameters: */

I32s BrkupSiz = 1024;  /* size of output file in K: break.1, break.2 ... */
I32s CumGeneBnk = 0;    /* Use cumulative gene files, or overwrite */
I32s debug = 0;	       /* 0 = off, 1 = on, printf statements for debugging */
I32s DiskOut = 1;      /* output data to disk (1 = on, 0 = off) */
I32s DiskBank = 1;    /* turn disk-genebanker on and off */
I32s GeneBnker = 1;    /* turn genebanker on and off */
I32s hangup = 0;    /* 0 = exit on error, 1 = hangup on error for debugging */
I32s Log = 0;    /* 0 = no log file, 1 = write tierra.log file to disk */
I32s MaxFreeBlocks = 600;/* initial # of structure for memory allocation */
#ifdef __MWERKS__
I8s  OutPath[80] = ":td:";	/* path for data output */
I8s  GenebankPath[80] = ":gb:";	/* path for genebanker output */
#else /* __MWERKS__ */
I8s  OutPath[80] = "td/";	/* path for data output */
I8s  GenebankPath[80] = "gb/";	/* path for genebanker output */
#endif /* __MWERKS__ */
I32s SaveFreq = 100;   /* frequency of saving core_out, soup_out and list */
I32s SavRenewMem = 1;  /* free and renew dynamic memory after saving to disk */
I32s SavMinNum = 2;   /* minimum number of individuals to save genotype */
float SavThrMem = .015;/* threshold memory occupancy to save genotype */
float SavThrPop = .015;/* threshold population proportion to save genotype */
I32s WatchExe = 0;     /* mark executed instructions in genome in genebank */
I32s WatchMov = 0;     /* set mov bits in genome in genebank */
I32s WatchTem = 0;     /* set template bits in genome in genebank */

/* environmental variables: */

I32s alive = 500;      /* how many millions of instruction will we run */
float DistFreq = .3;    /* frequency of disturbance, factor of recovery time */
float DistProp = .2;   /* proportion of population affected by distrubance */
I32s DivSameSiz = 0;   /* produce offspring of same size, stop size change */
I32s DivSameGen = 0;  /* produce offspring of same genotype, stop evolution */
I32s DropDead = 5;     /* stop system if no reproduction in last x million */
I32s EjectRate = 50; /* rate at which cells are randomly ejected from soup */
float GenPerBkgMut = 16.; /* mut rate control by generations ("cosmic ray") */
float GenPerFlaw = 32.;/* flaw control by generations */
float GenPerMovMut = 8.;/* mutation rate control by generations (copy mut) */
I8s IMapFile[80] = "opcode.map"; /* map of instructions set into space */
float JmpSouTra = 1.; /* source track switches per average size */
float JumpTrackProb = .2; /* prob of switching track during jump of IP */
I32s MalMode = 2; /* 0 = first fit, 1 = better fit, 2 = random preference,
3 = near mother's address, 4 = near dx address, 5 = near top of stack address*/
I32s MalReapTol = 1; /* 0 = reap by queue, 1 = reap oldest creat wthn MalTol */
I32s MalSamSiz = 0; /* force memory alloc to be same size as parent */
I32s MalTol = 5; /* multiple of avgsize to search for free block */
float MateProb = .2;	/* probability of mating, this mal */
I32s MateSearchL = 0;	/* Search limit to find a mate, like SearchLimit */
I32s MateSizeEp = 1;	/* critters size +- val => allowed to mate with */
float MateXoverProp = 1.0; /* prop. of gene to consider for Xover point */
I32s  MaxCpuPerCell = 16; /* maximum number of CPUs allowed per cell */
I32s  MaxIOBufSiz = 8;  /* maximum size for IOS buffer */
float MaxMalMult = 3;  /* multiple of cell size allowed for mal() */
I32s  MaxPutBufSiz = 4;  /* maximum size for put IO buffer */
I32s  MaxGetBufSiz = 4;  /* maximum size for get IO buffer */
I32s MinCellSize = 8;  /* minimum size for cells */
I32s MinTemplSize = 1; /* minimum size for templates */
float MovPropThrDiv = .7;/* min proportion of daughter cell filled by mov */
I32s MemModeFree = 0;  /* unix chmod for when mem is dealloced,  */
I32s MemModeMine = 0;  /* unix chmod for when mem is owned by creature,  */
I32s MemModeProt = 2;  /* unix chmod, mem is owned by another creature */
I32s new_soup = 1;     /* 1 = this a new soup, 0 = restarting an old run */
I32s NumCells = 1;    /* # of creatures and gaps used to inoculate new soup */
double PhotonPow = 1.5;/* power for photon match slice size */
I32s PhotonWidth = 8;  /* amount by which photons slide to find best fit */
I8s PhotonWord[80] = "chlorophill";	/* word used to define photon */
float PutLimit = 20.;   /* distance for intercellular communication */
float ReapRndProp = 0.0; /* rnd prop of top of reaper Q to reap from */
float SearchLimit = 5.;   /* distance for template search */
I32s seed = 0; /* seed for random number generator, 0 uses time to set seed */
I32s SizDepSlice = 1;  /* set slice size by size of creature */
double SlicePow = 1;  /* set power for slice size, use when SizDepSlice = 1 */
I32s SliceSize = 25;   /* slice size when SizDepSlice = 0 */
I32s SliceStyle = 2;   /* choose style of determining slice size */
float SlicFixFrac = 0; /* fixed fraction of slice size */
float SlicRanFrac = 2; /* random fraction of slice size */
I32s SoupSize = 60000L;  /* size of soup in instructions */
I16u LocalPort = 18001;  /* Port number for local node */
I16u MonPort = 17501;	 /*  Port number for network monitor */
#ifndef DECVAX
I8s map_fn[40] = "MapFile";  /* mapfile for Internet */
#else
I8s map_fn[40] = "MapFile.";  /* mapfile for Internet */
#endif /* DECVAX */
I32s TierraNice = 19;        /* Nice value for cpu */
#ifdef __MWERKS__
I8s MacHost[80] = "nohost";     /* word used to define host on macintosh */
I8s MacSite[80] = "nosite";     /* word used to define site on macintosh */
#endif /* __MWERKS__ */
I32s MAX_species_SIZ = 100;/* Maximum number of query_species for Size histogram */
I32s MAX_species_GEN = 100;/* Maximum number of query_species for Gene histogram */
I32s MAX_species_MEM = 100;/* Maximum number of query_species for Memory histogram */
I32s M_tvWait_sec = 25; /* time out for select in OV mode (sec.) */
I32s M_OV_threshold = 100; /* Threshold for time out in OV mode */

InstDef *id;

InstDef idt[] = {
    {0, "nop0", nop, pnop, "", 0},              /* no decode args */
    {0, "nop1", nop, pnop, "", 0},              /* no decode args */
    {0, "add", add, dec1d2s, "", 0},            /* "rrr" */
    {0, "add2", add, dec1d2s, "", 0},           /* "rrr" */
    {0, "adrb", adr, decadr, "", 0},            /* "rr  " */
    {0, "adrf", adr, decadr, "", 0},            /* "rr  " */
    {0, "adro", adr, decadr, "", 0},            /* "rr  " */
    {0, "and", and, dec1d2s, "", 0},            /* "rrr" */
    {0, "and2", and, dec1d2s, "", 0},           /* "rrr" */
    {0, "call", tcall, ptcall, "", 0},          /* no decode args */
    {0, "clrf", clrf, pnop, "", 0},             /* no decode args */
    {0, "clrfi", clrfi, pnop, "", 0},           /* no decode args */
    {0, "clrrf", clrrf, pnop, "", 0},           /* no decode args */
    {0, "csync", csync, pnop, "", 0},           /* no decode args */
    {0, "dec", add, dec1d1s, "", 0},            /* "rr" */
    {0, "decC", add, dec1d1s, "cc", 0},         /* "cc" */
    {0, "div", idiv, dec1d2s, "", 0},           /* "r" */
    {0, "div2", idiv, dec1d2s, "", 0},          /* "r" */
    {0, "divide", divide, dec2s, "", 0},        /* "rr" */
    {0, "enter", enter, pnop, "", 0},           /* no decode args */
    {0, "exch", exch, dec2s, "", 0},            /* "rr" */
    {0, "getregs", getregs, dec1s, "t", 0},     /* "#" */
    {0, "ifE", skip, dec2s, "", 0},             /* "rr" */
    {0, "ifS", skip, dec2s, "", 0},             /* "rr" */
    {0, "ifZ", skip, dec2s, "", 0},             /* "rr" */
    {0, "ifequal", skip, dec2s, "", 0},         /* "rr" */
    {0, "ifgrtr", skip, dec2s, "", 0},          /* "rr" */
    {0, "ifless", skip, dec2s, "", 0},          /* "rr" */
    {0, "ifz", skip, dec2s, "", 0},             /* "rr" */
    {0, "inc", add, dec1d1s, "", 0},            /* "rr" */
    {0, "incA", add, dec1d1s, "aa", 0},         /* "aa" */
    {0, "incB", add, dec1d1s, "bb", 0},         /* "bb" */
    {0, "incC", add, dec1d1s, "cc", 0},         /* "cc" */
    {0, "jmpb", adr, decjmp, "", 0},            /* "r" */
    {0, "jmpf", adr, decjmp, "", 0},            /* "r" */
    {0, "jmpo", adr, decjmp, "", 0},            /* "r" */
    {0, "join", join, pnop, "", 0},             /* no decode args */
    {0, "mal", malchm, dec1d3s, "", 0},         /* "rr r" */
    {0, "movBA", movdd, dec1d1s, "ba", 0},      /* "ba" */
    {0, "movDC", movdd, dec1d1s, "dc", 0},      /* "dc" */
    {0, "movdd", movdd, dec1d1s, "", 0},        /* "rr" */
    {0, "movdi", movdi, pmovdi, "", 0},         /* "rr" */
    {0, "movdi8", movdi, pmovdi, "", 0},        /* "rr" */
    {0, "movdi16", movdi, pmovdi, "", 0},       /* "rr" */
    {0, "movdi32", movdi, pmovdi, "", 0},       /* "rr" */
    {0, "movid", movid, pmovid, "", 0},         /* "rr" */
    {0, "movid8", movid, pmovid, "", 0},        /* "rr" */
    {0, "movid16", movid, pmovid, "", 0},       /* "rr" */
    {0, "movid32", movid, pmovid, "", 0},       /* "rr" */
    {0, "movii", movii, pmovii, "", 0},         /* "rr" */
    {0, "mul", mul, dec1d2s, "", 0},            /* "r" */
    {0, "mul2", mul, dec1d2s, "", 0},           /* "r" */
    {0, "not", not, dec1d, "", 0},              /* "r" */
    {0, "not0", not0, dec1d, "", 0},            /* "r" */
    {0, "offAACD", offset, dec1d3s, "aacd", 0}, /* "aacd" */
    {0, "offBBCD", offset, dec1d3s, "bbcd", 0}, /* "bbcd" */
    {0, "offset", offset, dec1d3s, "", 0},      /* "rrrr" */
    {0, "ior", ior, dec1d2s, "", 0},            /* "rrr" */
    {0, "ior2", ior, dec1d2s, "", 0},           /* "rrr" */
    {0, "pop", pop, dec1d, "", 0},              /* "r" */
    {0, "popA", pop, dec1d, "a", 0},            /* "a" */
    {0, "popB", pop, dec1d, "b", 0},            /* "b" */
    {0, "popC", pop, dec1d, "c", 0},            /* "c" */
    {0, "popD", pop, dec1d, "d", 0},            /* "d" */
    {0, "popE", pop, dec1d, "e", 0},            /* "e" */
    {0, "popF", pop, dec1d, "f", 0},            /* "f" */
    {0, "push", push, dec1s, "", 0},            /* "r" */
    {0, "pushA", push, dec1s, "a", 0},          /* "a" */
    {0, "pushB", push, dec1s, "b", 0},          /* "b" */
    {0, "pushC", push, dec1s, "c", 0},          /* "c" */
    {0, "pushD", push, dec1s, "d", 0},          /* "d" */
    {0, "pushE", push, dec1s, "e", 0},          /* "e" */
    {0, "pushF", push, dec1s, "f", 0},          /* "f" */
    {0, "rand", movdd, dec1d1s, "", 0},         /* "rr" */
    {0, "ret", pop, dec1d, "", 0},              /* no decode args */
    {0, "rolld", rolld, pnop, "", 0},           /* no decode args */
    {0, "rollu", rollu, pnop, "", 0},           /* no decode args */
    {0, "shl", shl, dec1d, "", 0},              /* "r" */
    {0, "shr", shr, dec1d, "", 0},              /* "r" */
    {0, "split", split, dec1d1s, "", 0},        /* "rr" */
    {0, "sub", add, dec1d2s, "", 0},            /* "rrr" */
    {0, "sub2", add, dec1d2s, "", 0},           /* "rrr" */
    {0, "subCAB", add, dec1d2s, "cab", 0},      /* "cab" */
    {0, "subAAC", add, dec1d2s, "aac", 0},      /* "aac" */
    {0, "surf", migrate, dec1s, "", 0},         /* "r" */
    {0, "tbf", tbf, pnop, "", 0},               /* no decode args */
    {0, "tdf", tdf, pnop, "", 0},               /* no decode args */
    {0, "ter", ter, pnop, "", 0},               /* no decode args */
    {0, "tsr", tsr, pnop, "", 0},               /* no decode args */
    {0, "tdr", tdr, pnop, "", 0},               /* no decode args */
    {0, "xor", xor, dec1d2s, "", 0},            /* "rrr" */
    {0, "xor2", xor, dec1d2s, "", 0},           /* "rrr" */
    {0, "zero", movdd, dec1d1s, "", 0},         /* "rr" */
    {0, "zeroD", movdd, dec1d1s, "dd", 0},      /* "dd" */
#ifdef IO
    {0, "get", get, dec1d1s, "", 0},            /* "r" */
    {0, "put", put, dec1d1s, "", 0},            /* "rr" */
    {0, "puticc", puticc, pputicc, "", 0},      /* "rr" */
#endif /* IO */
#if PLOIDY > 1
    {0, "trso", trso, pnop, "", 0},             /* no decode args */
    {0, "trde", trde, pnop, "", 0},             /* no decode args */
    {0, "trex", trex, pnop, "", 0},             /* no decode args */
#else /* PLOIDY > 1 */
    {0, "trso", NULL, NULL, "", 0},
    {0, "trde", NULL, NULL, "", 0},
    {0, "trex", NULL, NULL, "", 0},
#endif /* PLOIDY > 1 */
#ifdef SHADOW
    {0, "A", regorder, dec1s, "a", 0},          /* "a" */
    {0, "B", regorder, dec1s, "b", 0},          /* "b" */
    {0, "C", regorder, dec1s, "c", 0},          /* "c" */
    {0, "D", regorder, dec1s, "d", 0},          /* "d" */
#else /* SHADOW */
    {0, "A", NULL, NULL, "", 0},
    {0, "B", NULL, NULL, "", 0},
    {0, "C", NULL, NULL, "", 0},
    {0, "D", NULL, NULL, "", 0},
#endif /* SHADOW */
#ifdef NET
    {0, "tpings", tpingsnd, dec1s, "", 0},    /* "r" */
    {0, "tpingr", tpingrec, dec1d, "", 0},    /* "r" */
    {0, "getip",  getip,    dec1d, "", 0},    /* "r" */
#endif /* NET */
    {0, "END", NULL, NULL, "", 0}             /* this line must be last! */
};

#endif /* SOUP_IN_H */
