/* @(#)tierra.c    1.28 2/13/95*/
/* tierra.c   7-3-96  main module of Tierra Simulator */
/* Tierra Simulator V4.3: Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996 */
/* Tom Ray & Virtual Life */
/* MemProf labels: #00XX, in use: 0001-0002 */
/* FEError labels: #00XX, in use: 0006-0013 */

#ifndef lint
static char     sccsid[] = "@(#)tierra.c        1.5 7/21/92";
#endif

#include "license.h"
#include "tierra.h"
#define EXTERN
#include "globals.h"
#include "soup_in.h"

#ifdef MON
#define GLOBAL_VALUE_DEFINE 1
#include "obs.h"
#include "tmon_global.h"
#endif /* MON */

#ifdef ALCOMM

#include "tmonitor.h" 
#include "trequest.h"
#include <mlayer.h>
#include <alcomm.h>

#define                                                 _MFnCount       2
static MtDefaultRoutines        _message_fns[] = {
  { TrtPauseSim,        TSimRuncontrol },
  { TrtResumeSim,       TSimRuncontrol }
};

#define                                                 _QFnCount       2
static MtDefaultRoutines        _query_fns[] = {
  { TrtGeneralStats,    TQueryGeneralStats },
  { TrtQueryOrg,        TQueryOrganism }
};

#define                                                 _DIFnCount      4
static MtDefaultRoutines        _dfinit_fns[] = {
  { TrtOrgLifeEvent,    TInitOrgLifeEvents},
  { TrtIPEvent,         TMoveIP},
  { 1,                  TMoveD} ,
  { TrtPlanEvent,       TPlan}
};

#endif         /*ALCOMM */

I32s   FindCell;
I32s   itime, mtime;
Event  FindTime;

int t = 432432423 ;

#ifndef __GUI__

int main(argc,argv)
int   argc;
char  *argv[];
{
#ifdef __MWERKS__
#if FRONTEND == STDIO    /* get command line and parse it if on Mac */
    I8s *p1 =
"\nPlease input arguments for tierra separated by spaces:\n\ntierra ";
    fprintf(stdout, p1);
    argc = cmdline( "tierra ", &argv);
#else /* FRONTEND == STDIO */
    SIOUXSettings.standalone = FALSE;
    SIOUXSettings.setupmenus = FALSE;
    SIOUXSettings.initializeTB = FALSE;
    SIOUXSettings.showstatusline = FALSE;
    SIOUXSettings.autocloseonquit = FALSE;
    SIOUXSettings.asktosaveonclose = FALSE;
    SIOUXSettings.rows = 10;
    SIOUXSettings.columns = 80;
    SIOUXSettings.toppixel = windowHeight + 64;
    SIOUXSettings.leftpixel = 5;
    FEInitToolbox();
    Alert(128, nil);
    argc = ccommand( &argv );
#ifdef NET
    GUSISetup(GUSIwithSIOUXSockets);
    GUSISetup(GUSIwithInternetSockets);
#endif /* NET */
    wp = FECreateNewWindow();
#endif /* FRONTEND == STDIO */
#endif /* __MWERKS */

    initvar();
    GoBrkClr(1);
    SavBrkDat();

#ifdef MEM_PROF
    InitMemProf();
#endif /* MEM_PROF */

    FEStartup();         

#ifdef ALCOMM
    _t_init_alcomm();
#endif /* ALCOMM */

    GetSoup(argc,argv); 
#ifndef MON
    if(argc>2){
        FEMenu();
    }
    while(!NumCells){
        FEMenu();
    }
#else
    if(argc > 2)          /* For observe from one cell start by monitor */
      TMonOneCellStart();
#endif /* MON */

#ifdef TSysV
    signal(SIGINT,  T_sig_int);
#endif /* TSysV */
    life();
    WriteSoup(1);
#ifdef NET
    Bye_send();
#endif /* NET */
    if (hangup)
        FEMenu();
    if(Log)
        fclose(tfp_log);
    FEExit(0);
}

void life() /* doles out time slices and death */
{
#ifdef AMIGA
#ifdef NET
   int netrecvcnt;

   netrecvcnt=0;
#endif /* NET */
#endif /* AMIGA */

    /* or: while(!alive || InstExe.m < alive) */
    while(!alive || Generations < alive)
    {   if (KEYHIT())
            FEMenu();

#ifdef ALCOMM
        if (AL_run_flag == 1)
        {   (*slicer)();
            ReapCheck();
        }
        _t_life_bookeep();
#else /* ALCOMM */
        (*slicer)();
        ReapCheck();
#endif /* ALCOMM */

#ifdef NET
#ifdef AMIGA
   if(netrecvcnt<399){
      netrecvcnt++;
   }
   else{
      NetRecvFunc();
      netrecvcnt=0;
   }
#else /* AMIGA */
        NetRecvFunc();
#endif /* AMIGA */
#endif /* NET */
    }
}

#endif /* __GUI__ */

void TimeSlice(size_slice)
I32s    size_slice;
{
#ifndef AMIGA
    I8s     a = 0, b = 0;
#endif /* AMIGA */
    I16s    c, di;  /* decoded instruction */
    
    debug = 1; FindTime.m = 0; FindTime.i = 904455;
    ce->c.ib += size_slice;
    for(is.ts = ce->c.ib; is.ts > 0; )
    {   for (c = ce->c.n - 1; c >= 0; c--)
        {   ce->c.c = &(ce->c.ar[c]);
            ce->c.ac = c;
#ifdef EXECPROT
            if(PrivExec(ce, ce->c.c->ip))
            {
#endif /* EXECPROT */
            if (ce->c.sync && ce->c.c->sync)
                continue;
            di = FetchDecode();
            (*id[di].execute)();
            if (TierraWait)
                continue;
            IncrementIp();
/*                       FOR DEBUGGING PURPOSES
            b++;
            if (debug && InstExe.m >= FindTime.m && InstExe.i >= FindTime.i) 
            {   
                a = b;
            }
            a = ++a - b;
 */
            SystemWork();
#ifdef EXECPROT
            }
            else
                IncrNPrIp();
#endif /* EXECPROT */
        }
        ce->c.ib -= is.dib;
        is.ts -= is.dib;
    }
}

I16s FetchDecode()
{   I16s    di;

#if PLOIDY == 1
    is.eins = &soup[ce->c.c->ip];
#else /* PLOIDY > 1 */
    is.eins = &soup[ce->c.c->ip][ce->c.c->ex];
#endif /* PLOIDY > 1 */
    di = (*(is.eins)) % InstNum;
    if (di < 0)
        di = - di;
    is.oip = ce->c.c->ip;
    ce->c.d = id + di;
    (*id[di].decode)();

#ifdef MICRO
    if( MC_step  > -1L)
    {
#ifndef MON 
	Micro_Spy(ce);
#else /* MON */
	NetRecvFunc();
        M_Micro_spy(ce);
#endif /* MON */
    }
#endif
    TierraWait = 0;
    return di;
}

void IncrementIp()
{
#ifndef AMIGA
    I8s  ttr;
#endif /* AMIGA */

    ce->c.c->ip += is.iip;
    ce->c.c->ip = ad(ce->c.c->ip);
#if PLOIDY > 1 /* if there is an error, switch tracks & repeat instruction */
    if (ce->c.c->fl.E && !flaw())
    {   if (ce->c.c->wc < PLOIDY - 1)
        {   ce->c.c->ip -= is.iip;
            ce->c.c->ip = ad(ce->c.c->ip);
            (ce->c.c->wc)++;
        }
        else
            ce->c.c->wc = 0;
#if PLOIDY == 2
        ce->c.c->ex = !(ce->c.c->ex);
#else /* PLOIDY == 2 */
        ttr = ce->c.c->ex;
        do
        {   ce->c.c->ex = (I8s) tcrand() % PLOIDY;
        }   while (ce->c.c->ex == ttr);
#endif /* PLOIDY == 2 */
    }
#endif /* PLOIDY > 1 */
    if (GeneBnker && WatchExe)
        GenExExe(is.oip);
}

void IncrNPrIp()
{   ce->c.c->ip += 1;
    ce->c.c->ip = ad(ce->c.c->ip);
}

void SystemWork()
{   CellInd  this; /* index of this cell */
#ifndef AMIGA
    I16s     i;
#endif /* AMIGA */
#ifdef MEM_PROF
    MemProf  *mpa;
#endif /* MEM_PROF */

#ifdef KURT
    if (!(ce->c.ac))
#endif /* KURT */
        ce->d.inst += is.dib;
    if(ce->c.c->fl.E)
    {   ce->d.flags++;
        if(!(ce->d.dm))
            UpRprIf(ce);
    }
    CountMutRate++;
    if(CountMutRate >= RateMut && RateMut)
    {   mutate();
        TotMut++;
        CountMutRate = tlrand() % RateMut;
    }
    if(isolate)
        extract(&cells[extr.a][extr.i], 0);
#ifdef NET
    if (ConnectedFlg) 
    {   InstExeConnect.i++;
        if(InstExeConnect.i > 1000000L) 
        {   InstExeConnect.i %= 1000000L;
            InstExeConnect.m++;
        }
    }
#endif /* NET */
#ifdef MON
        Mstats();
#endif /* MON */
    InstExe.i++;
    if(InstExe.i > 1000000L)
    {   InstExe.i %= 1000000L; InstExe.m++;
        if(DropDead && (InstExe.m > LastDiv.m + DropDead))
        {   FEError(-6, EXIT, WRITE,
                "Tierra SystemWork() soup has died, saving system to disk");
        }
        if(SaveFreq && !(InstExe.m % SaveFreq))
        {   WriteSoup(0);
            if (SavRenewMem)
            {   this.a = ce->q.this.a; this.i = ce->q.this.i;
                FreeDynMem();
#ifdef MEM_PROF
                mpa = (MemProf *) calloc(MemStat.AlocSiz, sizeof(MemProf));
                for (i = 0; i < MemStat.AlocSiz; i++)
                    mpa[i] = MemStat.mpa[i];
                free(MemStat.mpa);
                MemStat.mpa = mpa;
#endif /* MEM_PROF */
                ReadDynMem();
                ReadGeneBank();
                ce = &cells[this.a][this.i];
            }
        }
        stats() ;
        plan();
    }
}

void mutate()
{   I32s  i;

    i = tlrand() % SoupSize;
#if PLOIDY == 1
    mut_site(soup + i, tcrand());
#else /* PLOIDY > 1 */
    mut_site(soup + i, tcrand() % PLOIDY);
#endif /* PLOIDY > 1 */
    MutBookeep(i);
}

void mut_site(s, track)
HpInst  s;
I32s     track;
{   
#if PLOIDY == 1
    s[0] ^= (1 << (tirand() % (I16s) InstBitNum)); 
#else /* PLOIDY > 1 */
    s[0][track] ^= (1 << (tirand() % (I16s) InstBitNum)); 
#endif /* PLOIDY > 1 */
}


void ReapCheck() /* kill some cells if necessary */
{   I32s  i, t, dtime;
    Event  result;

    if(DistFreq < -.00001 || !reaped || (!DistNext.m && !DistNext.i))
        return;
    dtime = SubEvent(&InstExe, &DistNext, &result);
    if(dtime > 0)
    {   Disturb = InstExe;
        DistNext.m = DistNext.i = 0L;
        t = (I32s) (DistProp * (float) NumCells);
        if(t == NumCells)
            t--;
        for(i = 0; i < t; i++)
            reaper(0,-1);
    }
}

void reaper(ex, sad)
I32s  ex;  /* is a creature executing now ? */
I32s  sad; /* suggested address for reaping */
{   Pcells  cr; /* cell to be reaped */
    Pcells  nc; /* daughter of cell to be reaped */
    Event   result;
    I32s    reap_range,i, j, ll, ul, goon, rtime, found = 0;

    if (MalReapTol && (sad >= 0 && sad < SoupSize))
    {   cr = TopReap; i = 1; goon = 1;
        ll = sad - MalLimit;
        ul = sad + MalLimit + 1;
        while (goon)
        {   goon = 0;
            if (ex && cr == ce)
                goon = 1;
            if (cr->md.s)
            {   if ((((cr->mm.p + cr->mm.s) < ll) || (cr->mm.p > ul))
                    && (((cr->md.p + cr->md.s) < ll) || (cr->md.p > ul)))
                goon = 1;
            }
            else
            {   if (((cr->mm.p + cr->mm.s) < ll)
                    || (cr->mm.p > ul))
                goon = 1;
            }
            if (goon)
            {   cr = &cells[cr->q.n_reap.a][cr->q.n_reap.i];
                i++;
            }
            if (i > NumCells || (!cr)
                || ((cr->q.this.a == 0) && (cr->q.this.i < 2))) 
                break;
            if (!goon)
            {   found = 1;
                break;
            }
        }
    }
    if (!found)
    {   reap_range =  ReapRndProp * NumCells;
        if(reap_range < 2)
            cr = TopReap;
        else        /* pick rnd cell in top reap_range */
        {   j = tlrand() % reap_range;
            for(cr = TopReap, i = 0; i < j; i++)
            {   cr = &cells[cr->q.n_reap.a][cr->q.n_reap.i];
#ifdef ERROR
                if ((!cr) || ((cr->q.this.a ==0) && (cr->q.this.i < 2))) 
        FEError(-7, EXIT, WRITE, "Tierra reaper() error, queues corrupted!");
#endif
            }
        }
    }
    if(ex && cr == ce)
    {   if(cr == TopReap)
            cr = &cells[cr->q.n_reap.a][cr->q.n_reap.i];
        else
            cr = &cells[cr->q.p_reap.a][cr->q.p_reap.i];
    }
    if(cr->mm.s){
    if(ex && DistFreq > -.00001 && !DistNext.m && !DistNext.i)
    {   rtime = SubEvent(&InstExe, &Disturb, &result);
        rtime = (I32s) (DistFreq * (float) rtime);
        DistNext = Disturb = InstExe;
        DistNext.m += rtime / 1000000L;
        DistNext.i += rtime % 1000000L;
        DistNext.m += DistNext.i / 1000000L;
        DistNext.i %= 1000000L;
    }
    if(NumCells == 1)
        FEError(-8, EXIT, WRITE,
            "Tierra reaper() error 0, attempt to reap last creature");
    /* DAN old cr = TopReap; l_top = TopReap; */
#ifdef ERROR
    if(!cr->ld || !NumCells || (!cr->mm.s && !cr->md.s))
        FEError(-9, EXIT, WRITE,
            "Tierra reaper() error 1, attempt to reap non-existant cell");
#endif
    if(cr->mm.s)
    {
#ifdef ERROR
        if(cr->mm.p < 0 || cr->mm.p >= SoupSize)
            FEError(-10, EXIT, WRITE,
   "Tierra reaper() error 2: attemp to deallocate mother memory not in soup");
#endif
        MemDealloc(cr->mm.p,cr->mm.s);
    }
    if(cr->md.s && (cr->md.p > -1))
    {
#ifdef ERROR
        if(cr->md.p < 0 || cr->md.p >= SoupSize)
            FEError(-11, EXIT, WRITE,
"Tierra reaper() error 3: attemp to deallocate daughter memory not in soup");
#endif
        if(cr->d.ne.a != cr->q.this.a || cr->d.ne.i != cr->q.this.i)
            /* cleanup daughter cpu */
        {   nc = &cells[cr->d.ne.a][cr->d.ne.i];
            if(nc->d.is) /* cleanup daughter instruction pointer */
                RmvFrmSlicer(nc);
            NumCells--;
            InitCell(nc->q.this.a, nc->q.this.i, nc);
        }
        MemDealloc(cr->md.p,cr->md.s);
    }
    if(cr->md.s && cr->md.p == -1)
    {    if (cr->d.genome)
         {/* tfree((void *) (cr->d.genome)); TERRIBLE MISTAKE! */
             cr->d.genome = soup + cr->mm.p;
         }
    }
    RmvFrmSlicer(cr);
    RmvFrmReaper(cr);
    ReapBookeep(cr); /*  InitCell(ci); done in ReapBookeep(ci); */
    }
}

I32s SubEvent(event1, event2, result) /* subtract e2 from e1 */
Event  *event1, *event2, *result;
{   result->m =  event1->m - event2->m;
    result->m += (event1->i - event2->i) / 1000000L;
    result->i =  (event1->i - event2->i) % 1000000L;
    if(result->m <= 0)
        return result->i + (result->m * 1000000L);
    if(result->i < 0)
    {   --result->m;
        result->i += 1000000L;
    }
    return result->i + (result->m * 1000000L);
}

/* --------------------------------------------------------------------- */
#ifdef NET
I16s NetRecvFunc()
{   I8s  *ReceiveBuf ;
#ifndef AMIGA
    I16s len;
#endif /* AMIGA */
    I16s received_len;
    I16u MaxRecvLen = SoupSize;          /* ?????????????? */
    I32s result, status;
#ifndef AMIGA
    I32s SigSaveSet;
#endif /* AMIGA */
    XDR xdrs_recv;
    TMessage mesg;
    NetAddr address;
    I16s nselect;
    struct timeval *  pWait;
    struct sockaddr_in fsin;    
    I32s alen = sizeof(fsin);

    clilen = sizeof(client);
    memset(&client, 0, clilen);
#ifndef MON
    pWait = &tvWait;
#else /* MON */
    if( MonOVP > M_OV_threshold ) {
      pWait = &m_tvWait;
    } else {
      pWait = &tvWait;
    }
#endif /* MON */
    bcopy((char *)&Afds, (char *)&Rfds, sizeof(Rfds));
#ifdef __MWERKS__
    if((nselect=select(FD_SETSIZE,&Afds,&Rfds,(fd_set *)0, pWait)) < 0)
#else /* __MWERKS__ */
#ifdef __linux__
    if((nselect=select(FD_SETSIZE,&Afds,&Rfds,(fd_set *)0, pWait)) < 0)
#else /* __linux__ */
#ifdef DECVAX
    if((nselect=select(Nfds, &Rfds, &Wfds, &Efds, pWait)) < 0)
#else
    if((nselect=select(Nfds,&Rfds,(fd_set *)0,(fd_set *)0, pWait)) < 0)
#endif /* DECVAX */
#endif /* __linux__ */
#endif /* __MWERKS__ */
    {   FEPrintf(MSG_X, MSG_Y, 0, 2, "Select Error");
    }
    else if ( nselect > 0 )
    {   ReceiveBuf = tcalloc(SoupSize, 1, 2);
#ifdef MON
        TMonAccept();
        TMonRequestRecv();
#endif /* MON */
#ifndef MON
				if(FD_ISSET(MonSockTCP, &Rfds))
        {   if( SuMonFlg == 0 )
                MonTCPNid = 0;
            MonSockTCP_ID[MonTCPNid].fd 
#ifdef AMIGA
                = accept(MonSockTCP,(struct sockaddr*)&fsin, (LONG *)(&alen));
#else
                = accept(MonSockTCP,(struct sockaddr*)&fsin, &alen);
#endif
            if (MonSockTCP_ID[MonTCPNid].fd < 0)
            {   FEPrintf(MSG_X, MSG_Y, 0, -1, "accept Error 1:");
            }
            else
            {   MonSockTCP_ID[MonTCPNid].flg = 'T';
                if(IMode==PLN_STATS){
                sprintf(Fbuf, "Accept network monitor,MonSockTCP_ID[%d]=%d:%c",
                        MonTCPNid, MonSockTCP_ID[MonTCPNid].fd,
                        MonSockTCP_ID[MonTCPNid].flg);
                    FEPrintf(MSG_X, MSG_Y, 0, 2, Fbuf);
                }
                SuMonFlg = 1;
                if (MonInitMesFunc(MonSockTCP_ID[MonTCPNid].fd)==0)
                {   (void) close(MonSockTCP_ID[MonTCPNid].fd);
                    FD_CLR(MonSockTCP_ID[MonTCPNid].fd, &Afds);
                    MonSockTCP_ID[MonTCPNid].flg = 'F';
                }
            } /* End of "if (MonSockTCP_ID[MonTCPNid].fd < 0) " */
        } /* End of "if(FD_ISSET(MonTCPNid, &Rfds))" */    
#endif /* MON */
        if (FD_ISSET(CellSockUDP, &Rfds))
        {
#ifdef SIGBLOCK
            SigSaveSet=TSigBlock(SigSet);
#endif /* SIGBLOCK */
            if ((received_len = recvfrom(CellSockUDP,ReceiveBuf,MaxRecvLen,0,
#ifdef AMIGA
                (struct sockaddr *)&client, (LONG *)(&clilen))) == -1)
#else
                (struct sockaddr *)&client,&clilen)) == -1)
#endif /* AMIGA */
            {
#ifdef SIGBLOCK
                (void) TSigRelease(SigSaveSet);
#endif /* SIGBLOCK */
           /*   FEPrintf(MSG_X, MSG_Y, 0, 2,
                    "recvfrom error in NetRecvFunc"); */
                ;
            }
            else
            {
#ifdef SIGBLOCK
                (void) TSigRelease(SigSaveSet);
#endif /* SIGBLOCK */
                if(IMode==PLN_STATS){
                    sprintf(Fbuf, "UDP datagram received, length = %d",
                        received_len);
                    FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);
                }
#ifdef SIGBLOCK
                SigSaveSet=TSigBlock(SigSet);
#endif /* SIGBLOCK */
                xdrmem_create(&xdrs_recv,ReceiveBuf,MaxRecvLen,XDR_DECODE);
                memset(&mesg, 0, sizeof(mesg));
                if (!xdr_TMessage(&xdrs_recv,&mesg))
                {
#ifdef SIGBLOCK
                    (void) TSigRelease(SigSaveSet);
#endif /* SIGBLOCK */
                    if(IMode==PLN_STATS){
                        FEPrintf(MSG_X, MSG_Y + 1, 0, 2,
                            "XDR decode error for message");
                    }
                    received_len = -2;
                }
                else
                {
#ifdef SIGBLOCK
                    (void) TSigRelease(SigSaveSet);
#endif /* SIGBLOCK */
                    if(IMode==PLN_STATS){
                        sprintf(Fbuf, "Message decoded, type = %ld",
                            mesg.info.tag);
                        FEPrintf(MSG_X, MSG_Y + 1, 0, 2, Fbuf);
                    }
                    switch((int)mesg.info.tag)
                    {   case SENDADDRTAG:
                        {   TPing_reply(&mesg);
                            if ((status = Addr_recv(&mesg)) < 0)
                            {   received_len = -3;
                            }
                            address = mesg.info.Data_u.Addr.address;
                            TreatTPingData(&mesg.PingData, &address, 0);
                            break;
                        }
                        case EMIGRATETAG:
                        {   TPing_reply(&mesg);
                            while(Inject((FpInst)
                                mesg.info.Data_u.Creature.
                                    genome.genome_val,
                                mesg.info.Data_u.Creature.
                                    genome.genome_len,
                                -1, 0, 0, &ReapRndProp)){
                                reaper(1,-1);
                            }
                            address = mesg.info.Data_u.Creature.source;
                            TreatTPingData(&mesg.PingData, &address, 0);
                            break;
                        }
                        case TPINGREQTAG:
                        {   if (TPing_reply(&mesg) < 0)
                            {   if(IMode==PLN_STATS){
                                    FEPrintf(MSG_X, MSG_Y + 2, 0, 2,
                                        "Tping request could not be processed");
                                }
                                received_len = -3;
                            }
                            else
                            {   if(IMode==PLN_STATS){
                                    FEPrintf(MSG_X, MSG_Y + 2, 0, 2,
                                        "TPing request processed");
                                }
                            }
                            address = mesg.info.Data_u.TPingReq.source.address;
                            TreatTPingData(&mesg.PingData, &address, 0);
                            break;
                        }
                        case TPINGREPTAG:
                        {   address = mesg.info.Data_u.TPingRep.source.address;
                            TreatTPingData(&mesg.PingData, &address, 1);
                            if (mesg.info.Data_u.TPingRep.dest.cellID != -1)
                            {   if (TPing_recv(&mesg) < 0)
                                {   if(IMode==PLN_STATS){
                                        FEPrintf(MSG_X, MSG_Y + 2, 0, 2,
                                 "Tping reply could not be written to cell");
                                    }
                                    received_len = -3;
                                }
                                else
                                {   if(IMode==PLN_STATS){
                                        FEPrintf(MSG_X, MSG_Y + 2, 0, 2,
                                            "TPing reply written to cell");
                                    }
                                }
                            }
                            break;
                        }
                        case BYETAG:
                        {   if ((result = Bye_recv(&mesg)) < 0)
                            {   if(IMode==PLN_STATS){
                                    FEPrintf(MSG_X, MSG_Y + 3, 0, 2,
                                        "Node could not be erased from IPMap");
                                }
                                received_len = -3;
                            }
                            else
                            {   if(IMode==PLN_STATS){
                                    sprintf(Fbuf,
                                    "Node no. %ld erased from IPMap", result);
                                    FEPrintf(MSG_X, MSG_Y + 3, 0, 2, Fbuf);
                                }
                            }
                            break;
                        }
                        default:
                        {   if(IMode==PLN_STATS){
                                FEPrintf(MSG_X, MSG_Y + 2, 0, 2,
                                    "Unknown message type");
                            }
                            break;
                        }
                    }
                } /* END of "switch(mesg.info.tag){" */
#ifdef SIGBLOCK
                SigSaveSet=TSigBlock(SigSet);
#endif /* SIGBLOCK */
#ifdef __SOLARIS2__
                xdr_free(xdr_TMessage,(I8s *)&mesg);
#else /* __SOLARIS2__ */
                xdr_free(xdr_TMessage,&mesg);
#endif /* __SOLARIS2__ */
                xdr_destroy(&xdrs_recv);
#ifdef SIGBLOCK
                (void) TSigRelease(SigSaveSet);
#endif /* SIGBLOCK */
            } /* END of "if( (received_len = recvfrom(.... " */
            tfree(ReceiveBuf, SoupSize, 0002);
        } /* END of "if((nselect=select(..... " */
    } /* END of "if (FD_ISSET(CellSockUDP, &Rfds))" */
    return(received_len);
}

#endif /* NET */
/* --------------------------------------------------------------------- */

#ifdef ALCOMM
void _t_init_alcomm()
{   MtStatus      iRet;

    AL_run_flag = 1;
    FEPrintf(MSG_X, MSG_Y, 0, -1, "t_init_alcomm:0");
    VPORT = 7001;
    if ((iRet = MInitialise(0, 0, _message_fns, _MFnCount, _query_fns,
        _QFnCount, M_NoFns, 0, _dfinit_fns, _DIFnCount)) != MsOK)
    {   sprintf(Fbuf,
            "Tierra _t_init_alcomm() main MInitialise error (%d)\n", iRet);
        FEError(-12, NOEXIT, NOWRITE, Fbuf);
    }
    for(VPORT=7001;VPORT < 8000;VPORT++)
    {   if ((iRet = MOpenPublicPort(VPORT)) != MsOK)
        {   sprintf(Fbuf,
            "Tierra _t_init_alcom() main MOpenPublicPort error (%d) on # %d",
                iRet, VPORT);
            FEError(-13, NOEXIT, NOWRITE, Fbuf);
        }
        else
            break;
    }
}

void _t_life_bookeep()
{   I32s         acount=50;
    MtStatus     iRet;

    if (AL_run_flag == 1)
    {   if (MIsDFEnabled(TrtIPEvent))
        {   TMoveIP(ce->mm.p,ce->c.c->ip);
        }
    }
    else
    {   if(acount++ > 30)
        {   FEPrintf(0, 0, 1, 2, "ALMOND: holding");
            acount = 0;
        }
        sleep( 1 );
    }
    if ((iRet = MServiceRequests(M_NoWait)) != MsOK)
    {   sprintf(Fbuf, "life MServiceRequests error (%d)\n", iRet );
        FEPrintf(MSG_X, MSG_Y, 0, 2, Fbuf);
    }
#ifdef DEBUG
    else
    {   sprintf(Fbuf, "life _t_life_bookeep iRet=%d",iRet );
        FEPrintf(MSG_X, MSG_Y, 0, -1, Fbuf);
    }
#endif /* DEBUG */
}
#endif /* ALCOMM */

/* ----------------------- END OF TIERRA.C ----------------------------- */
