/* @(#)tierra.h 1.27 1/12/95*/
/* tierra.h  7-3-96 */
/* type, structure and function definitions for the Tierra Simulator */
/* Tierra Simulator V4.3: Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996 */
/* Tom Ray & Virtual Life */

/*
 * tierra_h_sccsid: @(#)tierra.h        1.5    7/21/92
 */

#define MAX_MONS 8
#define NAMBUFSIZ 80

#include "license.h"

#ifndef LTIERRA_H
#define LTIERRA_H

#include <stdio.h>
#include <math.h>
#ifndef __SOLARIS2__
#include <string.h>
#endif /* __SOLARIS2__ */

#ifndef DECVAX
#include <time.h>
#endif /* DECVAX */

#include <errno.h>
#ifndef __MWERKS__
#include <fcntl.h>
#endif /* __MWERKS__ */
#include <signal.h>

#ifdef __MWERKS__
#include <types.h>
#include <SIOUX.h>
#include <unistd.h>
#ifndef NET
#include <sys/types.h>
#include <sys/stat.h>
#endif /* NET */
#else /* __MWERKS__ */
#include <sys/types.h>
#include <sys/stat.h>
#ifdef unix
#include <unistd.h>
#include <dirent.h>
#endif /* unix */
#endif /* __MWERKS__ */

#ifdef __linux__
typedef int bool_t;
typedef int enum_t;
#endif /* __linux__ */

#ifdef DJGPP
#undef unix
#endif /* DJGPP */

#include "configur.h"
#include "portable.h"

#ifdef __TURBOC__
#include <conio.h>
#include <dir.h>
#include <dos.h>
#endif /* __TURBOC__ */

#ifndef ANSI
#include <varargs.h>
#else /* ANSI */
#include <stdarg.h>
#endif /* ANSI */

#ifdef NET
#ifdef AMIGA
#include <rpc/types.h>
#endif
#ifdef __MWERKS__
#include <GUSI.h>
#endif /* __MWERKS__ */
#ifndef MON
#include <netdb.h>
#endif /* MON */
#endif

#if DECVAX
#ifdef NET
#include "multinet_root:[multinet.include.sys]types.h"
#include "multinet_root:[multinet.include.sys]socket.h"
#endif /* NET */
#else
#ifdef NET
#ifndef MON
#include <sys/socket.h>
#endif /* MON */
#endif /* NET */
#endif /* DECVAX */

#ifdef NET

#ifdef DECVAX
#include "multinet_root:[multinet.include.netinet]in.h"
#include "multinet_root:[multinet.include.arpa]inet.h"
#else /* DECVAX */
#ifndef MON
#include <netinet/in.h>
#endif /* MON */
#ifndef __MWERKS__
#ifndef MON
#include <arpa/inet.h>
#endif /* __MWERKS__ */
#endif /* MON */
#endif /* DECVAX */

#ifndef MON
#include <signal.h>
#endif /* MON */
/* #include <rpc/xdr.h> ;excahnged <rpc/rpc.h> by Kimezawa 950518 */

#ifdef __MWERKS__

#include "rpctypes.h"
#include "xdr.h"

#else /* __MWERKS__ */

#ifndef DECVAX
#include <rpc/rpc.h>
#else /* DECVAX */
#include "rpctypes.h"
#include "xdr.h"
#endif /* DECVAX */

#endif /* __MWERKS__ */

#include "mesg.h"

#endif /* NET */

#ifdef ALCOMM
#include <mlayer.h>
#endif /* ALCOMM */

#ifdef unix

#if FRONTEND == BASIC
#include <curses.h>
#endif /*FRONTEND == BASIC */

#define KEYHIT() ( TC_Menu )

#endif /* unix */
#ifdef AMIGA
#include <exec/types.h>
#if FRONTEND == BASIC
#include <curses.h>
#define KEYHIT() ( kbhit() )
#else /* FRONTEND == BASIC */
#define KEYHIT() ( TC_Menu )
#endif /* FRONTEND == BASIC */
#endif /* AMIGA */

#ifdef DECVAX
#if FRONTEND == BASIC
#include <curses.h>
#endif /*FRONTEND == BASIC */
#define KEYHIT() ( TC_Menu )
#endif /* DECVAX */

#if (OPSYS == BCDOS) || (OPSYS == DJGPPDOS)
#define KEYHIT() ( KeyHit() )
#endif /* (OPSYS == BCDOS) || (OPSYS == DJGPPDOS) */

#ifdef __MWERKS__
#define KEYHIT() ( FEProcessEvent() )
#endif /* __MWERKS__ */

#define ONE (I32u) 1

#define tulrand() ((I32u) (tdrand() * (double) I32U_MAX))
/* returns random 32 bit positive signed integer */
#define tlrand() ((I32s) (tdrand() * (double) I32S_MAX))
/* returns random 32 bit positive signed integer */
#define tirand() ((I16s) (tdrand() * (double) I16S_MAX))
/* returns random 16 bit positive signed integer */
#define tuirand() ((I16u) (tdrand() * (double) I16U_MAX))
/* returns random 16 bit unsigned integer */
#define tcrand() ((I8s) (tdrand() * (double) I8S_MAX))
/* returns random 8 bit positive signed integer */
#define tucrand() ((I8u) (tdrand() * (double) I8U_MAX))
/* returns random 8 bit unsigned integer */

#define IsBit(seed, bit) ((((I32u) seed) & (ONE << ((I32u) bit))) ? 1 : 0)
#define ad(A) ((A) >=0 ? ((A)%SoupSize) \
               : ((SoupSize-(-(A)%SoupSize))%SoupSize))
#define mo(A,B) ((A) >=0 ? ((A)%(B)) : (((B)-(-(A)%(B)))%(B)))
#define TNULL(pData) ((I32u)(pData) < 5L)

#define WRITE 1
#define NOWRITE 0
#define EXIT 1
#define NOEXIT 0
#define PLN_STATS 1
#define SIZ_HIST 2
#define SIZM_HIST 3
#define GEN_HIST 4
#define SIZ_QUERY 5

#ifdef __GUI__
typedef struct {
    short   szMarg;
    char    szDesc[80];
} wScreen;
#endif /* __GUI__ */

typedef unsigned char Inst;

#if PLOIDY == 1
typedef Inst Instruction;
typedef I8s GenBits;
#else  /* PLOIDY == 1 */
typedef Inst Instruction[PLOIDY];
typedef I8s GenBits[PLOIDY];
#endif /* PLOIDY == 1 */

typedef Instruction Hp HpInst;
typedef Instruction Fp FpInst;
typedef Instruction Np NpInst;
typedef Inst Fp FpIns;
typedef GenBits Fp FpGenB;

typedef struct cell       TCell;
typedef struct cell Fp    Pcells;
typedef struct g_list     GList;
typedef struct g_list Fp  Pgl;

typedef I32s  Reg;   /* type for use in CPU registers */
typedef Reg   *Preg; /* pointer to register */

typedef struct { /* struct for passing arguments from decode to execute */

    Preg   sreg; /* pointer to source register */
    FpIns  sins; /* pointer to source instruction */
    I32s   sval; /* source value */
    I8s    stra; /* source track */

    Preg   dreg;  /* pointer to destination register */
    I32s   dval;  /* original destination value */
    FpIns  dins;  /* pointer to destination instruction */
    I8s    dtra;  /* destination track */
    I32s   dmod;  /* destination modulused positive this size */
    I32s   dran;  /* destination kept in signed range of this value */
    Pcells dcel;  /* destination cell */

    Preg   sreg2; /* pointer to 2nd source register */
    FpIns  sins2; /* pointer to 2nd source instruction */
    I32s   sval2; /* 2nd source value */
    I8s    stra2; /* 2nd source track */

    Preg   dreg2; /* pointer to 2nd destination register */
    I32s   dval2; /* original destination value */
    FpIns  dins2; /* pointer to 2nd destination instruction */
    I8s    dtra2; /* 2nd destination track */
    I32s   dmod2; /* 2nd dest modulused positive this size */
    I32s   dran2; /* 2nd dest kept in signed range of this value */

    I32s   sval3; /* 3rd source value */
    I32s   dval3; /* original destination value */

    Preg   dreg3; /* pointer to 3rd destination register */
    I32s   dmod3; /* 3rd dest modulused positive this size */
    I32s   dran3; /* 3rd dest kept in signed range of this value */

    I8s    mode;  /* mode of instruction */
    I8s    mode2; /* 2nd mode of instruction */
    I8s    mode3; /* 3rd mode of instruction */

    I8s    expr;  /* execute protection 0 = no protection, 1 = protected */
    I32s   oip;   /* address of instruction being executed: ce->c.ip */
    FpIns  eins;  /* pointer to instruction being executed */
    I8s    iip;   /* amount to increment instruction pointer */
    I8s    dib;   /* amount to decrement instruction bank */
    I16s   ts;    /* size of time slice, used to control central loop */
} PInst;

typedef struct {
    I32s  n;  /* allocated size of file list */
    I32s  *l; /* pointer to list of .tmp file names */
} TmpList; /* list of names of .tmp files in genebank */

#ifndef NET       /* if NET is defined, Event is declared in mesg.h */
typedef struct {  /* structure for time measured in executed instructions */
    I32s m;     /* count of millions of instructions */
    I32s i;     /* count of instructions */
} Event;
#endif /* NET */

typedef struct {
    I32s size;        /* size class (~species) */
    I8s label[4];     /* genotype label */
} Genotype;

typedef struct {
    I32s si;           /* size index */
    I16s gi;           /* genotype index */
} GlIndex;


typedef struct {  /* structure for metabolic data */
    I32s  inst;      /* count of instructions executed */
    I32s  flags;     /* count of flags (error conditions) set */
    I32s  mov_daught;/* count of number of instructions moved to daughter */
    I32s  BreedTrue; /* 0=not, 1 = this daughter genetically same as parent */
} Metabolism;

typedef struct { /* structure for indexing cells in the cells arrays */
    I16u  a; /* which array */
    I16u  i; /* which element of the array */
} CellInd;

typedef struct { /* structure for demographic data */
    Genotype gen;   /* size and genotype name of cell */
    I32s RanID;      /* random ID # of for this cell */
    I16s gi;         /* index to this genotype in the gl array */
    I32s hash;       /* hash value for this genotype */
    I32s fecundity;  /* count of number of daughter cells produced */
    I32s flags;      /* count of flags (error conditions) set */
    I32s mov_daught; /* count of number of instructions moved to daughter */
    I32s inst;       /* count of instructions executed */
    I32s mut;        /* 0 = no somatic mutations, >= 1 = somatic mutations */
    I32s flaw;       /* 0 = no flaws, >= 1 = flaws */
    I32s max_cpus; /* max number CPUs simultaneously used during lifetime */
    Metabolism d1;   /* metabolic data for first daughter */
    Genotype parent; /* size and genotype name of parent */
    CellInd  ne;     /* address of daughter cell */
    I8s is;        /* 1 = this cpu is active, in the slicer; 0 = not active */
    I8s dm;          /* 0 = mother, 1 = daughter */
    I8s ploidy;      /* how many tracks */
    FpInst genome;   /* pointer to genome itself, in soup */
#ifdef HSEX
    I32s mate_addr;   /* soup address of mate */
    I16s x_over_addr; /* # bytes into gen for Xover, - first half, + second */
#endif /* HSEX */
} Dem;

typedef struct { /* pointers to this, previous and next cells in queues */
    CellInd  this;   /* index of this cell */
    CellInd  n_time;   /* index to next cell in slicer queue */
    CellInd  p_time;   /* index to previous cell in slicer queue */
    CellInd  n_reap;   /* index to next cell in reaper queue */
    CellInd  p_reap;   /* index to previous cell in reaper queue */
} Que;

typedef struct {   /* structure for allocated memory block of cell */
    I32s p;     /* location of start of cell memory */
    I32s s;    /* size of cell memory */
} Mem;

#ifdef IO

typedef struct { /* structure for put-get communications */
    I16s  psiz; /* currently allocated size of put buffer */
    I16s  gsiz; /* currently allocated size of get buffer */
    Preg  gb;   /* pointer to input buffer */
    Preg  pb;   /* pointer to output buffer */
} PGb;

typedef struct { /* structure for global communications */
    I32s gb; /* global buffer for inter-cpu communications */
    I8s  ty; /* type of communication */
    I8s  np; /* number participating so far */
} GloCom;

#endif /* IO */

#ifdef NET

typedef struct { /* structure for communications data */
    I32s len; /* length of message */
    I8s  *d; /* array for data communications */
} ComData;

typedef struct {   /* structure for IO for communication */
    ComData d; /* data */
    ComAddr s; /* source address */
    ComAddr e; /* destination address */
    I32s    t; /* tag for type of message 0 reserved for free struct */
} IOS;

typedef struct {   /* structure for IO for communications buffer */
    I32s  ipi; /* current index into IP map list */
    I16s  siz; /* currently allocated size of IOS buffer */
    I16s  nio; /* index of next free IOS for incoming messages */
    IOS   *io; /* pointer to IOS buffer; 0 struct for outgoing */
} IOb;                                /* 1 to (siz - 1) for incoming */

typedef struct {  /* structure for IPMap array */
    NetAddr address;
    TPingData data;
} MapNode;

#endif /* NET */

typedef struct {
    I8s  n;   /* number of register to toggle */
    I8s  *r;  /* list of n registers to toggle */
} Rtog; /* for keeping track of toggled registers */

typedef struct {  /* there will be only one global copy of this structure */
    Rtog  Se; /* list of segment registers */
    Rtog  De; /* list of destination registers */
    Rtog  So; /* list of source registers */
} IDRegs;

typedef struct {
    unsigned  Se: 1; /* oFfset - segment */
    unsigned  B:  1; /* Bits */
    unsigned  De: 1; /* Target - destination */
    unsigned  So: 1; /* Get - source */
    unsigned  D:  1; /* Direction */
    unsigned  H:  1; /* sHadow registers */
    unsigned  P:  1; /* reverse Polish */
    unsigned  C:  1; /* speCial */
} IDflags;

typedef struct { /* structure for instruction set definitions */
    I8s op;                     /* op code */
    I8s mn[9];                  /* assembler mnemonic */
    void (*execute) P_((void)); /* pointer to execute function */
    void (*decode) P_((void));  /* pointer to decode function */
    I8s  re[8];                 /* register assignments */
    IDflags  idf;               /* flags usage */
} InstDef;

typedef struct {
    int  E:  1; /* Error : 1 = error condition has occurred
                    0 = no error condition occurred */
    int  S:  1; /* Sign : resulting sign of arithmetic operation,
                    0 = +, 1 = - */
    int  Z:  1; /* Zero : result of arithmetic or compare operation,
                    0 = nonzero, 1 = zero */
    int  B:  2; /* Bits: 00 = 32, 01 = 16, 10 = 8 */
    int  D:  1; /* Direction: for shift, rotate, move, search */
} Flags;

typedef struct {
    I8s  i; /* index into Cpu.re array of registers */
    I8s  t; /* index into Rtog.r list of registers */
} TRind; /* register toggle indexes */
    /* note that TRind.t will be toggled by incrementing it with the
       modulus Rtog.n, after each toggle, TRind.i will be updated to
       provide a more direct reference to the actual Cpu.re register */

typedef struct {
    TRind  Se; /* current segment register */
    TRind  De; /* current destination register */
    TRind  So; /* current  source register */
} CRflags; /* CPU register flags */

typedef struct {         /* structure for registers of virtual cpu */
    Reg re[ALOC_REG];    /* array of registers */
    Reg ip;              /* instruction pointer */
    Reg sp;              /* stack pointer */
    Reg st[STACK_SIZE];  /* stack */
    Flags fl;            /* flags */
    CRflags cf;          /* CPU Register flags */
    I8s sync;            /* wait for sync */
#if PLOIDY > 1
    I8s ex; /* track of execution */
    I8s so; /* source trace for reads */
    I8s de; /* destination track for writes */
    I8s wc; /* wait count for error-track switching */
#endif /* PLOIDY > 1 */
} Cpu;

typedef struct { /* structure for cpu array */
    I16s ib; /* instruction bank */
    I32s n;  /* number of allocated cpus */
    I32s ac; /* number of this active cpu */
    I8s  sync; /* sync flag for this cell */
    Cpu  *c; /* pointer to currently active cpu */
    Cpu  *ar; /* pointer to array of cpus */
    InstDef *d; /* pointer to current InstDef structure for parsing */
#ifdef NET
    IOb io;              /* IO buffer for network communications */
#endif /* NET */
#ifdef IO
    PGb pg;              /* IO buffer for put - get communications */
    GloCom gc;
#endif /* IO */
} CpuA;

struct cell {   /* structure for cell of organisms */
    Dem d;  /* fecundity and times and dates of birth and death */
    Que q;  /* pointers to previous and next cells in queues */
    Mem mm; /* main cell memory */
    Mem md; /* daughter cell memory */
    CpuA c; /* virtual cpus */
    I8s ld; /* 0 = dead, 1 = alive */
} ;     /* sizeof(struct cell) = XX */

/* Structures for new soup allocator. CJS, July 1992. */

typedef struct {      /* Describes a free area of the soup */ 
  I32s    l,          /* Index of left son in cartesian tree; 
                         or index of 1st recycled node (>0);
                         or -(number of untouched nodes)   */
          r,          /* Index of rt son in cartesian tree */
          p,          /* Soup addr of this unoccupied area */
          s;          /* Size of the area (in instr slots) */
} MemFr ;

typedef MemFr Fp  Pmf;

struct g_list { /* structure for genotype list */
    I32s pop;   /* current number of adults of this genotype in soup */
    Genotype gen;   /* genotype of creature */
    Genotype parent;/* genotype of parent genotype (ancestor) */
    I32s hash;      /* hash number for genome identification */
    I32u bits;             /* see below */
    Metabolism d1;  /* metabolic data for first daughter */
    Metabolism d2;  /* metabolic data for second daughter */
    Event originI;  /* time of origin, in instruction time */
    I32s originC;      /* time of first origin of genotype, in clock time */
    float MaxPropPop;  /* max. propor. of NumCells reached by this gen. */
    float MaxPropInst; /* max. propor. of SoupSize reached by this gen. */
    Event mpp_time;    /* most recent time of MaxPropPop update */
    I8s ploidy;        /* how many tracks */
    FpInst genome;     /* pointer to genome itself */
    FpGenB gbits;      /* pointer to genome bit field */
    I32s max_cpus; /* max number CPUs simultaneously used during lifetime */
} ;

/* definitions of bits in struct g_list:
    bit  0  permanent genotype name, saved in .gen file
    bit  1  gen is saved to disk, but went extinct, then reappeared,
            and has not yet re-crossed save threshold
    bit  2  EXs = executes own instructions (self)
    bit  3  EXd = executes daughter's instructions
    bit  4  EXo = executes other cell's instructions
    bit  5  EXf = executes instructions in free memory
    bit  6  EXh = own instructions are executed by other creature (host)
    bit  7  TCs = matches template complement of self
    bit  8  TCd = matches template complement of daughter
    bit  9  TCo = matches template complement of other
    bit 10  TCf = matches template complement of free memory
    bit 11  TCh = own template complement is matched by other creature (host)
    bit 12  TPs = uses template pattern of self
    bit 13  TPd = uses template pattern of daughter
    bit 14  TPo = uses template pattern of other
    bit 15  TPf = uses template pattern of free memory
    bit 16  TPh = own template pattern is used by other creature (host)
    bit 17  MFs = moves instruction from self
    bit 18  MFd = moves instruction from daughter
    bit 19  MFo = moves instruction from other cell
    bit 20  MFf = moves instruction from free memory
    bit 21  MFh = own instructions are moved by other creature (host)
    bit 22  MTs = moves instruction to self
    bit 23  MTd = moves instruction to daughter
    bit 24  MTo = moves instruction to other cell
    bit 25  MTf = moves instruction to free memory
    bit 26  MTh = is written on by another creature (host)
    bit 27  MBs = executing other creatures code, moves inst from self
    bit 28  MBd = executing other creatures code, moves inst from daughter
    bit 29  MBo = executing other creatures code, moves inst from other cell
    bit 30  MBf = executing other creatures code, moves inst from free memory
    bit 31  MBh = other creature uses another cpu to move your instructions
*/

typedef struct { /* structure for size list */
    I32s num_c;  /* # adult creatures of this size in soup */
    I16s num_g;  /* # genotypes of this size extant in soup */
    I16s a_num;  /* allocated size of *g array */
    GList **g;   /* array of GList structures */
    I32s  *hash; /* hash array */
} SList;

typedef struct {
  I16s  size ;
  I16s  lbl;
  I32s  count;
  I8u   nstar;
  } HistType;

typedef struct {    /* record of last data output to disk */
    I32s  time;     /* elapsed time */
    I32s  mtime;    /* millions of instructions */
    I8s   bd;       /* b = birth, d = death */
    I32s  size;     /* size of creature */
    I8s   label[4]; /* genotype name of creature, e.g., aaa */
} LastOut;

typedef struct {
    I8s   magic[4];
    I32s  g_off;    /* ofsett where genomes begin */
    I32s  size;     /* size of genome */
    I32s  n;        /* number of genomes in bank */
    I32s  n_alloc;  /* allocated size of bank */
} head_t;

typedef struct {
    I8s   gen[4];
    I8s   pgen[4];
    I32s  psize;
    I32s  hash;
    I32u  bits;
    I32s  originC;
    I16s  mpp, mpi;
    Event mppT;       /* last time of mpp update */
    I32s  ptr;        /* reserved for future versions */
    Event originI;
    Metabolism d1, d2;
    I32s   pt;         /* ploidy and track */
    I32s max_cpus;/* max number of CPUs simultaneously used during lifetime */
} indx_t;

typedef struct {
    I8s     type;
    I8s     *s;
    I16u    h;
    I32s    i;
    float   f;
    double  d;
#ifdef MON
    I8s     name[40];
    I8s     value[40];
#endif /* MON */
} VarQuer;

#ifdef MEM_PROF

typedef struct {
    I32s  label; /* arbitrary label for this kind of allocation */
    I32s  num;   /* current number of allocations of this type */
    I32s  siz;  /* amount of memory held in allocations of this type, bytes */
} MemProf;

typedef struct {
    I32s  DynMemUse;  /* total dynamic memory allocated */
    I32s  TotNumAloc; /* total number of dynamic memory blocks allocated */
    I32s  AlocSiz;    /* current allocated size of MemProf array */
    MemProf  *mpa;     /* pointer to MemProf array */
} MemProfStat;

/* MEM_PROF label table:

0001 ReceiveBuf = (I8s *) tcalloc(SoupSize, sizeof(I8s), 1);
0002 ReceiveBuf = tcalloc(SoupSize, 1, 2);
0400 extract_buf = (char *) tcalloc(sizeof(ExtractMsg) + ce->d.gen.size *
         (sizeof(Instruction) + sizeof(GenBits)), sizeof(char), 400);
0600 t = (indx_t *) thcalloc(head->n_alloc, sizeof(indx_t), 600);
0604 buf = (I8s *) thcalloc(s = gensiz * head->n , 1, 604);
0605 gdat = (I8s *) tcalloc(85, sizeof(I8s), 605);
0608 id = (InstDef *) tcalloc(InstNum, sizeof(InstDef), 608);
0609 IDregs.Se.r = tcalloc(len, sizeof(I8s), 609);
0610 IDregs.De.r = tcalloc(len, sizeof(I8s), 610);
0611 IDregs.So.r = tcalloc(len, sizeof(I8s), 611);
0700 ce->c.io.io = (IOS *) tcalloc((I32u) 1, (I32u) sizeof(IOS), 700);
0701 buf = (I8u *) tcalloc(28 + ios->d.len, sizeof(I8u), 701);
0702 ios->d.d = (I8s *) tcalloc(ios->d.len, sizeof(I8s), 702);
0703 ce->c.pg.gb = (Preg) tcalloc(3, sizeof(Reg), 703);
0704 ce->c.pg.pb = (Preg) tcalloc(3, sizeof(Reg), 704);
0705 SendingBuf = tcalloc(MessageLen, 1, 705);
1000 IPMap = (MapNode *) tcalloc(1,siz, 1000);
1002 check = (I8s *) tcalloc(NumNodes,sizeof(I8s), 1002);
1003 SendBuf = (I8s *) tcalloc(128,sizeof(I8s), 1003); compose XDR stream
1004 CompBuf = (I8s *) tcalloc(32,sizeof(I8s), 1004);
1200 MemStat.mpa = (MemProf *) calloc(1, sizeof(MemProf));
1400 sl[si] = (SList Fp) tcalloc(1, sizeof(SList), 1400);
1401 sl[si]->g = (GList Fp Fp) tcalloc(gi + 1, sizeof(GList Fp), 1401);
1402 sl[si]->g[gi] = (GList Fp) tcalloc(1, sizeof(GList), 1402);
1403 tgl->genome = (FpInst) tcalloc(size, sizeof(Instruction), 1403);
1404 tgl->gbits = (FpGenB) tcalloc(size, sizeof(GenBits), 1404);
1405 sl[si]->h = (I32s Fp) tcalloc(20, sizeof(I32s), 1405);
1406 tl->l = (I32s *) tcalloc(1, sizeof(I32s), 1406);  Tmpl stuff
1900 cells = (Pcells  Fp) tcalloc(NumCelAr, sizeof(Pcells), 1900);
1901 cells[i] = (Pcells) tcalloc(CelArSiz, sizeof(TCell), 1901);
1902 ce->c.ar = (Cpu *) tcalloc(ce->c.n, sizeof(Cpu), 1902);
1903 sl = (SList Fp Fp) tcalloc(1, sizeof(SList Fp), 1903);
1904 GenInList = (I8s **) tcalloc((I32u) NumCells, sizeof(I8s *), 1904);
1905 GenInBuf = (I8s *) tcalloc((I32u) NumCells * 30, sizeof(I8s), 1905);
1906 soup = (HpInst) thcalloc((I32u) SoupSize, sizeof(Instruction), 1906);
1907 FreeMemry = (MemFr Fp) tcalloc(MaxFreeBlocks, sizeof(MemFr), 1907);
2100 buf = (size_buf *) thcalloc((num_spec + 1), sizeof(size_buf), 2100);
2101 Hist  = (HistType *) thcalloc((num_ent + 1) , sizeof(HistType), 2101);

#ifdef MON
============= in tmon_do_com.c =====================
12101 ReplyTmp = (ReqComSt *) thcalloc (n_send, sizeof (ReqComSt), 12101);
12102 ReplyData.buf = (I8s *) tcalloc(ReplyLen, 1, 12102);
12103 ReplyTmp = (ReqComSt *) thcalloc(n_send, sizeof(ReqComSt), 12103);
12104 ReplyData.buf = (I8s *) tcalloc(ReplyLen, 1, 12104);
12105 ReplyTmp = (ReqComSt *) thcalloc(n_send, sizeof(ReqComSt), 12105);
12106 ReplyData.buf = (I8s *) tcalloc(ReplyLen, 1, 12106);
12107 ReplyTmp = (ReqComSt *) thcalloc(n_send, sizeof(ReqComSt), 12107);
12108 ReplyData.buf = (I8s *) tcalloc(ReplyLen, 1, 12108);
12109 ReplyTmp = (ReqComSt *) thcalloc(tc + 1, sizeof(ReqComSt), 12109);
12110 ReplyTmp = (ReqComSt *) thcalloc(tc + 1, sizeof(ReqComSt), 12109);
12111 ReplyTmp = (ReqComSt *) thcalloc(NumMDVar, sizeof(ReqComSt), 12111);
12112 ReplyData.buf = (I8s *) tcalloc(ReplyLen, 1, 12112);
12113 MDVarBuf[id] = (MDVar *) thcalloc(1, sizeof(MDVar), 12113);
12114 MDTpingTmp = (MDTping *) thcalloc(NumNodes, (sizeof(MDTping) + 1) * 4, 12114);
12115 ReplyTmp = (ReqComSt *) thcalloc(NumNodes, sizeof(ReplyTmp) + (sizeof(MDTping)
+ 1) * 4, 12115);
12116 ReplyData.buf = thcalloc(ReplyLen, 1, 12116);
12117 ReplyData.buf = (I8s *) tcalloc(ReplyLen, 1, 12117);
12118 MDOVMesBuf = (MDOVMes *) tcalloc(MonOVP, sizeof(MDOVMes), 12118);
12119 MTB_OV = (I8s *) tcalloc(MonOVP, sizeof(I8s), 12119);
12120 ReplyTmp = (ReqComSt *) thcalloc(num, sizeof(ReqComSt), 12120);
12121 ReplyData.buf = (I8s *) tcalloc(1, ReplyLen, 12121);
12122 ReplyTmp = (ReqComSt *) thcalloc(MDOV_G_InstNumBuf.num,sizeof(ReqComSt), 12122)
;
12123 ReplyData.buf = (I8s *) tcalloc(1, ReplyLen, 12123);


======================= in tmon_func.c =====================================
12201 MDSizeQueryOutputBuf =
(MDSizeQueryOutput *) thcalloc ((num_spec + 1), sizeof (MDSizeQueryOutput),12201);
MDSizeHistBuf = (MDSizeHist *) thcalloc (Tmon_nnn + 1, sizeof (MDSizeHist),12202);
12203 MTB_SIZ_HIST = (I8s *) thcalloc (Tmon_nnn + 1, sizeof (I8s), 12203);
12204 MDGenHistBuf = (MDGenHist *) thcalloc (Tmon_nnn + 1, sizeof (MDGenHist), 12204)
;
12205 MTB_GEN_HIST = (I8s *) thcalloc (Tmon_nnn + 1, sizeof (I8s), 12205);
12206 MDMemHistBuf = (MDMemHist *) thcalloc (Tmon_nnn + 1, sizeof (MDMemHist), 12206)
;
12207 MTB_MEM_HIST = (I8s *) thcalloc (Tmon_nnn + 1, sizeof (I8s), 12207);
12208 MDOVMesBuf = (MDOVMes *) tcalloc (1, sizeof (MDOVMes), 12208);
12208 MDOVMesBuf = (MDOVMes *) trecalloc ((void *) MDOVMesBuf,
                                  (I32u) sizeof (MDOVMes) * (I32u) (MonOVP),
                      (I32u) sizeof (MDOVMes) * (I32u) (MonOVP - 1), 12208);
12209 MTB_OV = (I8s *) tcalloc (1, sizeof (I8s), 12209);
12209 MTB_OV = (I8s *) trecalloc ((void *) MTB_OV,
                          (I32u) sizeof (I8s) * (I32u) (MonOVP),
                          (I32u) sizeof (I8s) * (I32u) (MonOVP - 1), 12209);
12210 MDOVMesBuf = (MDOVMes *) tcalloc (1, sizeof (MDOVMes), 12210);
12210 MDOVMesBuf = (MDOVMes *) trecalloc ((void *) MDOVMesBuf,
                      (I32u) sizeof (MDOVMes) * (I32u) (MonOVP),
                      (I32u) sizeof (MDOVMes) * (I32u) (MonOVP - 1), 12210);
12211 MTB_OV = (I8s *) trecalloc ((void *) MTB_OV,
                      (I32u) sizeof (I8s) * (I32u) (MonOVP),
                      (I32u) sizeof (I8s) * (I32u) (MonOVP - 1), 12211);
12212 MDVarBuf = (MDVar **) tcalloc (MaxNumMDVar, sizeof (MDVar), 12212);

=================== in tmon_do_xdr.c =======================================
12301 xbuf = (I8s *)tcalloc (len, 1, 12301);
12302 xbuf = (I8s *)tcalloc (len, 1, 12302);
12303 xbuf = (I8s *)tcalloc (len, 1, 12303);
12304 xbuf = (I8s *)tcalloc (len, 1, 12304);
12305 xbuf = (I8s *)tcalloc (len * 4 + 1 + 10000, 1, 12305);

#endif /* MON */

 */

#endif /* MEM_PROF */

#ifndef MON
#ifdef NET
typedef struct{ /* Multiple Monitor Socket */
    I16s fd;    /* File descriptor */
    I8s  flg;   /* Flag for if this socket is used(=T) or unused(=F) */
} MonSock;
#endif /* NET */
#endif /* MON */

#ifdef DECVAX
#include <string.h>
#define bcopy(a,b,c) memmove(b,a,c)
#define bzero(a,b) memset(a,0,b)
#ifdef NET
struct timeval {
   long tv_sec;
   long tv_usec;
};
#endif /* NET */
#endif /* DECVAX */

typedef struct {
      Pcells    MicroSlice;    /* cell that is selected */
      Cpu      *MicroCpu;      /* pointer to selected cpu */
      I32s      MicroCpuI;     /* index to selected cpu */
#ifdef MICRO
      int       TrapType;      /* trap type */
      int       BrkSet;        /* "break point set" flag */
      int       BrkFnd;        /* "break point found" flag */
      GlIndex   host_genome;   /* host genome */
      GlIndex   prim_genome;   /* primary genome */
      I32s      genoffset;     /* genome offset */
      Event     AbsTime;       /* absolute stop time. */
      Event     IntervalTime;  /* interval stop time. */
      double    pctchg;        /* percent change */
      I32s      lowlim;        /* lower boundary of limit */
      I32s      hilim;         /* upper boundary of limit */
      char      permtemp;      /* p-permanent, t-temporary, b-both */
      double    avgpoprng;     /* average population over range. */

#endif /* MICRO */
} BrkTrapDat;

typedef struct {
  BrkTrapDat curbrkdat;
  BrkTrapDat savbrkdat;
} BrkTrapCond;

#ifdef MICRO

#define VIEWSOUPLINES 10
#define BRKTYP_GENOME_OFFSET             1
#define BRKTYP_CURCELL_OFFSET            2
#define BRKTYP_ABSTIMEINST               3
#define BRKTYP_INTRVLTIMEINST            4
#define BRKTYP_PARAGEN_HOSTGEN           5
#define BRKTYP_PCTCHGPOP                 6
#define BRKTYP_PERMPARAPERMHOST          7
#define BRKTYP_PERMGENTIME               8
#define BRKTYP_PARAGENPERMHOST           9
#define BRKTYP_PERMPARAHOST             10
#define BRKTYP_GENSIZERANGE             11
#define BRKTYP_PERMPARA_HOSTSIZERANGE   12
#define BRKTYP_PERMHOST_PARASIZERANGE   13

#endif /* MICRO */

typedef struct {
   I32s count;
   I32s lbl;
   I32s moves;
   I32s flags;
   I32s bits;
}  size_buf;

#include "prototyp.h"

#endif /* LTIERRA_H */
