/* @(#)tsetup.c    1.4 11/25/94*/
/* tsetup.c  7-3-96  Tierra Simulator  setup routines */
/* Tierra Simulator V4.3: Copyright (c) 1991, 1992, 1993, 1994, 1995, 1996 */
/* Tom Ray & Virtual Life */
/* MemProf labels: #19XX, in use: 1900-1907 */
/* FEError labels: #19XX, in use: 1908-1912 1914 1920-1922 1924-1931 */

#ifndef lint
static char sccsid[] = "@(#)tsetup.c    1.5 7/21/92";
#endif

#include "license.h"
#include "tierra.h"
#include "globals.h"
#ifdef AMIGA
#ifdef NET
#include "sys/ioctl.h"
#endif /* NET */
#endif /* AMIGA */

#ifdef MON
#include "obs.h"
#include "tmon_global.h"
#endif /* MON */

#ifdef LUNA
#define SEEK_SET   0
#define SEEK_END   2
#endif 

I8s corefile[120];

I8s GetAVar(data)
const I8s *data;
{
    switch (*data) {
    case 'a':
    if (!strncmp(data, "alive", 5))
    {   sscanf(data, "alive = %ld", &alive);
        vqu.type = 'i'; vqu.i = alive; return 1;
    }
    case 'd':
    if (!strncmp(data, "debug", 5))
    {   sscanf(data, "debug = %ld", &debug);
        vqu.type = 'i'; vqu.i = debug; return 1;
    }
    case 'h':
    if (!strncmp(data, "hangup", 6))
    {   sscanf(data, "hangup = %ld", &hangup);
        vqu.type = 'i'; vqu.i = hangup; return 1;
    }
    case 'n':
    if (!strncmp(data, "new_soup", 8))
    {   sscanf(data, "new_soup = %ld", &new_soup);
        vqu.type = 'i'; vqu.i = new_soup; return 1;
    }
    case 's':
    if (!strncmp(data, "seed", 4))
    {   sscanf(data, "seed = %ld", &seed);
        vqu.type = 'i'; vqu.i = seed; return 1;
    }
    case 'B':
    if (!strncmp(data, "BrkupSiz", 8))
    {   sscanf(data, "BrkupSiz = %ld", &BrkupSiz);
        vqu.type = 'i'; vqu.i = BrkupSiz; return 1;
    }
    case 'C':
    if (!strncmp(data, "CumGeneBnk", 10))
    {   sscanf(data, "CumGeneBnk = %ld", &CumGeneBnk);
        vqu.type = 'i'; vqu.i = CumGeneBnk; return 1;
    }
    case 'D':
    if (!strncmp(data, "DiskBank", 8))
    {   sscanf(data, "DiskBank = %ld", &DiskBank);
        vqu.type = 'i'; vqu.i = DiskBank; return 1;
    }
    if (!strncmp(data, "DiskOut", 7))
    {   sscanf(data, "DiskOut = %ld", &DiskOut);
        vqu.type = 'i'; vqu.i = DiskOut; return 1;
    }
    if (!strncmp(data, "DistFreq", 8))
    {   sscanf(data, "DistFreq = %f", &DistFreq);
        vqu.type = 'f'; vqu.f = DistFreq; return 1;
    }
    if (!strncmp(data, "DistProp", 8))
    {   sscanf(data, "DistProp = %f", &DistProp);
        vqu.type = 'f'; vqu.f = DistProp; return 1;
    }
    if (!strncmp(data, "DivSameSiz", 10))
    {   sscanf(data, "DivSameSiz = %ld", &DivSameSiz);
        vqu.type = 'i'; vqu.i = DivSameSiz; return 1;
    }
    if (!strncmp(data, "DivSameGen", 10))
    {   sscanf(data, "DivSameGen = %ld", &DivSameGen);
        vqu.type = 'i'; vqu.i = DivSameGen; return 1;
    }
    if (!strncmp(data, "DropDead", 8))
    {   sscanf(data, "DropDead = %ld", &DropDead);
        vqu.type = 'i'; vqu.i = DropDead; return 1;
    }
    case 'E':
    if (!strncmp(data, "EjectRate", 9))
    {   sscanf(data, "EjectRate = %ld", &EjectRate);
        vqu.type = 'i'; vqu.i = EjectRate; return 1;
    }
    case 'G':
    if (!strncmp(data, "GeneBnker", 9))
    {   sscanf(data, "GeneBnker = %ld", &GeneBnker);
        vqu.type = 'i'; vqu.i = GeneBnker; return 1;
    }
    if (!strncmp(data, "GenebankPath", 12))
    {   sscanf(data, "GenebankPath = %s", GenebankPath);
        vqu.type = 's'; vqu.s = GenebankPath; return 1;
    }
    if (!strncmp(data, "GenPerBkgMut", 12))
    {   sscanf(data, "GenPerBkgMut = %f", &GenPerBkgMut);
        vqu.type = 'f'; vqu.f = GenPerBkgMut; return 1;
    }
    if (!strncmp(data, "GenPerFlaw", 10))
    {   sscanf(data, "GenPerFlaw = %f", &GenPerFlaw);
        vqu.type = 'f'; vqu.f = GenPerFlaw; return 1;
    }
    if (!strncmp(data, "GenPerMovMut", 12))
    {   sscanf(data, "GenPerMovMut = %f", &GenPerMovMut);
        vqu.type = 'f'; vqu.f = GenPerMovMut; return 1;
    }
#ifdef __MWERKS__
#ifdef NET
    case 'H':
    if (!strncmp(data, "Host", 4))
    {   sscanf(data, "Host = %s", &MacHost);
        vqu.type = 's'; vqu.s = MacHost; return 1;
    }
#endif /* NET */
#endif /* __MWERKS__ */
    case 'L':
    if (!strncmp(data, "Log", 3))
    {   sscanf(data, "Log = %ld", &Log);
        vqu.type = 'i'; vqu.i = Log; return 1;
    }
#ifdef NET
    if (!strncmp(data, "LocalPort", 9))
    {   sscanf(data, "LocalPort = %hu", &LocalPort);
        vqu.type = 'h'; vqu.i = LocalPort; return 1;
    }
#endif /* NET */
    case 'I':
    if (!strncmp(data, "IMapFile", 8))
    {   sscanf(data, "IMapFile = %s", IMapFile);
        vqu.type = 's'; vqu.s = IMapFile; return 1;
    }
    case 'J':
    if (!strncmp(data, "JmpSouTra", 9))
    {   sscanf(data, "JmpSouTra = %f", &JmpSouTra);
        vqu.type = 'f'; vqu.f = JmpSouTra; return 1;
    }
    if (!strncmp(data, "JumpTrackProb", 13))
    {   sscanf(data, "JumpTrackProb = %f", &JumpTrackProb);
        vqu.type = 'f'; vqu.f = JumpTrackProb; return 1;
    }
    case 'M':
    if (!strncmp(data, "MalMode", 7))
    {   sscanf(data, "MalMode = %ld", &MalMode);
        vqu.type = 'i'; vqu.i = MalMode; return 1;
    }
    if (!strncmp(data, "MalReapTol", 10))
    {   sscanf(data, "MalReapTol = %ld", &MalReapTol);
        vqu.type = 'i'; vqu.i = MalReapTol; return 1;
    }
    if (!strncmp(data, "MalSamSiz", 9))
    {   sscanf(data, "MalSamSiz = %ld", &MalSamSiz);
        vqu.type = 'i'; vqu.i = MalSamSiz; return 1;
    }
    if (!strncmp(data, "MalTol", 6))
    {   sscanf(data, "MalTol = %ld", &MalTol);
        vqu.type = 'i'; vqu.i = MalTol; return 1;
    }
    if (!strncmp(data, "MateProb", 8))
    {   sscanf(data, "MateProb = %f", &MateProb);
        vqu.type = 'f'; vqu.f = MateProb; return 1;
    }
    if (!strncmp(data, "MateSearchL", 11))
    {   sscanf(data, "MateSearchL = %ld", &MateSearchL);
        vqu.type = 'i'; vqu.i = MateSearchL; return 1;
    }
    if (!strncmp(data, "MateSizeEp", 10))
    {   sscanf(data, "MateSizeEp = %ld", &MateSizeEp);
        vqu.type = 'i'; vqu.i = MateSizeEp; return 1;
    }
    if (!strncmp(data, "MateXoverProp", 13))
    {   sscanf(data, "MateXoverProp = %f", &MateXoverProp);
        vqu.type = 'f'; vqu.f = MateXoverProp; return 1;
    }
    if (!strncmp(data, "MaxCpuPerCell", 13))
    {   sscanf(data, "MaxCpuPerCell = %ld", &MaxCpuPerCell);
        vqu.type = 'i'; vqu.i = MaxCpuPerCell; return 1;
    }
    if (!strncmp(data, "MaxIOBufSiz", 11))
    {   sscanf(data, "MaxIOBufSiz = %ld", &MaxIOBufSiz);
        if (MaxIOBufSiz < 2)
            MaxIOBufSiz = 2;
        vqu.type = 'i'; vqu.i = MaxIOBufSiz; return 1;
    }
    if (!strncmp(data, "MaxPutBufSiz", 12))
    {   sscanf(data, "MaxPutBufSiz = %ld", &MaxPutBufSiz);
        vqu.type = 'i'; vqu.i = MaxPutBufSiz; return 1;
    }
    if (!strncmp(data, "MaxGetBufSiz", 12))
    {   sscanf(data, "MaxGetBufSiz = %ld", &MaxGetBufSiz);
        vqu.type = 'i'; vqu.i = MaxGetBufSiz; return 1;
    }
    if (!strncmp(data, "MaxFreeBlocks", 13))
    {   sscanf(data, "MaxFreeBlocks = %ld", &MaxFreeBlocks);
        vqu.type = 'i'; vqu.i = MaxFreeBlocks; return 1;
    }
    if (!strncmp(data, "MemModeFree", 11))
    {   sscanf(data, "MemModeFree = %ld", &MemModeFree);
        vqu.type = 'i'; vqu.i = MemModeFree; return 1;
    }
    if (!strncmp(data, "MemModeMine", 11))
    {   sscanf(data, "MemModeMine = %ld", &MemModeMine);
        vqu.type = 'i'; vqu.i = MemModeMine; return 1;
    }
    if (!strncmp(data, "MemModeProt", 11))
    {   sscanf(data, "MemModeProt = %ld", &MemModeProt);
        vqu.type = 'i'; vqu.i = MemModeProt; return 1;
    }
    if (!strncmp(data, "MaxMalMult", 10))
    {   sscanf(data, "MaxMalMult = %f", &MaxMalMult);
        vqu.type = 'f'; vqu.f = MaxMalMult; return 1;
    }
    if (!strncmp(data, "MinCellSize", 11))
    {   sscanf(data, "MinCellSize = %ld", &MinCellSize);
        vqu.type = 'i'; vqu.i = MinCellSize; return 1;
    }
    if (!strncmp(data, "MinTemplSize ", 12))
    {   sscanf(data, "MinTemplSize = %ld", &MinTemplSize);
        vqu.type = 'i'; vqu.i = MinTemplSize; return 1;
    }
    if (!strncmp(data, "MovPropThrDiv", 13))
    {   sscanf(data, "MovPropThrDiv = %f", &MovPropThrDiv);
        vqu.type = 'f'; vqu.f = MovPropThrDiv; return 1;
    }
#ifdef NET
    if (!strncmp(data, "MonPort", 7))
    {   sscanf(data, "MonPort = %hu", &MonPort);
        vqu.type = 'h'; vqu.i = MonPort; return 1;
    }
		if (!strncmp(data, "MAX_species_SIZ", 15))
    {   sscanf(data, "MAX_species_SIZ = %ld", &MAX_species_SIZ);
        vqu.type = 'i'; vqu.i = MAX_species_SIZ; return 1;
    }
    if (!strncmp(data, "MAX_species_GEN", 15))
    {   sscanf(data, "MAX_species_GEN = %ld", &MAX_species_GEN);
        vqu.type = 'i'; vqu.i = MAX_species_GEN; return 1;
    }
    if (!strncmp(data, "MAX_species_MEM", 15))
    {   sscanf(data, "MAX_species_MEM = %ld", &MAX_species_MEM);
        vqu.type = 'i'; vqu.i = MAX_species_MEM; return 1;
    }
    if (!strncmp(data, "M_tvWait_sec", 12))
    {   sscanf(data, "M_tvWait_sec = %ld", &M_tvWait_sec);
        vqu.type = 'i'; vqu.i = M_tvWait_sec; return 1;
    }
    if (!strncmp(data, "M_OV_threshold", 14))
    {   sscanf(data, "M_OV_threshold = %ld", &M_OV_threshold);
        vqu.type = 'i'; vqu.i = M_OV_threshold; return 1;
    }
    case 'm':
    if (!strncmp(data, "map_fn", 6))
    {   sscanf(data, "map_fn = %s", map_fn);
        vqu.type = 's'; vqu.s = map_fn; return 1;
    }
#endif /* NET */
    case 'N':
    if (!strncmp(data, "NumCells", 8))
    {   sscanf(data, "NumCells = %ld", &NumCells);
        vqu.type = 'i'; vqu.i = NumCells; return 1;
    }
    case 'O':
    if (!strncmp(data, "OutPath", 7))
    {   sscanf(data, "OutPath = %s", OutPath);
        vqu.type = 's'; vqu.s = OutPath; return 1;
    }
    case 'P':
    if (!strncmp(data, "PhotonPow", 9))
    {   sscanf(data, "PhotonPow = %lf", &PhotonPow);
        vqu.type = 'd'; vqu.d = PhotonPow; return 1;
    }
    if (!strncmp(data, "PhotonWidth", 11))
    {   sscanf(data, "PhotonWidth = %ld", &PhotonWidth);
        vqu.type = 'i'; vqu.i = PhotonWidth; return 1;
    }
    if (!strncmp(data, "PhotonWord", 10))
    {   sscanf(data, "PhotonWord = %s", PhotonWord);
        vqu.type = 's'; vqu.s = PhotonWord; return 1;
    }
    if (!strncmp(data, "PutLimit", 8))
    {   sscanf(data, "PutLimit = %f", &PutLimit);
        vqu.type = 'f'; vqu.f = PutLimit; return 1;
    }
    case 'R':
    if (!strncmp(data, "ReapRndProp", 11))
    {   sscanf(data, "ReapRndProp = %f", &ReapRndProp);
        vqu.type = 'f'; vqu.f = ReapRndProp; return 1;
    }
    case 'S':
    if (!strncmp(data, "SaveFreq", 8))
    {   sscanf(data, "SaveFreq = %ld", &SaveFreq);
        vqu.type = 'i'; vqu.i = SaveFreq; return 1;
    }
    if (!strncmp(data, "SavRenewMem", 11))
    {   sscanf(data, "SavRenewMem = %ld", &SavRenewMem);
        vqu.type = 'i'; vqu.i = SavRenewMem; return 1;
    }
    if (!strncmp(data, "SavMinNum", 9))
    {   sscanf(data, "SavMinNum = %ld", &SavMinNum);
        vqu.type = 'i'; vqu.i = SavMinNum; return 1;
    }
    if (!strncmp(data, "SavThrMem", 9))
    {   sscanf(data, "SavThrMem = %f", &SavThrMem);
        vqu.type = 'f'; vqu.f = SavThrMem; return 1;
    }
    if (!strncmp(data, "SavThrPop", 9))
    {   sscanf(data, "SavThrPop = %f", &SavThrPop);
        vqu.type = 'f'; vqu.f = SavThrPop; return 1;
    }
    if (!strncmp(data, "SearchLimit", 11))
    {   sscanf(data, "SearchLimit = %f", &SearchLimit);
        vqu.type = 'f'; vqu.f = SearchLimit; return 1;
    }
    if (!strncmp(data, "SizDepSlice", 11))
    {   sscanf(data, "SizDepSlice = %ld", &SizDepSlice);
        vqu.type = 'i'; vqu.i = SizDepSlice; return 1;
    }
    if (!strncmp(data, "SlicePow", 8))
    {   sscanf(data, "SlicePow = %lf", &SlicePow);
        vqu.type = 'd'; vqu.d = SlicePow; return 1;
    }
    if (!strncmp(data, "SliceSize", 9))
    {   sscanf(data, "SliceSize = %ld", &SliceSize);
        vqu.type = 'i'; vqu.i = SliceSize; return 1;
    }
    if (!strncmp(data, "SliceStyle", 10))
    {   sscanf(data, "SliceStyle = %ld", &SliceStyle);
        vqu.type = 'i'; vqu.i = SliceStyle; return 1;
    }
    if (!strncmp(data, "SlicFixFrac", 11))
    {   sscanf(data, "SlicFixFrac = %f", &SlicFixFrac);
        vqu.type = 'f'; vqu.f = SlicFixFrac; return 1;
    }
    if (!strncmp(data, "SlicRanFrac", 11))
    {   sscanf(data, "SlicRanFrac = %f", &SlicRanFrac);
        vqu.type = 'f'; vqu.f = SlicRanFrac; return 1;
    }
    if (!strncmp(data, "SoupSize", 8))
    {   sscanf(data, "SoupSize = %ld", &SoupSize);
        vqu.type = 'i'; vqu.i = SoupSize; return 1;
    }
#ifdef __MWERKS__
#ifdef NET
    if (!strncmp(data, "Site", 4))
    {   sscanf(data, "Site = %s", &MacSite);
        vqu.type = 's'; vqu.s = MacSite; return 1;
    }
#endif /* NET */
#endif /* __MWERKS */
#ifdef NET
    case 'T':
    if (!strncmp(data, "TierraNice", 10))
    {   sscanf(data, "TierraNice = %ld", &TierraNice);
        vqu.type = 'i'; vqu.i = TierraNice; return 1;
    }
#endif /* NET */
    case 'W':
    if (!strncmp(data, "WatchExe", 8))
    {   sscanf(data, "WatchExe = %ld", &WatchExe);
        vqu.type = 'i'; vqu.i = WatchExe; return 1;
    }
    if (!strncmp(data, "WatchMov", 8))
    {   sscanf(data, "WatchMov = %ld", &WatchMov);
        vqu.type = 'i'; vqu.i = WatchMov; return 1;
    }
    if (!strncmp(data, "WatchTem", 8))
    {   sscanf(data, "WatchTem = %ld", &WatchTem);
        vqu.type = 'i'; vqu.i = WatchTem; return 1;
    }
    default:
        vqu.type = '0';
        return 0;
    }
}

#ifdef MON
I8s GetAVarToMon(data)
const I8s *data;
{
    switch (*data) {
    case 'a':
    if (!strncmp(data, "alive", 5))
    {   /*sscanf(data, "alive = %ld", &alive);*/
        strcpy(vqu.name, "alive"); sprintf(vqu.value, "%ld", alive);
        vqu.type = 'i'; vqu.i = alive; return 1;
    }
    case 'd':
    if (!strncmp(data, "debug", 5))
    {   /*sscanf(data, "debug = %ld", &debug); */
        strcpy(vqu.name, "debug"); sprintf(vqu.value, "%ld", debug);
        vqu.type = 'i'; vqu.i = debug; return 1;
    }
    case 'h':
    if (!strncmp(data, "hangup", 6))
    {   /*sscanf(data, "hangup = %ld", &hangup); */
        strcpy(vqu.name, "hangup"); sprintf(vqu.value, "%ld", hangup);
        vqu.type = 'i'; vqu.i = hangup; return 1;
    }
    case 'n':
    if (!strncmp(data, "new_soup", 8))
    {   /*sscanf(data, "new_soup = %ld", &new_soup); */
        strcpy(vqu.name, "new_soup"); sprintf(vqu.value, "%ld", new_soup);
        vqu.type = 'i'; vqu.i = new_soup; return 1;
    }
    case 's':
    if (!strncmp(data, "seed", 4))
    {   /*sscanf(data, "seed = %ld", &seed); */
        strcpy(vqu.name, "seed"); sprintf(vqu.value, "%ld", seed);
        vqu.type = 'i'; vqu.i = seed; return 1;
    }
    case 'B':
    if (!strncmp(data, "BrkupSiz", 8))
    {   /*sscanf(data, "BrkupSiz = %ld", &BrkupSiz); */
        strcpy(vqu.name, "BrkupSiz"); sprintf(vqu.value, "%ld", BrkupSiz);
        vqu.type = 'i'; vqu.i = BrkupSiz; return 1;
    }
    case 'C':
    if (!strncmp(data, "CumGeneBnk", 10))
    {   /*sscanf(data, "CumGeneBnk = %ld", &CumGeneBnk); */
        strcpy(vqu.name, "CumGeneBnk"); sprintf(vqu.value, "%ld", CumGeneBnk);
        vqu.type = 'i'; vqu.i = CumGeneBnk; return 1;
    }
    case 'D':
    if (!strncmp(data, "DiskBank", 8))
    {   /*sscanf(data, "DiskBank = %ld", &DiskBank); */
        strcpy(vqu.name, "DiskBank"); sprintf(vqu.value, "%ld", DiskBank);
        vqu.type = 'i'; vqu.i = DiskBank; return 1;
    }
    if (!strncmp(data, "DiskOut", 7))
    {   /*sscanf(data, "DiskOut = %ld", &DiskOut); */
        strcpy(vqu.name, "DiskOut"); sprintf(vqu.value, "%ld", DiskOut);
        vqu.type = 'i'; vqu.i = DiskOut; return 1;
    }
    if (!strncmp(data, "DistFreq", 8))
    {   /*sscanf(data, "DistFreq = %f", &DistFreq); */
        strcpy(vqu.name, "DistFreq"); sprintf(vqu.value, "%f", DistFreq);
        vqu.type = 'f'; vqu.f = DistFreq; return 1;
    }
    if (!strncmp(data, "DistProp", 8))
    {   /*sscanf(data, "DistProp = %f", &DistProp); */
        strcpy(vqu.name, "DistProp"); sprintf(vqu.value, "%ld", DistProp);
        vqu.type = 'f'; vqu.f = DistProp; return 1;
    }
    if (!strncmp(data, "DivSameSiz", 10))
    {   /*sscanf(data, "DivSameSiz = %ld", &DivSameSiz); */
        strcpy(vqu.name, "DivSameSiz"); sprintf(vqu.value, "%ld", DivSameSiz);
        vqu.type = 'i'; vqu.i = DivSameSiz; return 1;
    }
    if (!strncmp(data, "DivSameGen", 10))
    {   /*sscanf(data, "DivSameGen = %ld", &DivSameGen); */
        strcpy(vqu.name, "DivSameGen"); sprintf(vqu.value, "%ld", DivSameGen);
        vqu.type = 'i'; vqu.i = DivSameGen; return 1;
    }
    if (!strncmp(data, "DropDead", 8))
    {   /*sscanf(data, "DropDead = %ld", &DropDead); */
        strcpy(vqu.name, "DropDead"); sprintf(vqu.value, "%ld", DropDead);
        vqu.type = 'i'; vqu.i = DropDead; return 1;
    }
    case 'E':
    if (!strncmp(data, "EjectRate", 9))
    {   /*sscanf(data, "EjectRate = %ld", &EjectRate); */
        strcpy(vqu.name, "EjectRate"); sprintf(vqu.value, "%ld", EjectRate);
        vqu.type = 'i'; vqu.i = EjectRate; return 1;
    }
    case 'G':
    if (!strncmp(data, "GeneBnker", 9))
    {   /*sscanf(data, "GeneBnker = %ld", &GeneBnker); */
        strcpy(vqu.name, "GeneBnker"); sprintf(vqu.value, "%ld", GeneBnker);
        vqu.type = 'i'; vqu.i = GeneBnker; return 1;
    }
    if (!strncmp(data, "GenebankPath", 12))
    {   /*sscanf(data, "GenebankPath = %s", GenebankPath); */
        strcpy(vqu.name, "GenebankPath"); sprintf(vqu.value, "%s", GenebankPath);
        vqu.type = 's'; vqu.s = GenebankPath; return 1;
    }
    if (!strncmp(data, "GenPerBkgMut", 12))
    {   /*sscanf(data, "GenPerBkgMut = %f", &GenPerBkgMut); */
        strcpy(vqu.name, "GenPerBkgMut"); sprintf(vqu.value, "%f", GenPerBkgMut);
        vqu.type = 'f'; vqu.f = GenPerBkgMut; return 1;
    }
    if (!strncmp(data, "GenPerFlaw", 10))
    {   /*sscanf(data, "GenPerFlaw = %f", &GenPerFlaw); */
        strcpy(vqu.name, "GenPerFlaw"); sprintf(vqu.value, "%f", GenPerFlaw);
        vqu.type = 'f'; vqu.f = GenPerFlaw; return 1;
    }
    if (!strncmp(data, "GenPerMovMut", 12))
    {   /*sscanf(data, "GenPerMovMut = %f", &GenPerMovMut); */
        strcpy(vqu.name, "GenPerMovMut"); sprintf(vqu.value, "%f", GenPerMovMut);
        vqu.type = 'f'; vqu.f = GenPerMovMut; return 1;
    }
    case 'L':
    if (!strncmp(data, "Log", 3))
    {   /*sscanf(data, "Log = %ld", &Log); */
        strcpy(vqu.name, "Log"); sprintf(vqu.value, "%ld", Log);
        vqu.type = 'i'; vqu.i = Log; return 1;
    }
#ifdef NET
    if (!strncmp(data, "LocalPort", 9))
    {   /*sscanf(data, "LocalPort = %hu", &LocalPort); */
        strcpy(vqu.name, "LocalPort"); sprintf(vqu.value, "%hu", LocalPort);
        vqu.type = 'h'; vqu.i = LocalPort; return 1;
    }
#endif /* NET */
    case 'I':
    if (!strncmp(data, "IMapFile", 8))
    {   /*sscanf(data, "IMapFile = %s", IMapFile); */
        strcpy(vqu.name, "IMapFile"); sprintf(vqu.value, "%s", IMapFile);
        vqu.type = 's'; vqu.s = IMapFile; return 1;
    }
    case 'J':
    if (!strncmp(data, "JmpSouTra", 9))
    {   /*sscanf(data, "JmpSouTra = %f", &JmpSouTra); */
        strcpy(vqu.name, "JmpSouTra"); sprintf(vqu.value, "%f", JmpSouTra);
        vqu.type = 'f'; vqu.f = JmpSouTra; return 1;
    }
    if (!strncmp(data, "JumpTrackProb", 13))
    {   /*sscanf(data, "JumpTrackProb = %f", &JumpTrackProb); */
        strcpy(vqu.name, "JumpTrackProb"); sprintf(vqu.value, "%f", JumpTrackProb);
        vqu.type = 'f'; vqu.f = JumpTrackProb; return 1;
    }
    case 'M':
    if (!strncmp(data, "MalMode", 7))
    {   /*sscanf(data, "MalMode = %ld", &MalMode); */
        strcpy(vqu.name, "MalMode"); sprintf(vqu.value, "%ld", MalMode);
        vqu.type = 'i'; vqu.i = MalMode; return 1;
    }
    if (!strncmp(data, "MalReapTol", 10))
    {   /*sscanf(data, "MalReapTol = %ld", &MalReapTol); */
        strcpy(vqu.name, "MalReapTol"); sprintf(vqu.value, "%ld", MalReapTol);
        vqu.type = 'i'; vqu.i = MalReapTol; return 1;
    }
    if (!strncmp(data, "MalSamSiz", 9))
    {   /*sscanf(data, "MalSamSiz = %ld", &MalSamSiz); */
        strcpy(vqu.name, "MalSamSiz"); sprintf(vqu.value, "%ld",MalSamSiz);
        vqu.type = 'i'; vqu.i = MalSamSiz; return 1;
    }
    if (!strncmp(data, "MalTol", 6))
    {   /*sscanf(data, "MalTol = %ld", &MalTol); */
        strcpy(vqu.name, "MalTol"); sprintf(vqu.value, "%ld", MalTol);
        vqu.type = 'i'; vqu.i = MalTol; return 1;
    }
    if (!strncmp(data, "MateProb", 8))
    {   /*sscanf(data, "MateProb = %f", &MateProb); */
        strcpy(vqu.name, "MateProb"); sprintf(vqu.value, "%f", MateProb);
        vqu.type = 'f'; vqu.f = MateProb; return 1;
    }
    if (!strncmp(data, "MateSearchL", 11))
    {   /*sscanf(data, "MateSearchL = %ld", &MateSearchL); */
        strcpy(vqu.name, "MateSearchL"); sprintf(vqu.value, "%ld", MateSearchL);
        vqu.type = 'i'; vqu.i = MateSearchL; return 1;
    }
    if (!strncmp(data, "MateSizeEp", 10))
    {   /*sscanf(data, "MateSizeEp = %ld", &MateSizeEp); */
        strcpy(vqu.name, "MateSizeEp"); sprintf(vqu.value, "%ld", MateSizeEp);
        vqu.type = 'i'; vqu.i = MateSizeEp; return 1;
    }
    if (!strncmp(data, "MateXoverProp", 13))
    {   /*sscanf(data, "MateXoverProp = %f", &MateXoverProp); */
        strcpy(vqu.name, "MateXoverProp"); sprintf(vqu.value, "%f", MateXoverProp);
        vqu.type = 'f'; vqu.f = MateXoverProp; return 1;
    }
    if (!strncmp(data, "MaxCpuPerCell", 13))
    {   /*sscanf(data, "MaxCpuPerCell = %ld", &MaxCpuPerCell); */
        strcpy(vqu.name, "MaxCpuPerCell"); sprintf(vqu.value, "%ld", MaxCpuPerCell);
        vqu.type = 'i'; vqu.i = MaxCpuPerCell; return 1;
    }
    if (!strncmp(data, "MaxIOBufSiz", 11))
    {   /*sscanf(data, "MaxIOBufSiz = %ld", &MaxIOBufSiz); */
        if (MaxIOBufSiz < 2)
            MaxIOBufSiz = 2;
        strcpy(vqu.name, "MaxIOBufSiz"); sprintf(vqu.value, "%ld", MaxIOBufSiz);
        vqu.type = 'i'; vqu.i = MaxIOBufSiz; return 1;
    }
    if (!strncmp(data, "MaxPutBufSiz", 12))
    {   /*sscanf(data, "MaxPutBufSiz = %ld", &MaxPutBufSiz); */
        strcpy(vqu.name, "MaxPutBufSiz"); sprintf(vqu.value, "%ld", MaxPutBufSiz);
        vqu.type = 'i'; vqu.i = MaxPutBufSiz; return 1;
    }
    if (!strncmp(data, "MaxGetBufSiz", 12))
    {   /*sscanf(data, "MaxGetBufSiz = %ld", &MaxGetBufSiz); */
        strcpy(vqu.name, "MaxGetBufSiz"); sprintf(vqu.value, "%ld", MaxGetBufSiz);
        vqu.type = 'i'; vqu.i = MaxGetBufSiz; return 1;
    }
    if (!strncmp(data, "MaxFreeBlocks", 13))
    {   /*sscanf(data, "MaxFreeBlocks = %ld", &MaxFreeBlocks); */
        strcpy(vqu.name, "MaxFreeBlocks"); sprintf(vqu.value, "%ld", MaxFreeBlocks);
        vqu.type = 'i'; vqu.i = MaxFreeBlocks; return 1;
    }
    if (!strncmp(data, "MemModeFree", 11))
    {   /*sscanf(data, "MemModeFree = %ld", &MemModeFree); */
        strcpy(vqu.name, "MemModeFree"); sprintf(vqu.value, "%ld", MemModeFree);
        vqu.type = 'i'; vqu.i = MemModeFree; return 1;
    }
    if (!strncmp(data, "MemModeMine", 11))
    {   /*sscanf(data, "MemModeMine = %ld", &MemModeMine); */
        strcpy(vqu.name, "MemModeMine"); sprintf(vqu.value, "%ld", MemModeMine);
        vqu.type = 'i'; vqu.i = MemModeMine; return 1;
    }
    if (!strncmp(data, "MemModeProt", 11))
    {   /*sscanf(data, "MemModeProt = %ld", &MemModeProt); */
        strcpy(vqu.name, "MemModeProt"); sprintf(vqu.value, "%ld", MemModeProt);
        vqu.type = 'i'; vqu.i = MemModeProt; return 1;
    }
    if (!strncmp(data, "MaxMalMult", 10))
    {   /*sscanf(data, "MaxMalMult = %f", &MaxMalMult); */
        strcpy(vqu.name, "MaxMalMult"); sprintf(vqu.value, "%f", MaxMalMult);
        vqu.type = 'f'; vqu.f = MaxMalMult; return 1;
    }
    if (!strncmp(data, "MinCellSize", 11))
    {   /*sscanf(data, "MinCellSize = %ld", &MinCellSize); */
        strcpy(vqu.name, "MinCellSize"); sprintf(vqu.value, "%ld", MinCellSize);
        vqu.type = 'i'; vqu.i = MinCellSize; return 1;
    }
    if (!strncmp(data, "MinTemplSize ", 12))
    {   /*sscanf(data, "MinTemplSize = %ld", &MinTemplSize); */
        strcpy(vqu.name, "MinTemplSize"); sprintf(vqu.value, "%ld", MinTemplSize);
        vqu.type = 'i'; vqu.i = MinTemplSize; return 1;
    }
    if (!strncmp(data, "MovPropThrDiv", 13))
    {   /*sscanf(data, "MovPropThrDiv = %f", &MovPropThrDiv); */
        strcpy(vqu.name, "MovPropThrDiv"); sprintf(vqu.value, "%f", MovPropThrDiv);
        vqu.type = 'f'; vqu.f = MovPropThrDiv; return 1;
    }
#ifdef NET
    if (!strncmp(data, "MonPort", 7))
    {   /*sscanf(data, "MonPort = %hu", &MonPort); */
        strcpy(vqu.name, "MonPort"); sprintf(vqu.value, "%hu", MonPort);
        vqu.type = 'h'; vqu.i = MonPort; return 1;
    }
    if (!strncmp(data, "MAX_species_SIZ", 15))
    {   /* sscanf(data, "MAX_species_SIZ = %ld", &MAX_species_SIZ); */
        strcpy(vqu.name,"MAX_species_SIZ");sprintf(vqu.value,"%ld",MAX_species_SIZ);
        vqu.type = 'i'; vqu.i = MAX_species_SIZ; return 1;
    }
    if (!strncmp(data, "MAX_species_GEN", 15))
    {   /* sscanf(data, "MAX_species_GEN = %ld", &MAX_species_GEN); */
        strcpy(vqu.name,"MAX_species_GEN");sprintf(vqu.value,"%ld",MAX_species_GEN);
        vqu.type = 'i'; vqu.i = MAX_species_GEN; return 1;
    }
    if (!strncmp(data, "MAX_species_MEM", 15))
    {   /* sscanf(data, "MAX_species_MEM = %ld", &MAX_species_MEM); */
        strcpy(vqu.name,"MAX_species_MEM");sprintf(vqu.value,"%ld",MAX_species_MEM);
        vqu.type = 'i'; vqu.i = MAX_species_MEM; return 1;
    }
    if (!strncmp(data, "M_tvWait_sec", 12))
    {   /* sscanf(data, "M_tvWait_sec = %ld", &M_tvWait_sec); */
        strcpy(vqu.name,"M_tvWait_sec");sprintf(vqu.value,"%ld",M_tvWait_sec);
        vqu.type = 'i'; vqu.i = M_tvWait_sec; return 1;
    }
    if (!strncmp(data, "M_OV_threshold", 14))
    {   /* sscanf(data, "M_OV_threshold = %ld", &M_OV_threshold); */
        strcpy(vqu.name,"M_OV_threshold");sprintf(vqu.value,"%ld",M_OV_threshold);
        vqu.type = 'i'; vqu.i = M_OV_threshold; return 1;
    }
    case 'm':
    if (!strncmp(data, "map_fn", 6))
    {   /*sscanf(data, "map_fn = %s", map_fn); */
        strcpy(vqu.name, "map_fn"); sprintf(vqu.value, "%s", map_fn);
        vqu.type = 's'; vqu.s = map_fn; return 1;
    }
#endif /* NET */
    case 'N':
    if (!strncmp(data, "NumCells", 8))
    {   /*sscanf(data, "NumCells = %ld", &NumCells); */
        strcpy(vqu.name, "NumCells"); sprintf(vqu.value, "%ld", NumCells);
        vqu.type = 'i'; vqu.i = NumCells; return 1;
    }
#ifdef NET
    if (!strncmp(data, "TierraNice", 4))
    {   /*sscanf(data, "TierraNice = %ld", &TierraNice); */
        strcpy(vqu.name, "TierraNice"); sprintf(vqu.value, "%ld", TierraNice);
        vqu.type = 'i'; vqu.i = TierraNice; return 1;
    }
#endif /* NET */
    case 'O':
    if (!strncmp(data, "OutPath", 7))
    {   /*sscanf(data, "OutPath = %s", OutPath); */
        strcpy(vqu.name, "OutPath"); sprintf(vqu.value, "%s", OutPath);
        vqu.type = 's'; vqu.s = OutPath; return 1;
    }
    case 'P':
    if (!strncmp(data, "PhotonPow", 9))
    {   /*sscanf(data, "PhotonPow = %lf", &PhotonPow); */
        strcpy(vqu.name, "PhotonPow"); sprintf(vqu.value, "%lf", PhotonPow);
        vqu.type = 'd'; vqu.d = PhotonPow; return 1;
    }
    if (!strncmp(data, "PhotonWidth", 11))
    {   /*sscanf(data, "PhotonWidth = %ld", &PhotonWidth); */
        strcpy(vqu.name, "PhotonWidth"); sprintf(vqu.value, "%ld", PhotonWidth);
        vqu.type = 'i'; vqu.i = PhotonWidth; return 1;
    }
    if (!strncmp(data, "PhotonWord", 10))
    {   /*sscanf(data, "PhotonWord = %s", PhotonWord); */
        strcpy(vqu.name, "PhotonWord"); sprintf(vqu.value, "%s", PhotonWord);
        vqu.type = 's'; vqu.s = PhotonWord; return 1;
    }
    if (!strncmp(data, "PutLimit", 8))
    {   /*sscanf(data, "PutLimit = %f", &PutLimit); */
        strcpy(vqu.name, "PutLimit"); sprintf(vqu.value, "%f", PutLimit);
        vqu.type = 'f'; vqu.f = PutLimit; return 1;
    }
    case 'R':
    if (!strncmp(data, "ReapRndProp", 11))
    {   /*sscanf(data, "ReapRndProp = %f", &ReapRndProp); */
        strcpy(vqu.name, "ReapRndProp"); sprintf(vqu.value, "%f", ReapRndProp);
        vqu.type = 'f'; vqu.f = ReapRndProp; return 1;
    }
    case 'S':
    if (!strncmp(data, "SaveFreq", 8))
    {   /*sscanf(data, "SaveFreq = %ld", &SaveFreq); */
        strcpy(vqu.name, "SaveFreq"); sprintf(vqu.value, "%ld", SaveFreq);
        vqu.type = 'i'; vqu.i = SaveFreq; return 1;
    }
    if (!strncmp(data, "SavRenewMem", 11))
    {   /*sscanf(data, "SavRenewMem = %ld", &SavRenewMem); */
        strcpy(vqu.name, "SavRenewMem"); sprintf(vqu.value, "%ld", SavRenewMem);
        vqu.type = 'i'; vqu.i = SavRenewMem; return 1;
    }
    if (!strncmp(data, "SavMinNum", 9))
    {   /*sscanf(data, "SavMinNum = %ld", &SavMinNum); */
        strcpy(vqu.name, "SavMinNum"); sprintf(vqu.value, "%ld", SavMinNum);
        vqu.type = 'i'; vqu.i = SavMinNum; return 1;
    }
    if (!strncmp(data, "SavThrMem", 9))
    {   /*sscanf(data, "SavThrMem = %f", &SavThrMem); */
        strcpy(vqu.name, "SavThrMem"); sprintf(vqu.value, "%f", SavThrMem);
        vqu.type = 'f'; vqu.f = SavThrMem; return 1;
    }
    if (!strncmp(data, "SavThrPop", 9))
    {   /*sscanf(data, "SavThrPop = %f", &SavThrPop); */
        strcpy(vqu.name, "SavThrPop"); sprintf(vqu.value, "%f", SavThrPop);
        vqu.type = 'f'; vqu.f = SavThrPop; return 1;
    }
    if (!strncmp(data, "SearchLimit", 11))
    {   /*sscanf(data, "SearchLimit = %f", &SearchLimit); */
        strcpy(vqu.name, "SearchLimit"); sprintf(vqu.value, "%f", SearchLimit);
        vqu.type = 'f'; vqu.f = SearchLimit; return 1;
    }
    if (!strncmp(data, "SizDepSlice", 11))
    {   /*sscanf(data, "SizDepSlice = %ld", &SizDepSlice); */
        strcpy(vqu.name, "SizDepSlice"); sprintf(vqu.value, "%ld", SizDepSlice);
        vqu.type = 'i'; vqu.i = SizDepSlice; return 1;
    }
    if (!strncmp(data, "SlicePow", 8))
    {   /*sscanf(data, "SlicePow = %lf", &SlicePow); */
        strcpy(vqu.name, "SlicePow"); sprintf(vqu.value, "%lf", SlicePow);
        vqu.type = 'd'; vqu.d = SlicePow; return 1;
    }
    if (!strncmp(data, "SliceSize", 9))
    {   /*sscanf(data, "SliceSize = %ld", &SliceSize); */
        strcpy(vqu.name, "SliceSize"); sprintf(vqu.value, "%ld", SliceSize);
        vqu.type = 'i'; vqu.i = SliceSize; return 1;
    }
    if (!strncmp(data, "SliceStyle", 10))
    {   /*sscanf(data, "SliceStyle = %ld", &SliceStyle); */
        strcpy(vqu.name, "SliceStyle"); sprintf(vqu.value, "%ld", SliceStyle);
        vqu.type = 'i'; vqu.i = SliceStyle; return 1;
    }
    if (!strncmp(data, "SlicFixFrac", 11))
    {   /*sscanf(data, "SlicFixFrac = %f", &SlicFixFrac); */
        strcpy(vqu.name, "SlicFixFrac"); sprintf(vqu.value, "%f", SlicFixFrac);
        vqu.type = 'f'; vqu.f = SlicFixFrac; return 1;
    }
    if (!strncmp(data, "SlicRanFrac", 11))
    {   /*sscanf(data, "SlicRanFrac = %f", &SlicRanFrac); */
        strcpy(vqu.name, "SlicRanFrac"); sprintf(vqu.value, "%f", SlicRanFrac);
        vqu.type = 'f'; vqu.f = SlicRanFrac; return 1;
    }
    if (!strncmp(data, "SoupSize", 8))
    {   /*sscanf(data, "SoupSize = %ld", &SoupSize); */
        strcpy(vqu.name, "SoupSize"); sprintf(vqu.value, "%ld", SoupSize);
        vqu.type = 'i'; vqu.i = SoupSize; return 1;
    }
#ifdef NET
    case 'T':
    if (!strncmp(data, "TierraNice", 10))
    {   sscanf(data, "TierraNice = %ld", &TierraNice);
        vqu.type = 'i'; vqu.i = TierraNice; return 1;
    }
#endif /* NET */
    case 'W':
    if (!strncmp(data, "WatchExe", 8))
    {   /*sscanf(data, "WatchExe = %ld", &WatchExe); */
        strcpy(vqu.name, "WatchExe"); sprintf(vqu.value, "%ld", WatchExe);
        vqu.type = 'i'; vqu.i = WatchExe; return 1;
    }
    if (!strncmp(data, "WatchMov", 8))
    {   /*sscanf(data, "WatchMov = %ld", &WatchMov); */
        strcpy(vqu.name, "WatchMov"); sprintf(vqu.value, "%ld", WatchMov);
        vqu.type = 'i'; vqu.i = WatchMov; return 1;
    }
    if (!strncmp(data, "WatchTem", 8))
    {   /*sscanf(data, "WatchTem = %ld", &WatchTem); */
        strcpy(vqu.name, "WatchTem"); sprintf(vqu.value, "%ld", WatchTem);
        vqu.type = 'i'; vqu.i = WatchTem; return 1;
    }
    default:
        strcpy(vqu.name, "----"); sprintf(vqu.value, "0");
        vqu.type = '0';
        return 0;
    }
}
#endif /* MON */

void initvar()
{   histostrtidx=0;
    histoentcnt=0;
    histodsplnct=0;
    tmpl.n = 0;        /* list of .tmp files */
    tmpl.l = NULL;     /* list of .tmp files */
    TierraClock = 0;   /* clock time at last plan() */
    Speed = 200;       /* difference in TierraClock time between plans() */
    AverageSize = 0;   /* average size of cells in soup */
    fe_lines = 24;     /* approx hight in chars of screen, default 20 */
    fe_width = 60;     /* approx width in chars of screen, default 60 */
    AvgPop = 0.;   /* average population over the last million instructions */
    GenInList = NULL;  /* pointers to soup_in genome names */
    Hist = NULL;       /* pointer to struct for histograms */
    HistSize = 0;      /* Num of elements alloced in Hist */
    HistAlocSiz = 0;   /* allocated size of Hist array, in bytes */
    HistNStars = 0.0;  /* ratio of counts to stars */
    GenInBuf = 0;      /* buffer containing soup_in genome names */
    GFormat = -1; /* select genebank format style, -1 = first file = format */
    GoDown = 0;        /* flag to bring system down to defragment memory */
    HistPrint = 0;     /* boolean to tell us weather to print hists, to log */
    Nop0 = 0;          /* instruct num corresponding to nop0 */
    Nop1 = 1;          /* instruct num corresponding to nop1 */
    NopS = 1;          /* Nop0 + Nop1 sum of Nops for template search */
    siz_sl = 0;        /* allocated size of *sl array */
    tfp_log = NULL;    /* file pointer for log */
    TC_Menu = 0;       /* flag unix sigint, to do a menu */
    sl = NULL;         /* list of unique size classes, number of gts */
    FE_DV_Mode= 0;
    PLN_X = 1;
    PLN_Y = 1;         /* stats output by FEPlan() */
    MSG_X = 1;
    MSG_Y = 1;         /* location of messages, just below plan stats */
    ERR_X = 1;
    ERR_Y = 1;         /* error messages, bottom of screen - 2 lines */
    HLP_X = 1;
    HLP_Y = 1;         /* help messages, bottom of screen - 1 line */
    
#ifdef NET
    ConnectedFlg = 0;  /* flag for connection to the net */
#endif /* NET */
    
#ifdef MICRO
    MC_step = -1L;
    soupviewstrt=0;
    dbgdisptype=0;
#endif /* MICRO */
    
#ifdef __TURBOC__
    _stklen = 32767;
#endif /* __TURBOC__ */
    
#if INTERFACE == BASICM
    LINES  = 25;
    COLS  = 80;
#endif /* INTERFACE == BASICM */
    
#ifdef NET
    tvWait.tv_sec = 0;
    tvWait.tv_usec = 0;
    NetWriteSoupFlg=0;
#endif /* NET */
}

void GetSoup(argc,argv)
I32s argc;
I8s *argv[];
{
    FILE *inf;
    I32s i, AlocGenInList, AlocGenInBuf;
#ifndef AMIGA
    SList **tsl;
#endif
#ifdef AMIGA
#ifdef NET
    long dontblock;
#endif
#endif /* AMIGA */
#ifdef DECVAX
#ifdef NET
    long dontblock;
    char svbyt;
#endif
#endif /* DECVAX */
#ifdef MON
    I32s iVar;
#endif /* MON */

#ifdef NET
    FILE *fp;
#ifndef AMIGA
    I32s FcntlFlg;
    struct in_addr inaddr;
#endif /* AMIGA */
#ifdef __MWERKS__
    char        tmpbuf1[64],tmpbuf2[48];
    char        addrstr[100];
    struct hostent * thisHost;
    struct in_addr       addr;
    long dontblock;
#else
    I8s tmpbuf1[39],tmpbuf2[39];
#endif /* __MWERKS__ */
    I8s LocalPortStr[7];
    I8s MonPortStr[7];
    I16s QLEN = 5;
#endif /* NET */

#ifdef __TURBOC__
    timezone = (I32s) 5L * 60L * 60L;
#endif /* __TURBOC__ */

#ifdef unix
    signal(SIGINT,  T_sig_int);
    signal(SIGUSR1, T_sig_read);
    signal(SIGUSR2, T_sig_info);
    signal(SIGHUP,  T_sig_write);
#ifndef __SOLARIS2__
    SigBlockSet = sigmask(SIGINT);
#ifdef SIGBLOCK
    SigSet = sigmask( SIGIO ) | sigmask( SIGPIPE );
#endif /* SIGBLOCK */
#endif /* __SOLARIS2__ */
#endif /* unix */

#ifdef DECVAX
    signal(SIGINT,  T_sig_int);
    SigBlockSet = 1<<SIGINT;
#ifdef SIGBLOCK
/*     SigSet = (1<<SIGIO) | (1<<SIGPIPE); */
SigSet = 0;
#endif /* SIGBLOCK */
#endif /* DECVAX */

    MaxSizeT = ((unsigned int) (~0)) - 1;
    if (argc > 1)
    {   sprintf(soup_fn,"%s", argv[1]); }
    else
    {
#ifdef IBM3090
        sprintf(soup_fn,"soup_in.io.d");
#else /* IBM3090 */
        sprintf(soup_fn,"soup_in");
#endif /* IBM3090 */
    }

    inf = fopen(soup_fn, "r");
    if (inf == NULL)
    {   sprintf(Fbuf,
            "Tierra GetSoup() file %s not opened, exiting\n", soup_fn);
        FEError(-1908, EXIT, NOWRITE, Fbuf);
    }
    fgets(Buff, 84, inf);
#ifdef MON
    iVar = 1;
#endif /* MON */
    while (1)
    {   if (*Buff != '#' && strlen(Buff) > 3 && !GetAVar(Buff))
        {   *(Buff + 40) = 0;
            sprintf(Fbuf,
                "Tierra GetSoup() bad soup_in line: %s\n", Buff);
            FEError(-1909, NOEXIT, NOWRITE, Fbuf);
        }
        fgets(Buff, 84, inf);
        if(feof(inf))
            break;
#ifdef MON 
        iVar++;
#endif /* MON */
        if (*Buff >= '0' && *Buff <= '9' || !strncmp("space",Buff,5))
            break;
    }
#ifdef MON
    MaxNumMDVar = iVar;
#endif /* MON */
    TGeneBnker = GeneBnker;
    if(strncmp(IMapFile,"-.map",5) ) /* not the default inst map */
    {   sprintf(Buf85b,"%s%s",GenebankPath,IMapFile);
        GetAMap(Buf85b);
    }
    ToggleLog();
    if (!seed)
    {   
        seed = (I32s) time(NULL);
        tsrand(seed);
        seed = tlrand();
        if (!new_soup)
        {   tsrand(seed);
            tlrand();
        }
    }
    if (new_soup)
    {   
        tsrand(seed);
        tlrand();
        sprintf(Fbuf, "seed = %ld", seed);
        FEPrintf(MSG_X, MSG_Y + 2, 0, 0, Fbuf);
        if(NumCells){
            GenInList = (I8s **) tcalloc((I32u)
                NumCells, sizeof(I8s *), 1904);
            AlocGenInList = NumCells * sizeof(I8s *);
            GenInBuf = (I8s *) tcalloc((I32u)
                NumCells * 30, sizeof(I8s), 1905);
            AlocGenInBuf = NumCells * 30 * sizeof(I8s);
            for (i = 0; i < NumCells; i++)
            {   GenInList[i] = GenInBuf + (i * 30);
                sscanf(Buff, "%[^\n]", GenInList[i]);
                fgets(Buff, 84, inf);
            }
        }
    }

    /* allocate arrays */
    sprintf(Fbuf, "sizeof(Instruction)   = %ld",
        (I32s) sizeof(Instruction));
    FEPrintf(MSG_X, MSG_Y + 3, 0, 0, Fbuf);
    sprintf(Fbuf, "sizeof(TCell)   = %ld",
        (I32s) sizeof(TCell));
    FEPrintf(MSG_X, MSG_Y + 4, 0, 0, Fbuf);
    sprintf(Fbuf, "sizeof(MemFr) = %ld",
        (I32s) sizeof(MemFr));
    FEPrintf(MSG_X, MSG_Y + 5, 0, 0, Fbuf);
#if (defined __TURBOC__) && (!defined __GUI__)
    sprintf(Fbuf, "coreleft = %lu", (I32u) coreleft());
    FEPrintf(MSG_X, MSG_Y + 3, 0, 0, Fbuf);
#endif /* (defined __TURBOC__) && (!defined __GUI__) */
    if (new_soup)
    {
        soup = (HpInst) thcalloc((I32u) SoupSize, sizeof(Instruction), 1906);
        sprintf(Fbuf, "    %ld bytes allocated for soup",
            SoupSize * sizeof(Instruction));
        FEPrintf(MSG_X, MSG_Y + 6, 0, 0, Fbuf);
        CelArSiz = CellsSize = (I32s) 16384 / (I32s) sizeof(TCell);
        NumCelAr = 1;
        if (NumCells > CellsSize - 2)
        {   NumCelAr = (NumCells + 2) / CelArSiz;
            if((NumCells + 2) % CelArSiz)
                NumCelAr++;
            CellsSize = NumCelAr * CelArSiz;
        }
        cells = (Pcells  Fp) tcalloc(NumCelAr, sizeof(Pcells), 1900);
        for (i = 0; i < NumCelAr; i++)
            cells[i] = (Pcells) tcalloc(CelArSiz, sizeof(TCell), 1901);
        sprintf(Fbuf, "    %ld bytes allocated for cells",
            (CellsSize * sizeof(TCell)) + (NumCelAr * sizeof(TCell)));
        FEPrintf(MSG_X, MSG_Y + 7, 0, 0, Fbuf);
        TopDummy =    &cells[0][0];
        BottomDummy = &cells[0][1];
        FreeMemry = (MemFr Fp) tcalloc(MaxFreeBlocks, sizeof(MemFr), 1907);
        sprintf(Fbuf, "    %ld bytes allocated for MemFr",
            MaxFreeBlocks * sizeof(MemFr));
        FEPrintf(MSG_X, MSG_Y + 8, 0, 0, Fbuf);

#if (defined __TURBOC__) && (!defined __GUI__)
        sprintf(Fbuf, "coreleft = %lu  tsetup (soup, cells, FreeMemry)",
            coreleft());
        FEPrintf(MSG_X, MSG_Y + 3, 0, 0, Fbuf);
#endif /* (defined __TURBOC__) && (!defined __GUI__) */
        if (!soup || !cells || !FreeMemry)
            FEError(-1910, EXIT, NOWRITE,
                "Tierra GetSoup() setup malloc error, exiting\n");
        else
            FEPrintf(MSG_X, MSG_Y + 9, 0, 0,
                "tsetup: arrays allocated without error");
    }
    TotFlaw = TotMovMut = TotMut = isolate = 0;
    extr.a = extr.i = 0;
    Disturb.m = Disturb.i = DistNext.m = DistNext.i = 0L;
    if (DivSameGen)
        DivSameSiz = 1;
    if (GeneBnker)
    {   siz_sl = 1;
        sl = (SList Fp Fp) tcalloc(siz_sl, sizeof(SList *), 1903);
    }
    else
        WatchExe = WatchMov = WatchTem = 0;
#ifdef MON
		sprintf(MonPortStr,"%hu",MonPort);
    TMon_setup( MonPortStr );
#endif /* MON */
    if (new_soup)
        GetNewSoup();
    else
        GetOldSoup(inf);
#ifdef NET
    if((fp=fopen(map_fn,"r")) == NULL)
      {   
    sprintf(Fbuf, "Node Machine Map file %s can't open\n", map_fn);
    FEError(-1911, EXIT, NOWRITE, Fbuf);
      }
    GetIPMap(fp);                   /* fill in IPMap array */
    fclose(fp);
                                    /* get a LocalHostName */
    memset(tmpbuf1, 0, sizeof(tmpbuf1));
    memset(tmpbuf2, 0, sizeof(tmpbuf2));
    (void)gethostname(tmpbuf1,sizeof(tmpbuf1));
#ifdef AMIGA
    tmpbuf2[0]='\0';
#else
#ifdef DECVAX
    tmpbuf2[0]='\0';
#else
    (void)getdomainname(tmpbuf2,sizeof(tmpbuf2));
#endif /* DECVAX */
#endif /* AMIGA */
#ifdef __MWERKS__
    sprintf(LocalHostName,"%s",tmpbuf1);
#else
    sprintf(LocalHostName,"%s.%s",tmpbuf1,tmpbuf2);
#endif /* __MWERKS__ */
    sprintf(Fbuf, "LocalHostName = %s", LocalHostName);
    FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);
    if( (LocalHost = gethostbyname(tmpbuf1)) == NULL ) {
      sprintf(Fbuf,"Error gethostbyname(tmpbuf1) = %s\n",tmpbuf1);
      FEError(-1914, EXIT, NOWRITE, Fbuf);
    }
    LocalHostAddr.s_addr = pr_inet(LocalHost->h_addr_list,LocalHost->h_length);
    LocalNetAddr.node = LocalHostAddr.s_addr;
    LocalNetAddr.portnb = LocalPort;
    sprintf(LocalPortStr,"%hu",LocalPort);
    sprintf(Fbuf, "LocalPort=%hu", LocalPort);
    FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);
    CellSockUDP = passiveUDP( LocalPortStr );
    sprintf(Fbuf,"CellSockUDP = %d",CellSockUDP);
    FEPrintf(MSG_X, MSG_Y + 1, 0, 0, Fbuf);
    CellSockTCP = passiveTCP( LocalPortStr, QLEN );
    sprintf(Fbuf,"CellSockTCP = %d",CellSockTCP);
    FEPrintf(MSG_X, MSG_Y + 2, 0, 0, Fbuf);
#ifndef MON
#ifndef __MWERKS__
    sprintf(MonPortStr,"%hu",MonPort);
    MonSockUDP  = passiveUDP( MonPortStr );
    sprintf(Fbuf,"MonSockUDP = %d",MonSockUDP);
    FEPrintf(MSG_X, MSG_Y + 3, 0, 0, Fbuf);
    MonSockTCP  = passiveTCP( MonPortStr,   QLEN );
    sprintf(Fbuf,"MonSockTCP = %d",MonSockTCP);
    FEPrintf(MSG_X, MSG_Y + 4, 0, 0, Fbuf);
#endif /* __MWERKS__ */
#endif /* MON */
    FD_ZERO(&Afds);
    FD_ZERO(&Wfds);
    FD_ZERO(&Efds);
    FD_SET(CellSockUDP, &Afds);
    FD_SET(CellSockTCP, &Afds);
#ifdef __MWERKS__
    dontblock = 1;
    ioctl(CellSockUDP, FIONBIO, &dontblock);
#endif /* __MWERKS__ */
#ifndef __MWERKS__
    FD_SET(MonSockUDP, &Afds);
    FD_SET(MonSockTCP, &Afds);
#ifdef AMIGA
    dontblock = 1;
    IoctlSocket(CellSockUDP, (unsigned long)FIONBIO, (char *)&dontblock);
#endif /* AMIGA */
    Nfds = getdtablesize();
#ifndef MON
    {   I16s  ifd;
    for(ifd = 0; ifd < MAX_MONS; ifd++)
        {   MonSockTCP_ID[ifd].fd = -1;
            MonSockTCP_ID[ifd].flg = 'F';
        }    
    }    
    MonTCPNid = 0;
#endif /* MON */
#endif /* __MWERKS__ */

#ifdef MON
    MonSockTCP = m_passiveTCP(MonPortStr, QLEN);
    FD_SET(MonSockTCP, &Afds);
    /* Since we're doing lots of TCP, just ignore SIGPIPE altogether. */
    signal (SIGPIPE, SIG_IGN);
    MonConnectionFlg = 0;
    MonConnectedFlg = 0;
#endif /* MON */

    ConnectedFlg = 1;
    
    if (Addr_send() < 0)
    FEPrintf(MSG_X, MSG_Y, 0, 0, "Error while brodcasting my address");
    
#ifndef __MWERKS__
#ifndef AMIGA
    nice(TierraNice);
#endif /* AMIGA */
    sprintf(Fbuf, "TierraNice = %ld", TierraNice);
    FEPrintf(MSG_X, MSG_Y, 0, 0, Fbuf);
#endif /* __MWERKS__ */
#endif /* NET */

    FEPrintf(MSG_X, MSG_Y + 12, 0, 0, "tsetup: soup gotten");
    if (SliceStyle == 1)
    {   PhotonSize = (I32s) strlen(PhotonWord);
        PhotonTranslate(PhotonInst, PhotonWord);
        slicer = SlicerPhoton;
    }
    else if (SliceStyle == 0)
        slicer = SlicerQueue;
    else /* default SliceStyle == 2 */
        slicer = RanSlicerQueue;
    if (new_soup)
    {   if (GenInList)
        {   tfree((void *) GenInList, AlocGenInList, 1904);
            GenInList = NULL;
        }
        if (GenInBuf)
        {   tfree((void *) GenInBuf, AlocGenInBuf, 1905);
            GenInBuf = NULL;
        }
    }
    fclose(inf);

#ifndef __GUI__

/* added to GetSoup from old tierra.c */
#ifdef __TURBOC__
#if FRONTEND == STDIO
    ctrlbrk( T_sig_int);
#endif /* FRONTEND == STDIO */
#if FRONTEND == BASIC
    FEPrintf(HLP_X, HLP_Y, 1, 0,
"                         Press Any Key for menu ...                        ");
#endif /* FRONTEND == BASIC */
#endif /* __TURBOC__ */

#else /* __GUI__ */
} /* end GetSoup for __GUI__ */

void EndGetSoup()
{
#endif /* __GUI__ */

    if (GeneBnker)
        VerifyGB();
#ifdef MEM_PROF
    if (Log)
        MemStatReport();
#endif /* MEM_PROF */

#ifndef __GUI__
    FEClrmsg(MSG_Y,
        ((OPSYS == BCDOS) || (OPSYS == DJGPPDOS) || (OPSYS == AMIGADOS)
        || (OPSYS == MAC) ?
"                       Press Any Key for Menu ...                             "
        :
"                    Press Interrupt Key for Menu ...                          "
        ));
#else /* __GUI__ */
    FEClrmsg(MSG_Y,
"                     Use Menu for Mode Selection ...                          "
        );
#endif /* __GUI__ */

#ifdef AMIGA
#if FRONTEND == BASIC
   nodelay(stdscr, TRUE);
#endif /* FRONTEND == BASIC */
#endif /* AMIGA */
}

void GetNewSoup()
{   I32s i, j, ar = 0, ci = 2, cs, sad = 0, tNumCells = NumCells;

    NumCells = 0;
    reaped = InstExe.i = InstExe.m = ExtractCount = 0;
    TimeStats = InstExe;
    CountMutRate = CountFlaw = CountMovMut = CountJmpSou = 0;
    RateMovMut = RateMut = RateFlaw = RateJmpSou = 0;
    TimeBirth = TimeDeath = 0;
    FreeBlocks = FirstOutDisk = 1L;
    TimePop = Generations = 0.;
    FreeMemCurrent = SoupSize;
    /* initialize FreeMemry array */
    MemInit();
    /* initialize cells array */
    for (i = 0; i < NumCelAr; i++)
        for (j = 0; j < CelArSiz; j++)
            InitCell(i,j,&cells[i][j]);
    TopDummy->ld = BottomDummy->ld = 1;
    ce = BottomReap = TopReap = &cells[0][2];

    /* read in the cell genotypes */
    for (i = 0; i < tNumCells; i++)
    {   if (!strncmp("space", GenInList[i], 5))
        {   sscanf(GenInList[i], "%*s%ld", &cs);
            sprintf(Fbuf, "skipping %ld instructions", cs);
            FEPrintf(MSG_X, MSG_Y + 10, 0, 0, Fbuf);
        }
        else
        {   sscanf(GenInList[i], "%4ld", &cs);
            sprintf(Fbuf, "GetNewSoup: loading %s into cell %ld,%ld",
                GenInList[i], ar, ci);
            FEPrintf(MSG_X, MSG_Y + 11, 0, 0, Fbuf);
            if(!InjectFromBank(GenInList[i], sad, 0, 1)){
                sprintf(Fbuf, "injection failure\n");
                FEError(-1912, EXIT, NOWRITE, Fbuf);
            }
            ci++;
        }
        if (!(ci % CelArSiz))
        {   ci = 0;
            ar++;
        }
        sad += cs;
    }
    stats();
    plan();
}

void GetOldSoup(inf)
FILE *inf;
{   
    fgets(Buff, 84, inf); fgets(Buff, 84, inf);
    sscanf(Buff, "AverageSize = %ld", &AverageSize);
    fgets(Buff, 84, inf);
    sscanf(Buff, "AvgPop = %lf", &AvgPop);
    fgets(Buff, 84, inf);
    sscanf(Buff, "BrkupCou = %ld", &BrkupCou);
    fgets(Buff, 84, inf);
    sscanf(Buff, "BrkupCum = %ld", &BrkupCum);
    fgets(Buff, 84, inf);
    sscanf(Buff, "CelArSiz = %ld", &CelArSiz);
    fgets(Buff, 84, inf);
    sscanf(Buff, "CellsSize = %ld", &CellsSize);
    fgets(Buff, 84, inf);
    sscanf(Buff, "TierraClock = %ld", &TierraClock);
    fgets(Buff, 84, inf);
    sscanf(Buff, "CountFlaw = %ld", &CountFlaw);
    fgets(Buff, 84, inf);
    sscanf(Buff, "CountJmpSou = %ld", &CountJmpSou);
    fgets(Buff, 84, inf);
    sscanf(Buff, "CountMovMut = %ld", &CountMovMut);
    fgets(Buff, 84, inf);
    sscanf(Buff, "CountMutRate = %ld", &CountMutRate);
    fgets(Buff, 84, inf);
    sscanf(Buff, "debug_switch = %ld", &debug_switch);
    fgets(Buff, 84, inf);
    sscanf(Buff, "DistNext.m = %ld", &DistNext.m);
    fgets(Buff, 84, inf);
    sscanf(Buff, "DistNext.i = %ld", &DistNext.i);
    fgets(Buff, 84, inf);
    sscanf(Buff, "Disturb.m = %ld", &Disturb.m);
    fgets(Buff, 84, inf);
    sscanf(Buff, "Disturb.i = %ld", &Disturb.i);
    fgets(Buff, 84, inf);
    sscanf(Buff, "ExtractCount = %ld", &ExtractCount);
    fgets(Buff, 84, inf);
    sscanf(Buff, "FirstOutDisk = %ld", &FirstOutDisk);
    fgets(Buff, 84, inf);
    sscanf(Buff, "FreeBlocks = %ld", &FreeBlocks);
    fgets(Buff, 84, inf);
    sscanf(Buff, "FreeMemCurrent = %ld", &FreeMemCurrent);
    fgets(Buff, 84, inf);
    sscanf(Buff, "Generations = %lf", &Generations);
    fgets(Buff, 84, inf);
    sscanf(Buff, "InstExe.i = %ld", &InstExe.i);
    fgets(Buff, 84, inf);
    sscanf(Buff, "InstExe.m = %ld", &InstExe.m);
    fgets(Buff, 84, inf);
    sscanf(Buff, "isolate = %ld", &isolate);
    fgets(Buff, 84, inf);
    sscanf(Buff, "LastDiv.i = %ld", &LastDiv.i);
    fgets(Buff, 84, inf);
    sscanf(Buff, "LastDiv.m = %ld", &LastDiv.m);
    fgets(Buff, 84, inf);
    sscanf(Buff, "MalLimit = %ld", &MalLimit);
    fgets(Buff, 84, inf);
    sscanf(Buff, "NumCelAr = %ld", &NumCelAr);
    fgets(Buff, 84, inf);
    sscanf(Buff, "NumGenotypes = %ld", &NumGenotypes);
    fgets(Buff, 84, inf);
    sscanf(Buff, "NumSizes = %ld", &NumSizes);
    fgets(Buff, 84, inf);
    sscanf(Buff, "Put_limit = %ld", &Put_limit);
    fgets(Buff, 84, inf);
    sscanf(Buff, "RandIx1 = %ld", &RandIx1);
    fgets(Buff, 84, inf);
    sscanf(Buff, "RandIx2 = %ld", &RandIx2);
    fgets(Buff, 84, inf);
    sscanf(Buff, "RandIx3 = %ld", &RandIx3);
    fgets(Buff, 84, inf);
    sscanf(Buff, "RateFlaw = %ld", &RateFlaw);
    fgets(Buff, 84, inf);
    sscanf(Buff, "RateJmpSou = %ld", &RateJmpSou);
    fgets(Buff, 84, inf);
    sscanf(Buff, "RateMovMut = %ld", &RateMovMut);
    fgets(Buff, 84, inf);
    sscanf(Buff, "RateMut = %ld", &RateMut);
    fgets(Buff, 84, inf);
    sscanf(Buff, "reaped = %ld", &reaped);
    fgets(Buff, 84, inf);
    sscanf(Buff, "Search_limit = %ld", &Search_limit);
    fgets(Buff, 84, inf);
    sscanf(Buff, "SoupBot = %ld", &SoupBot);
    fgets(Buff, 84, inf);
    sscanf(Buff, "SoupTop = %ld", &SoupTop);
    fgets(Buff, 84, inf);
    sscanf(Buff, "Speed = %ld", &Speed);
    fgets(Buff, 84, inf);
    sscanf(Buff, "TimeBirth = %ld", &TimeBirth);
    fgets(Buff, 84, inf);
    sscanf(Buff, "TimeDeath = %ld", &TimeDeath);
    fgets(Buff, 84, inf);
    sscanf(Buff, "TimeGenIndiv = %ld", &TimeGenIndiv);
    fgets(Buff, 84, inf);
    sscanf(Buff, "TimePop = %lf", &TimePop);
    fgets(Buff, 84, inf);
    sscanf(Buff, "TimeStats.i = %ld", &TimeStats.i);
    fgets(Buff, 84, inf);
    sscanf(Buff, "TimeStats.m = %ld", &TimeStats.m);
    fgets(Buff, 84, inf);
    sscanf(Buff, "TotFlaw = %ld", &TotFlaw);
    fgets(Buff, 84, inf);
    sscanf(Buff, "TotMovMut = %ld", &TotMovMut);
    fgets(Buff, 84, inf);
    sscanf(Buff, "TotMut = %ld", &TotMut);
    fgets(Buff, 84, inf);
    sscanf(Buff, "filepos = %ld", &pos);
#ifdef NET
/*  fgets(Buff, 84, inf);
    sscanf(Buff, "LocalPort = %hu", &LocalPort);
    fgets(Buff, 84, inf);
    sscanf(Buff, "map_fn = %s", &map_fn);
    fgets(Buff, 84, inf);
    sscanf(Buff, "TierraNice = %ld", &TierraNice); */
#ifdef DYNIPADR
    strcpy(Buff, "core_out");
#else
#ifdef AMIGA
    sprintf(Buff, "core_out-%s",getenv("HOSTNAME"));
#else
    sprintf(Buff, "core_out-%s",getenv("HOST"));
#endif /* AMIGA */
#endif /* DYNIPADR */
#else /* NET */
#ifdef NETMON
    strcpy(Buff, "outfile_core");
#endif /* NETMON */
#ifdef IBM3090
    strcpy(Buff, "core_out.io.d");
#else
    strcpy(Buff, "core_out");
#endif
#endif /* NET */
#ifdef NETMON
    strcpy(Buff, "core_out_net");
#endif /* NETMON */

    ReadDynMem();
    ReadGeneBank();

#ifdef NETMON
    DiskOut = 0;
#endif /* NETMON */

    if (DiskOut)
    {
#ifdef IBM3090
        if (BrkupSiz)
            sprintf(Buff, "break.%ld.d", BrkupCou);
        else
            sprintf(Buff, "tierra.run");
#else
        if (BrkupSiz)
            sprintf(Buff, "%sbreak.%ld", OutPath, BrkupCou);
        else
            sprintf(Buff, "%stierra.run", OutPath);
#endif
        oufr = fopen(Buff, "r+");
        if (oufr == NULL)
        {   sprintf(Fbuf,
                "Tierra GetOldSoup() 1 file %s not opened, exiting", Buff);
            FEError(-1920, EXIT, NOWRITE, Fbuf);
        }
        TSEEK(oufr, pos, SEEK_SET);
    }
    stats();
    plan();
}

void WriteSoup(close_disk)
    I32s close_disk;
{
    FILE    *ouf;
    I32s    pos;
    time_t  tp;
    I8s     soupoutf[80];
#ifdef NET
    I8s *tmp_fn = "ipmap.tmp";
    FILE *map_fp,*tmp_fp;
#endif /* NET */
    if (DiskOut)
    {   pos = ftell(oufr);
        if (close_disk)
       {
           fclose(oufr);
       }
    }
    if (DiskBank)
        SavGeneBank();
    new_soup = 0;
#ifndef NET
#ifdef IBM3090
    sprintf(soupoutf, "soup_out.io.d");
#else /* IBM3090 */
    sprintf(soupoutf, "soup_out");
#endif /* IBM3090 */
#else /* NET */
#ifdef DYNIPADR
    sprintf(soupoutf, "soup_out");
#else
#ifdef AMIGA
    sprintf(soupoutf, "soup_out-%s",getenv("HOSTNAME"));
#else
    sprintf(soupoutf, "soup_out-%s",getenv("HOST"));
#endif /* AMIGA */
#endif /* DYNIPADR */
#endif /* NET */

    tp = (I32s) time(NULL);
    ouf = fopen(soupoutf, "w");
    if (ouf == NULL)
    {   sprintf(Fbuf,
            "Tierra WriteSoup() 0 file %s not opened, exiting", soupoutf);
        FEError(-1921, EXIT, NOWRITE, Fbuf);
    }
    fprintf(ouf, "# tierra core:  %s\n", ctime(&tp));
    fprintf(ouf, "# observational parameters:\n\n");

    fprintf(ouf, "BrkupSiz = %ld\n", BrkupSiz);
    fprintf(ouf, "CumGeneBnk = %ld\n", CumGeneBnk);
    fprintf(ouf, "debug = %ld\n", debug);
    fprintf(ouf, "DiskOut = %ld\n", DiskOut);
    fprintf(ouf, "DiskBank = %ld\n", DiskBank);
    fprintf(ouf, "GeneBnker = %ld\n", GeneBnker);
    fprintf(ouf, "GenebankPath = %s\n", GenebankPath);
    fprintf(ouf, "hangup = %ld\n", hangup);
    fprintf(ouf, "Log = %ld\n", Log);
    fprintf(ouf, "MaxFreeBlocks = %ld\n", MaxFreeBlocks);
    fprintf(ouf, "OutPath = %s\n", OutPath);
    fprintf(ouf, "SaveFreq = %ld\n", SaveFreq);
    fprintf(ouf, "SavRenewMem = %ld\n", SavRenewMem);
    fprintf(ouf, "SavMinNum = %ld\n", SavMinNum);
    fprintf(ouf, "SavThrMem = %g\n", SavThrMem);
    fprintf(ouf, "SavThrPop = %g\n", SavThrPop);
    fprintf(ouf, "WatchExe = %ld\n", WatchExe);
    fprintf(ouf, "WatchMov = %ld\n", WatchMov);
    fprintf(ouf, "WatchTem = %ld\n", WatchTem);

    fprintf(ouf, "\n# environmental variables:\n\n");

#ifdef NET
    fprintf(ouf, "LocalPort = %hu\n", LocalPort);
    fprintf(ouf, "map_fn = %s\n", map_fn);
    fprintf(ouf, "TierraNice = %ld\n", TierraNice);
#endif /* NET */
    fprintf(ouf, "alive = %ld\n", alive);
    fprintf(ouf, "DistFreq = %f\n", DistFreq);
    fprintf(ouf, "DistProp = %f\n", DistProp);
    fprintf(ouf, "DivSameSiz = %ld\n", DivSameSiz);
    fprintf(ouf, "DivSameGen = %ld\n", DivSameGen);
    fprintf(ouf, "DropDead = %ld\n", DropDead);
    fprintf(ouf, "EjectRate = %ld\n", EjectRate);
    fprintf(ouf, "GenPerBkgMut = %f\n", GenPerBkgMut);
    fprintf(ouf, "GenPerFlaw = %f\n", GenPerFlaw);
    fprintf(ouf, "GenPerMovMut = %f\n", GenPerMovMut);
    fprintf(ouf, "IMapFile = %s\n", IMapFile);
    fprintf(ouf, "JmpSouTra = %f\n", JmpSouTra);
    fprintf(ouf, "JumpTrackProb = %f\n", JumpTrackProb);
    fprintf(ouf, "MalMode = %ld\n", MalMode);
    fprintf(ouf, "MalReapTol = %ld\n", MalReapTol);
    fprintf(ouf, "MalSamSiz = %ld\n", MalSamSiz);
    fprintf(ouf, "MalTol = %ld\n", MalTol);
    fprintf(ouf, "MateProb = %f\n", MateProb);
    fprintf(ouf, "MateSearchL = %ld\n", MateSearchL);
    fprintf(ouf, "MateSizeEp = %ld\n", MateSizeEp);
    fprintf(ouf, "MateXoverProp = %f\n", MateXoverProp);
    fprintf(ouf, "MaxCpuPerCell = %ld\n", MaxCpuPerCell);
    fprintf(ouf, "MaxIOBufSiz = %ld\n", MaxIOBufSiz);
    fprintf(ouf, "MaxGetBufSiz = %ld\n", MaxGetBufSiz);
    fprintf(ouf, "MaxPutBufSiz = %ld\n", MaxPutBufSiz);
    fprintf(ouf, "MaxMalMult = %g\n", MaxMalMult);
    fprintf(ouf, "MinCellSize = %ld\n", MinCellSize);
    fprintf(ouf, "MinTemplSize = %ld\n", MinTemplSize);
    fprintf(ouf, "MovPropThrDiv = %g\n", MovPropThrDiv);
    fprintf(ouf, "MemModeFree = %ld\n", MemModeFree);
    fprintf(ouf, "MemModeMine = %ld\n", MemModeMine);
    fprintf(ouf, "MemModeProt = %ld\n", MemModeProt);
    fprintf(ouf, "new_soup = %ld\n", new_soup);
    fprintf(ouf, "NumCells = %ld\n", NumCells);
    fprintf(ouf, "PhotonPow = %g\n", PhotonPow);
    fprintf(ouf, "PhotonWidth = %ld\n", PhotonWidth);
    fprintf(ouf, "PhotonWord = %s\n", PhotonWord);
    fprintf(ouf, "PutLimit = %g\n", PutLimit);
    fprintf(ouf, "ReapRndProp = %g\n", ReapRndProp);
    fprintf(ouf, "SearchLimit = %g\n", SearchLimit);
    fprintf(ouf, "seed = %ld\n", seed);
    fprintf(ouf, "SizDepSlice = %ld\n", SizDepSlice);
    fprintf(ouf, "SlicePow = %g\n", SlicePow);
    fprintf(ouf, "SliceSize = %ld\n", SliceSize);
    fprintf(ouf, "SliceStyle = %ld\n", SliceStyle);
    fprintf(ouf, "SlicFixFrac = %g\n", SlicFixFrac);
    fprintf(ouf, "SlicRanFrac = %g\n", SlicRanFrac);
    fprintf(ouf, "SoupSize = %ld\n", SoupSize);

    fprintf(ouf, "\n0 to stop GetAVar\n\n");
    /* end soup_in variables */

    fprintf(ouf, "AverageSize = %ld\n", AverageSize);
    fprintf(ouf, "AvgPop = %lf\n", AvgPop);
    fprintf(ouf, "BrkupCou = %ld\n", BrkupCou);
    fprintf(ouf, "BrkupCum = %ld\n", BrkupCum);
    fprintf(ouf, "CelArSiz = %ld\n", CelArSiz);
    fprintf(ouf, "CellsSize = %ld\n", CellsSize);
    fprintf(ouf, "TierraClock = %ld\n", TierraClock);
    fprintf(ouf, "CountFlaw = %ld\n", CountFlaw);
    fprintf(ouf, "CountJmpSou = %ld\n", CountJmpSou);
    fprintf(ouf, "CountMovMut = %ld\n", CountMovMut);
    fprintf(ouf, "CountMutRate = %ld\n", CountMutRate);
    fprintf(ouf, "debug_switch = %ld\n", debug_switch);
    fprintf(ouf, "DistNext.m = %ld\n", DistNext.m);
    fprintf(ouf, "DistNext.i = %ld\n", DistNext.i);
    fprintf(ouf, "Disturb.m = %ld\n", Disturb.m);
    fprintf(ouf, "Disturb.i = %ld\n", Disturb.i);
    fprintf(ouf, "ExtractCount = %ld\n", ExtractCount);
    fprintf(ouf, "FirstOutDisk = %ld\n", FirstOutDisk);
    fprintf(ouf, "FreeBlocks = %ld\n", FreeBlocks);
    fprintf(ouf, "FreeMemCurrent = %ld\n", FreeMemCurrent);
    fprintf(ouf, "Generations = %lf\n", Generations);
    fprintf(ouf, "InstExe.i = %ld\n", InstExe.i);
    fprintf(ouf, "InstExe.m = %ld\n", InstExe.m);
    fprintf(ouf, "isolate = %ld\n", isolate);
    fprintf(ouf, "LastDiv.i = %ld\n", LastDiv.i);
    fprintf(ouf, "LastDiv.m = %ld\n", LastDiv.m);
    fprintf(ouf, "MalLimit = %ld\n", MalLimit);
    fprintf(ouf, "NumCelAr = %ld\n", NumCelAr);
    fprintf(ouf, "NumGenotypes = %ld\n", NumGenotypes);
    fprintf(ouf, "NumSizes = %ld\n", NumSizes);
    fprintf(ouf, "Put_limit = %ld\n", Put_limit);
    fprintf(ouf, "RandIx1 = %ld\n", RandIx1);
    fprintf(ouf, "RandIx2 = %ld\n", RandIx2);
    fprintf(ouf, "RandIx3 = %ld\n", RandIx3);
    fprintf(ouf, "RateFlaw = %ld\n", RateFlaw);
    fprintf(ouf, "RateJmpSou = %ld\n", RateJmpSou);
    fprintf(ouf, "RateMovMut = %ld\n", RateMovMut);
    fprintf(ouf, "RateMut = %ld\n", RateMut);
    fprintf(ouf, "reaped = %ld\n", reaped);
    fprintf(ouf, "Search_limit = %ld\n", Search_limit);
    fprintf(ouf, "SoupBot = %ld\n", SoupBot);
    fprintf(ouf, "SoupTop = %ld\n", SoupTop);
    fprintf(ouf, "Speed = %ld\n", Speed);
    fprintf(ouf, "TimeBirth = %ld\n", TimeBirth);
    fprintf(ouf, "TimeDeath = %ld\n", TimeDeath);
    fprintf(ouf, "TimeGenIndiv = %ld\n", TimeGenIndiv);
    fprintf(ouf, "TimePop = %lf\n", TimePop);
    fprintf(ouf, "TimeStats.i = %ld\n", TimeStats.i);
    fprintf(ouf, "TimeStats.m = %ld\n", TimeStats.m);
    fprintf(ouf, "TotFlaw = %ld\n", TotFlaw);
    fprintf(ouf, "TotMovMut = %ld\n", TotMovMut);
    fprintf(ouf, "TotMut = %ld\n", TotMut);
    fprintf(ouf, "filepos = %ld\n", pos);

    fclose(ouf);

#ifdef NET
    if ((map_fp = fopen(map_fn,"r")) == NULL)
        FEError(-1922,EXIT,NOWRITE,"WriteSoup() could not open MapFile");
    if ((tmp_fp = fopen(tmp_fn,"w")) == NULL)
        FEError(-1924,EXIT,NOWRITE,"WriteSoup() could not open tmp file");
    SaveIPMap(map_fp,tmp_fp);
    fclose(tmp_fp);
#ifndef DECVAX
    chmod(tmp_fn, S_IRUSR|S_IWUSR|S_IRGRP|S_IROTH);/* need something better! */
#endif /* DECVAX */
    fclose(map_fp);                   /* save IPMap to disk */
    remove(map_fn);
    rename(tmp_fn,map_fn);
    remove(tmp_fn);
#endif /* NET */
    SavDynMem();

#ifdef MEM_PROF
    if (Log)
        MemStatReport();
#endif /* MEM_PROF */
}

void SavDynMem()
{   I32s     i, j;
    FILE     *ouf;
    CellInd  cind[3];
    Pcells   cw; /* cell to be written */

#ifdef IBM3090
    strcpy(corefile, "core_out.io.d");
#else /* IBM3090 */
#ifdef NET
#ifdef DYNIPADR
   strcpy(corefile, "core_out");
#else
#ifdef AMIGA
    sprintf(corefile, "core_out-%s",getenv("HOSTNAME"));
#else
    sprintf(corefile, "core_out-%s",getenv("HOST"));
#endif /* AMIGA */
#endif /* DYNIPADR */
#else /* NET */
    strcpy(corefile, "core_out");
#endif /* NET */
#endif /* IBM3090 */

    ouf = fopen(corefile, "wb");
    if (ouf == NULL)
    {   sprintf(Fbuf,
            "Tierra SavDynMem() file %s not opened, exiting", corefile);
        FEError(-1925, EXIT, NOWRITE, Fbuf);
    }
    tfwrite((I8s Hp) soup, sizeof(Instruction), SoupSize, ouf);
    if (DiskOut)
        fwrite(&lo, sizeof(LastOut), 1, ouf);
    fwrite(&is, sizeof(PInst), 1, ouf);
    fwrite(TrandArray, sizeof(double), 98, ouf);
    cind[0].a = BottomReap->q.this.a;
    cind[0].i = BottomReap->q.this.i;
    cind[1].a = TopReap->q.this.a;
    cind[1].i = TopReap->q.this.i;
    cind[2].a = ce->q.this.a;
    cind[2].i = ce->q.this.i;
    fwrite(cind, sizeof(CellInd), 3, ouf);
    for (i = 0; i < NumCelAr; i++)
    {   fwrite((I8s Fp) cells[i], sizeof(TCell), CelArSiz, ouf);
        for (j = 0; j < CelArSiz; j++)
        {   cw = &(cells[i][j]);
            fwrite((I8s Fp) cw->c.ar, sizeof(Cpu), cw->c.n, ouf);
#ifdef NET
            if (cw->c.io.io)
                fwrite((I8s Fp) cw->c.io.io, sizeof(IOS), cw->c.io.siz,  ouf);
#endif /* NET */
#ifdef IO
            if (cw->c.pg.pb)
                fwrite((I8s Fp) cw->c.pg.pb,
                    sizeof(Reg), cw->c.pg.psiz + 2, ouf);
            if (cw->c.pg.gb)
                fwrite((I8s Fp) cw->c.pg.gb,
                    sizeof(Reg), cw->c.pg.gsiz + 2, ouf);
#endif /* IO */
        }
    }
    tfwrite((I8s Hp) FreeMemry, sizeof(MemFr), MaxFreeBlocks, ouf);
    tfwrite((I8s Fp) &tmpl, sizeof(TmpList), 1, ouf);
    if (tmpl.n)
        tfwrite((I8s Fp) tmpl.l, sizeof(I32s), tmpl.n, ouf);
    fclose(ouf);
}

void ReadDynMem()
{   I32s     i, j;
    CellInd  cind[3];
    FILE     *inf;
    Pcells   cr; /* cell to be read */

#ifdef IBM3090
    strcpy(corefile, "core_out.io.d");
#else /* IBM3090 */
#ifdef NET
#ifdef DYNIPADR
   strcpy(corefile, "core_out");
#else /* DYNIPADR */
#ifdef AMIGA
    sprintf(corefile, "core_out-%s",getenv("HOSTNAME"));
#else /* AMIGA */
    sprintf(corefile, "core_out-%s",getenv("HOST"));
#endif /* AMIGA */
#endif /* DYNIPADR */
#else /* NET */
    strcpy(corefile, "core_out");
#endif /* NET */
#endif /* IBM3090 */

    inf = fopen(corefile, "rb");
    if (inf == NULL)
    {   sprintf(Fbuf,
            "Tierra ReadDynMem() file %s not opened, exiting", corefile);
        FEError(-1926, EXIT, NOWRITE, Fbuf);
    }
    soup = (HpInst) thcalloc((I32u) SoupSize, sizeof(Instruction), 1906);
    tfread((I8s Hp) soup, sizeof(Instruction), SoupSize, inf);
    if (DiskOut)
        fread(&lo, sizeof(LastOut), 1, inf);
    fread(&is, sizeof(PInst), 1, inf);
    fread(TrandArray, sizeof(double), 98, inf);
    fread(cind, sizeof(CellInd), 3, inf);
    cells = (Pcells  *) tcalloc(NumCelAr, sizeof(Pcells), 1900);
    for (i = 0; i < NumCelAr; i++)
    {   cells[i] = (Pcells) tcalloc(CelArSiz, sizeof(TCell), 1901);
        fread((I8s Fp) cells[i], sizeof(TCell), CelArSiz, inf);
        for (j = 0; j < CelArSiz; j++)
        {   cr = &(cells[i][j]);
            cr->c.ar = (Cpu *) tcalloc(cr->c.n, sizeof(Cpu), 1902);
            fread((I8s Fp) cr->c.ar, sizeof(Cpu), cr->c.n, inf);
#ifdef NET
            if (cr->c.io.io)
            {   cr->c.io.io = (IOS *) tcalloc(cr->c.io.siz, sizeof(IOS), 700);
                fread((I8s Fp) cr->c.io.io, sizeof(IOS), cr->c.io.siz,  inf);
            }
#endif /* NET */
#ifdef IO
            if (cr->c.pg.pb)
            {   cr->c.pg.pb = (Preg)
                    tcalloc(cr->c.pg.psiz + 2, sizeof(Reg), 704);
                fread((I8s Fp) cr->c.pg.pb,
                    sizeof(Reg), cr->c.pg.psiz + 2, inf);
            }
            if (cr->c.pg.gb)
            {   cr->c.pg.gb = (Preg)
                    tcalloc(cr->c.pg.gsiz + 2, sizeof(Reg), 703);
                fread((I8s Fp) cr->c.pg.gb,
                    sizeof(Reg), cr->c.pg.gsiz + 2, inf);
            }
#endif /* IO */
        }
    }
    FreeMemry = (MemFr Fp) tcalloc(MaxFreeBlocks, sizeof(MemFr), 1907);
    tfread((I8s Hp) FreeMemry, sizeof(MemFr), MaxFreeBlocks, inf);
    tfread((I8s Fp) &tmpl, sizeof(TmpList), 1, inf);
    if (tmpl.n)
    {   tmpl.l = (I32s *) tcalloc(tmpl.n, sizeof(I32s), 1406);
        tfread((I8s Fp) tmpl.l, sizeof(I32s), tmpl.n, inf);
    }

    fclose(inf);

    TopDummy    = &cells[0][0];
    BottomDummy = &cells[0][1];
    BottomReap  = &cells[cind[0].a][cind[0].i];
    TopReap     = &cells[cind[1].a][cind[1].i];
    ce          = &cells[cind[2].a][cind[2].i];
}

void ReadGeneBank()
{
#ifndef AMIGA
    I32s    tgi;
#endif
    I32s    si, ar, ci, oNumGenotypes, oNumSizes;
    Pcells  cr; /* cell to be read */
    I32s    old_hash ;
    I32s    old_gi, gi, flag;

    oNumGenotypes = NumGenotypes;
    NumGenotypes = 0;
    oNumSizes = NumSizes;
    NumSizes = 0;
    for (ar = 0; ar < NumCelAr; ar++)
        for (ci = 0; ci < CelArSiz; ci++)
    {   cr = &cells[ar][ci];
        if (!cr->ld || (ar == 0 && ci < 2))
            continue;
        cr->d.genome = soup + cr->mm.p;
        if (!GeneBnker)
            continue;
        old_hash = cr->d.hash ;
        old_gi = cr->d.gi ;
        cr->d.hash = Hash(cr->d.gen.size,cr->d.genome) ;  
        if (DiskBank)
            flag = 15;
        else
            flag = 0;             /* check .gen & .tmp files */
        CheckGenotype(&(cr->d), flag, &siz_sl, &sl);
#ifdef ERROR                               /* and preserve bit 1 */
        if (cr->d.hash != old_hash)
        {   sprintf(Fbuf,
              "ReadGeneBank: (hash on disk = %ld) != (computed hash = %ld)\n",
                old_hash, cr->d.hash);
            FEError(-1927, EXIT, NOWRITE, Fbuf);
        }
        if (DiskBank && (cr->d.gi != (tgi = Lbl2Int(cr->d.gen.label))))
        {   sprintf(Fbuf,
                "ReadGeneBank(): cr->d.gen.label = %s = %ld, cr->d.gi = %hd\n",
                cr->d.gen.label, tgi, cr->d.gi);
            FEError(-1928, EXIT, NOWRITE, Fbuf);
        }
        if (DiskBank && (old_gi != cr->d.gi))
        {   sprintf(Fbuf,
                "ReadGeneBank(): cr->d.gi = %hd, gi from disk = %hd\n",
                cr->d.gi, old_gi);
            FEError(-1929, EXIT, NOWRITE, Fbuf);
        }
#endif /* ERROR */
        gi = cr->d.gi ;
        si = cr->d.gen.size;
        strcpy(cr->d.gen.label, Int2Lbl(gi));
        if (!sl[si]->g[gi]->pop)
        {   NumGenotypes++;
            sl[si]->num_g++;
        }
        sl[si]->g[gi]->pop++;
        if (!sl[si]->num_c)
            NumSizes++;
        sl[si]->num_c++;
    }
    if (!GeneBnker)
        return;
#ifdef ERROR
    if(oNumGenotypes && oNumGenotypes != NumGenotypes)
    {   sprintf(Fbuf,
    "Tierra ReadGeneBank() error: oNumGenotoypes = %ld  NumGenotypes = %ld\n",
            oNumGenotypes, NumGenotypes);
        FEError(-1930, NOEXIT, NOWRITE, Fbuf);
    }
    if(oNumSizes && oNumSizes != NumSizes)
    {   sprintf(Fbuf,
            "Tierra ReadGeneBank() error: oNumSizes = %ld  NumSizes = %ld\n",
            oNumSizes, NumSizes);
        FEError(-1931, NOEXIT, NOWRITE, Fbuf);
    }
#endif /* ERROR */
}

void SavGeneBank()
{   I32s    si, gi;
    I8s     path[80], tpath[80];
    GList   *tgl;
    FILE    *fp, *tf;
    head_t  head, thead;
    indx_t  *indx, *tindx;
#ifndef AMIGA
    indx_t  gindx, indxt;
#endif /* AMIGA */
    TmpList  tmpt;

    tmpt.n = 0; tmpt.l = NULL;
    if (tmpl.n)
    {   tmpt.n = tmpl.n;
        tmpt.l = (I32s *) tcalloc(tmpt.n, sizeof(I32s), 1406);
        for (si = 0; si < tmpt.n; si++)
            tmpt.l[si] = tmpl.l[si];
    }
    for (si = 0; si < siz_sl; si++)
    {   if (!sl[si] || !sl[si]->num_c)
            continue;
        sprintf(tpath, "%s%04ld.tmp", GenebankPath, si);
        sprintf( path, "%s%04ld.gen", GenebankPath, si);
        if (tmpl.n)
            TmplRem(si, &tmpl);
        if (tmpt.n)
            TmplRem(si, &tmpt);
        fp = open_ar( path, si, GFormat, -1);
        tf = open_ar(tpath, si, GFormat,  1);
        head = read_head(fp);
        thead = read_head(tf);
        indx = read_indx(fp, &head);
        tindx = read_indx(tf, &thead);
        /* for each genotype of this size */
        for (gi = 0; gi < sl[si]->a_num; gi++)
        {   if (!TNULL((tgl = sl[si]->g[gi])))
            {   if (IsBit(tgl->bits, 0)) /* if permanent genotype name */
                    add_gen(fp, &head, &indx, tgl);
                else if (tgl->pop)    /* or has a residual population */
                    add_gen(tf, &thead, &tindx, tgl);
            }
        }
        fclose(fp); fclose(tf);
        if (!head.n)
#ifdef DECVAX
            delete(path);
#else
            unlink(path);
#endif
        if (!thead.n)
#ifdef DECVAX
            delete(path);
#else
            unlink(tpath);
#endif
        else
            TmplAdd(si, &tmpl);
        if (indx)
        {   thfree((void *) indx, head.n_alloc * sizeof(indx_t), 600);
            indx = NULL;
        }
        if (tindx)
        {   thfree((void *) tindx, thead.n_alloc * sizeof(indx_t), 600);
            tindx = NULL;
        }
    }
    if (tmpt.n)
    {   for (si = 0; si < tmpt.n; si++)
        {   sprintf(tpath, "%s%04ld.tmp", GenebankPath, tmpt.l[si]);
#ifdef DECVAX
            delete(path);
#else
            unlink(tpath);
#endif
        }
        tfree(tmpt.l, tmpt.n * sizeof(I32s), 1406);
        tmpt.l = NULL;
        tmpt.n = 0;
    }
}

void InitCell(ar, ci, cp)
    I32s    ar, ci;
    Pcells  cp;
{   I16s  i, j;

    if (cp->c.ar)
    {   tfree((void *) (cp->c.ar), cp->c.n * sizeof(Cpu), 1902);
        cp->c.ar = NULL;
    }
#ifdef NET
    if (cp->c.io.io)
    {   tfree((void *) (cp->c.io.io), cp->c.io.siz * sizeof(IOS), 700);
        cp->c.io.siz = 0;
        cp->c.io.io = NULL;
    }
#endif /* NET */
#ifdef IO
    if (cp->c.pg.pb)
    {   tfree((void *) (cp->c.pg.pb), cp->c.pg.psiz * sizeof(Reg), 704);
        cp->c.pg.psiz = 0;
        cp->c.pg.pb = NULL;
    }
    if (cp->c.pg.gb)
    {   tfree((void *) (cp->c.pg.gb), cp->c.pg.gsiz * sizeof(Reg), 703);
        cp->c.pg.gsiz = 0;
        cp->c.pg.gb = NULL;
    }
#endif /* IO */
    memset(cp, 0, sizeof(TCell));
    strcpy(cp->d.gen.label, "---");
    strcpy(cp->d.parent.label, "---");
    cp->d.RanID = tlrand();
    cp->d.gi = (I32s) -1;    /* index to genome in bank */
    cp->d.ploidy = (I8s) PLOIDY;    /* how many tracks */
    cp->q.this.a = ar; cp->q.this.i = ci;
    cp->d.ne = cp->q.n_time = cp->q.p_time = cp->q.n_reap
        = cp->q.p_reap = cp->q.this;
    cp->c.n = PLOIDY;
    cp->c.ar = (Cpu *) tcalloc(cp->c.n, sizeof(Cpu), 1902);
    for (i = 0; i < cp->c.n; i++)
    {   cp->c.ar[i].sp = (I16s) STACK_SIZE - 1;
        if (IDregs.Se.n)
            cp->c.ar[i].cf.Se.i = IDregs.Se.r[0];
        if (IDregs.De.n)
            cp->c.ar[i].cf.De.i = IDregs.De.r[0];
        if (IDregs.So.n)
            cp->c.ar[i].cf.So.i = IDregs.So.r[0];
#ifdef SHADOW
    for (j = 0; j < NUMREG; j++)
        cp->c.ar[i].re[NUMREG + j] = j;
#endif /* SHADOW */
#if PLOIDY != 1
        cp->c.ar[i].ex = cp->c.ar[i].so = cp->c.ar[i].de = i;
/*          (I8s) (tcrand() % PLOIDY); */
#endif /* PLOIDY != 1 */
    }
    cp->c.c = &(cp->c.ar[0]);
}

void FreeDynMem()
{   I32s  i, j;
    Pcells  cp;

    FreeGB(&sl, &siz_sl);
    if (soup)
    {   thfree((void *) soup, SoupSize * sizeof(Instruction), 1906);
        soup = NULL;
    }
    for (i = 0; i < NumCelAr; i++)
    {   if (cells[i])
        {   for (j = 0; j < CelArSiz; j++)
            {   cp = &cells[i][j];
                if (cp->c.ar)
                {   tfree((void *) (cp->c.ar), cp->c.n * sizeof(Cpu), 1902);
                    cp->c.ar = NULL;
                }
#ifdef NET
                if (cp->c.io.io)
                {   tfree((void *) (cp->c.io.io), cp->c.io.siz * sizeof(IOS),
                        700);
                    cp->c.io.siz = 0;
                    cp->c.io.io = NULL;
                }
#endif /* NET */
#ifdef IO
                if (cp->c.pg.pb)
                {   tfree((void *) (cp->c.pg.pb), cp->c.pg.psiz * sizeof(Reg),
                        704);
                    cp->c.pg.psiz = 0;
                    cp->c.pg.pb = NULL;
                }
                if (cp->c.pg.gb)
                {   tfree((void *) (cp->c.pg.gb), cp->c.pg.gsiz * sizeof(Reg),
                        703);
                    cp->c.pg.gsiz = 0;
                    cp->c.pg.gb = NULL;
                }
#endif /* IO */
            }
            tfree((void *) cells[i], CelArSiz * sizeof(TCell), 1901);
            cells[i] = NULL;
        }
    }
    if (cells)
    {   tfree((void *) cells, NumCelAr * sizeof(Pcells), 1900);
        cells = NULL;
    }
    if (FreeMemry)
    {   tfree((void *) FreeMemry, MaxFreeBlocks * sizeof(MemFr), 1907);
        FreeMemry = NULL;
    }
    if (tmpl.n)
    {   tfree(tmpl.l, tmpl.n * sizeof(I32s), 1406);
        tmpl.l = NULL;
        tmpl.n = 0;
    }
}
