/*----------------------------------------------------
    WNTIERRA.C -- Tierra Windows 3.1 Display Program  V 0.5
                      RY GOUIN, April 28th 1995
  ----------------------------------------------------*/
#include "portable.h"
#ifdef __GUI__
#define WEXTERN_H
#include "wntierra.h"
#include "tierra.h"
#include "extern.h"
#define min(a,b) (((a) < (b)) ? (a) : (b))
#define max(a,b) (((a) > (b)) ? (a) : (b))
long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG) ;
BOOL FAR PASCAL _export GetStrDlgProc (HWND, UINT, UINT, LONG) ;
FARPROC lpfnGetStrDlgProc ;
HANDLE      hInst ;
HWND        hwnd ;
UINT        message ;
UINT        wParam ;
LONG        lParam ;
HDC         hdcnew ;
PAINTSTRUCT ps ;
BOOL        iconmode;
short       cxChar, cyChar, nVscrollPos, nHscrollPos, nPaintBeg, nPaintEnd ;
static short    wnstart = 0 ;
static HMENU    hMenu, hMenu1, hMenu2, hMenu3 ;
static wScreen  FEwPrintf[] =
{   {0, ""},
    {0, ""},
    {0, ""},
    {35,"TIERRA"},
    {0, " "},
    {0, " "},
    {28, "December 94  Ver 4.2"},
    {0, " "},
    {0, " "},
    {24, "Information Wants To Be Alive!"},
    {0, " "},
    {0, " "},
    {37, "By"},
    {0, " "},
    {32, "Thomas S. Ray"},
    {0, " "},
    {15, "Kurt Thearling, Tsukasa Kimesawa, Agnes Charrel"},
    {20, "Daniel Pirone, Tom Uffner, Marc Cygnus"},
    {0, " "},
    {25, "Windows Port by Roger Gouin"},
    {34, "April 95"},
    {32, "Preliminary"},
    {0, ""},
    {28, "Use File Menu to start"},
    {0, ""},
    {0, ""}
};

wScreen     *FEw;
static int  NUMLINES = (sizeof FEwPrintf / sizeof (wScreen)) - 1;

void FEwTextOut(wScreen *FEw, short l)
{   int x =  cxChar * (1 - nHscrollPos) + cxChar * ((FEw + l)->szMarg) ;

    if (iconmode)
        x = x - cxChar * 12 ;
    TextOut(hdcnew,
        x,
        cyChar * (1 - nVscrollPos + l ),
        (FEw + l)->szDesc,
        lstrlen ((FEw + l)->szDesc)
    );
}

void CheckMenuItm (UINT wParam, UINT *lpwFileSelect)
{   hMenu = hMenu2;
    SetMenu(hwnd, hMenu); // File, Mode, Help on screen
    CheckMenuItem (hMenu, wParam, MF_CHECKED);
    *lpwFileSelect = wParam;
    InvalidateRect(hwnd, NULL, FALSE);
}
void CheckMenItem (HMENU hMenu, UINT wParam, UINT *lpwModeSelect)
{   CheckMenuItem (hMenu, wParam, MF_CHECKED);
    EnableMenuItem (hMenu, wParam, MF_GRAYED);
    CheckMenuItem (hMenu, *lpwModeSelect, MF_UNCHECKED);
    EnableMenuItem (hMenu, *lpwModeSelect, MF_ENABLED);
    *lpwModeSelect = wParam;
}

//==WINMAIN=============================================================

int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdLine, int nCmdShow)
{   static char szAppName[] = "wnTierra" ;
    MSG         msg ;
    WNDCLASS    wndclass ;
    HINSTANCE   bwcc_library ;
    hInst = hInstance ;
    if (!hPrevInstance)
    {
        wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
        wndclass.lpfnWndProc   = WndProc ;
        wndclass.cbClsExtra    = 0 ;
        wndclass.cbWndExtra    = 0 ;
        wndclass.hInstance     = hInstance ;
        wndclass.hIcon         = NULL;
        // wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
        wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
        wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;
        wndclass.lpszMenuName  = NULL ;
        wndclass.lpszClassName = szAppName ;

        RegisterClass (&wndclass) ;
    }

    hwnd = CreateWindow (szAppName, "Tierra",
        WS_OVERLAPPEDWINDOW | WS_VSCROLL | WS_HSCROLL,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
        NULL, NULL, hInstance, NULL) ;

    ShowWindow (hwnd, SW_SHOWMAXIMIZED) ;
    UpdateWindow (hwnd) ;

    bwcc_library = LoadLibrary("BWCC.DLL");
    if (bwcc_library == NULL)
    {   MessageBox( NULL, "Error: Could not load library BWCC.DLL",
            "Error", MB_ICONEXCLAMATION);
        return 0;
    }
    while (GetMessage (&msg, NULL, 0, 0))
    {
        TranslateMessage (&msg) ;
        DispatchMessage (&msg) ;
    }
    FreeLibrary(bwcc_library);
    return msg.wParam ;
}

//===WndProc===============================================================
long FAR PASCAL _export WndProc (HWND hwnd, UINT message, UINT wParam,
            LONG lParam)
{   // Scroll bars
    static short    cxCaps, cxClient, cyClient, nMaxWidth,
                        nVscrollMax, nHscrollMax ;
    short           i, nVscrollInc, nHscrollInc ;
    TEXTMETRIC   tm ;
    int             argc = 2;
    char             *argv[] = {"tierra", "si0" };

    // Menus
    BOOL            GETMENU = TRUE ; // For attended run of Tierra & test
    static UINT     wSelection = CM_MODESTOP, wModeSelect = CM_MODEPLAN,
                        wFileSelect;

    // Title screen
    FEw = FEwPrintf;

    // Main switch
    switch (message)
    {   case WM_CREATE:

        //Scroll bars
            hdcnew = GetDC (hwnd) ;
            SelectObject (hdcnew, GetStockObject (SYSTEM_FIXED_FONT)) ;
            GetTextMetrics (hdcnew, &tm) ;
            cxChar = tm.tmAveCharWidth ;
            cxCaps = (tm.tmPitchAndFamily & 1 ? 3 : 2) * cxChar / 2 ;
            cyChar = tm.tmHeight;
            ReleaseDC (hwnd, hdcnew) ;
            nMaxWidth = 40 * cxChar + 22 * cxCaps ;

        //Menus
            hMenu1 = LoadMenu (hInst, MAKEINTRESOURCE(MENU_1));
            hMenu2 = LoadMenu (hInst, MAKEINTRESOURCE(MENU_2));
            hMenu3 = LoadMenu (hInst, MAKEINTRESOURCE(MENU_3));
            hMenu = hMenu1;
            SetMenu (hwnd, hMenu) ;

        // Dialog Box
            lpfnGetStrDlgProc = MakeProcInstance ((FARPROC) GetStrDlgProc,
                hInst) ;
            return 0 ;

        case WM_SIZE:
            cxClient = LOWORD (lParam) ;
            cyClient = HIWORD (lParam) ;
            nVscrollMax = max (0, NUMLINES + 2 -cyClient / cyChar) ;
            nVscrollPos = min (nVscrollPos, nVscrollMax) ;
            SetScrollRange (hwnd, SB_VERT, 0, nVscrollMax, FALSE) ;
            SetScrollPos   (hwnd, SB_VERT, nVscrollPos, TRUE) ;
            nHscrollMax = max (0, 2 + (nMaxWidth - cxClient) / cxChar) ;
            nHscrollPos = min (nHscrollPos, nHscrollMax) ;
            SetScrollRange (hwnd, SB_HORZ, 0, nHscrollMax, FALSE) ;
            SetScrollPos   (hwnd, SB_HORZ, nHscrollPos, TRUE) ;
            InvalidateRect(hwnd, NULL, FALSE);
            return 0 ;

        case WM_VSCROLL:
            switch (wParam)
            {   case SB_TOP:
                    nVscrollInc = -nVscrollPos ;
                    break ;

                case SB_BOTTOM:
                    nVscrollInc = nVscrollMax - nVscrollPos ;
                    break ;

                case SB_LINEUP:
                    nVscrollInc = -1 ;
                    break ;

                case SB_LINEDOWN:
                    nVscrollInc = 1 ;
                    break ;

                case SB_PAGEUP:
                    nVscrollInc = min (-1, -cyClient / cyChar) ;
                    break ;

                case SB_PAGEDOWN:
                    nVscrollInc = max (1, cyClient / cyChar) ;
                    break ;

                case SB_THUMBTRACK:
                    nVscrollInc = LOWORD (lParam) - nVscrollPos ;
                    break ;

                default:
                    nVscrollInc = 0 ;
            }
            nVscrollInc = max (-nVscrollPos,
                min (nVscrollInc, nVscrollMax - nVscrollPos)) ;

            if (nVscrollInc != 0)
            {   nVscrollPos += nVscrollInc ;
                ScrollWindow (hwnd, 0, -cyChar * nVscrollInc, NULL, NULL) ;
                SetScrollPos (hwnd, SB_VERT, nVscrollPos, TRUE) ;
            }
            InvalidateRect (hwnd, NULL, FALSE) ;
            return 0 ;

        case WM_HSCROLL:
            switch (wParam)
            {   case SB_LINEUP:
                    nHscrollInc = -1 ;
                    break ;

                case SB_LINEDOWN:
                    nHscrollInc = 1 ;
                    break ;

                case SB_PAGEUP:
                    nHscrollInc = -8 ;
                    break ;

                case SB_PAGEDOWN:
                    nHscrollInc = 8 ;
                    break ;

                case SB_THUMBPOSITION:
                    nHscrollInc = LOWORD (lParam) - nHscrollPos ;
                    break ;

                default:
                    nHscrollInc = 0 ;
            }
            nHscrollInc = max (-nHscrollPos,
                min (nHscrollInc, nHscrollMax - nHscrollPos)) ;

            if (nHscrollInc != 0)
            {   nHscrollPos += nHscrollInc ;
                ScrollWindow (hwnd, -cxChar * nHscrollInc, 0, NULL, NULL) ;
                SetScrollPos (hwnd, SB_HORZ, nHscrollPos, TRUE) ;
            }
            InvalidateRect (hwnd, NULL, FALSE);
            return 0 ;

        case WM_SYSCOMMAND :
            switch (wParam)
            {   case SC_CLOSE :
                    if (IDNO == MessageBox(hwnd, "Quit without saving Soup?",
                        "Tierra Nice EndBox", MB_ICONQUESTION | MB_YESNO))
                    {   InvalidateRect (hwnd, NULL, FALSE);
                        return 0;
                    }
                    DestroyWindow(hwnd);// here we leave nicely!
                    return 0;

                case SC_MINIMIZE :
                    InvalidateRect(hwnd, NULL, FALSE);
                    break;
            }
            break;

        case WM_COMMAND :
            switch (wParam)
            {   case CM_FILENEW_SOUP0 :
                    CheckMenuItm (wParam, &wFileSelect);
                    strcpy(argv[1], "si0"); wSelection = CM_MODERUN;
                    return 0;
                case CM_FILENEW_SOUP1 :
                    CheckMenuItm (wParam, &wFileSelect);
                    strcpy(argv[1], "si1"); wSelection = CM_MODERUN;
                    return 0;
                case CM_FILENEW_SOUP2 :
                    CheckMenuItm (wParam, &wFileSelect);
                    strcpy(argv[1], "si2"); wSelection = CM_MODERUN;
                    return 0;
                case CM_FILENEW_SOUP3 :
                    CheckMenuItm (wParam, &wFileSelect);
                    strcpy(argv[1], "si3"); wSelection = CM_MODERUN;
                    return 0;
                case CM_FILENEW_SOUP4 :
                    CheckMenuItm (wParam, &wFileSelect);
                    strcpy(argv[1], "si4"); wSelection = CM_MODERUN;
                    return 0;
                case CM_FILENEW_SOUP7 :
                    CheckMenuItm (wParam, &wFileSelect);
                    strcpy(argv[1], "si7"); wSelection = CM_MODERUN;
                    return 0;
                case CM_FILENEW_SOUP8 :
                    CheckMenuItm (wParam, &wFileSelect);
                    strcpy(argv[1], "si8"); wSelection = CM_MODERUN;
                    return 0;
                case CM_FILEOLD_SOUP :
                    CheckMenuItm (wParam, &wFileSelect);
                    strcpy(argv[1], "soup_out"); wSelection = CM_MODERUN;
                    return 0;

                case CM_MODEATTENDED_RUN :
                    CheckMenuItem (hMenu, wParam,
                        ((GETMENU = !GETMENU)) ? MF_CHECKED : MF_UNCHECKED);
                    break;

                case CM_FILESAVE_SOUP :
                    GoSave();
                    break;
                case CM_FILESAVE_EXIT :
                    GoSaveQuit();
                    break;
                case CM_FILEEXIT :
                    if (IDNO == MessageBox(hwnd, "Quit without saving Soup?",
                        "Tierra Nice EndBox", MB_ICONQUESTION | MB_YESNO))
                    {   InvalidateRect (hwnd, NULL, FALSE);
                        return 0;
                    }
                    DestroyWindow(hwnd);// here we leave nicely!
                    return 0;

//MODERUN/MODESTOP are a bistable with wSelection to start/stop the process
// receiving MODERUN messages from PAINT via PostMessage call in queue
                case CM_MODERUN : // Initial enabled, disabled by MODESTOP
                    if (wnstart < 2) wnstart++;
                    CheckMenItem (hMenu, wParam, &wSelection);
                    InvalidateRect (hwnd, NULL, FALSE);
                    break;
                case CM_MODESTOP : //Initial checked, grayed
                    ValidateRect (hwnd, NULL);
                    CheckMenItem (hMenu, wParam, &wSelection);
                    break; // Stop does nothing...except enable run

                case CM_MODEPLAN :
                    CheckMenItem (hMenu, wParam, &wModeSelect);
                    GoPlan();
                    InvalidateRect(hwnd,NULL,TRUE);
                    break;
                case CM_MODESIZE_HISTO :
                    CheckMenItem (hMenu, wParam, &wModeSelect);
                    GoSizeHist();
                    InvalidateRect(hwnd,NULL,TRUE);
                    break;
                case CM_MODEGENE_HISTO :
                    CheckMenItem (hMenu, wParam, &wModeSelect);
                    GoGene();
                    InvalidateRect(hwnd,NULL,TRUE);
                    break;
                case CM_MODEMEM_HISTO :
                    CheckMenItem (hMenu, wParam, &wModeSelect);
                    GoMem();
                    InvalidateRect(hwnd,NULL,TRUE);
                    break;
                      
                case CM_EDITALTER_VARS :
                    GoAlter();
                    break;
                case CM_EDITINJECT_GENE :
                    GoInject();
                    break;

                case CM_INFO_SIZE :
                    GoSizeQuery();
                    break;
                case CM_INFOEXAM_VARS :
                    GoExamine();
                    break;
                case CM_INFOHISTO_LOGGING :
                    GoHistoLog();
                    break;
#ifdef MICRO
                case CM_INFOMICRO_TOGGLE :
                    GoMicroToggle();
                    InvalidateRect(hwnd,NULL,TRUE);
                    break;
#endif

                case CM_HELPINDEX :
                    case CM_HELPKEYBOARD :
                    case CM_HELPCOMMANDS :
                    case CM_HELPPROCEDURES :
                    case CM_HELPUSING_HELP :
                    case CM_HELPABOUT :

                    MessageBox (hwnd, "Help not yet implemented!","Tierra",
                        MB_ICONEXCLAMATION);
                    return 0 ;
            }
            break;

        case WM_PAINT:

            iconmode = IsIconic (hwnd);
            hdcnew = BeginPaint (hwnd, &ps) ;  // validates rectangle

            SelectObject (hdcnew, GetStockObject (SYSTEM_FIXED_FONT)) ;

// Draw screen upon reentry, may have been resized, requires screen storage
            nPaintBeg = max (0, nVscrollPos + ps.rcPaint.top / cyChar - 1) ;
            nPaintEnd = min (NUMLINES,
                nVscrollPos + ps.rcPaint.bottom / cyChar) ;

            for (i = nPaintBeg ; i < nPaintEnd ; i++)
            {   if (i <2 || i>22)
                    SetBkColor (hdcnew, RGB(255,255,0));
                else
                    SetBkColor (hdcnew, RGB(255,255,255));
                FEwTextOut(FEw,i) ;
            }
            if (wSelection == CM_MODERUN) //Start via File Menu
                switch (wnstart)
                {   case 0 :

#ifdef MEMP_PROF
                        InitMemProf() ;
#endif /* MEM_PROF */
                      
                        FEStartup() ;         //initialize display
                        GetSoup(argc, argv);//Tierra func split in 2 parts
                        if (!GETMENU)    //if 'Attended Run' was not checked
                        {   wnstart++;
                            InvalidateRect(hwnd,NULL,FALSE);//return>thisloop
                        }                 // to stop screen redraw, use FALSE
                        else              //you can look at start messages
                        {   MessageBox(hwnd,//otherwise go directly next case
            "Stop for Start Messages Display \n-- Use Mode Menu to continue",
                                "Tierra Info",MB_OK);
                            SendMessage (hwnd, WM_COMMAND, CM_MODESTOP, 0L);
                            SelectObject (hdcnew,
                            GetStockObject (SYSTEM_FIXED_FONT));
                        }
                        break;  // to EndPaint and loop back

                    case 1 :

                        EndGetSoup();  // erase start messages

                        hMenu = hMenu3;
                        SetMenu(hwnd, hMenu);// File, Mode, Edit, Info, Help
                        CheckMenuItem (hMenu, wFileSelect, MF_CHECKED);
                        if (!GETMENU) //start stop box was not checked
                        {   wnstart++;
                            InvalidateRect(hwnd,NULL,FALSE);//return>loop
                        }
                        else         //so go next case to start Tierra...
                        {   MessageBox (hwnd,
    "Stop for check/modify Start Parameters \n--Use Mode Menu to continue",
                                "Tierra Info",MB_OK);
                            SendMessage (hwnd, WM_COMMAND, CM_MODESTOP, 0L);
                            SelectObject (hdcnew,
                            GetStockObject (SYSTEM_FIXED_FONT)) ;
                        }
                        break;  // to EndPaint and loop back

                    case 2 :  // Tierra is ON!

                        while ((Generations < alive) &&
                                                (FEGetch(-1,-1) != 'z'))
                        {   (*slicer)();//otherwise it goes thru 1 cycle 1st
                            ReapCheck();//after, it checks click each cycle
                        }
                        if (Generations >= alive) wnstart++; //We are done
                        break;//to EndPaint - for click/kbd check by Windows

                    case 3 :
                        WriteSoup (1) ;
                        if (Log) fclose(tfp_log) ;
                        if (!GETMENU)
                            DestroyWindow (hwnd);//send WM_DESTROY message
                                // to end program, no need to return now!
                        else
                            MessageBox (hwnd,
    "End of Run -- Stop for check of End Parameters --Use File Menu to quit",
                                "Tierra Info",MB_OK);

                };// end of wnstart switch and 'if run' statement

                EndPaint(hwnd, &ps) ;// happens after start and at end of
                                                // each life-death cycle
                return 0 ; // end of case WM_PAINT

            case WM_LBUTTONDOWN :
                InvalidateRect(hwnd, NULL, FALSE);
                break;

            case WM_DESTROY:
                PostQuitMessage (0) ;
                return 0 ;

    }   // end of main switch
    return DefWindowProc (hwnd,message,wParam,lParam) ; //for other cases
}       // end of WndProc

BOOL FAR PASCAL _export GetStrDlgProc (HWND hDlg, UINT message, UINT wParam,
            LONG lParam)
{   switch (message)
    {   case WM_INITDIALOG :
            return TRUE;

        case WM_COMMAND :
            switch (wParam)
            {   case IDOK :  // only one case!---FGSbuf is output used
                                        //by WndProc FEGetStr in frontend.c
                    GetDlgItemText (hDlg,IDC_EDIT1,FGSbuf, 32) ;
                    EndDialog (hDlg, 0);
                    SelectObject (hdcnew, GetStockObject(SYSTEM_FIXED_FONT));
                    return TRUE ;
            }
    }
    return FALSE;
}

#endif /* __GUI__ */
